/*
 * @@COPYRIGHT@@ 
 */
package com.cosylab.application;

import java.util.EventObject;

/**
 * <code>PlugInEvent</code> ...
 * 
 * @author Igor Kriznar (igor.kriznar@cosylab.com)
 * @version @@VERSION@@
 */
/**
 * Event used in event notifications through <code>PlugInListener</code>
 * interface.
 * 
 * @version @@VERSION@@
 */
public class PlugInEvent extends EventObject {
  private PlugIn plugin;
	
	/**
	 * Creates a new instance of this event. Delegates to 
	 * parent constructor.
	 * 
	 * @param source the plugin manager that is firing this event
   * @param plugin the plugin which was installed
	 */
	public PlugInEvent(PlugInManager source, PlugIn plugin)
	{
		super(source);
    this.plugin=plugin;
	}
  
  
  /**
   * Returns plugin which generated this event.
   * @return plugin which generated this event
   */
  public PlugIn getPlugIn() {
    return plugin;
  }
}

