/*
 * Copyright (c) 2003 by Cosylab d.o.o.
 *
 * The full license specifying the redistribution, modification, usage and other
 * rights and obligations is included with the distribution of this project in
 * the file license.html. If the license is not included you may find a copy at
 * http://www.cosylab.com/legal/abeans_license.htm or may write to Cosylab, d.o.o.
 *
 * THIS SOFTWARE IS PROVIDED AS-IS WITHOUT WARRANTY OF ANY KIND, NOT EVEN THE
 * IMPLIED WARRANTY OF MERCHANTABILITY. THE AUTHOR OF THIS SOFTWARE, ASSUMES
 * _NO_ RESPONSIBILITY FOR ANY CONSEQUENCE RESULTING FROM THE USE, MODIFICATION,
 * OR REDISTRIBUTION OF THIS SOFTWARE.
 */

package com.cosylab.application;

import javax.swing.JComponent;


/**
 * <code>VisiblePlugIn</code> interface extends <code>PlugIn</code> interface
 * with access to plug-ins GUI container.
 *
 * @author Igor Kriznar (<a
 *         href="mailto:igor.kriznar@cosylab.com">igor.kriznar&x40;cosylab.com</a>)
 * @version $Id: VisiblePlugIn.java,v 1.1 2006/09/22 12:35:02 ikriznar Exp $
 *
 * @since Jul 16, 2003.
 */
public interface VisiblePlugIn extends PlugIn
{
	/**
	 * Plugin must return non-null component with GUI presentation of plugin.
	 * @return non-null component with GUI presentation of plugin
	 */
	JComponent getGUIPanel();
}

/* __oOo__ */
