package com.cosylab.gui;

import java.awt.Component;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.beans.PropertyEditor;
import java.beans.PropertyEditorSupport;

import javax.swing.Icon;

import com.cosylab.gui.components.util.IconHelper;

/**
 * 
 * @author Jaka Bobnar, Cosylab
 *
 */
public class IconPropertyEditor extends PropertyEditorSupport implements PropertyEditor {

	private IconEditor editor;
	 
	/**
	 * Creates new instance of SelectorPropertyEditor.
	 */
	public IconPropertyEditor() {
		super();
	}
	
	/*
	 * (non-Javadoc)
	 * @see java.beans.PropertyEditorSupport#getCustomEditor()
	 */
	public Component getCustomEditor() {
		if (editor == null) {
			editor = new IconEditor();
			editor.setIcon((String)getValue());
			editor.addPropertyChangeListener(IconEditor.ICON,new PropertyChangeListener() {
				public void propertyChange(PropertyChangeEvent evt) {
					setValueSilently(editor.getIconPath());
				}
			});
			editor.setSize(250,80);
		}
		
		return editor;
    }

	/*
	 * (non-Javadoc)
	 * @see java.beans.PropertyEditorSupport#getJavaInitializationString()
	 */
	public String getJavaInitializationString() {
		return "\"" + getAsText() + "\"";
//		if (getValue() == null) return "null";
//		String name = getValue().toString(); 
//		name = name.replace('\\','/');
//		int index = name.indexOf("!/");
//		if (index > 0) {
//			name = name.substring(index+2);
//		}
//		return "com.cosylab.gui.components.util.IconHelper.createIcon(\"" + name + "\")";
    }

	/*
	 * (non-Javadoc)
	 * @see java.beans.PropertyEditorSupport#supportsCustomEditor()
	 */
	public boolean supportsCustomEditor() {
	    return true;
    }
	
	private void setValueSilently(Object value) {
		super.setValue(value);
	}
	
	/* (non-Javadoc)
	 * @see java.beans.PropertyEditorSupport#setValue(java.lang.Object)
	 */
	public void setValue(Object value) {
		super.setValue(value);
		if (editor!=null) {
			editor.setIcon((String)value);
		}
	}
	
}


/* __oOo__ */