package com.cosylab.gui;

import javax.swing.Icon;

import com.cosylab.gui.components.util.IconHelper;

/**
 * 
 * @author Jaka Bobnar, Cosylab
 *
 */
public class ValueIconPair implements Comparable {
	
	private Icon icon;
	private Long value;
	private String iconName;
	
	
	public ValueIconPair(long value, Icon icon) {
		this(new Long(value),icon);
	}
	public ValueIconPair(Long value, Icon icon) {
		this.icon = icon;
		this.value = value;
		this.iconName = icon.toString();
	}
	
	public ValueIconPair(Long value, String iconName) {
		this.value = value;
		this.icon = IconHelper.createIcon(iconName);
		this.iconName = iconName;
	}

	public Icon getIcon() {
		return icon;
	}

	public Long getValue() {
		return value;
	}
	
	public String getIconName() {
		return iconName;
	}
	
	public boolean equals(Object o) {
		if (!(o instanceof ValueIconPair)) return false;
		ValueIconPair d = (ValueIconPair)o;
		if (value != null)
			return (value.equals(d.value) && d.icon.equals(icon));
		else 
			return (d.value == null && d.icon.equals(icon));
		
	}
	
	/*
	 * (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	public String toString() {
		return value + "= " + iconName ;
	}
	
	/* (non-Javadoc)
	 * @see java.lang.Comparable#compareTo(T)
	 */
	public int compareTo(Object o) {
		if (o instanceof ValueIconPair) {
			ValueIconPair v= (ValueIconPair)o;
			return (int)(value-v.value);
		}
		return 0;
	}
}
