/*
 * Copyright (c) 2003 by Cosylab d.o.o.
 *
 * The full license specifying the redistribution, modification, usage and other
 * rights and obligations is included with the distribution of this project in
 * the file license.html. If the license is not included you may find a copy at
 * http://www.cosylab.com/legal/abeans_license.htm or may write to Cosylab, d.o.o.
 *
 * THIS SOFTWARE IS PROVIDED AS-IS WITHOUT WARRANTY OF ANY KIND, NOT EVEN THE
 * IMPLIED WARRANTY OF MERCHANTABILITY. THE AUTHOR OF THIS SOFTWARE, ASSUMES
 * _NO_ RESPONSIBILITY FOR ANY CONSEQUENCE RESULTING FROM THE USE, MODIFICATION,
 * OR REDISTRIBUTION OF THIS SOFTWARE.
 */

package com.cosylab.gui.adapters;

import com.cosylab.gui.displayers.AsynchronousNumberConsumer;
import com.cosylab.gui.displayers.DataConsumer;
import com.cosylab.gui.displayers.UpdateRequest;
import com.cosylab.util.CommonException;


/**
 * <code>AsynchronousDispatcher</code> is implementation of
 * <code>AsynchronousNumberConsumer</code> which delegates value updates to
 * registered consumers.
 *
 * @author <a href="mailto:igor.kriznar@cosylab.com">Igor Kriznar</a>
 * @version $Id: AsynchronousDispatcher.java,v 1.2 2006/08/29 16:27:21 jbobnar Exp $
 *
 * @since Feb 14, 2004.
 */
public class AsynchronousDispatcher extends DataConsumerDispatcher
	implements AsynchronousNumberConsumer
{
	/**
	 * Creates new dispatcher.
	 */
	public AsynchronousDispatcher()
	{
		super(new Class[]{ AsynchronousNumberConsumer.class });
	}

	/* (non-Javadoc)
	 * @see com.cosylab.gui.displayers.NonblockingNumberConsumer#updateNonblocking(java.lang.Number)
	 */
	 /* (non-Javadoc)
	 * @see com.cosylab.gui.displayers.AsynchronousNumberConsumer#updateAcynchronously(com.cosylab.gui.displayers.UpdateRequest)
	 */
	public void updateAcynchronously(UpdateRequest request)
		throws CommonException {
		DataConsumer[] delegates = getConsumers();

		for (int i = 0; i < delegates.length; i++) {
			try {
				((AsynchronousNumberConsumer)delegates[i]).updateAcynchronously(request);
			} catch (CommonException e) {
				throw e;
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
	}

}

/* __oOo__ */
