package com.cosylab.gui.adapters;

/**
 * <code>IdentityConverter</code> is ismplest possible conversion, it delegates same data value to consumers. 
 *
 * @author <a href="mailto:igor.kriznar@cosylab.com">Igor Kriznar</a>
 * @version $Id: IdentityConverter.java,v 1.9 2007-12-11 13:33:02 jbobnar Exp $
 * 
 * @since Feb 15, 2004.
 */
public class IdentityConverter extends SimpleConverterSupport {

	private static final long serialVersionUID = 583866778614153371L;
	public static final String SHORT_NAME = "Identity";
	/**
	 * Creates new identity converter.
	 * 
	 */
	public IdentityConverter() {
		super();
	}

	/**
	 * Here we return same value.
	 * @see com.cosylab.gui.adapters.SimpleConverterSupport#transform(double)
	 */
	protected double transform(double value) {
		return value;
	}

	/**
	 * Here we return same value.
	 * @see com.cosylab.gui.adapters.SimpleConverterSupport#inverseTransform(double)
	 */
	protected double inverseTransform(double value) {
		return value;
	}

	public String getName(){
		return SHORT_NAME;
	}
	
	public String toString(){
		return SHORT_NAME;
	}
	
	@Override
	public boolean equals(Object obj) {
		if (obj instanceof IdentityConverter) return true;
		return false;
	}
}
