/*
 * Copyright (c) 2003 by Cosylab d.o.o.
 *
 * The full license specifying the redistribution, modification, usage and other
 * rights and obligations is included with the distribution of this project in
 * the file license.html. If the license is not included you may find a copy at
 * http://www.cosylab.com/legal/abeans_license.htm or may write to Cosylab, d.o.o.
 *
 * THIS SOFTWARE IS PROVIDED AS-IS WITHOUT WARRANTY OF ANY KIND, NOT EVEN THE
 * IMPLIED WARRANTY OF MERCHANTABILITY. THE AUTHOR OF THIS SOFTWARE, ASSUMES
 * _NO_ RESPONSIBILITY FOR ANY CONSEQUENCE RESULTING FROM THE USE, MODIFICATION,
 * OR REDISTRIBUTION OF THIS SOFTWARE.
 */

package com.cosylab.gui.adapters;

import com.cosylab.gui.displayers.DataConsumer;
import com.cosylab.gui.displayers.SynchronousNumberConsumer;


/**
 * <code>SynchronousNumberDispatcher</code> is implementation of
 * <code>SynchronousNumberConsumer</code> which delegates value updates to
 * registered consumers.
 *
 * @author <a href="mailto:igor.kriznar@cosylab.com">Igor Kriznar</a>
 * @version $Id: SynchronousNumberDispatcher.java,v 1.1 2004/06/28 03:59:33 ikriznar Exp $
 *
 * @since Feb 14, 2004.
 */
public class SynchronousNumberDispatcher extends DataConsumerDispatcher
	implements SynchronousNumberConsumer
{
	/**
	 * Creates new dispatcher.
	 */
	public SynchronousNumberDispatcher()
	{
		super(new Class[]{ SynchronousNumberConsumer.class });
	}

	/* (non-Javadoc)
	 * @see com.cosylab.gui.displayers.NonblockingNumberConsumer#updateNonblocking(java.lang.Number)
	 */
	public void updateSynchronously(long timestamp, Number value)
	{
		DataConsumer[] delegates = getConsumers();

		for (int i = 0; i < delegates.length; i++) {
			try {
				((SynchronousNumberConsumer)delegates[i]).updateSynchronously(timestamp,
				    value);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
	}
}

/* __oOo__ */
