/*
 * Copyright (c) 2003 by Cosylab d.o.o.
 *
 * The full license specifying the redistribution, modification, usage and other
 * rights and obligations is included with the distribution of this project in
 * the file license.html. If the license is not included you may find a copy at
 * http://www.cosylab.com/legal/abeans_license.htm or may write to Cosylab, d.o.o.
 *
 * THIS SOFTWARE IS PROVIDED AS-IS WITHOUT WARRANTY OF ANY KIND, NOT EVEN THE
 * IMPLIED WARRANTY OF MERCHANTABILITY. THE AUTHOR OF THIS SOFTWARE, ASSUMES
 * _NO_ RESPONSIBILITY FOR ANY CONSEQUENCE RESULTING FROM THE USE, MODIFICATION,
 * OR REDISTRIBUTION OF THIS SOFTWARE.
 */

package com.cosylab.gui.components;

import java.awt.Color;

import javax.swing.border.LineBorder;
import javax.swing.border.TitledBorder;


/**
 * Border with tile and thin line.
 *
 * @author <a href="mailto:igor.kriznar@cosylab.com">Igor Kriznar</a>
 * @version $id$
 */
public class GroupBoxBorder extends TitledBorder
{
	/**
	 * Creates a new GroupBoxBorder object.
	 */
	public GroupBoxBorder()
	{
		super(new LineBorder(Color.black));
	}

	/**
	 * Creates border with specificed title.
	 *
	 * @param title
	 */
	public GroupBoxBorder(String title)
	{
		this();
		setTitle(title);
	}
}

/* __oOo__ */
