/*
 * Copyright (c) 2003 by Cosylab d.o.o.
 *
 * The full license specifying the redistribution, modification, usage and other
 * rights and obligations is included with the distribution of this project in
 * the file license.html. If the license is not included you may find a copy at
 * http://www.cosylab.com/legal/abeans_license.htm or may write to Cosylab, d.o.o.
 *
 * THIS SOFTWARE IS PROVIDED AS-IS WITHOUT WARRANTY OF ANY KIND, NOT EVEN THE
 * IMPLIED WARRANTY OF MERCHANTABILITY. THE AUTHOR OF THIS SOFTWARE, ASSUMES
 * _NO_ RESPONSIBILITY FOR ANY CONSEQUENCE RESULTING FROM THE USE, MODIFICATION,
 * OR REDISTRIBUTION OF THIS SOFTWARE.
 */

package com.cosylab.gui.components;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.event.ContainerEvent;
import java.awt.event.ContainerListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import javax.swing.JComponent;
import javax.swing.JFrame;

import com.cosylab.application.state.State;
import com.cosylab.gui.components.ledder.BitDescriptor;
import com.cosylab.gui.components.ledder.DefaultBitDescriptor;


/**
 * <code>LabelledLedder</code> ...  DOCUMENT ME!
 *
 * @author <a href="mailto:anze.zupanc@cosylab.com">Anze Zupanc</a>
 * @version $Id: LabelledLedder.java,v 1.22 2007-03-01 11:08:49 ikriznar Exp $
 *
 * @since Jul 20, 2004.
 */
public class LabelledLedder extends AbstractDisplayerPanel
{

	//private BitmaskField bitmask=null;
	private static final long serialVersionUID = 1L;

	/**
	 * DOCUMENT ME!
	 *
	 * @param args DOCUMENT ME!
	 */
	public static void main(String[] args)
	{
		LabelledLedder ll = new LabelledLedder("Labelled Ledder") ;
		DefaultBitDescriptor lm = new DefaultBitDescriptor();
		ll.setBitDescriptor(lm);
		
		int ledCount = 7;

		String[] descText =
			{
				"1On",
				"2Sum Failure",
				"3DC Overcurrent",
				"4Remote",
				"5Phase Failure",
				"6External Interlock",
				"7Not Ready"};

		long c = 0;
		long m = 1;

		for (int i = 0; i < ledCount; i++) {
			Color con = Color.GREEN;
			Color cof = Color.RED;
			String cde;

			if (i < descText.length) {
				cde = descText[i % descText.length];
			} else {
				int nChars = (int) (Math.random() * 12) + 2;
				cde = "";
				cde += (char) (int) (Math.random() * 25 + 65);
				for (int j = 0; j < nChars; j++) {
					cde += (char) (int) (Math.random() * 25 + 97);
				}
			}
			c += m;
			m *= 2;
			
			lm.add(cde, con, cof);
		}
		
		ll.setMask(c);

		

		JFrame frame = new JFrame("Ledder Testing Applet");
		frame.getContentPane().setLayout(new BorderLayout(10, 10));
		frame.getContentPane().add(ll);
		frame.setSize(500, 200);
		frame.addWindowListener(new WindowAdapter() {
				public void windowClosing(WindowEvent e)
				{
					System.exit(0);
				}
			});
	//	ll.setEditable(true);
		ll.setEditable(true);
		frame.setVisible(true);
/*		try {
            Thread.sleep(2000);
            ll.setBits(10);
            Thread.sleep(2000);
            ll.getLedder().setBits(15);
            Thread.sleep(2000);
            System.out.println(ll.getLedder().getBits());
        } catch (InterruptedException e1) {
            // TODO Auto-generated catch block
            e1.printStackTrace();
        }
*/		
	}

	private Ledder ledder;
	
	/**
	 * Creates a new LabelledLedder object.
	 */
	public LabelledLedder()
	{
		this(null);
	}

	/**
	 * Creates a new LabelledLedder object.
	 *
	 * @param title DOCUMENT ME!
	 */
	public LabelledLedder(String title)
	{
		// TODO initialize with super constructor, use popup manager from parent
		super();
		
		setTitle(title);

		setTitleVisible(true);
		setLayoutOrientation(DYNAMIC_LAYOUT);
		setResizable(true);
		setEnhanced(true);
	}

	/**
	 * DOCUMENT ME!
	 *TODO prej je bil bitmask().getBits... vracal je 0!
	 * @return long
	 */
	public long getBits()
	{
		return getLedder().getBits();
	}

	/**
	 * DOCUMENT ME!
	 *
	 * @return int
	 */
	
	protected Ledder getLedder()
	{
		if (ledder == null) {
			ledder = new Ledder();
			//			ledder.addPropertyChangeListener(new PropertyChangeListener() {
			//					/**
			//					 * @see java.beans.PropertyChangeListener#propertyChange(PropertyChangeEvent)
			//					 */
			//					public void propertyChange(PropertyChangeEvent evt)
			//					{
			//						firePropertyChange(evt.getPropertyName(),
			//						    evt.getOldValue(), evt.getNewValue());
			//					}
			//				});
			//ledder.addMouseListener(getPopupManager().getMouseHook());
			
			
			
			ledder.addContainerListener(new ContainerListener() {
				public void componentRemoved(ContainerEvent e) {
					e.getChild().removeMouseListener(getPopupManager().getMouseHook());
				}
				public void componentAdded(ContainerEvent e) {
					e.getChild().addMouseListener(getPopupManager().getMouseHook());
				}
			});
		
		}

		return ledder;
	}

	/**
	 * DOCUMENT ME!
	 *
	 * @return long
	 */
	public long getMask()
	{
		return getLedder().getMask();
	}

	/**
	 * DOCUMENT ME!
	 *
	 * @return BitDescriptor
	 */
	public BitDescriptor getBitDescriptor()
	{
		return getLedder().getModel();
	}


	/**
	 * Overriden to implement additional features saving.
	 *
	 * @return state of the component.
	 */
	public State getState()
	{
		State state = super.getState();

		return state;
	}

	
	/**
	 * Returns value displaying GUI component: the <code>Wheelswitch</code>.
	 *
	 * @see AbstractDisplayerPanel#getValueComponent()
	 */
	protected JComponent getValueComponent()
	{
		return getLedder();
	}

	/**
	 * Overriden to implement additional functionality.
	 *
	 * @see com.cosylab.gui.components.AbstractDisplayerPanel#setResizable(boolean)
	 */
	protected void internalSetResizable()
	{
		super.internalSetResizable();
		getLedder().revalidate();
	}

	/**
	 * Returns whether the ledder can be edited  by the user.
	 *
	 * @return boolean
	 */
	public boolean isEditable()
	{
		return getLedder().isEditable();
	}
	
	public void setEditable(boolean editable){
	    getLedder().setEditable(editable);
	}
	/**
	 * If the reverseLedsOrder is <code>true<code> then the leds will be displayed
	 * in reverse order.
	 * 
	 * @return reverseLedsOrder boolean 
	 */
	public boolean isReverseLedsOrder() {
		return getLedder().isReverseLedsOrder();
	}
	/* (non-Javadoc)
	 * @see com.cosylab.gui.components.AbstractDisplayerPanel#layoutDisplayer()
	 */
	
	/**
	 * DOCUMENT ME!
	 *
	 * @param value long
	 */
	public void setBits(long value)
	{
		getLedder().setBits(value);
	}

	/**
	 * DOCUMENT ME!
	 *
	 * @param value long
	 */
	public void setMask(long value)
	{
		getLedder().setMask(value);
	}

	/**
	 * DOCUMENT ME!
	 *
	 * @param model BitDescriptor
	 */
	public void setBitDescriptor(BitDescriptor model)
	{
		getLedder().setModel(model);
	}

	/**
	 * If the reverseLedsOrder is <code>true<code> then the leds will be displayed
	 * in reverse order.
	 * 
	 * @param b boolean
	 */
	public void setReverseLedsOrder(boolean b) {
		getLedder().setReverseLedsOrder(b);
	}
	
	/**
	 * Overriden to implement additional features loading.
	 *
	 * @param state to be loaded.
	 */
	public void setState(State state)
	{
		super.setState(state);

	}
	
	
	public void setEnabled(boolean enabled){
	    getTitleComponent().setEnabled(enabled);
	}
	

}

/* __oOo__ */
