package com.cosylab.gui.components;

import java.awt.BorderLayout;
import javax.swing.JPanel;
import javax.swing.JFrame;

public class LabelledLedderTester extends JFrame {

	private static final long serialVersionUID = 1L;

	private JPanel jContentPane = null;

	private LabelledLedder labelledLedder = null;

	/**
	 * This is the default constructor
	 */
	public LabelledLedderTester() {
		super();
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(300, 200);
		this.setContentPane(getJContentPane());
		this.setTitle("JFrame");
	}

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new JPanel();
			jContentPane.setLayout(new BorderLayout());
			jContentPane.add(getLabelledLedder(), BorderLayout.CENTER);
		}
		return jContentPane;
	}

	/**
	 * This method initializes labelledLedder
	 * 
	 * @return com.cosylab.gui.components.LabelledLedder
	 */
	private LabelledLedder getLabelledLedder() {
		if (labelledLedder == null) {
			labelledLedder = new LabelledLedder();

			labelledLedder.setEditable(true);
			labelledLedder.setTitle("Title");
			labelledLedder.setMask(111L);
		}
		return labelledLedder;
	}

} // @jve:decl-index=0:visual-constraint="9,5"
