/*
 * Copyright (c) 2003 by Cosylab d.o.o.
 *
 * The full license specifying the redistribution, modification, usage and other
 * rights and obligations is included with the distribution of this project in
 * the file license.html. If the license is not included you may find a copy at
 * http://www.cosylab.com/legal/abeans_license.htm or may write to Cosylab, d.o.o.
 *
 * THIS SOFTWARE IS PROVIDED AS-IS WITHOUT WARRANTY OF ANY KIND, NOT EVEN THE
 * IMPLIED WARRANTY OF MERCHANTABILITY. THE AUTHOR OF THIS SOFTWARE, ASSUMES
 * _NO_ RESPONSIBILITY FOR ANY CONSEQUENCE RESULTING FROM THE USE, MODIFICATION,
 * OR REDISTRIBUTION OF THIS SOFTWARE.
 */

package com.cosylab.gui.components;

/**
 * Interface for listeners interested into monitoring progress of tasks.
 *
 * @author <a href="mailto:ales.pucelj@cosylab.com">Ales Pucelj</a>
 * @version $Revision: 1.1 $
 */
public interface ProgressListener
{
	/**
	 * Notifies that task has changed progress.
	 *
	 * @param e event.
	 */
	public void progress(ProgressEvent e);

	/**
	 * Notifies that task has completed.
	 *
	 * @param e event.
	 */
	public void taskComplete(ProgressEvent e);

	/**
	 * Notifies that task has been interrupted.
	 *
	 * @param e event.
	 */
	public void taskInterruped(ProgressEvent e);

	/**
	 * Notifies that task has started.
	 *
	 * @param e event.
	 */
	public void taskStarted(ProgressEvent e);
}

/* __oOo__ */
