/*
 * Copyright (c) 2003 by Cosylab d.o.o.
 *
 * The full license specifying the redistribution, modification, usage and other
 * rights and obligations is included with the distribution of this project in
 * the file license.html. If the license is not included you may find a copy at
 * http://www.cosylab.com/legal/abeans_license.htm or may write to Cosylab, d.o.o.
 *
 * THIS SOFTWARE IS PROVIDED AS-IS WITHOUT WARRANTY OF ANY KIND, NOT EVEN THE
 * IMPLIED WARRANTY OF MERCHANTABILITY. THE AUTHOR OF THIS SOFTWARE, ASSUMES
 * _NO_ RESPONSIBILITY FOR ANY CONSEQUENCE RESULTING FROM THE USE, MODIFICATION,
 * OR REDISTRIBUTION OF THIS SOFTWARE.
 */

package com.cosylab.gui.components;

import com.cosylab.gui.components.util.PopupManageable;

import java.util.Map;


/**
 * <code>SimpleDisplayer</code> interface defines some usefull features, that
 * should have all GUI widget, that wants to colaborate with Abeans framework.
 *
 * @author <a href="mailto:igor.kriznar@cosylab.com">Igor Kriznar</a>
 * @version $id$
 */
public interface SimpleDisplayer extends PopupManageable
{
	/**
	 * Returns map of editors for different displayer contexts.  Keys ar of
	 * form "slider", "slider/alarms", etc. Value is  <code>Class</code> of
	 * editor, which customizes displayer in aspect of  context key. Values
	 * must implement <code>Editor</code> interace.
	 *
	 * @return map of editors
	 */
	Map getEditors();
}

/* __oOo__ */
