package com.cosylab.gui.components;

import java.awt.Component;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.beans.PropertyEditorSupport;

import com.cosylab.gui.components.range2.RangedValuePolicy;

/**
 * RangedValuePolicy property editor for gui builder.
 * 
 * @author <a href="mailto:jaka.bobnar@cosylab.com">Jaka Bobnar</a>
 * @version $Id: ValuePolicyPropertyEditor.java,v 1.4 2007-07-26 12:43:35 jbobnar Exp $
 *
 */
public class ValuePolicyPropertyEditor extends PropertyEditorSupport {
	
	private ValuePolicyCustomizer editor;
	 
	public Component getCustomEditor() {
		if (editor == null) {
			editor = new ValuePolicyCustomizer();
			editor.setValuePolicy((RangedValuePolicy)getValue());
			editor.addPropertyChangeListener("valuePolicy", new PropertyChangeListener() {
				public void propertyChange(PropertyChangeEvent evt) {
					setValueSilently(editor.getValuePolicy());
				}
			});
		}

		return editor;
    }

	public String getJavaInitializationString() {
		return "new " + getValue().getClass().getName()+"()";
    }

	public boolean supportsCustomEditor() {
	    return true;
    }
	
	private void setValueSilently(Object value) {
		super.setValue(value);
	}
	
	/* (non-Javadoc)
	 * @see java.beans.PropertyEditorSupport#setValue(java.lang.Object)
	 */
	@Override
	public void setValue(Object value) {
		super.setValue(value);
		if (editor!=null) {
			editor.setValuePolicy((RangedValuePolicy)value);
		}
	}
}
