/*
 * @@COPYRIGHT@@
 */
package com.cosylab.gui.components.introspection;

import java.awt.Component;
import java.lang.reflect.Member;

import javax.swing.DefaultListCellRenderer;

import com.cosylab.introspection.DataFormatter;

/**
 * Creation date: (12.1.2002 2:56:04)
 * 
 * @author <a href="mailto:miha.kadunc@cosylab.com">Miha Kadunc</a>
 * @version $id$
 */
public class MemberListCellRenderer extends DefaultListCellRenderer {
	private boolean fShowType=true;
	private boolean fShowParameters=false;
/**
 * MemberListCellRenderer constructor comment.
 * @param showType boolean
 * @param showParameters boolean
 */
public MemberListCellRenderer(boolean showType, boolean showParameters) {
	super();
	fShowType=showType;
	fShowParameters=showParameters;
}
/**
 * Creation date: (12.1.2002 2:56:47)
 * @param list javax.swing.JList
 * @param value Object
 * @param index int
 * @param isSelected boolean
 * @param cellHasFocus boolean
 * @return Component
 * @see javax.swing.ListCellRenderer#getListCellRendererComponent(JList, Object, int, boolean, boolean)
 */
public Component getListCellRendererComponent(
  javax.swing.JList list,
  Object value,
  int index,
  boolean isSelected,
  boolean cellHasFocus) {
	  
	return super.getListCellRendererComponent(list,toString((Member)value),index,isSelected,cellHasFocus);
}
/**
 * Creation date: (12.1.2002 2:56:47)
 * @param aMember Member
 * @return String
 */
public String toString(Member aMember) {
	return DataFormatter.toString(aMember,fShowType,fShowParameters);
}
}
