package com.cosylab.gui.components.ledder;

import java.awt.Color;
import java.awt.Component;
import java.awt.Graphics;

import javax.swing.border.BevelBorder;

/*Custom border is extended from BebelBorder and overides the 
 * paintRaisedBevel method for optimal displaying leds
 */

public class CustomBorder extends BevelBorder {
	
	private boolean visible=true;

	public CustomBorder(){
		super(RAISED);
	}
	
	protected void paintRaisedBevel(Component c, Graphics g, int x, int y,
		                            int width, int height) {
		 if (visible) {
			 super.paintRaisedBevel(c,g,x,y,width,height);
		 }
	}

	/**
	 * @return Returns the visible.
	 */
	public boolean isVisible() {
		return visible;
	}

	/**
	 * @param visible The visible to set.
	 */
	public void setVisible(boolean visible) {
		
		this.visible = visible;
	}
	
	
}
