/*
 * @@COPYRIGHT@@
 */
package com.cosylab.gui.components.numberfield;


/**
 * This is the implementation of the <code>AbstractNumberDocument</code> class
 * implementing the integer parser.
 * 
 * @author <a href="mailto:ales.pucelj@cosylab.com">Ales Pucelj</a>
 * @version $id$
 */
public class IntegerDocument extends AbstractNumberDocument {

	/**
	 * Constructor for IntegerDocument.
	 */
	public IntegerDocument() {
		super();
	}

	/**
	 * Parses the string as integer.
	 * 
	 * @param s String
	 * @return Number
	 * @see AbstractNumberDocument#parseNumber(String)
	 */
	protected Number parseNumber(String s) {
		Integer value = null;

		try {
			value = new Integer(s);

		} catch (NumberFormatException e) {
			value = null;
		}

		return value;
	}
}
