package com.cosylab.gui.components.range2;

import com.cosylab.util.PrintfFormat;

/**
 * 
 * @author <a href="mailto:jaka.bobnar@cosylab.com">Jaka Bobnar</a>
 * @version $Id: DefaultTickParameters.java,v 1.1 2007-08-29 16:48:06 jbobnar Exp $
 *
 */
public class DefaultTickParameters implements TickParameters {
	
	private int width;
	private PrintfFormat formatter;

	/**
	 * Default constructor for DefaultTickCallback (tick width is 50, format is %3.2f).
	 */
	public DefaultTickParameters()
	{
		this(50, "%3.2f");
	}

	public DefaultTickParameters(int tickWidth, String format)
	{
		width = Math.max(tickWidth, 0);
		formatter = new PrintfFormat(format);
	}

	/*
	 * (non-Javadoc)
	 * @see com.cosylab.gui.components.range2.TickParameters#measureTick(double, java.lang.String)
	 */
	public int measureTick(double position, String text)
	{
		return width;
	}
	
	/*
	 * (non-Javadoc)
	 * @see com.cosylab.gui.components.range2.TickParameters#formatNumber(double)
	 */
	public String formatNumber(double value) {
		return formatter.sprintf(value);
	}
}
