/*
 * Copyright (c) 2003 by Cosylab d.o.o.
 *
 * The full license specifying the redistribution, modification, usage and other
 * rights and obligations is included with the distribution of this project in
 * the file license.html. If the license is not included you may find a copy at
 * http://www.cosylab.com/legal/abeans_license.htm or may write to Cosylab, d.o.o.
 *
 * THIS SOFTWARE IS PROVIDED AS-IS WITHOUT WARRANTY OF ANY KIND, NOT EVEN THE
 * IMPLIED WARRANTY OF MERCHANTABILITY. THE AUTHOR OF THIS SOFTWARE, ASSUMES
 * _NO_ RESPONSIBILITY FOR ANY CONSEQUENCE RESULTING FROM THE USE, MODIFICATION,
 * OR REDISTRIBUTION OF THIS SOFTWARE.
 */

package com.cosylab.gui.components.range2;

/**
 * Helper class for the Ticks class. Tick contains information about individual
 * tick that is rendered on the scale.
 *
 * @author <a href="mailto:ales.pucelj@cosylab.com">Ales Pucelj</a>
 * @version 1.0
 */
public final class Tick
{
	/** DOCUMENT ME! */
	public static final int TICKS_OFFSET_PIXELS = 20;

	// Value in range [0..1] indicating the position of the tick on the scale

	/** DOCUMENT ME! */
	public double proportional = 0;

	/** DOCUMENT ME! */
	public double absolute = 0;

	// If true, the tick will be rendered longer

	/** DOCUMENT ME! */
	public boolean major = false;

	// Text to be displayed for this tick.
	// Text is only displayed if major == true.

	/** DOCUMENT ME! */
	public String text = null;

	/**
	 * Constructs new Tick
	 *
	 * @param proportional
	 * @param major
	 */
	public Tick(double absolute, double proportional, boolean major)
	{
		this.absolute= absolute;
		this.proportional = proportional;
		this.major = major;
		this.text = null;
	}

	/**
	 * Constructs new Tick
	 *
	 * @param proportional
	 * @param major
	 * @param text
	 */
	public Tick(double absolute, double proportional, boolean major, String text)
	{
		this.absolute= absolute;
		this.proportional = proportional;
		this.major = major;
		this.text = text;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	public String toString()
	{
		StringBuffer sb = new StringBuffer();
		sb.append("Tick = { text='");
		sb.append(text);
		sb.append("' major='");
		sb.append(major);
		sb.append("' prop='");
		sb.append(proportional);
		sb.append("' }");

		return sb.toString();
	}
}

/* __oOo__ */
