/*
 * Copyright (c) 2003 by Cosylab d.o.o.
 *
 * The full license specifying the redistribution, modification, usage and other
 * rights and obligations is included with the distribution of this project in
 * the file license.html. If the license is not included you may find a copy at
 * http://www.cosylab.com/legal/abeans_license.htm or may write to Cosylab, d.o.o.
 *
 * THIS SOFTWARE IS PROVIDED AS-IS WITHOUT WARRANTY OF ANY KIND, NOT EVEN THE
 * IMPLIED WARRANTY OF MERCHANTABILITY. THE AUTHOR OF THIS SOFTWARE, ASSUMES
 * _NO_ RESPONSIBILITY FOR ANY CONSEQUENCE RESULTING FROM THE USE, MODIFICATION,
 * OR REDISTRIBUTION OF THIS SOFTWARE.
 */

package com.cosylab.gui.components.range2;

/**
 * Defines callback interface that is called when determining optimal tick
 * position.
 *
 * @author <a href="mailto:ales.pucelj@cosylab.com">Ales Pucelj</a>
 * @version $id$
 */
public interface TickParameters
{
	/**
	 * Returns size of tick label in pixels. Size is determined as distance
	 * between maximum extent of the label along the tick axis.
	 *
	 * @param position relative position of the tick on 0..1.
	 * @param text label to display, may be empty string or null.
	 *
	 * @return size of tick in pixels.
	 */
	int measureTick(double position, String text);
	
	
	/**
	 * Formats the input value to a specific print format. If return value
	 * is null use internal format specified by the caller of this method.
	 * 
	 * @param value double to be formatted
	 * @return formatted value
	 */
	String formatNumber(double value);
}

/* __oOo__ */
