package com.cosylab.gui.components.table;

public class DefaultRowComparator implements RowComparator {

	int column = 0;
	boolean descending;

	/**
							 *
							 */
	public DefaultRowComparator(int col, boolean desc)
	{
		column = col;
		descending = desc;
	}

	/* (non-Javadoc)
	 * @see java.util.Comparator#compare(java.lang.Object, java.lang.Object)
	 */
	public int compare(Object o1, Object o2)
	{
		if ((o1 instanceof TableRow) && (o2 instanceof TableRow)) {
			TableRow r1 = (TableRow)o1;
			TableRow r2 = (TableRow)o2;

			if (descending) {
				return r2.compareTo(r1, column);
			}

			return r1.compareTo(r2, column);
		}

		return 0;
	}
	
	public void setColumn(int column) {
		this.column = column;
	}

	public void setDescending(boolean descending) {
		this.descending = descending;
	}

	public int getColumn() {
		return column;
	}

	public boolean getDescending() {
		return descending;
	}

}
