/*
 * Copyright (c) 2003 by Cosylab d.o.o.
 *
 * The full license specifying the redistribution, modification, usage and other
 * rights and obligations is included with the distribution of this project in
 * the file license.html. If the license is not included you may find a copy at
 * http://www.cosylab.com/legal/abeans_license.htm or may write to Cosylab, d.o.o.
 *
 * THIS SOFTWARE IS PROVIDED AS-IS WITHOUT WARRANTY OF ANY KIND, NOT EVEN THE
 * IMPLIED WARRANTY OF MERCHANTABILITY. THE AUTHOR OF THIS SOFTWARE, ASSUMES
 * _NO_ RESPONSIBILITY FOR ANY CONSEQUENCE RESULTING FROM THE USE, MODIFICATION,
 * OR REDISTRIBUTION OF THIS SOFTWARE.
 */

package com.cosylab.gui.components.table;

/**
 * <code>TableRowModelListener</code> is listener which is notifyied about
 * changes in <code>TableRowModel</code>.
 *
 * @author <a href="mailto:igor.kriznar@cosylab.com">Igor Kriznar</a>
 * @version $Id: TableRowModelListener.java,v 1.1 2004/06/28 02:03:29 ikriznar Exp $
 *
 * @since May 3, 2004.
 */
public interface TableRowModelListener
{
	/**
	 * Called when change occured in <code>TableRowModel</code>
	 *
	 * @param event an event with change information
	 */
	public void tableChanged(TableRowModelEvent event);
}

/* __oOo__ */
