/*
 * Copyright (c) 2004 by Cosylab d.o.o.
 *
 * The full license specifying the redistribution, modification, usage and other
 * rights and obligations is included with the distribution of this project in
 * the file license.html. If the license is not included you may find a copy at
 * http://www.cosylab.com/legal/abeans_license.htm or may write to Cosylab, d.o.o.
 *
 * THIS SOFTWARE IS PROVIDED AS-IS WITHOUT WARRANTY OF ANY KIND, NOT EVEN THE
 * IMPLIED WARRANTY OF MERCHANTABILITY. THE AUTHOR OF THIS SOFTWARE, ASSUMES
 * _NO_ RESPONSIBILITY FOR ANY CONSEQUENCE RESULTING FROM THE USE, MODIFICATION,
 * OR REDISTRIBUTION OF THIS SOFTWARE.
 */

package com.cosylab.gui.components.table.cells;

/**
 * Command is interface for wraper aroud action, whcih can be performed with
 * arbitrary table cell. Calling <code>execute</code> on cell directly
 * executes the action.
 *
 * @author <a href="mailto:igor.kriznar@cosylab.com">Igor Kriznar</a>
 * @version $id$
 */
public interface Command
{
	public String getName();
	/**
	 * Executes by this command 
	 *
	 * @param originator the table cell, from which command was on which command was executed
	 *
	 * @throws CommandException DOCUMENT ME!
	 */
	public void execute(TableCell originator) throws CommandException;
}

/* __oOo__ */
