/*
 * Copyright (c) 2004 by Cosylab d.o.o.
 *
 * The full license specifying the redistribution, modification, usage and other
 * rights and obligations is included with the distribution of this project in
 * the file license.html. If the license is not included you may find a copy at
 * http://www.cosylab.com/legal/abeans_license.htm or may write to Cosylab, d.o.o.
 *
 * THIS SOFTWARE IS PROVIDED AS-IS WITHOUT WARRANTY OF ANY KIND, NOT EVEN THE
 * IMPLIED WARRANTY OF MERCHANTABILITY. THE AUTHOR OF THIS SOFTWARE, ASSUMES
 * _NO_ RESPONSIBILITY FOR ANY CONSEQUENCE RESULTING FROM THE USE, MODIFICATION,
 * OR REDISTRIBUTION OF THIS SOFTWARE.
 */

package com.cosylab.gui.components.table.cells;

import com.cosylab.util.CommonException;


/**
 * description
 *
 * @author <a href="mailto:igor.kriznar@cosylab.com">Igor Kriznar</a>
 * @version $id$
 */
public class CommandException extends CommonException
{
	private Command command;

	/**
	 * CommandException constructor comment.
	 *
	 * @param instance cell which generated exception
	 * @param c command
	 * @param message exception message
	 * @param cause cause
	 */
	public CommandException(TableCell instance, Command c, String message,
	    Throwable cause)
	{
		super(instance, message, cause);
		command = c;
	}

	/**
	 * Return command.
	 *
	 * @return command
	 */
	public Command getCommand()
	{
		return command;
	}

	/**
	 * DOCUMENT ME!
	 *
	 * @return DOCUMENT ME!
	 */
	public TableCell getTableCell()
	{
		return (TableCell)getInstance();
	}
}

/* __oOo__ */
