/*
 * Copyright (c) 2004 by Cosylab d.o.o.
 *
 * The full license specifying the redistribution, modification, usage and other
 * rights and obligations is included with the distribution of this project in
 * the file license.html. If the license is not included you may find a copy at
 * http://www.cosylab.com/legal/abeans_license.htm or may write to Cosylab, d.o.o.
 *
 * THIS SOFTWARE IS PROVIDED AS-IS WITHOUT WARRANTY OF ANY KIND, NOT EVEN THE
 * IMPLIED WARRANTY OF MERCHANTABILITY. THE AUTHOR OF THIS SOFTWARE, ASSUMES
 * _NO_ RESPONSIBILITY FOR ANY CONSEQUENCE RESULTING FROM THE USE, MODIFICATION,
 * OR REDISTRIBUTION OF THIS SOFTWARE.
 */

package com.cosylab.gui.components.table.cells;

import com.cosylab.util.NumericStringComparator;

/**
 * DeviceCell holds place for device: an entitiy providion identifier and
 * possibly commands.
 *
 * @author <a href="mailto:igor.kriznar@cosylab.com">Igor Kriznar</a>
 */
public class DeviceCell extends TableCell
{
	
	private boolean highlightCell;
	
	/**
		 *
		 */
	public DeviceCell()
	{
		super();
	}

	/**
	 * DOCUMENT ME!
	 *
	 * @param identifier
	 * @param dataSource
	 * @param value
	 * @param commands
	 */
	public DeviceCell(String identifier, Object dataSource, Object value,
	    Command[] commands)
	{
		super(identifier, dataSource, value, commands);
	}

	/**
	 * Returns identifier.
	 *
	 * @see com.cosylab.gui.components.table.cells.TableCell#toString()
	 */
	public String toString()
	{
		return getIdentifier();
	}

	NumericStringComparator numericStringComparator = new NumericStringComparator();

	/* (non-Javadoc)
	 * @see com.cosylab.gui.components.table.cells.TableCell#compareTo(java.lang.Object)
	 */
	public int compareTo(Object o)
	{
		if (o instanceof DeviceCell) {
			return numericStringComparator.compare(getIdentifier(),((DeviceCell)o).getIdentifier());
		}

		return super.compareTo(o);
	}

	public boolean isHighlightCell() {
		return highlightCell;
	}

	public void setHighlightCell(boolean cellSelected) {
		this.highlightCell = cellSelected;
	}
}

/* __oOo__ */
