/*
 * Copyright (c) 2004 by Cosylab d.o.o.
 *
 * The full license specifying the redistribution, modification, usage and other
 * rights and obligations is included with the distribution of this project in
 * the file license.html. If the license is not included you may find a copy at
 * http://www.cosylab.com/legal/abeans_license.htm or may write to Cosylab, d.o.o.
 *
 * THIS SOFTWARE IS PROVIDED AS-IS WITHOUT WARRANTY OF ANY KIND, NOT EVEN THE
 * IMPLIED WARRANTY OF MERCHANTABILITY. THE AUTHOR OF THIS SOFTWARE, ASSUMES
 * _NO_ RESPONSIBILITY FOR ANY CONSEQUENCE RESULTING FROM THE USE, MODIFICATION,
 * OR REDISTRIBUTION OF THIS SOFTWARE.
 */

package com.cosylab.gui.components.table.cells;

/**
 * DobubleCell holds double value.
 *
 * @author <a href="mailto:igor.kriznar@cosylab.com">Igor Kriznar</a>
 * @version $id$
 */
public class DoubleCell extends NumericCell
{
	/**
		 *
		 */
	public DoubleCell()
	{
		super();
		//setting default value to avoid null pointer
		setDoubleValue(0.0);
	}

	/**
	 * DOCUMENT ME!
	 *
	 * @param identifier
	 * @param dataSource
	 * @param value
	 * @param commands
	 */
	public DoubleCell(String identifier, Object dataSource, double value,
	    Command[] commands)
	{
		super(identifier, dataSource, new Double(value), commands);
	}

	/**
				 *
				 */
	public double getDoubleValue()
	{
		return ((Number)value).doubleValue();
	}

	/**
				 *
				 */
	public void setDoubleValue(double value)
	{
		setValue(new Double(value));
	}
	
}

/* __oOo__ */
