/*
 * Copyright (c) 2004 by Cosylab d.o.o.
 *
 * The full license specifying the redistribution, modification, usage and other
 * rights and obligations is included with the distribution of this project in
 * the file license.html. If the license is not included you may find a copy at
 * http://www.cosylab.com/legal/abeans_license.htm or may write to Cosylab, d.o.o.
 *
 * THIS SOFTWARE IS PROVIDED AS-IS WITHOUT WARRANTY OF ANY KIND, NOT EVEN THE
 * IMPLIED WARRANTY OF MERCHANTABILITY. THE AUTHOR OF THIS SOFTWARE, ASSUMES
 * _NO_ RESPONSIBILITY FOR ANY CONSEQUENCE RESULTING FROM THE USE, MODIFICATION,
 * OR REDISTRIBUTION OF THIS SOFTWARE.
 */

/*
 * Created on Apr 16, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package com.cosylab.gui.components.table.renderers;

import com.cosylab.gui.components.table.cells.LongEnumCell;

import javax.swing.AbstractListModel;
import javax.swing.ComboBoxModel;


class EnumComboBoxModel extends AbstractListModel implements ComboBoxModel
{
	LongEnumCell cell;
	int min = -1;
	int max = 0;
	String selected;

	/**
			 *
			 */
	public EnumComboBoxModel()
	{
		super();
	}

	/* (non-Javadoc)
	 * @see javax.swing.ListModel#getElementAt(int)
	 */
	public Object getElementAt(int index)
	{
		if (cell == null) {
			return null;
		}

		return cell.getStateLabel(index - min);
	}

	/* (non-Javadoc)
	 * @see javax.swing.ListModel#getSize()
	 */
	public int getSize()
	{
		return max - min + 1;
	}

	/* (non-Javadoc)
	 * @see javax.swing.ComboBoxModel#getSelectedItem()
	 */
	public Object getSelectedItem()
	{
		return selected;
	}

	/* (non-Javadoc)
	 * @see javax.swing.ComboBoxModel#setSelectedItem(java.lang.Object)
	 */
	public void setSelectedItem(Object anItem)
	{
		selected = (String)anItem;
	}

	/**
	 * DOCUMENT ME!
	 *
	 * @param c DOCUMENT ME!
	 */
	public void setCell(LongEnumCell c)
	{
		cell = c;
		selected = null;

		int size = getSize();
		max = 0;
		min = -1;

		if (size > 0) {
			fireIntervalRemoved(this, 0, size);
		}

		if (cell == null) {
			return;
		}

		min = 15;
		max = 0;

		for (int i = 0; i < 16; i++) {
			Object o = cell.getCharacteristic(LongEnumCell.STATE_DESCRIPTION
				    + i);

			if (o !=null ) {
				if (i < min) {
					min = i;
				}

				if (i > max) {
					max = i;
				}
			}
		}

		fireIntervalAdded(this, 0, getSize());
	}

	/**
	 * DOCUMENT ME!
	 *
	 * @return DOCUMENT ME!
	 */
	public Long getLongVale()
	{
		if (selected == null || cell == null) {
			return null;
		}

		return new Long(cell.toLongValue(selected));
	}
}

/* __oOo__ */
