/*
 * Copyright (c) 2004 by Cosylab d.o.o.
 *
 * The full license specifying the redistribution, modification, usage and other
 * rights and obligations is included with the distribution of this project in
 * the file license.html. If the license is not included you may find a copy at
 * http://www.cosylab.com/legal/abeans_license.htm or may write to Cosylab, d.o.o.
 *
 * THIS SOFTWARE IS PROVIDED AS-IS WITHOUT WARRANTY OF ANY KIND, NOT EVEN THE
 * IMPLIED WARRANTY OF MERCHANTABILITY. THE AUTHOR OF THIS SOFTWARE, ASSUMES
 * _NO_ RESPONSIBILITY FOR ANY CONSEQUENCE RESULTING FROM THE USE, MODIFICATION,
 * OR REDISTRIBUTION OF THIS SOFTWARE.
 */

package com.cosylab.gui.components.table.renderers;

import com.cosylab.gui.components.table.cells.LongEnumCell;

import java.awt.Component;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

import javax.swing.DefaultCellEditor;
import javax.swing.JComboBox;
import javax.swing.JTable;


/**
 * <code>DiamondStatusCellEditor</code> ...  DOCUMENT ME!
 *
 * @author <a href="mailto:jernej.kamenik@cosylab.com">Jernej Kamenik</a>
 * @version $Id: LongEnumCellEditor.java,v 1.3 2005/11/17 12:34:25 mslenc Exp $
 *
 * @since May 8, 2004.
 */
public class LongEnumCellEditor extends DefaultCellEditor
{
	EnumComboBoxModel comboModel;

	/**
	 * Creates a new DiamondStatusCellEditor object.
	 */
	public LongEnumCellEditor()
	{
		super(new JComboBox(new EnumComboBoxModel()));
		
		getComponent().addMouseListener(new MouseListener() {
			public void mouseClicked(MouseEvent e) {
			}

			public void mouseEntered(MouseEvent e) {
			}

			public void mouseExited(MouseEvent e) {
				cancelCellEditing();
			}

			public void mousePressed(MouseEvent e) {
			}

			public void mouseReleased(MouseEvent e) {
			}
		});
	}

	/* (non-Javadoc)
	 * @see javax.swing.DefaultCellEditor#getTableCellEditorComponent(javax.swing.JTable, java.lang.Object, boolean, int, int)
	 */
	public Component getTableCellEditorComponent(JTable table, Object value,
	    boolean isSelected, int row, int column)
	{
		JComboBox box = (JComboBox)super.getTableCellEditorComponent(table,
			    value, isSelected, row, column);

		if (comboModel == null) {
			comboModel = (EnumComboBoxModel)box.getModel();
		}

		if (value instanceof LongEnumCell) {
			LongEnumCell cell = (LongEnumCell)value;
			comboModel.setCell(cell);
		} else {
			comboModel.setCell(null);
		}

		return box;
	}

	/* (non-Javadoc)
	 * @see javax.swing.DefaultCellEditor#getCellEditorValue()
	 */
	public Object getCellEditorValue()
	{
		return comboModel.getLongVale();
	}
}

/* __oOo__ */
