/*
 * Copyright (c) 2004 by Cosylab d.o.o.
 *
 * The full license specifying the redistribution, modification, usage and other
 * rights and obligations is included with the distribution of this project in
 * the file license.html. If the license is not included you may find a copy at
 * http://www.cosylab.com/legal/abeans_license.htm or may write to Cosylab, d.o.o.
 *
 * THIS SOFTWARE IS PROVIDED AS-IS WITHOUT WARRANTY OF ANY KIND, NOT EVEN THE
 * IMPLIED WARRANTY OF MERCHANTABILITY. THE AUTHOR OF THIS SOFTWARE, ASSUMES
 * _NO_ RESPONSIBILITY FOR ANY CONSEQUENCE RESULTING FROM THE USE, MODIFICATION,
 * OR REDISTRIBUTION OF THIS SOFTWARE.
 */

package com.cosylab.gui.components.table.renderers;

import com.cosylab.gui.components.table.cells.LongEnumCell;

import java.awt.Component;

import javax.swing.JTable;


/**
 * Default table renderer for LongEnumCell. Displays enum state description.
 *
 * @author <a href="mailto:igor.kriznar@cosylab.com">Igor Kriznar</a>
 * @version $id$
 */
public class LongEnumCellRenderer extends DefaultTableCellRenderer
{
	/**
		 *
		 */
	public LongEnumCellRenderer()
	{
		super();
	}

	/**
	 * Creates a new LongEnumCellRenderer object.
	 *
	 * @param decorateBorder DOCUMENT ME!
	 * @param decorateBackground DOCUMENT ME!
	 */
	public LongEnumCellRenderer(boolean decorateBorder,
	    boolean decorateBackground)
	{
		super(decorateBorder, decorateBackground);
	}

	/**
	 * description
	 *
	 * @see javax.swing.table.TableCellRenderer#getTableCellRendererComponent(JTable,
	 *      Object, boolean, boolean, int, int)
	 */
	public Component getTableCellRendererComponent(JTable table, Object cell,
	    boolean isSelected, boolean hasFocus, int row, int column)
	{
		super.getTableCellRendererComponent(table, cell, isSelected, hasFocus,
		    row, column);

		if (cell instanceof LongEnumCell) {
			LongEnumCell property = (LongEnumCell)cell;

			if (property.isSuspended()) {
				setText("");
			} else {
				long l = property.getLongValue();
				String s = property.getStateDescription(l);

				if (s == null) {
					StringBuffer sb = new StringBuffer(8);
					sb.append('<');
					sb.append(l);
					sb.append('>');
					s = sb.toString();
				}

				setText(s);
			}
		}

		return this;
	}
}

/* __oOo__ */
