/*
 * @@COPYRIGHT@@
 */
package com.cosylab.gui.components.util;

import java.awt.Dimension;
import java.awt.Toolkit;
import java.awt.Window;

/**
 * This is a convenience class with static methods used to position graphic components 
 * on screen.
 * 
 * @author <a href="mailto:miha.kadunc@cosylab.com">Miha Kadunc</a>
 * @version $id$
 */

public class ComponentPositioner {
	
	/**
	 * Centers a window in the middle of the screen. Screen size is queried from the 
	 * AWT Toolkit. The window is centered by calling its <code>setLocation</code> function.
	 * 
	 * @param w the window to be centered
	 */
	public static void centerOnScreen(Window w)
	{
		Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
		Dimension size = w.getSize();
		w.setLocation(screenSize.width / 2 - size.width / 2, screenSize.height / 2 - size.height / 2);
	}
}

