package com.cosylab.gui.components.util;
import java.awt.Image;
import java.awt.datatransfer.DataFlavor;
import java.awt.datatransfer.Transferable;

import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.TransferHandler;


public class ImageClipboardHelper extends TransferHandler implements Transferable {
   
    private static final DataFlavor[] flavors = { DataFlavor.imageFlavor };
    private Image image;

    
    /**
     * we need to define action copy , because we are copying image to sys. clipboard
     */
    public int getSourceActions(JComponent c) {
        return TransferHandler.COPY;
    }

   

    public Transferable createTransferable(JComponent comp) {
        image = null;

        Icon icon = null;

        if (comp instanceof JLabel) {
            JLabel label = (JLabel) comp;
            icon = label.getIcon();
        } 
        if (icon instanceof ImageIcon) {
            image = ((ImageIcon) icon).getImage();

            return this;
        }

        return null;
    }

    
    // Transferable
    public Object getTransferData(DataFlavor flavor) {
        if (isDataFlavorSupported(flavor)) {
            return image;
        }

        return null;
    }

    public DataFlavor[] getTransferDataFlavors() {
        return flavors;
    }

    public boolean isDataFlavorSupported(DataFlavor flavor) {
        return flavor.equals(flavors[0]);
    }
}
