/*
 * @@COPYRIGHT@@
 */
package com.cosylab.gui.components.util;

import java.awt.Container;
import java.awt.Window;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import javax.swing.JFrame;


/**
 * 
 * 
 * @author <a href="mailto:miha.kadunc@cosylab.com">Miha Kadunc</a>
 * @version $id$
 */
public class RunnerHelper {

  public static void runFrame(Window frame, int width, int height) {
    try {
      frame.setSize(width, height);
      frame.addWindowListener(new WindowAdapter() {
        /**
         * @see java.awt.event.WindowAdapter#windowClosing(WindowEvent)
         */
        public void windowClosing(WindowEvent e) {
          super.windowClosing(e);
          System.exit(0);
        }
      });
      ComponentPositioner.centerOnScreen(frame);
      frame.show();
    } catch (Exception e) {
      System.out.println(">>> Exception in main");
      e.printStackTrace();
    }
  }

  public static void runComponent(Container c, int width, int height) {
    try {

      JFrame frame = new JFrame(c.getName());
      frame.setContentPane(c);
      int w = width + frame.getInsets().left + frame.getInsets().right;
      int h = height + frame.getInsets().bottom + frame.getInsets().top;
      runFrame(frame, w, h);
    } catch (Exception e) {
      System.out.println(">>> Exception in main");
      e.printStackTrace();
    }
  }

}
