package com.cosylab.gui.displayers;

import java.beans.PropertyVetoException;

import com.cosylab.gui.adapters.Converter;

/**
 * <code>ConvertibleDisplayer</code> enables usage of Converters. It should be implemented by those 
 * DataConsumers that needs to convert the value they are receiveing from data source.
 * 
 * @author Jaka Bobnar, Cosylab
 *
 */
public interface ConvertibleDisplayer extends Displayer {
	
	public static String CONVERTER_PROPERTY="converter";
	
	/**
	 * Sets the Converter that is used when displaying value with this.
	 * 
	 * @param converter
	 */
	public void setConverter(Converter converter) throws PropertyVetoException;
	
	/**
	 * Returns the converter that is used with the displayer.
	 * 
	 * @return
	 */
	public Converter getConverter();
	
}


/* __oOo__ */