/*
 * Copyright (c) 2003 by Cosylab d.o.o.
 *
 * The full license specifying the redistribution, modification, usage and other
 * rights and obligations is included with the distribution of this project in
 * the file license.html. If the license is not included you may find a copy at
 * http://www.cosylab.com/legal/abeans_license.htm or may write to Cosylab, d.o.o.
 *
 * THIS SOFTWARE IS PROVIDED AS-IS WITHOUT WARRANTY OF ANY KIND, NOT EVEN THE
 * IMPLIED WARRANTY OF MERCHANTABILITY. THE AUTHOR OF THIS SOFTWARE, ASSUMES
 * _NO_ RESPONSIBILITY FOR ANY CONSEQUENCE RESULTING FROM THE USE, MODIFICATION,
 * OR REDISTRIBUTION OF THIS SOFTWARE.
 */

package com.cosylab.gui.displayers;

/**
 * A specialization of <code>Displayer</code> interface for enumerations.
 *
 * @author Jernej Kamenik
 * @version $id$
 */
public interface EnumDisplayer extends Displayer, ObjectConsumer
{
	/**
	 * Sets the range of all possible values to be displayed by this displayer.
	 *
	 * @param values
	 */
	public void setValues(Object[] values);

	/**
	 * Selects the value to be displayed
	 *
	 * @param value
	 */
	public void setValue(Object value);

	/**
	 * Return the displayed value
	 *
	 * @return the displayed value
	 */
	public Object getValue();
}

/* __oOo__ */
