/*
 * Copyright (c) 2003 by Cosylab d.o.o.
 *
 * The full license specifying the redistribution, modification, usage and other
 * rights and obligations is included with the distribution of this project in
 * the file license.html. If the license is not included you may find a copy at
 * http://www.cosylab.com/legal/abeans_license.htm or may write to Cosylab, d.o.o.
 *
 * THIS SOFTWARE IS PROVIDED AS-IS WITHOUT WARRANTY OF ANY KIND, NOT EVEN THE
 * IMPLIED WARRANTY OF MERCHANTABILITY. THE AUTHOR OF THIS SOFTWARE, ASSUMES
 * _NO_ RESPONSIBILITY FOR ANY CONSEQUENCE RESULTING FROM THE USE, MODIFICATION,
 * OR REDISTRIBUTION OF THIS SOFTWARE.
 */

package com.cosylab.gui.displayers;

/**
 * A specialization of the <code>Displayer</code> interface for
 * <code>String</code> Java type. The same adapter can be used to display
 * <code>Object</code> as well, via the <code>toString()</code> method.
 *
 * @author <a href="mailto:igor.kriznar@cosylab.com">Igor Kriznar</a>
 * @version $id$
 * 
 */
public interface StringDisplayer extends Displayer, StringConsumer
{
	/**
	 * Gets the value displayed by the displayer. This method can be invoked by
	 * any object and will probably most often be invoked by the GUI rendition
	 * code.
	 *
	 * @return String currently displayed value
	 */
	public String getValue();

	/**
	 * Sets the value displayed by the displayer. This method may be invoked
	 * only by the adapter delivering a new value from the modeling layer.
	 *
	 * @param value new value to be displayed
	 */
	void setValue(String value);
}

/* __oOo__ */
