/*
 * Copyright (c) 2003 by Cosylab d.o.o.
 *
 * The full license specifying the redistribution, modification, usage and other
 * rights and obligations is included with the distribution of this project in
 * the file license.html. If the license is not included you may find a copy at
 * http://www.cosylab.com/legal/abeans_license.htm or may write to Cosylab, d.o.o.
 *
 * THIS SOFTWARE IS PROVIDED AS-IS WITHOUT WARRANTY OF ANY KIND, NOT EVEN THE
 * IMPLIED WARRANTY OF MERCHANTABILITY. THE AUTHOR OF THIS SOFTWARE, ASSUMES
 * _NO_ RESPONSIBILITY FOR ANY CONSEQUENCE RESULTING FROM THE USE, MODIFICATION,
 * OR REDISTRIBUTION OF THIS SOFTWARE.
 */

package com.cosylab.gui.displayers;

/**
 * <code>UpdateRequestListener</code> receives response for asynchronous update
 * request.
 *
 * @author <a href="mailto:igor.kriznar@cosylab.com">Igor Kriznar</a>
 * @version $Id: UpdateRequestListener.java,v 1.1 2004/06/28 03:59:33 ikriznar Exp $
 *
 * @since Dec 3, 2003.
 */
public interface UpdateRequestListener
{
	/**
	 * This event hook is called by <code>AsynchronousNumberConsumer</code>
	 * when receives response for update request.
	 *
	 * @param request the request which originated the respons
	 * @param successful <code>true</code> if update was succesful
	 * @param exception the exceptionthat was thrown upon uncussesful update
	 */
	public void replay(UpdateRequest request, boolean success,
	    Exception exception);
}

/* __oOo__ */
