package com.cosylab.gui.infopanel;

import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.util.Date;

import javax.swing.JLabel;
import javax.swing.JPanel;

import com.cosylab.gui.displayers.DataState;

public class DebugPanel extends JPanel {
		
	private static final long serialVersionUID = -1976156943972439878L;
	private DataState dataState;
	
	private JLabel stateLabel;
	private JLabel errorLabel;
	private JLabel timeLabel;
	
	private JLabel state;
	private JLabel error;
	private JLabel time;
	
	public DebugPanel() {
		super();
		initialize();
	}
	
	private void initialize() {
		this.setLayout(new GridBagLayout());
		stateLabel = new JLabel("State: ");
		stateLabel.setMaximumSize(new Dimension(100,21));
		stateLabel.setMinimumSize(new Dimension(100,21));
		stateLabel.setPreferredSize(new Dimension(100,21));
		this.add(stateLabel, new GridBagConstraints(0,0,1,1,0,0,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(11,11,1,1),0,0));
		state = new JLabel();
		this.add(state, new GridBagConstraints(1,0,1,1,1,0,GridBagConstraints.WEST, GridBagConstraints.BOTH, new Insets(11,1,1,11),0,0));
		
		errorLabel = new JLabel("Description: ");
		errorLabel.setMaximumSize(new Dimension(100,21));
		errorLabel.setMinimumSize(new Dimension(100,21));
		errorLabel.setPreferredSize(new Dimension(100,21));
		this.add(errorLabel, new GridBagConstraints(0,1,1,1,0,0,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(1,11,1,1),0,0));
		error = new JLabel();
		this.add(error, new GridBagConstraints(1,1,1,1,1,0,GridBagConstraints.WEST, GridBagConstraints.BOTH, new Insets(1,1,1,11),0,0));

		timeLabel = new JLabel("Time: ");
		timeLabel.setMaximumSize(new Dimension(100,21));
		timeLabel.setMinimumSize(new Dimension(100,21));
		timeLabel.setPreferredSize(new Dimension(100,21));
		this.add(timeLabel, new GridBagConstraints(0,2,1,1,0,0,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(1,11,11,1),0,0));
		time = new JLabel();
		this.add(time, new GridBagConstraints(1,2,1,1,1,0,GridBagConstraints.WEST, GridBagConstraints.BOTH, new Insets(1,1,11,11),0,0));
	}
	
	public void setDataState(DataState dataState) {
		this.dataState = dataState;
		if (this.dataState != null) {
			state.setText(dataState.type);
			error.setText(dataState.description);
			time.setText(String.valueOf(new Date(dataState.timestamp)));
		} else {
			state.setText("< NONE >");
			error.setText("< NONE >");
			time.setText(String.valueOf(new Date(System.currentTimeMillis())));
		}
		
	}
	
	public DataState getDataState() {
		return dataState;
	}
	
}