/*
 * @@COPYRIGHT@@
 */
package com.cosylab.gui.property.editors;

import com.cosylab.gui.components.numberfield.LongDocument;

/**
 * description
 * 
 * @author <a href="mailto:ales.pucelj@cosylab.com">Ales Pucelj</a> 
 * @version $id$
 */
public class LongEditor extends NumberEditor {
    /**
     * 
     */
	public LongEditor() {
		super(new LongDocument());
		setValue(new Long(0));
	}
    
    /* (non-Javadoc)
     * @see com.cosylab.gui.property.editors.NumberEditor#getPropertyValue()
     */
    public Object getPropertyValue() {
        Number val=getValue();
        if (val==null) return null;
        return new Long(val.longValue());
    }
    /* (non-Javadoc)
     * @see com.cosylab.gui.property.editors.NumberEditor#setValue(java.lang.Number)
     */
    public void setValue(Number newValue) {
        Number oldValue=getValue();
        setText(newValue==null?"":String.valueOf(newValue.longValue()));
        revalidate();
        if (oldValue==null && newValue==null) return;
        if ((newValue==null || oldValue==null) || !(newValue.longValue()==oldValue.longValue())) {
            firePropertyChange(PROPERTY_VALUE_NAME,oldValue,newValue);
        }
    }
}
