/*
 * @@COPYRIGHT@@
 */
package com.cosylab.gui.property.editors;

import javax.swing.JTextField;


/**
 * description
 * 
 * @author <a href="mailto:ales.pucelj@cosylab.com">Ales Pucelj</a> 
 * @version $id$
 */
public class StringEditor extends JTextField implements PropertyEditor {

	private boolean nullAllowed = false;

    /**
	 * Constructor for StringEditor.
	 */
	public StringEditor() {
		super();
	}

	/**
	 * @see PropertyEditor#getValue()
	 */
	public Object getPropertyValue() {
        String ret=getText();
        if (ret==null && !nullAllowed) {
            ret="";
        }
        if (ret=="" && nullAllowed) {
            ret=null;
        }
		return ret; 
	}

	/**
	 * @see PropertyEditor#setValue(Object)
	 */
	public boolean setPropertyValue(Object value) {
		String old=getText();
		if (value == null) {
			setText("");
		} else {
		    setText(String.valueOf(value));
        }
		if (!(old==null && value==null) && (old==null && old.equals(value))){
			firePropertyChange(PROPERTY_VALUE_NAME,old,value);
		}
		return true;
	}

	/**
	 * @see PropertyEditor#getDescription()
	 */
	public String getDescription() {
		return null;
	}

	/**
	 * @see PropertyEditor#setDescription(String)
	 */
	public void setDescription(String description) {
	}

	/**
	 * @see PropertyEditor#getEditor()
	 */
	public PropertyEditor getEditor() {
		return null;
	}

    public boolean isNullAllowed() {
        return nullAllowed;
    }

    public void setNullAllowed(boolean allow) {
        this.nullAllowed=allow;
    }

}
