
package com.cosylab.gui.util;

import java.awt.datatransfer.DataFlavor;

import javax.swing.JComponent;

import com.cosylab.gui.displayers.Displayer;
import com.cosylab.gui.displayers.DisplayerParameters;
import com.cosylab.gui.displayers.DoubleDisplayer;

/**
 * <code>DisplayerParametersTransferHandler</code> is a TransferHandler for
 * DisplayerParametersAcceptors and MultipleParametersAcceptors.
 * 
 * @author tkusterle
 *
 */
public class DefaultDisplayerParametersTransferHandler extends AbstractDisplayerParametersTransferHandler {
	
	private static final long serialVersionUID = -4223198013311762602L;

	protected Displayer displayer;

	public DefaultDisplayerParametersTransferHandler(Displayer comp, boolean reciveEnabled, boolean exportEnabled) {
		super((JComponent)comp,reciveEnabled, exportEnabled);
		displayer= (Displayer)comp;
	}
	
	

	/**
	 * @param comp
	 * @param reciveEnabled
	 * @param exportEnabled
	 * @param f
	 * @param resetFlavors
	 */
	public DefaultDisplayerParametersTransferHandler(Displayer comp, boolean reciveEnabled, boolean exportEnabled, DataFlavor[] f, boolean resetFlavors) {
		super((JComponent)comp, reciveEnabled, exportEnabled, f, resetFlavors);
		displayer= (Displayer)comp;
	}



	protected DisplayerParameters exportDisplayerParameters() {
 		if (displayer instanceof DoubleDisplayer) {
			return new DisplayerParameters(displayer.getTitle(),(DoubleDisplayer)displayer);
		} 
 		return new DisplayerParameters(displayer.getTitle());
	}

	/**
	 * Returns the displayer.
	 * @return Returns the displayer.
	 */
	public Displayer getDisplayer() {
		return displayer;
	}	
}
