package de.desy.acop.chart.customizer;

import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.lang.reflect.Method;
import java.text.Format;
import javax.swing.JFormattedTextField;
import de.desy.acop.chart.Acop;

public class AcopJFormattedTextField extends JFormattedTextField
{
  Acop acopBean;
  String proper;
  int dataType; // integer, Double, string
  boolean checkRange;
  double lowCheck, highCheck;
  Class c;
  Object oldValue, newValue;
  public AcopJFormattedTextField()
  {
    super();
    // TODO Auto-generated constructor stub
  }
  public AcopJFormattedTextField(Object value)
  {
    super(value);
    // TODO Auto-generated constructor stub
  }
  public AcopJFormattedTextField(Format format)
  {
    super(format);
    // TODO Auto-generated constructor stub
  }
  public AcopJFormattedTextField(AbstractFormatter formatter)
  {
    super(formatter);
    // TODO Auto-generated constructor stub
  }
  public AcopJFormattedTextField(AbstractFormatterFactory factory)
  {
    super(factory);
    // TODO Auto-generated constructor stub
  }
  public AcopJFormattedTextField(AbstractFormatterFactory factory, Object currentValue)
  {
    super(factory, currentValue);
    // TODO Auto-generated constructor stub
  }
  public void setAcopBean(Acop Bean)
  {
    acopBean = Bean;
    try
    {
      Method m = acopBean.getClass().getMethod("get" + proper, null);
      oldValue = m.invoke(acopBean, null);

//      System.out.println("set Text by acopBean: " + oldValue.toString());
      
      setValue(oldValue); // set text value
      setText(oldValue.toString());
    }
    catch (Exception ex)
    {
      ex.printStackTrace();
    }
  }
  public AcopJFormattedTextField(String text, String property, Object value)
  {
    super(value);
    initAcopJFormattedTextField(text, property, value, false, 0, 0);
  }
  public AcopJFormattedTextField(String text, String property, Object value, boolean check, double low,
      double high)
  {
    super(value);
    initAcopJFormattedTextField(text, property, value, check, low, high);
  }
  public void initAcopJFormattedTextField(String text, String property, Object value, boolean check,
      double low, double high)
  {
    proper = property;
    oldValue = value;
    checkRange = check;
    this.lowCheck = low;
    this.highCheck = high;
    setName(proper);
    if (value.equals(int.class) || value.equals(short.class))
    {
      c = int.class;
      dataType = 0;
    }
    else if (value.equals(float.class) || value.equals(double.class))
    {
      c = double.class;
      dataType = 1;
    }
    else
    {
      c = String.class;
      dataType = 2;
    }
//    System.out.println("text data Type: " + dataType);
    this.addPropertyChangeListener(new PropertyChangeListener()
    {
      public void propertyChange(PropertyChangeEvent evt)
      {
        String name = evt.getPropertyName();
        if ( name.equals(proper)) {
        	return;
        }
        Object source = evt.getSource();
        newValue = ((JFormattedTextField) source).getValue();
        // amount = ((Number)amountField.getValue()).doubleValue();
        // paymentField.setValue(new Double(payment));
//        System.out.println("text changed: " + proper + "   oldValue: " + oldValue + "   value: " + newValue); // TODO
                                                                                                              // Auto-generated
                                                                                                              // Event
                                                                                                              // stub
                                                                                                              // itemStateChanged()
        if (checkRange)
        {
          double conValue = Double.valueOf(newValue.toString());
          if (conValue < lowCheck || conValue > highCheck)
          {
            setValue(oldValue); // set text value
            setText(oldValue.toString());
          }
        }
        if (acopBean != null && !newValue.equals(oldValue))
        {
          try
          {
            Method m = acopBean.getClass().getMethod("set" + proper, c);
            m.invoke(acopBean, newValue);
//            System.out.println("fire===> text changed: " + proper + "   oldValue: " + oldValue + "   value: "
//                + newValue); // TODO Auto-generated Event stub
                              // itemStateChanged()
            firePropertyChange(proper, oldValue, newValue);
            // firePropertyChange(null, null, null);
            oldValue = newValue;
          }
          catch (Exception ex)
          {
            ex.printStackTrace();
          }
        }
        // }
      }
    });
  }
}
