/*
 * Copyright (c) 2006 by Cosylab d.o.o.
 *
 * The full license specifying the redistribution, modification, usage and other
 * rights and obligations is included with the distribution of this project in
 * the file license.html. If the license is not included you may find a copy at
 * http://www.cosylab.com/legal/abeans_license.htm or may write to Cosylab, d.o.o.
 *
 * THIS SOFTWARE IS PROVIDED AS-IS WITHOUT WARRANTY OF ANY KIND, NOT EVEN THE
 * IMPLIED WARRANTY OF MERCHANTABILITY. THE AUTHOR OF THIS SOFTWARE, ASSUMES
 * _NO_ RESPONSIBILITY FOR ANY CONSEQUENCE RESULTING FROM THE USE, MODIFICATION,
 * OR REDISTRIBUTION OF THIS SOFTWARE.
 */
/**
 * 
 */
package de.desy.acop.demo;

import java.awt.BorderLayout;
import javax.swing.JPanel;
import javax.swing.JFrame;
import de.desy.acop.displayers.AcopChart;
import de.desy.acop.displayers.tools.AcopGraphParameters;
import de.desy.acop.transport.ConnectionParameters;
import de.desy.acop.transport.AccessMode;

/**
 * Acop Chart simple demo.
 * @author Igor Kriznar (igor.kriznarATcosylab.com)
 *
 */
public class AcopChartDemo extends JFrame {

	private JPanel jContentPane = null;
	private AcopChart acopChart = null;

	/**
	 * This method initializes acopChart	
	 * 	
	 * @return de.desy.acop.displayers.AcopChart	
	 */
	private AcopChart getAcopChart() {
		if (acopChart == null) {
			try {
				acopChart = new AcopChart();

				acopChart.setCaption("TINE/TEST/JWKSINE/Device 2/Sine");  // Generated
				acopChart.setDisplayerParameters(new de.desy.acop.displayers.tools.AcopGraphParameters[] {new AcopGraphParameters(new ConnectionParameters("TINE/TEST/JWKSINE/Device 2/Sine", AccessMode.POLL, 1000))});  // Generated
			} catch (java.lang.Throwable e) {
				e.printStackTrace();
			}
		}
		return acopChart;
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		AcopChartDemo d= new AcopChartDemo();
		d.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		d.setVisible(true);
	}

	/**
	 * This is the default constructor
	 */
	public AcopChartDemo() {
		super();
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(300, 200);
		this.setContentPane(getJContentPane());
		this.setTitle("JFrame");
	}

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new JPanel();
			jContentPane.setLayout(new BorderLayout());
			jContentPane.add(getAcopChart(), java.awt.BorderLayout.CENTER);  // Generated
		}
		return jContentPane;
	}

}
