package de.desy.acop.demo;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.event.MouseEvent;

import javax.swing.JPanel;

import com.cosylab.gui.components.util.RunnerHelper;

import de.desy.acop.chart.AcopDisplayMode;
import de.desy.acop.chart.AcopEvent;
import de.desy.acop.chart.AcopGraphStyleEnum;
import de.desy.acop.chart.AcopListener;
import de.desy.acop.displayers.AcopChart;
import de.desy.acop.displayers.tools.AcopGraphParameters;
import de.desy.acop.transport.AccessMode;
import de.desy.acop.transport.ConnectionParameters;

public class AcopChartDemo2 extends JPanel {

	private AcopChart chart;
	
	public AcopChartDemo2() {
		super();
		initialize();
	}
	
	private void initialize() {
		setLayout(new BorderLayout());
		add(getAcopChart(), BorderLayout.CENTER);
	}
	
	private AcopChart getAcopChart() {
		if (chart == null) {
			try {
				chart = new AcopChart();
				
				double[] yData = new double[50];
				double[] xData = new double[50];
				for (int i = 0; i < yData.length; i++) {
					yData[i] = Math.random()*100;
					xData[i] = System.currentTimeMillis()/1000 - 300 * (1. - (double)i/(yData.length-1) );
				}
				
				//set blue color
				chart.setForeground(Color.BLUE);
				
				// TODO to draw point and dots two data arrays need to be drawn
				//draw line over the data
				chart.setDisplayMode(AcopDisplayMode.PolyLine.ordinal());
				final int handle1 = chart.draw(yData, xData);
				//draw points over the data
				chart.setDisplayMode(AcopDisplayMode.Dots.ordinal());
				final int handle2 = chart.draw(yData, xData);
				
				// TODO 2. limits set here are not aligned with data on chart
				//set axis
				chart.setXMin(System.currentTimeMillis()/1000 - 300 );
				chart.setXMax(System.currentTimeMillis()/1000);				
				chart.setGraphStyle(AcopGraphStyleEnum.TimeLin.ordinal());
				
				new Thread(new Runnable(){
					public void run() {
						while(true) {
							double[] y = new double[]{Math.random()*100};
							double[] x = new double[]{System.currentTimeMillis()/1000};
							// TODO to draw point and dots two data arrays need to be drawn
							//draw line and point
							chart.appendScreen(y, handle1,x);
							chart.appendScreen(y, handle2,x);
							try {
								Thread.sleep(1000);
							} catch (InterruptedException e) {
								// TODO Auto-generated catch block
								e.printStackTrace();
							}
						}
					}
				}).start();
				
				
				chart.addAcopListener(new AcopListener(){

					public void acopMouseClick(AcopEvent click) {
						System.out.println("POS X: "+click.getMousePositionX());
						System.out.println("POS Y: " +click.getMousePositionY());
						// TODO 1. How to get data under mouse?
						System.out.println("Idx: "+click.getHistoIndex());
						
						
					}

					public void acopMouseDoubleClick(AcopEvent doubleClick) {
						// TODO Auto-generated method stub
						
					}

					public void acopMouseEnter(AcopEvent enter) {
						// TODO Auto-generated method stub
						
					}

					public void acopMouseExit(AcopEvent exit) {
						// TODO Auto-generated method stub
						
					}

					public void acopMouseMove(AcopEvent move) {
						
					}

					public void acopMousePressed(AcopEvent pressed) {
						// TODO Auto-generated method stub
						
					}

					public void acopMouseZoom(AcopEvent zoom) {
						// TODO Auto-generated method stub
						
					}

					public void acopReceive(AcopEvent receive) {
						// TODO Auto-generated method stub
						
					}
					
				});
			} catch (java.lang.Throwable e) {
				e.printStackTrace();
			}
		}
		return chart;
	}
	
	public static void main(String[] args) {
		RunnerHelper.runComponent(new AcopChartDemo2(), 600,600);
	}

}
