/*
 * Copyright (c) 2006 by Cosylab d.o.o.
 *
 * The full license specifying the redistribution, modification, usage and other
 * rights and obligations is included with the distribution of this project in
 * the file license.html. If the license is not included you may find a copy at
 * http://www.cosylab.com/legal/abeans_license.htm or may write to Cosylab, d.o.o.
 *
 * THIS SOFTWARE IS PROVIDED AS-IS WITHOUT WARRANTY OF ANY KIND, NOT EVEN THE
 * IMPLIED WARRANTY OF MERCHANTABILITY. THE AUTHOR OF THIS SOFTWARE, ASSUMES
 * _NO_ RESPONSIBILITY FOR ANY CONSEQUENCE RESULTING FROM THE USE, MODIFICATION,
 * OR REDISTRIBUTION OF THIS SOFTWARE.
 */
/**
 * 
 */
package de.desy.acop.demo;

import java.awt.BorderLayout;
import javax.swing.JPanel;
import javax.swing.JFrame;

import com.cosylab.gui.adapters.Converter;
import com.cosylab.gui.adapters.ConverterChain;
import com.cosylab.gui.adapters.MultiplierConverter;

import de.desy.acop.displayers.AcopGauger;
import de.desy.acop.displayers.AcopWheelswitch;
import java.awt.GridBagConstraints;

/**
 * @author Igor Kriznar (igor.kriznarATcosylab.com)
 *
 */
public class AcopConvertersDemo extends JFrame {

	private JPanel jContentPane = null;
	private AcopWheelswitch acopWheelswitch = null;
	private AcopGauger acopGauger = null;
	/**
	 * This method initializes acopWheelswitch	
	 * 	
	 * @return de.desy.acop.displayers.AcopWheelswitch	
	 */
	private AcopWheelswitch getAcopWheelswitch() {
		if (acopWheelswitch == null) {
			try {
				acopWheelswitch = new AcopWheelswitch();
				acopWheelswitch.setConverter(new com.cosylab.gui.adapters.ConverterChain(new com.cosylab.gui.adapters.Converter[]{new com.cosylab.gui.adapters.PotentialConverter(2.0),new com.cosylab.gui.adapters.MultiplierConverter(3.0),new com.cosylab.gui.adapters.LinearConverter(1.0,4.0)}));  // Generated
			} catch (java.lang.Throwable e) {
				e.printStackTrace();
			}
		}
		return acopWheelswitch;
	}

	/**
	 * This method initializes acopGauger	
	 * 	
	 * @return de.desy.acop.displayers.AcopGauger	
	 */
	private AcopGauger getAcopGauger() {
		if (acopGauger == null) {
			try {
				acopGauger = new AcopGauger();
				acopGauger.setTitle("TINE/TEST/JWKSINE/Device 0/Amplitude");  // Generated
				acopGauger.setConnectionParameters(new de.desy.acop.transport.ConnectionParameters("TINE/TEST/JWKSINE/Device 1/Amplitude",de.desy.acop.transport.AccessMode.POLL,1000));  // Generated
				/*
				 * Below is single converter which multiplies by 2
				 */
				acopGauger.setConverter(new MultiplierConverter(2.0));
				/*
				 * Below is converter chain which furst multiplies by 2 then devides by 2
				 */
				acopGauger.setConverter(new ConverterChain(new Converter[]{new MultiplierConverter(2.0),new MultiplierConverter(0.5)}));
			} catch (java.lang.Throwable e) {
				e.printStackTrace();
			}
		}
		return acopGauger;
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		AcopConvertersDemo acd= new AcopConvertersDemo();
		acd.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		acd.setVisible(true);
	}

	/**
	 * This is the default constructor
	 */
	public AcopConvertersDemo() {
		super();
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(361, 340);
		this.setContentPane(getJContentPane());
		this.setTitle("JFrame");
	}

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new JPanel();
			jContentPane.setLayout(new BorderLayout());
			jContentPane.add(getAcopWheelswitch(), java.awt.BorderLayout.SOUTH);  // Generated
			jContentPane.add(getAcopGauger(), java.awt.BorderLayout.CENTER);  // Generated
		}
		return jContentPane;
	}

}  //  @jve:decl-index=0:visual-constraint="10,10"
