/*
 * Copyright (c) 2006 by Cosylab d.o.o.
 *
 * The full license specifying the redistribution, modification, usage and other
 * rights and obligations is included with the distribution of this project in
 * the file license.html. If the license is not included you may find a copy at
 * http://www.cosylab.com/legal/abeans_license.htm or may write to Cosylab, d.o.o.
 *
 * THIS SOFTWARE IS PROVIDED AS-IS WITHOUT WARRANTY OF ANY KIND, NOT EVEN THE
 * IMPLIED WARRANTY OF MERCHANTABILITY. THE AUTHOR OF THIS SOFTWARE, ASSUMES
 * _NO_ RESPONSIBILITY FOR ANY CONSEQUENCE RESULTING FROM THE USE, MODIFICATION,
 * OR REDISTRIBUTION OF THIS SOFTWARE.
 */
/**
 * 
 */
package de.desy.acop.demo;

import java.awt.ComponentOrientation;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;

import javax.swing.JComponent;
import javax.swing.JFrame;
import javax.swing.JPanel;

import com.cosylab.gui.components.util.IconHelper;
import com.cosylab.gui.plugins.VitragePlugIn;

import de.desy.acop.displayers.AcopChart;
import de.desy.acop.displayers.AcopDialKnob;
import de.desy.acop.displayers.AcopGauger;
import de.desy.acop.displayers.AcopIcon;
import de.desy.acop.displayers.AcopNumberLabel;
import de.desy.acop.displayers.AcopSlider;
import de.desy.acop.displayers.AcopSpider;
import de.desy.acop.displayers.AcopWheelswitch;
import de.desy.acop.displayers.tools.AcopGraphParameters;
import de.desy.acop.displayers.AcopLabel;
import de.desy.acop.transport.AcopTransport;

/**
 * @author Igor Kriznar (igor.kriznarATcosylab.com)
 *
 */
public class AcopDisplayersDemo extends JFrame {

	private JPanel jContentPane = null;
	private AcopNumberLabel acopNumberLabel = null;
	private AcopGauger acopGauger = null;
	private AcopChart acopChart = null;
	private AcopDialKnob acopDialKnob = null;
	private AcopWheelswitch acopWheelswitch = null;
	private AcopSlider acopSlider = null;
	private AcopIcon acopIcon = null;
	private AcopSpider spiderBean = null;
	private AcopLabel acopLabel = null;
	private AcopTransport acopTransport = null;  //  @jve:decl-index=0:visual-constraint="603,59"
	/**
	 * This method initializes acopLabel	
	 * 	
	 * @return de.desy.acop.displayers.AcopLabel	
	 */
	private AcopNumberLabel getAcopNumberLabel() {
		if (acopNumberLabel == null) {
			try {
				acopNumberLabel = new AcopNumberLabel();
			} catch (java.lang.Throwable e) {
				e.printStackTrace();
			}
		}
		return acopNumberLabel;
	}

	/**
	 * This method initializes acopGauger	
	 * 	
	 * @return de.desy.acop.displayers.AcopGauger	
	 */
	private AcopGauger getAcopGauger() {
		if (acopGauger == null) {
			try {
				acopGauger = new AcopGauger();
				acopGauger.setMaximum(1000.0D);  // Generated
				acopGauger.setMinimum(0.0D);  // Generated
				acopGauger.setUnits("bozos");  // Generated
			} catch (java.lang.Throwable e) {
				e.printStackTrace();
			}
		}
		return acopGauger;
	}

	/**
	 * This method initializes acopDisplayer	
	 * 	
	 * @return de.desy.acop.displayers.AcopDisplayer	
	 */
	private AcopChart getAcopChart() {
		if (acopChart == null) {
			try {
				acopChart = new AcopChart();
				acopChart.setYBestScale(true);
			} catch (java.lang.Throwable e) {
				e.printStackTrace();
			}
		}
		return acopChart;
	}

	/**
	 * This method initializes acopDialKnob	
	 * 	
	 * @return de.desy.acop.displayers.AcopDialKnob	
	 */
	private AcopDialKnob getAcopDialKnob() {
		if (acopDialKnob == null) {
			try {
				acopDialKnob = new AcopDialKnob();
			} catch (java.lang.Throwable e) {
				e.printStackTrace();
			}
		}
		return acopDialKnob;
	}

	/**
	 * This method initializes acopWheelswitch	
	 * 	
	 * @return de.desy.acop.displayers.AcopWheelswitch	
	 */
	private AcopWheelswitch getAcopWheelswitch() {
		if (acopWheelswitch == null) {
			try {
				acopWheelswitch = new AcopWheelswitch();
			} catch (java.lang.Throwable e) {
				e.printStackTrace();
			}
		}
		return acopWheelswitch;
	}

	/**
	 * This method initializes acopSlider	
	 * 	
	 * @return de.desy.acop.displayers.AcopSlider	
	 */
	private AcopSlider getAcopSlider() {
		if (acopSlider == null) {
			try {
				acopSlider = new AcopSlider();
			} catch (java.lang.Throwable e) {
				e.printStackTrace();
			}
		}
		return acopSlider;
	}

	/**
	 * This method initializes acopIcon	
	 * 	
	 * @return de.desy.acop.displayers.AcopIcon	
	 */
	private AcopIcon getAcopIcon() {
		if (acopIcon == null) {
			try {
				acopIcon = new AcopIcon();
				acopIcon.setBounds(new java.awt.Rectangle(342,239,115,92));  // Generated
				acopIcon.setSize(new java.awt.Dimension(115,92));  // Generated
				acopIcon.setLocation(new java.awt.Point(342,239));  // Generated
				acopIcon.setTitle("");  // Generated
				acopIcon.setDefaultIconName("ilc_kollision_ger.jpg");  // Generated
				acopIcon.setMinimumSize(new java.awt.Dimension(2,2));  // Generated
			} catch (java.lang.Throwable e) {
				e.printStackTrace();
			}
		}
		return acopIcon;
	}

	/**
	 * This method initializes acopLabel1	
	 * 	
	 * @return de.desy.acop.displayers.AcopLabel	
	 */
	private AcopLabel getAcopLabel() {
		if (acopLabel == null) {
			try {
				acopLabel = new AcopLabel();
			} catch (java.lang.Throwable e) {
				e.printStackTrace();
			}
		}
		return acopLabel;
	}

	/**
	 * This method initializes acopTransport	
	 * 	
	 * @return de.desy.acop.transport.AcopTransport	
	 */
	private AcopTransport getAcopTransport() {
		if (acopTransport == null) {
			try {
				acopTransport = new AcopTransport();
			} catch (java.lang.Throwable e) {
				// TODO: Something
			}
		}
		return acopTransport;
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		AcopDisplayersDemo demo= new AcopDisplayersDemo();
		new VitragePlugIn((JComponent)demo.getContentPane());
		demo.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		demo.setVisible(true);
	}

	/**
	 * This is the default constructor
	 */
	public AcopDisplayersDemo() {
		super();
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(566, 481);
		this.setContentPane(getJContentPane());
		this.setTitle("ACOP Demo Panel");
	}

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			GridBagConstraints gridBagConstraints7 = new GridBagConstraints();
			gridBagConstraints7.gridx = 0;
			gridBagConstraints7.fill = GridBagConstraints.BOTH;
			gridBagConstraints7.gridwidth = 2;
			gridBagConstraints7.gridy = 6;
			GridBagConstraints gridBagConstraints6 = new GridBagConstraints();
			gridBagConstraints6.gridx = 1;
			gridBagConstraints6.anchor = GridBagConstraints.WEST;
			gridBagConstraints6.weighty = 1.0D;
			gridBagConstraints6.weightx = 1.0D;
			gridBagConstraints6.fill = GridBagConstraints.BOTH;
			gridBagConstraints6.insets = new Insets(4, 4, 4, 4);
			gridBagConstraints6.ipady = 20;  // Generated
			gridBagConstraints6.gridy = 0;
			spiderBean = new AcopSpider();
			spiderBean.setComponentOrientation(ComponentOrientation.LEFT_TO_RIGHT);
			GridBagConstraints gridBagConstraints5 = new GridBagConstraints();
			gridBagConstraints5.gridx = 1;
			gridBagConstraints5.weighty = 1.0D;
			gridBagConstraints5.gridheight = 2;
			gridBagConstraints5.fill = GridBagConstraints.BOTH;
			gridBagConstraints5.weightx = 1.0D;
			gridBagConstraints5.insets = new Insets(4, 4, 4, 4);
			gridBagConstraints5.gridy = 3;
			GridBagConstraints gridBagConstraints4 = new GridBagConstraints();
			gridBagConstraints4.gridx = 0;  // Generated
			gridBagConstraints4.fill = java.awt.GridBagConstraints.BOTH;  // Generated
			gridBagConstraints4.insets = new java.awt.Insets(4,4,4,4);  // Generated
			gridBagConstraints4.weightx = 1.0D;  // Generated
			gridBagConstraints4.weighty = 0.1D;  // Generated
			gridBagConstraints4.gridy = 4;  // Generated
			GridBagConstraints gridBagConstraints3 = new GridBagConstraints();
			gridBagConstraints3.gridx = 0;  // Generated
			gridBagConstraints3.gridwidth = 2;  // Generated
			gridBagConstraints3.weightx = 1.0D;  // Generated
			gridBagConstraints3.weighty = 0.1D;  // Generated
			gridBagConstraints3.insets = new java.awt.Insets(4,4,4,4);  // Generated
			gridBagConstraints3.fill = java.awt.GridBagConstraints.BOTH;  // Generated
			gridBagConstraints3.gridy = 5;  // Generated
			GridBagConstraints gridBagConstraints2 = new GridBagConstraints();
			gridBagConstraints2.gridx = 0;  // Generated
			gridBagConstraints2.insets = new java.awt.Insets(4,4,4,4);  // Generated
			gridBagConstraints2.weightx = 1.0D;  // Generated
			gridBagConstraints2.weighty = 0.1D;  // Generated
			gridBagConstraints2.fill = java.awt.GridBagConstraints.BOTH;  // Generated
			gridBagConstraints2.gridy = 3;  // Generated
			GridBagConstraints gridBagConstraints12 = new GridBagConstraints();
			gridBagConstraints12.gridx = 1;  // Generated
			gridBagConstraints12.weightx = 1.0D;  // Generated
			gridBagConstraints12.weighty = 1.0D;  // Generated
			gridBagConstraints12.fill = java.awt.GridBagConstraints.BOTH;  // Generated
			gridBagConstraints12.insets = new java.awt.Insets(4,4,4,4);  // Generated
			gridBagConstraints12.gridy = 2;  // Generated
			GridBagConstraints gridBagConstraints11 = new GridBagConstraints();
			gridBagConstraints11.gridx = 0;  // Generated
			gridBagConstraints11.fill = java.awt.GridBagConstraints.BOTH;  // Generated
			gridBagConstraints11.weightx = 1.0D;  // Generated
			gridBagConstraints11.weighty = 1.0D;  // Generated
			gridBagConstraints11.gridwidth = 2;  // Generated
			gridBagConstraints11.ipady = 150;  // Generated
			gridBagConstraints11.gridy = 1;  // Generated
			GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
			gridBagConstraints1.gridx = 0;  // Generated
			gridBagConstraints1.insets = new java.awt.Insets(4,4,4,4);  // Generated
			gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;  // Generated
			gridBagConstraints1.weighty = 1.0D;  // Generated
			gridBagConstraints1.weightx = 1.0D;  // Generated
			gridBagConstraints1.ipadx = 100;  // Generated
			gridBagConstraints1.ipady = 0;  // Generated
			gridBagConstraints1.gridy = 2;  // Generated
			jContentPane = new JPanel();
			jContentPane.setLayout(new GridBagLayout());
			jContentPane.add(getAcopGauger(), gridBagConstraints1);
			jContentPane.add(getAcopChart(), gridBagConstraints11);
			jContentPane.add(getAcopDialKnob(), gridBagConstraints12);
			jContentPane.add(getAcopWheelswitch(), gridBagConstraints2);
			jContentPane.add(getAcopSlider(), gridBagConstraints3);
			jContentPane.add(getAcopNumberLabel(), gridBagConstraints4);
			jContentPane.add(getAcopIcon(), gridBagConstraints5);
			jContentPane.add(spiderBean, gridBagConstraints6);  // Generated
			jContentPane.add(getAcopLabel(), gridBagConstraints7);
		}
		return jContentPane;
	}

}  //  @jve:decl-index=0:visual-constraint="10,10"
