/*
 * Copyright (c) 2006 by Cosylab d.o.o.
 *
 * The full license specifying the redistribution, modification, usage and other
 * rights and obligations is included with the distribution of this project in
 * the file license.html. If the license is not included you may find a copy at
 * http://www.cosylab.com/legal/abeans_license.htm or may write to Cosylab, d.o.o.
 *
 * THIS SOFTWARE IS PROVIDED AS-IS WITHOUT WARRANTY OF ANY KIND, NOT EVEN THE
 * IMPLIED WARRANTY OF MERCHANTABILITY. THE AUTHOR OF THIS SOFTWARE, ASSUMES
 * _NO_ RESPONSIBILITY FOR ANY CONSEQUENCE RESULTING FROM THE USE, MODIFICATION,
 * OR REDISTRIBUTION OF THIS SOFTWARE.
 */
/**
 * 
 */
package de.desy.acop.demo;

import java.awt.Color;
import java.awt.Component;
import java.awt.Graphics;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;

import javax.swing.Icon;
import javax.swing.JFrame;

import com.cosylab.gui.components.util.IconHelper;

import de.desy.acop.displayers.AcopIcon;

/**
 * @author Igor Kriznar (igor.kriznarATcosylab.com)
 *
 */
public class AcopIconDemo extends JFrame {

	private AcopIcon acopIcon = null;

	class SimpleIcon implements Icon {
		Color color;
		SimpleIcon(Color c) {
			color=c;
		}
		/* (non-Javadoc)
		 * @see javax.swing.Icon#getIconHeight()
		 */
		public int getIconHeight() {
			return 32;
		}
		/* (non-Javadoc)
		 * @see javax.swing.Icon#getIconWidth()
		 */
		public int getIconWidth() {
			return 32;
		}
		/* (non-Javadoc)
		 * @see javax.swing.Icon#paintIcon(java.awt.Component, java.awt.Graphics, int, int)
		 */
		public void paintIcon(Component c, Graphics g, int x, int y) {
			int w= Math.min(g.getClipBounds().height,g.getClipBounds().width);
			g.setColor(color);
			g.fillRoundRect((g.getClipBounds().width-w)/2+5,(g.getClipBounds().height-w)/2+5,w-10,w-10,w/5,w/5);
		}
	}
	

	/**
	 * This method initializes acopIcon1	
	 * 	
	 * @return de.desy.acop.displayers.AcopIcon	
	 */
	private AcopIcon getAcopIcon1() {
		if (acopIcon == null) {
			try {
				acopIcon = new AcopIcon();
				acopIcon.setDefaultIcon(IconHelper.createIcon("teilchenspuren_1_ger.jpg"));
				acopIcon.addIcon(0,new SimpleIcon(Color.RED));
				acopIcon.addIcon(1,new SimpleIcon(Color.GREEN));
				acopIcon.addIcon(2,new SimpleIcon(Color.BLUE));
				
				acopIcon.addMouseListener(new MouseAdapter() {
				
					@Override
					public void mouseClicked(MouseEvent e) {
						acopIcon.setValue((acopIcon.getValue()+1)%4);
					}
				
				});
			} catch (java.lang.Throwable e) {
				e.printStackTrace();
			}
		}
		return acopIcon;
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		AcopIconDemo demo= new AcopIconDemo();
		demo.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		demo.pack();
		demo.setVisible(true);
	}

	/**
	 * This is the default constructor
	 */
	public AcopIconDemo() {
		super();
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(319, 317);
		this.setContentPane(getAcopIcon1());
		this.setTitle("JFrame");
	}

}  //  @jve:decl-index=0:visual-constraint="10,10"
