/*
 * Copyright (c) 2006 by Cosylab d.o.o.
 *
 * The full license specifying the redistribution, modification, usage and other
 * rights and obligations is included with the distribution of this project in
 * the file license.html. If the license is not included you may find a copy at
 * http://www.cosylab.com/legal/abeans_license.htm or may write to Cosylab, d.o.o.
 *
 * THIS SOFTWARE IS PROVIDED AS-IS WITHOUT WARRANTY OF ANY KIND, NOT EVEN THE
 * IMPLIED WARRANTY OF MERCHANTABILITY. THE AUTHOR OF THIS SOFTWARE, ASSUMES
 * _NO_ RESPONSIBILITY FOR ANY CONSEQUENCE RESULTING FROM THE USE, MODIFICATION,
 * OR REDISTRIBUTION OF THIS SOFTWARE.
 */
/**
 * 
 */
package de.desy.acop.demo;

import java.awt.BorderLayout;

import javax.swing.JFrame;
import javax.swing.JPanel;

import de.desy.acop.displayers.AcopTable;

/**
 * @author Igor Kriznar (igor.kriznarATcosylab.com)
 *
 */
public class AcopTableDemo extends JFrame {

	private JPanel jContentPane = null;
	private AcopTable acopTable = null;

	/**
	 * This method initializes acopTable	
	 * 	
	 * @return de.desy.acop.displayers.AcopTable	
	 */
	private AcopTable getAcopTable() {
		if (acopTable == null) {
			try {
				acopTable = new AcopTable();
			} catch (java.lang.Throwable e) {
				e.printStackTrace();
			}
		}
		return acopTable;
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		try {
			AcopTableDemo t= new AcopTableDemo();
			t.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
			t.pack();
			t.setVisible(true);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * This is the default constructor
	 */
	public AcopTableDemo() {
		super();
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(400, 334);
		this.setContentPane(getJContentPane());
		this.setTitle("JFrame");
	}

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new JPanel();
			jContentPane.setLayout(new BorderLayout());
			jContentPane.add(getAcopTable(), java.awt.BorderLayout.CENTER);  // Generated
		}
		return jContentPane;
	}

}  //  @jve:decl-index=0:visual-constraint="10,10"
