/*
 * Copyright (c) 2006 by Cosylab d.o.o.
 *
 * The full license specifying the redistribution, modification, usage and other
 * rights and obligations is included with the distribution of this project in
 * the file license.html. If the license is not included you may find a copy at
 * http://www.cosylab.com/legal/abeans_license.htm or may write to Cosylab, d.o.o.
 *
 * THIS SOFTWARE IS PROVIDED AS-IS WITHOUT WARRANTY OF ANY KIND, NOT EVEN THE
 * IMPLIED WARRANTY OF MERCHANTABILITY. THE AUTHOR OF THIS SOFTWARE, ASSUMES
 * _NO_ RESPONSIBILITY FOR ANY CONSEQUENCE RESULTING FROM THE USE, MODIFICATION,
 * OR REDISTRIBUTION OF THIS SOFTWARE.
 */
/**
 * 
 */
package de.desy.acop.displayers;
 
import java.beans.IntrospectionException;

import com.cosylab.gui.components.util.IconHelper;
import com.cosylab.util.BeanInfoSupport;

import de.desy.acop.displayers.selector.ChartSelectorPropertyEditor;
  
/** 
 * @author Igor Kriznar (igor.kriznarATcosylab.com)
 *
 */ 
public class AcopChartBeanInfo extends BeanInfoSupport {
	  
	/**  
	 * Creates new instance of AcopDisplayerBeanInfo.
	 * @throws IntrospectionException 
	 */
	public AcopChartBeanInfo() throws IntrospectionException {
		super(); 
		setBeanDescriptor(AcopChartCustomizer.class);
		loadDefaultPropertyDescriptors();     
		overridePropertyDescriptor("displayerParameters", ChartSelectorPropertyEditor.class, "getDisplayerParameters", "setDisplayerParameters");
//		loadPropertyDescriptor("displayerParameters", ChartSelectorPropertyEditor.class);
		removePropertyDescriptor("connectionParameters");           
	}	
	
	/*
	 * (non-Javadoc)
	 * @see java.beans.SimpleBeanInfo#getIcon(int)
	 */
	@Override
    public java.awt.Image getIcon(int iconKind) {
    	return IconHelper.createImage("icons/chart/ChartChubby16.gif");
    }
	
	
}

