package de.desy.acop.displayers.chart;

import java.awt.datatransfer.DataFlavor;
import java.awt.datatransfer.Transferable;
import java.beans.PropertyVetoException;

import javax.swing.JComponent;

import com.cosylab.gui.displayers.DisplayerParameters;
import com.cosylab.gui.util.DisplayerParametersFlavor;
import com.cosylab.gui.util.MultipleDisplayerParametersFlavor;

import de.desy.acop.displayers.AcopChartReorg;
import de.desy.acop.displayers.AcopTrendChart;
import de.desy.acop.displayers.tools.AcopChartTransferHandler;
import de.desy.acop.displayers.tools.AcopDisplayerParametersFlavor;
import de.desy.acop.displayers.tools.AcopGraphHistoryParameters;
import de.desy.acop.displayers.tools.AcopGraphParameters;
import de.desy.acop.displayers.tools.AcopGraphParametersFlavor;
import de.desy.acop.displayers.tools.ConnectionParametersFlavor;
import de.desy.acop.transport.ConnectionParameters;


public class AcopChartReorgTransferHandler extends AcopChartTransferHandler {

	private static final long serialVersionUID = -6825714785450126489L;
	
	private TrendSelectorDialog trendSelectorDialog;

	public AcopChartReorgTransferHandler(AcopChartReorg comp) {
		super(comp, true, true, new DataFlavor[] {AcopGraphParametersFlavor.FLAVOR, 
				AcopDisplayerParametersFlavor.FLAVOR,	MultipleDisplayerParametersFlavor.FLAVOR,
				DisplayerParametersFlavor.FLAVOR,ConnectionParametersFlavor.FLAVOR,
				DataFlavor.stringFlavor}, true);

	}
	
	/* (non-Javadoc)
	 * @see de.desy.acop.displayers.tools.AcopTransferHandler#importData(javax.swing.JComponent, java.awt.datatransfer.Transferable)
	 */
	@Override
	public boolean importData(JComponent comp, Transferable t) {
		try {
			if (t.isDataFlavorSupported(AcopGraphParametersFlavor.FLAVOR)) {
				Object drop= t.getTransferData(AcopGraphParametersFlavor.FLAVOR);
				
				if (!(drop instanceof AcopGraphParameters[])) {
					return false;
				}
				
				AcopGraphParameters[] p = (AcopGraphParameters[])drop;
				for (int i = 0; i < p.length; i++) {
					if (displayer instanceof AcopTrendChart && !(p[i] instanceof AcopGraphHistoryParameters && ((AcopGraphHistoryParameters)p[i]).getHistoryParameters() != null)) {
						HistoryParameters hp = getTrendSelectorDialog().chooseHistoryParameters(p[i].getConnectionParameters());
						p[i] = new AcopGraphHistoryParameters(p[i], hp);
					}
					((AcopChartReorg)displayer).addDisplayerParameters(p[i]);
				}
				return true;
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
		
		if (super.importData(comp,t)) {
			return true;
		}
		
		return false;
	}
	
	@Override
	public boolean setParametersToDisplayer(Object disp, DisplayerParameters parameters) throws PropertyVetoException {
		try {
			if (displayer instanceof AcopTrendChart && !(parameters instanceof AcopGraphHistoryParameters && ((AcopGraphHistoryParameters)parameters).getHistoryParameters() != null)) {
				ConnectionParameters cp = ((AcopGraphParameters)parameters).getConnectionParameters();
				HistoryParameters hp = getTrendSelectorDialog().chooseHistoryParameters(cp.deriveWithDeviceProperty(cp.getDeviceProperty() +".HIST"));
				parameters = new AcopGraphHistoryParameters((AcopGraphParameters)parameters, hp);
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
		return super.setParametersToDisplayer(disp, parameters);
	}
	
	private TrendSelectorDialog getTrendSelectorDialog() {
		if (trendSelectorDialog == null) {
			trendSelectorDialog = new TrendSelectorDialog(displayer);
		}

		return trendSelectorDialog;
	}

}
