/**
 * 
 */
package de.desy.acop.displayers.chart;

import java.io.Serializable;

/**
 * @author Tilen Kusterle, Cosylab
 *
 */
public class HistoryParameters implements Serializable {
	
	private static final long serialVersionUID = 1L;
	
	private String historyContext;
	private String historyServer;
	private String historyDevice;
	private String historyProperty;
	private int historyIndex;
	
	public HistoryParameters(String historyContext, String historyServer, String historyDevice, String historyProperty, int historyIndex) {
		this.historyContext = historyContext;
		this.historyServer = historyServer;
		this.historyDevice = historyDevice;
		this.historyProperty = historyProperty;
		this.historyIndex = historyIndex;
	}
	
	public HistoryParameters(String remoteName) {
		String[] s = remoteName.split("/");
	    
		this.historyContext = (s.length>0 && s[0]!=null) ? s[0] : "";
		this.historyServer = (s.length>1 && s[1]!=null) ? s[1] : "";
		this.historyProperty = (s.length>3 && s[s.length-1]!=null) ? s[s.length-1] : "";
		
		StringBuilder sb= new StringBuilder(128);
		
		if (s.length>2 && s[2]!=null) {
			sb.append(s[2]);
		}
		for (int i = 3; i < s.length-1; i++) {
			sb.append('/');
			if (s[i]!=null) sb.append(s[i]);
		}
		
		this.historyDevice = sb.toString();
	}
	
	/* (non-Javadoc)
	 * @see java.lang.Object#equals(java.lang.Object)
	 */
	@Override
	public boolean equals(Object obj) {
		if (!(obj instanceof HistoryParameters)) return false;
		return this.toString().equals(obj.toString());
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString() {
		return historyContext + "/" + historyServer + "/" + historyDevice + "/" + historyProperty;
	}

	/**
	 * @return the historyContext
	 */
	public String getHistoryContext() {
		return historyContext;
	}
	/**
	 * @param historyContext the historyContext to set
	 */
	public void setHistoryContext(String historyContext) {
		this.historyContext = historyContext;
	}
	/**
	 * @return the historyDevice
	 */
	public String getHistoryDevice() {
		return historyDevice;
	}
	/**
	 * @param historyDevice the historyDevice to set
	 */
	public void setHistoryDevice(String historyDevice) {
		this.historyDevice = historyDevice;
	}
	/**
	 * @return the historyProperty
	 */
	public String getHistoryProperty() {
		return historyProperty;
	}
	/**
	 * @param historyProperty the historyProperty to set
	 */
	public void setHistoryProperty(String historyProperty) {
		this.historyProperty = historyProperty;
	}
	/**
	 * @return the historyServer
	 */
	public String getHistoryServer() {
		return historyServer;
	}
	/**
	 * @param historyServer the historyServer to set
	 */
	public void setHistoryServer(String historyServer) {
		this.historyServer = historyServer;
	}

	/**
	 * @return the historyIndex
	 */
	public int getHistoryIndex() {
		return historyIndex;
	}

	/**
	 * @param historyIndex the historyIndex to set
	 */
	public void setHistoryIndex(int historyIndex) {
		this.historyIndex = historyIndex;
	}
	
	
}
