/**
 * 
 */
package de.desy.acop.displayers.chart;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.beans.Customizer;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;

import javax.swing.JCheckBox;
import javax.swing.JPanel;

import de.desy.acop.displayers.AcopChartReorg;
import de.desy.acop.displayers.AcopTrendChart;
import de.desy.acop.displayers.tools.RecentTimespanSelector;

/**
 * @author Tilen Kusterle, Cosylab
 *
 */
public class RecentTimespanCustomizer extends JPanel implements Customizer {

	private static final long serialVersionUID = 1L;
	
	private AcopTrendChart acopTrendChart;
	private JCheckBox allDataBox;
	private RecentTimespanSelector selector;
	
	public RecentTimespanCustomizer() {
		setLayout(new GridBagLayout());
		add(getAllDataBox(), new GridBagConstraints(0,0,1,1,1,1,GridBagConstraints.CENTER,GridBagConstraints.NONE,new Insets(1,1,1,1),0,0));
		selector = new RecentTimespanSelector();
		add(selector, new GridBagConstraints(0,1,1,1,1,1,GridBagConstraints.CENTER,GridBagConstraints.BOTH,new Insets(1,1,1,1),0,0));
		
	}

	/* (non-Javadoc)
	 * @see java.beans.Customizer#setObject(java.lang.Object)
	 */
	public void setObject(Object bean) {
		acopTrendChart = (AcopTrendChart) bean;
		acopTrendChart.addPropertyChangeListener(new PropertyChangeListener() {
			public void propertyChange(PropertyChangeEvent evt) {
				String propertyName = evt.getPropertyName();
				if (propertyName.equals(AcopChartReorg.X_RANGE_MIN) || propertyName.equals(AcopChartReorg.X_RANGE_MAX)) {
					selector.setTimeSpan(acopTrendChart.getXRangeMax()-acopTrendChart.getXRangeMin());
				}
			}});
		selector.addPropertyChangeListener(RecentTimespanSelector.TIME_SPAN, new PropertyChangeListener() {
			public void propertyChange(PropertyChangeEvent evt) {
				acopTrendChart.setTimeSpan((Double) evt.getNewValue());
			}});
		getAllDataBox().setSelected(acopTrendChart.isAutoScaleToLiveData());
		selector.setEnabled(false);

	}
	
	private JCheckBox getAllDataBox() {
		if (allDataBox == null) {
			allDataBox = new JCheckBox("Autoscale to Live Data");
			allDataBox.setToolTipText("Adjusts displayed time span to include new live data");
			allDataBox.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					if (acopTrendChart != null) acopTrendChart.setAutoScaleToLiveData(allDataBox.isSelected());
					selector.setEnabled(!allDataBox.isSelected());
				}});
		}

		return allDataBox;
	}

}
