/**
 * 
 */
package de.desy.acop.displayers.chart;

import java.awt.Component;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JOptionPane;
import javax.swing.JPanel;

import de.desy.acop.displayers.selector.SelectorUtilities;
import de.desy.acop.transport.ConnectionParameters;

/**
 * @author Tilen Kusterle, Cosylab
 *
 */
public class TrendSelectorDialog {

	private static final long serialVersionUID = 1L;
	
	private JDialog dialog;
	private TrendSelector trendSelector;
	private JButton applyButton;
	
	private boolean apply = false;
	
	public TrendSelectorDialog(Component owner) {
		dialog = new JDialog(JOptionPane.getFrameForComponent(owner), "Trend Settings", true);
		dialog.setSize(300, 400);
		JPanel contentPane = new JPanel(new GridBagLayout());
		trendSelector = new TrendSelector();
		applyButton = new JButton("Apply");
		applyButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				apply = true;
				dialog.setVisible(false);
			}});
		contentPane.add(trendSelector, new GridBagConstraints(0,0,1,1,1,1,GridBagConstraints.CENTER,GridBagConstraints.BOTH,new Insets(1,1,1,1),0,0));
		contentPane.add(applyButton, new GridBagConstraints(0,1,1,1,0,0,GridBagConstraints.CENTER,GridBagConstraints.NONE,new Insets(1,1,1,1),0,0));
		dialog.setContentPane(contentPane);
	}
	
	public HistoryParameters chooseHistoryParameters(ConnectionParameters cp) {
		apply = false;
		trendSelector.setHistoryParameters(cp.getDeviceContext(), cp.getDeviceGroup(), cp.getDeviceName(), cp.getDeviceProperty());
		if (SelectorUtilities.isConnectionParametersValid(cp)) {
			trendSelector.setIndexMax(SelectorUtilities.getSequenceLength(cp)-1);
		}
		dialog.setLocationRelativeTo(dialog.getOwner());
		dialog.setVisible(true);
		if (apply) return trendSelector.getHistoryParameters();
		else return null;
	}

}
