package de.desy.acop.displayers.info;
import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;

import javax.swing.JLabel;
import javax.swing.JPanel;

import com.cosylab.gui.displayers.CommonDisplayer;

import de.desy.acop.transport.ConnectionFailed;
import de.desy.acop.transport.ConnectionParameters;
import de.desy.acop.transport.adapters.AdapterFactoryService;

public class ConnectionPanel extends JPanel {
		private static final long serialVersionUID = -8289192882139945420L;
		private JLabel protocolLabel;
		private JLabel protocol;
		private JLabel contextLabel;
		private JLabel context;
		private JLabel serverLabel;
		private JLabel server;
		private JLabel deviceLabel;
		private JLabel device;
		private JLabel propertyLabel;
		private JLabel property;
		private JLabel accessRateLabel;
		private JLabel accessRate;
		private JLabel accessModeLabel;
		private JLabel accessMode;
		private JLabel sizeLabel;
		private JLabel size;
		private JLabel infoLabel;
		private ConnectionParameters connectionParameters;
		
		public ConnectionPanel() {
			super();
			initialize();
		}
		
		private void initialize() {
			this.setLayout(new GridBagLayout());
			
			protocolLabel = new JLabel("Protocol:");
			protocolLabel.setMinimumSize(new Dimension(120,21));
			protocolLabel.setMaximumSize(new Dimension(120,21));
			protocolLabel.setPreferredSize(new Dimension(120,21));
			add(protocolLabel, new GridBagConstraints(0,0,1,1,0,0,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(11,11,1,1),0,0));
			
			protocol = new JLabel("N/A");
			protocol.setMinimumSize(new Dimension(120,21));
			protocol.setMaximumSize(new Dimension(120,21));
			protocol.setPreferredSize(new Dimension(120,21));
			add(protocol, new GridBagConstraints(1,0,1,1,0,0,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(11,1,1,11),0,0));
						
			contextLabel = new JLabel("Context:");
			contextLabel.setMinimumSize(new Dimension(120,21));
			contextLabel.setMaximumSize(new Dimension(120,21));
			contextLabel.setPreferredSize(new Dimension(120,21));
			add(contextLabel, new GridBagConstraints(0,1,1,1,0,0,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(1,11,1,1),0,0));
			
			context = new JLabel("N/A");
			context.setMinimumSize(new Dimension(120,21));
			context.setMaximumSize(new Dimension(120,21));
			context.setPreferredSize(new Dimension(120,21));
			add(context, new GridBagConstraints(1,1,1,1,0,0,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(1,1,1,11),0,0));
			
			serverLabel = new JLabel("Server:");
			serverLabel.setMinimumSize(new Dimension(120,21));
			serverLabel.setMaximumSize(new Dimension(120,21));
			serverLabel.setPreferredSize(new Dimension(120,21));
			add(serverLabel, new GridBagConstraints(0,2,1,1,0,0,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(1,11,1,1),0,0));
			
			server = new JLabel("N/A");
			server.setMinimumSize(new Dimension(120,21));
			server.setMaximumSize(new Dimension(120,21));
			server.setPreferredSize(new Dimension(120,21));
			add(server, new GridBagConstraints(1,2,1,1,0,0,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(1,1,1,11),0,0));
			
			deviceLabel = new JLabel("Device:");
			deviceLabel.setMinimumSize(new Dimension(120,21));
			deviceLabel.setMaximumSize(new Dimension(120,21));
			deviceLabel.setPreferredSize(new Dimension(120,21));
			add(deviceLabel, new GridBagConstraints(0,3,1,1,0,0,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(1,11,1,1),0,0));
			
			device = new JLabel("N/A");
			device.setMinimumSize(new Dimension(120,21));
			device.setMaximumSize(new Dimension(120,21));
			device.setPreferredSize(new Dimension(120,21));
			add(device, new GridBagConstraints(1,3,1,1,0,0,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(1,1,1,11),0,0));
			
			propertyLabel = new JLabel("Property:");
			propertyLabel.setMinimumSize(new Dimension(120,21));
			propertyLabel.setMaximumSize(new Dimension(120,21));
			propertyLabel.setPreferredSize(new Dimension(120,21));
			add(propertyLabel, new GridBagConstraints(0,4,1,1,0,0,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(1,11,1,1),0,0));
			
			property = new JLabel("N/A");
			property.setMinimumSize(new Dimension(120,21));
			property.setMaximumSize(new Dimension(120,21));
			property.setPreferredSize(new Dimension(120,21));
			add(property, new GridBagConstraints(1,4,1,1,0,0,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(1,1,1,11),0,0));
			
			sizeLabel = new JLabel("Size:");
			sizeLabel.setMinimumSize(new Dimension(120,21));
			sizeLabel.setMaximumSize(new Dimension(120,21));
			sizeLabel.setPreferredSize(new Dimension(120,21));
			add(sizeLabel, new GridBagConstraints(0,5,1,1,0,0,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(1,11,1,1),0,0));
			
			size = new JLabel("N/A");
			size.setMinimumSize(new Dimension(120,21));
			size.setMaximumSize(new Dimension(120,21));
			size.setPreferredSize(new Dimension(120,21));
			add(size, new GridBagConstraints(1,5,1,1,0,0,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(1,1,1,11),0,0));

			accessRateLabel = new JLabel("Access Rate:");
			accessRateLabel.setMinimumSize(new Dimension(120,21));
			accessRateLabel.setMaximumSize(new Dimension(120,21));
			accessRateLabel.setPreferredSize(new Dimension(120,21));
			add(accessRateLabel, new GridBagConstraints(0,6,1,1,0,0,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(1,11,1,1),0,0));
			
			accessRate = new JLabel("N/A");
			accessRate.setMinimumSize(new Dimension(120,21));
			accessRate.setMaximumSize(new Dimension(120,21));
			accessRate.setPreferredSize(new Dimension(120,21));
			add(accessRate, new GridBagConstraints(1,6,1,1,0,0,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(1,1,1,11),0,0));
			
			accessModeLabel = new JLabel("Access Mode:");
			accessModeLabel.setMinimumSize(new Dimension(120,21));
			accessModeLabel.setMaximumSize(new Dimension(120,21));
			accessModeLabel.setPreferredSize(new Dimension(120,21));
			add(accessModeLabel, new GridBagConstraints(0,7,1,1,0,0,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(1,11,1,1),0,0));
			
			accessMode = new JLabel("N/A");
			accessMode.setMinimumSize(new Dimension(120,21));
			accessMode.setMaximumSize(new Dimension(120,21));
			accessMode.setPreferredSize(new Dimension(120,21));
			add(accessMode, new GridBagConstraints(1,7,1,1,0,0,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(1,1,1,11),0,0));
			
			infoLabel = new JLabel();
			infoLabel.setMinimumSize(new Dimension(240,21));
			infoLabel.setMaximumSize(new Dimension(240,21));
			infoLabel.setPreferredSize(new Dimension(240,21));
			add(infoLabel, new GridBagConstraints(0,8,2,1,0,0,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(4,11,11,11),0,0));
			
		}
		
		public void setConnectionParameters(ConnectionParameters p) {
			this.connectionParameters = p;
			
			if (this.connectionParameters != null) {
				protocol.setText(connectionParameters.getAccessProtocol());
				context.setText(connectionParameters.getDeviceContext());
				server.setText(connectionParameters.getDeviceGroup());
				device.setText(connectionParameters.getDeviceName());
				property.setText(connectionParameters.getDeviceProperty());
				size.setText(String.valueOf(connectionParameters.getPropertySize()));
				accessRate.setText(String.valueOf(connectionParameters.getAccessRate()));
				accessMode.setText(String.valueOf(connectionParameters.getAccessMode()));
				infoLabel.setText(getInfo(connectionParameters));
			} else {
				protocol.setText("N/A");
				context.setText("N/A");
				server.setText("N/A");
				device.setText("N/A");
				property.setText("N/A");
				size.setText("N/A");
				accessRate.setText("N/A");
				accessMode.setText("N/A");
			}
		}
		public ConnectionParameters getConnectionParameters() {
			return connectionParameters;
		}
		
		private String getInfo(ConnectionParameters param) {
			try {
				return (String) AdapterFactoryService.getInstance().getAdapterFactory().getCharacteristics(param).get(CommonDisplayer.C_DESCRIPTION);
			} catch (ConnectionFailed e) {
				e.printStackTrace();
			}
			return "N/A";
		}
	}