package de.desy.acop.displayers.selector;

import javax.swing.AbstractListModel;
import javax.swing.ComboBoxModel;

public class AcopComboBoxModel extends AbstractListModel implements ComboBoxModel {

	private static final long serialVersionUID = -380035760547442817L;
	String[] elements= new String[0];
    String selectedItem;

    /**
     * Constructs an empty DefaultComboBoxModel object.
     */
    public AcopComboBoxModel() {
    	
    }

    /**
     * Set the value of the selected item. The selected item may be null.
     * <p>
     * @param anObject The combo box value or null for no selection.
     */
    public void setSelectedItem(Object anObject) {
    	if ("".equals(anObject)) {
    		anObject=null;
    	}
        if ((selectedItem != null && !selectedItem.equals( anObject )) ||
        		(selectedItem == null && anObject != null)) {
        	selectedItem= (String)anObject;
        	fireContentsChanged(this, -1, -1);
        }
    }

    // implements javax.swing.ComboBoxModel
    public String getSelectedItem() {
        return selectedItem;
    }

    // implements javax.swing.ListModel
    public int getSize() {
        return elements.length;
    }

    // implements javax.swing.ListModel
    public Object getElementAt(int index) {
        if ( index >= 0 && index < elements.length)
            return elements[index];
        else
            return null;
    }

    // implements javax.swing.MutableComboBoxModel
    public void addElement(Object anObject) {
    }
    
    public void setElements(String[] obj) {
    	if (obj==elements || (obj==null && elements==null)) {
    		return;
    	}
    	removeAllElements();
    	if (obj != null) {
    		elements=obj;
	    	fireIntervalAdded(this,0, obj.length-1 > 0 ? obj.length - 1 : 0);
    	}
    	
    }
    
    public String[] getElements() {
    	return elements;
    }

    /**
     * Empties the list.
     */
    protected void removeAllElements() {
        if ( elements.length > 0 ) {
            int firstIndex = 0;
            int lastIndex = elements.length - 1;
            elements=new String[0];
            fireIntervalRemoved(this, firstIndex, lastIndex);
        }
    }
    
    public void replaceElement(int index, String newItem) {
    	if (elements == null || index > elements.length || index < 0) return;
    	elements[index] = newItem;
    	fireIntervalAdded(this, index, index);
    }
    
    public boolean contains(Object o) {
    	if (o == null) return false;
    	for (Object obj : elements) {
    		if (o.equals(obj)) return true;
    	}
    	return false;
    }
	
	
}


/* __oOo__ */