package de.desy.acop.displayers.selector;

import java.awt.Component;

import de.desy.acop.displayers.table.AcopTableParameters;
import de.desy.acop.displayers.tools.AcopDisplayerParameters;
import de.desy.acop.transport.ConnectionParameters;

/**
 * 
 * @author Jaka Bobnar, Cosylab
 *
 */
public class AcopTableParametersDialog extends AcopDisplayerParametersDialog<AcopTableParameters> {

	private static final long serialVersionUID = 4031445693248397678L;
	private TableCustomizerPanel tableCustomizerPanel;
	
	public AcopTableParametersDialog(Component comp) {
		super(comp);
	}

	/*
	 * (non-Javadoc)
	 * @see de.desy.acop.displayers.selector.AcopDisplayerParametersDialog#generateParameters()
	 */
	@Override
	protected AcopTableParameters generateParameters() {
	    return  new AcopTableParameters(getDisplayerParameters().getConnectionParameters(),
	    		getTableCustomizerPanel().getType(), getConverterPanel().getConverter(), getTableCustomizerPanel().getName());

	}

	/*
	 * (non-Javadoc)
	 * @see de.desy.acop.displayers.selector.AcopDisplayerParametersDialog#getCustomizerPanel()
	 */
	@Override
	protected MultipleDisplayerAbstractSettingsPanel<AcopTableParameters> getCustomizerPanel() {
		return getTableCustomizerPanel();
	}
	
	private TableCustomizerPanel getTableCustomizerPanel()
	{
		if (tableCustomizerPanel == null) {
			tableCustomizerPanel = new TableCustomizerPanel();
			tableCustomizerPanel.setParameters(null);
		}
		return tableCustomizerPanel;
	}
	
	/*
	 * (non-Javadoc)
	 * @see de.desy.acop.displayers.selector.AcopDisplayerParametersDialog#showChartDialog(java.awt.Component, de.desy.acop.displayers.tools.AcopDisplayerParameters)
	 */
	@Override
	public AcopTableParameters showDialog(Component component, AcopDisplayerParameters adp) {
		this.getTableCustomizerPanel().setType(null);
		this.getTableCustomizerPanel().setName(null);
		return super.showDialog(component, adp);
	}
	
	/*
	 * (non-Javadoc)
	 * @see de.desy.acop.displayers.selector.AcopDisplayerParametersDialog#showChartDialog(java.awt.Component, de.desy.acop.transport.ConnectionParameters)
	 */
	@Override
	public AcopTableParameters showDialog(Component component, ConnectionParameters cp) {
		this.getTableCustomizerPanel().setType(null);
		this.getTableCustomizerPanel().setName(null);
		return super.showDialog(component, cp);
	}
	
}
