package de.desy.acop.displayers.selector;

import java.awt.Component;

import javax.swing.JOptionPane;

/**
 * This class offers a method that opens an input dialog with a list of Integers where an index
 * can be selected and returned.
 * 
 * @author tkusterle
 *
 */
public class ChannelSelector {

	public static int selectChannelDialog(Component c, int length, int current) {
		if (length == 1) return 0;
		Object[] possibilities = new Object[length];
		for (int i = 0; i < length; i++) {
			possibilities[i] = new Integer(i);
		}
		Object selected = JOptionPane.showInputDialog(
                c,
                "Select Channel:",
                "Select Index",
                JOptionPane.PLAIN_MESSAGE,
                null,
                possibilities,
                new Integer(current));
		if (selected == null) {
			return -1;
		} else {
			return ((Integer) selected).intValue();
		}
	}
	
}
