package de.desy.acop.displayers.selector;

import java.util.EventObject;

/**
 * Exception event should be triggered when an exception occurs. Exception should be caught
 * and the event should then be distributed to the listeners who will handle the exception.
 * 
 * @author Jaka Bobnar, Cosylab
 *
 */
public class ExceptionEvent extends EventObject {

	private static final long serialVersionUID = 5045718406814086160L;
	private Throwable th; 
	public ExceptionEvent(Object source, Throwable e) {
		super(source);
		th = e;
	}
	
	/**
	 * Returns the exception.
	 * @return
	 */
	public Throwable getThrowable() {
		return th;
	}
	
	

}
