package de.desy.acop.displayers.selector;

import java.awt.Component;
import java.awt.Container;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.beans.PropertyEditor;
import java.beans.PropertyEditorSupport;

import com.cosylab.gui.components.util.RunnerHelper;

import de.desy.acop.displayers.tools.AcopDisplayer;
import de.desy.acop.transport.ConnectionParameters;

/**
 * 
 * @author Jaka Bobnar, Cosylab
 *
 */
public class SelectorPropertyEditor extends PropertyEditorSupport implements PropertyEditor {

	private ConnectionCustomizer editor;
	
	/**
	 * Creates new instance of SelectorPropertyEditor.
	 */
	public SelectorPropertyEditor() {
		super();
	}
	
	public Component getCustomEditor() {
		if (editor == null) {
			editor = new ConnectionCustomizer();
			editor.setConnectButtonVisible(false);
			editor.setConnectionParameters((ConnectionParameters)getValue());
			editor.addPropertyChangeListener(AcopDisplayer.CONNECTION_PARAMETERS_PROPERTY, new PropertyChangeListener() {
				public void propertyChange(PropertyChangeEvent evt) {
					setValueSilently(editor.getConnectionParameters());
				}
			});
		}

		return editor;
    }

	public String getJavaInitializationString() {
		ConnectionParameters param = (ConnectionParameters) getValue();
		return "new de.desy.acop.transport.ConnectionParameters(\""+param.getRemoteName()+
				"\",de.desy.acop.transport.AccessMode."+param.getAccessMode()+","+param.getAccessRate()+"," + param.getPropertySize() +")";
    }

	public boolean supportsCustomEditor() {
	    return true;
    }
	
//	public void setAsText(String text) {
//		String[] values = text.split(",");
//		setValue(new ConnectionParameters(values[0], AccessMode.valueOf(values[1]),Integer.parseInt(values[2])));
//    }
	
	private void setValueSilently(Object value) {
		super.setValue(value);
	}
	
	/* (non-Javadoc)
	 * @see java.beans.PropertyEditorSupport#setValue(java.lang.Object)
	 */
	@Override
	public void setValue(Object value) {
		super.setValue(value);
		if (editor!=null) {
			editor.setConnectionParameters((ConnectionParameters)value);
		}
	}
	
	public static void main(String[] args) {
		try {
			
			SelectorPropertyEditor e= new SelectorPropertyEditor();
			e.addPropertyChangeListener(new PropertyChangeListener() {
			
				public void propertyChange(PropertyChangeEvent evt) {
					System.out.println("E: "+evt.getPropertyName()+" "+evt.getNewValue());
				}
			
			});
			
			Component c= e.getCustomEditor();
			
			RunnerHelper.runComponent((Container)c,300,300);
			
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
}


/* __oOo__ */