package de.desy.acop.displayers.selector;

import java.util.Map;

import com.cosylab.gui.displayers.CommonDisplayer;

import de.desy.acop.displayers.tools.AcopDisplayer;
import de.desy.acop.transport.ConnectionFailed;
import de.desy.acop.transport.ConnectionParameters;
import de.desy.acop.transport.adapters.AdapterFactoryService;
import de.desy.tine.definitions.TArrayType;

public class SelectorUtilities {

	private static ConnectionParameters latestParameters;
	private static Map<String, Object> latestCharacteristics;
	
	public static boolean isChannel(ConnectionParameters param) {
		try {
			if (!(param != null && param.equals(latestParameters))) {
				latestCharacteristics = AdapterFactoryService.getInstance().getAdapterFactory().getCharacteristics(param);
			} 
			latestParameters = param;
			return ((TArrayType)latestCharacteristics.get("arrayType")).isChannel();
//			return ((TArrayType) AdapterFactoryService.getInstance().getAdapterFactory().getCharacteristics(param).get("arrayType")).isChannel();
		} catch (ConnectionFailed e) {
			e.printStackTrace();
		}
		return false;
	}
	
	public static boolean isConnectionParametersValid(ConnectionParameters param) {
    	if (param == null) return false;
    	if (param.getAccessProtocol() == null || param.getAccessMode() == null 
    			|| param.getDeviceContext() == null || param.getDeviceGroup() == null 
    			|| param.getDeviceName() == null || param.getDeviceProperty() == null ||
    			param.getAccessProtocol().trim().equals("") || param.getDeviceContext().trim().equals("") 
    			|| param.getDeviceGroup().trim().equals("") 
    			|| param.getDeviceName().trim().equals("") || param.getDeviceProperty().trim().equals("")) return false;
    	return true;
    }
	
	public static String getInfo(ConnectionParameters param) {
		try {
			if (!(param != null && param.equals(latestParameters))) {
				latestCharacteristics = AdapterFactoryService.getInstance().getAdapterFactory().getCharacteristics(param);
			} 
			latestParameters = param;
			return (String)latestCharacteristics.get(CommonDisplayer.C_DESCRIPTION);
//			return (String) AdapterFactoryService.getInstance().getAdapterFactory().getCharacteristics(param).get(CommonDisplayer.C_DESCRIPTION);
		} catch (ConnectionFailed e) {
			e.printStackTrace();
		}
		return "N/A";
	}
	
	public static int getSequenceLength(ConnectionParameters param) {
		try {
			if (!(param != null && param.equals(latestParameters))) {
				latestCharacteristics = AdapterFactoryService.getInstance().getAdapterFactory().getCharacteristics(param);
			} 
			latestParameters = param;
			return ((Integer)latestCharacteristics.get(AcopDisplayer.C_SEQUENCE_LENGTH)).intValue();
//			return ((Integer) AdapterFactoryService.getInstance().getAdapterFactory().getCharacteristics(param).get(AcopDisplayer.C_SEQUENCE_LENGTH)).intValue();
		} catch (ConnectionFailed e) {
			e.printStackTrace();
		}
		
		return 0;
	}
	
	
}
