package de.desy.acop.displayers.table;

import com.cosylab.gui.adapters.Converter;

import de.desy.acop.displayers.tools.AcopDisplayerParameters;
import de.desy.acop.transport.ConnectionParameters;

/**
 * 
 * @author Jaka Bobnar, Cosylab
 *
 */
public class AcopTableParameters extends AcopDisplayerParameters {
	
	private static final long serialVersionUID = -4689823006847926238L;

	public AcopTableParameters() {
		this(null, TableColumnType.VALUE, null);
	}
	//OLD CONSTRUCTORS
	public AcopTableParameters(ConnectionParameters parameters) {
		this(null, TableColumnType.VALUE, "");
	}
	
	public AcopTableParameters(ConnectionParameters parameters, TableColumnType type, String name) {
		this(parameters, type, null, name);
	}
	
	public AcopTableParameters(ConnectionParameters parameters, TableColumnType type, int arrayIndex, String name) {
		this(parameters, type, arrayIndex, null, name);
	}
	//end OLD CONSTRUCTORS
	
	public AcopTableParameters(ConnectionParameters parameters, Converter converter, String name) {
		this(null, TableColumnType.VALUE, converter, name);
	}
	
	public AcopTableParameters(ConnectionParameters parameters, TableColumnType type, Converter converter, String name) {
		this(parameters, type, 0, converter, name);
	}
	
	public AcopTableParameters(ConnectionParameters parameters, TableColumnType type, int arrayIndex, Converter converter, String name) {
		super(parameters, arrayIndex, converter);
		values.put("columnType", type);
		values.put("columnName", name);
	}
	
	public TableColumnType getColumnType() {
		return (TableColumnType)values.get("columnType");
	}
	
	public String getColumnName() {
		return (String) values.get("columnName");
	}
	
	public AcopTableParameters deriveWith(ConnectionParameters parameters) {
		return new AcopTableParameters(parameters, getColumnType(), getArrayIndex(), getConverter(), getColumnName());
	}
		
}
