package de.desy.acop.displayers.tools;

import java.awt.datatransfer.DataFlavor;
import java.awt.event.MouseEvent;
import java.beans.PropertyVetoException;

import javax.swing.JComponent;

import com.cosylab.gui.displayers.DisplayerParameters;
import com.cosylab.util.CommonException;

public class AcopChartTransferHandler extends GraphParametersTransferHandler{
	
	private static final long serialVersionUID = 4277524441131938702L;

	public AcopChartTransferHandler(MultipleAcopDisplayer<AcopGraphParameters> comp, boolean reciveEnabled, boolean exportEnabled, DataFlavor[] f, boolean resetFlavors) {
		super((JComponent)comp, reciveEnabled, exportEnabled, f, resetFlavors);
	}
	
	/* (non-Javadoc)
	 * @see com.cosylab.gui.components.util.CosyTransferHandler#isMouseDragGesture(java.awt.event.MouseEvent)
	 */
	@Override
	protected boolean isMouseDragGesture(MouseEvent e) {
		AcopGraphParameters[] agp = exportMultipleDisplayerParameters();
		boolean ok = false;
		for(AcopGraphParameters p : agp) {
			if (p.getConnectionParameters() != null) ok = true;
		}
		
		return super.isMouseDragGesture(e) && 
			(e.isControlDown() && ok);
	}

	@Override
	protected AcopGraphParameters[] exportMultipleDisplayerParameters() {
		return ((MultipleAcopDisplayer<AcopGraphParameters>)displayer).getDisplayerParameters();
	}
	
	@Override
	public boolean setParametersToDisplayer(Object disp, DisplayerParameters parameters) throws PropertyVetoException {
		try {
			if (parameters instanceof AcopGraphParameters) {
				((MultipleAcopDisplayer<AcopGraphParameters>)displayer).addDisplayerParameters((AcopGraphParameters) parameters);
				return true;
			}
		} catch (CommonException e) {
			e.printStackTrace();
		}
		return false;
	}
}
