package de.desy.acop.displayers.tools;

import com.cosylab.gui.displayers.ConvertibleDisplayer;
import com.cosylab.gui.displayers.Displayer;
import com.cosylab.gui.displayers.DoubleSeqConsumer;

/**
 * <code>AcopDisplayerConnector</code> should be implemented by all Acop single displayers.
 *  
 * @author Jaka Bobnar, Cosylab
 *
 */
public interface AcopDisplayer extends Displayer, ConvertibleDisplayer, DoubleSeqConsumer, ConnectionParametersReceiver {
		
	/**
	 * Name of JavaBean property for array index.
	 */
	public static final String ARRAY_INDEX_PROPERTY="arrayIndex";
	
	/**
	 * Sets index, which is used when this displayer must pick one value from incoming array of values.
	 * @param index of value in incoming array
	 */
	public void setArrayIndex(int index);
	
	/**
	 * Returns index, which is used when this displayer must pick one value from incoming array of values.
	 * @return index of value in incoming array
	 */
	public int getArrayIndex();
	
}
/* __oOo__ */