/**
 * 
 */
package de.desy.acop.displayers.tools;

import de.desy.acop.displayers.chart.HistoryParameters;

/**
 * @author Tilen Kusterle, Cosylab
 *
 */
public class AcopGraphHistoryParameters extends AcopGraphParameters {

	
	private static final long serialVersionUID = 7485604445974438082L;

	public AcopGraphHistoryParameters(AcopGraphParameters acopGraphParameters, HistoryParameters historyParameters) {
		super(
				acopGraphParameters.getConnectionParameters(),
				acopGraphParameters.getArrayIndex(),
				acopGraphParameters.getMinimum(),
				acopGraphParameters.getMaximum(),
				acopGraphParameters.getUnits(),
				acopGraphParameters.getFormat(),
				acopGraphParameters.getColor(),
				acopGraphParameters.getFFT(),
				acopGraphParameters.getDrawStyle(),
				acopGraphParameters.getMode(),
				acopGraphParameters.getWidth(),
				acopGraphParameters.isTrend(),
				acopGraphParameters.getTrendLength(),
				acopGraphParameters.getConverter()
				);
		values.put("historyParameters", historyParameters);
	}
	
	public AcopGraphHistoryParameters(AcopGraphParameters acopGraphParameters) {
		this(acopGraphParameters, null);
	}

	/**
	 * @return the historyParameters
	 */
	public HistoryParameters getHistoryParameters() {
		return (HistoryParameters) values.get("historyParameters");
	}

	/**
	 * @param historyParameters the historyParameters to set
	 */
	public void setHistoryParameters(HistoryParameters historyParameters) {
		values.put("historyParameters", historyParameters);
	}

}
