package de.desy.acop.displayers.tools;

import java.awt.Color;

import com.cosylab.gui.adapters.Converter;

import de.desy.acop.transport.ConnectionParameters;

/**
 * 
 * @author Jaka Bobnar, Cosylab
 *
 */
public class AcopGraphParameters extends AcopDisplayerParameters {

	private static final long serialVersionUID = -7187249526651411944L;

	public AcopGraphParameters() {
		this((ConnectionParameters)null, null, -1, -1, -1, 1, false, 100, null);
	}
	
	public AcopGraphParameters(ConnectionParameters param) {
		this (param, null, -1, -1, -1,1, false, 100, null);
	}
	
	public AcopGraphParameters(ConnectionParameters parameters, Color color, int fft, int drawStyle, int mode, int width, boolean trend, int trendLength) {
		this(parameters,-1,Double.NaN,Double.NaN,null,null,color, fft, drawStyle, mode, width, trend, trendLength, null);
	}
	
	public AcopGraphParameters(ConnectionParameters parameters, Color color, int fft, int drawStyle, int mode, int width, boolean trend, int trendLength, Converter converter) {
		this(parameters,-1,Double.NaN,Double.NaN,null,null,color, fft, drawStyle, mode, width, trend, trendLength, converter);
	}

	protected AcopGraphParameters(ConnectionParameters parameters, int index, double min, double max, String units, String format, Color color, int fft, int drawStyle, int mode, int width, boolean trend, int trendLength, Converter converter) {
		super(parameters,index,min,max,units,format, converter);
		values.put("color",color);
		values.put("fft",fft);
		values.put("drawStyle",drawStyle);
		values.put("mode",mode);
		values.put("width",width);
		values.put("trend",trend);
		values.put("trendLength",trendLength);
	}
	
	public AcopGraphParameters (AcopDisplayerParameters adp) {
		this(adp, null, -1, -1, -1, 1, false, 100, null);
	}
	
	public AcopGraphParameters(AcopDisplayerParameters adp, Color color, int fft, int drawStyle, int mode, int width, boolean trend, int trendLength) {
		this(adp.getConnectionParameters(), adp.getArrayIndex(), adp.getMinimum(), adp.getMaximum(), adp.getUnits(), adp.getFormat(), color, fft, drawStyle, mode, width, trend, trendLength, adp.getConverter());
	}
	
	public AcopGraphParameters(AcopDisplayerParameters adp, Color color, int fft, int drawStyle, int mode, int width, boolean trend, int trendLength, Converter converter) {
		this(adp.getConnectionParameters(), adp.getArrayIndex(), adp.getMinimum(), adp.getMaximum(), adp.getUnits(), adp.getFormat(), color, fft, drawStyle, mode, width, trend, trendLength, converter);
	}

	/**
     * @return the color
     */
    public Color getColor() {
    	return (Color)values.get("color");
    }

	/**
     * @return the fFT
     */
    public int getFFT() {
    	return getInt("fft");
    }

	/**
     * @return the graphStyle
     */
    public int getDrawStyle() {
    	return getInt("drawStyle");
    }
    
    /**
     * 
     * @return is trend
     */
    public boolean isTrend() {
    	return getBool("trend");
    }
    
    public int getTrendLength() {
    	return getInt("trendLength");
    }
	
	/**
     * @return the mode
     */
    public int getMode() {
    	return getInt("mode");
    }

	/**
     * @return the mode
     */
    public int getWidth() {
    	return getInt("width");
    }
}


/* __oOo__ */