/**
 * 
 */
package de.desy.acop.displayers.tools;

import java.util.EventObject;

/**
 * @author Tilen Kusterle, Cosylab
 *
 */
public class AcopTrendChartEvent extends EventObject {
	
	private static final long serialVersionUID = 1L;
	
	public static final String TIMEOUT = "Timeout";
	public static final String NO_DATA = "No data";

	public static enum EventType {OPERATION_STARTED,MULTIPLE_OPERATION_STARTED,OPERATION_ENDED,MULTIPLE_OPERATION_ENDED,ERROR,PROGRESS};
	
	private EventType type;
	private String message;
	private AcopGraphHistoryParameters currentElement;
	private Throwable throwable;
	
	
	public AcopTrendChartEvent(Object source) {
		super(source);
	}
	
	public AcopTrendChartEvent(Object source, EventType type, String message) {
		this(source, type, message, null, null);
	}
	
	public AcopTrendChartEvent(Object source, EventType type, String message, AcopGraphHistoryParameters currentElement) {
		this(source, type, message, currentElement, null);
	}
	
	public AcopTrendChartEvent(Object source, EventType type, Throwable throwable) {
		this(source, type, null, null, throwable);
	}
	
	/**
	 * @param source
	 * @param type
	 * @param message
	 * @param currentElement
	 * @param throwable
	 */
	public AcopTrendChartEvent(Object source, EventType type, String message, AcopGraphHistoryParameters currentElement, Throwable throwable) {
		super(source);
		this.type = type;
		this.message = message;
		this.currentElement = currentElement;
		this.throwable = throwable;
	}


	/**
	 * @return the currentElement
	 */
	public AcopGraphHistoryParameters getCurrentElement() {
		return currentElement;
	}


	/**
	 * @return the message
	 */
	public String getMessage() {
		return message;
	}


	/**
	 * @return the type
	 */
	public EventType getType() {
		return type;
	}

	/**
	 * @return the exception
	 */
	public Throwable getThrowable() {
		return throwable;
	}
	
}
