package de.desy.acop.displayers.tools;

import java.util.EventListener;

public interface AcopTrendChartListener extends EventListener {
	
	/**
	 * Reports progress on </code>AcopTrendChart</code> operations.
	 * @param e an </code>AcopTrendChartEvent</code>
	 */
	public void reportProgress(AcopTrendChartEvent e);
	
	/**
	 * Reports errors. If returned boolean is </code>true</code>, then current action 
	 * is repeated.
	 * @param e an </code>AcopTrendChartEvent</code>
	 * @return </code>true</code> if current action should be repeated
	 */
	public boolean reportError(AcopTrendChartEvent e);
}
