/*
 * Copyright (c) 2006 by Cosylab d.o.o.
 *
 * The full license specifying the redistribution, modification, usage and other
 * rights and obligations is included with the distribution of this project in
 * the file license.html. If the license is not included you may find a copy at
 * http://www.cosylab.com/legal/abeans_license.htm or may write to Cosylab, d.o.o.
 *
 * THIS SOFTWARE IS PROVIDED AS-IS WITHOUT WARRANTY OF ANY KIND, NOT EVEN THE
 * IMPLIED WARRANTY OF MERCHANTABILITY. THE AUTHOR OF THIS SOFTWARE, ASSUMES
 * _NO_ RESPONSIBILITY FOR ANY CONSEQUENCE RESULTING FROM THE USE, MODIFICATION,
 * OR REDISTRIBUTION OF THIS SOFTWARE.
 */
/**
 * 
 */
package de.desy.acop.transport.test;

import java.util.StringTokenizer;

import de.desy.acop.transport.AccessMode;
import de.desy.acop.transport.ConnectionParameters;
import junit.framework.TestCase;


/**
 * @author Igor Kriznar (igor.kriznarATcosylab.com)
 *
 */
public class ConnectionParametersTest extends TestCase {

	public void testConnectionParameters() throws Exception {
		testConnectionParameters("A/B/C/D/E","A","B","C","D","E",AccessMode.POLL,10);
		testConnectionParameters("/B/C/D/E","","B","C","D","E",AccessMode.POLL,10);
		testConnectionParameters("////","","","","","",AccessMode.POLL,10);
		testConnectionParameters("A/B/C//E","A","B","C","","E",AccessMode.POLL,10);
		testConnectionParameters("A/B/C/D/","A","B","C","D","",AccessMode.POLL,10);
		
		testConnectionParameters("A/B/C/D/D1/D2/E","A","B","C","D/D1/D2","E",AccessMode.POLL,10);
	}

	public void testConnectionParameters(String rname, String a, String b, String c, String d, String e, AccessMode mode, int rate) throws Exception {

		ConnectionParameters p= new ConnectionParameters(rname,mode,rate);
		
		assertEquals(mode,p.getAccessMode());
		assertEquals(rate,p.getAccessRate());
		assertEquals(rname,p.getRemoteName());
		assertEquals(a,p.getAccessProtocol());
		assertEquals(b,p.getDeviceContext());
		assertEquals(c,p.getDeviceGroup());
		assertEquals(d,p.getDeviceName());
		assertEquals(e,p.getDeviceProperty());
	}
}
