package de.desy.tine.addrUtils;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import de.desy.tine.endianUtils.Swap;

public final class FECAddr
{
  public String Name = new String(new StringBuffer(16));
  public byte[] reserved = new byte[3];
  public byte[] Port = new byte[2];
  public byte[] Network = new byte[4];
  public byte[] Node = new byte[6];
  public byte[] ImmediateAddress = new byte[6];
  public String IP = new String(new StringBuffer(16));
  public byte PortOffset;
  public byte[] IPh_addr = new byte[4];
  public short  Prot;
  public static int sizeInBytes = (21+16+21+2);
  ByteArrayOutputStream dBuffer = new ByteArrayOutputStream(sizeInBytes);
  byte[] hByteArray;
  public short getPortOffset()
  {
    short poff;
    poff = (short)((Port[1] << 8) | Port[0]);
    if (poff == 0) poff = PortOffset;
    if (poff < 0) poff += 256;
    return poff;
  }
  public byte[] toByteArray()
  {
    try
    {
      dBuffer.reset();
      DataOutputStream ds = new DataOutputStream(dBuffer);
      byte[] bstr = new byte[16];
      byte[] tmp  = Name.getBytes();
      for (int i=0; i<16; i++) bstr[i] = i < tmp.length ? tmp[i] : 0;
      ds.write(bstr,0,16);
      ds.write(reserved,0,3);  // the reserved bytes
      ds.write(Port,0,2);
      ds.write(Network,0,4);
      ds.write(Node,0,6);
      ds.write(ImmediateAddress,0,6);
      tmp = IP.getBytes();
      for (int i=0; i<16; i++) bstr[i] = i < tmp.length ? tmp[i] : 0;
      ds.write(bstr,0,16);
      ds.writeByte(PortOffset);
      ds.write(IPh_addr,0,4);
      ds.writeShort(Swap.Short(Prot));
      ds.close();	
    }
    catch (IOException e)
    {
      e.printStackTrace();
      System.out.println("could not prepare byte stream");
      return null;
    }	 
    hByteArray = dBuffer.toByteArray();
    return hByteArray;
  }  
  public void toStruct()
  {
    try
    {
      ByteArrayInputStream dis = new ByteArrayInputStream(hByteArray);
      DataInputStream ds = new DataInputStream(dis);
      byte[] bstr = new byte[16];
      ds.read(bstr,0,16);
      Name = new String(bstr);
      ds.read(reserved,0,3);
      ds.read(Port,0,2);
      ds.read(Network,0,4);
      ds.read(Node,0,6);
      ds.read(ImmediateAddress,0,6);
      ds.read(bstr,0,16);
      IP = new String(bstr);
      PortOffset = ds.readByte();
      ds.read(IPh_addr,0,4);
      Prot = Swap.Short(ds.readShort());
      ds.close(); dis.close();
    }
    catch (IOException e)
    {
      e.printStackTrace();
      System.out.println("could not prepare byte stream");
    }	 
  }
  public String toString()
  {
    String msg = new String("FEC name : " + Name);
    msg = msg.concat("\nFEC IP   : " + IP);
    msg = msg.concat("\nFEC Port : " + getPortOffset());
    return msg;  
  }
}