/*
 * Created on Nov 20, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package de.desy.tine.addrUtils;
import java.io.*;

/**
 * \internal
 * 
 * @author duval
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class FECInfo
{
  private String os;   // 12 chars
  private String desc; // 64 chars
  private String loc;  // 32 chars
  private String hdw;  // 32 chars
  private String sub;  // 16 chars
  private String resp; // 32 chars
  private static int sizeInBytes = (12+64+32*2+16+32);
  public static int getSizeInBytes() { return sizeInBytes; }
  public FECInfo(String fecOS,String fecDescription,String fecLocation,String fecHardware,String fecSubsystem,String responsiblePersons)
  {
    os = fecOS.trim();
    desc = fecDescription.trim();
    loc = fecLocation.trim();
    hdw = fecHardware.trim();
    sub = fecSubsystem.trim();
    resp = responsiblePersons.trim();
  }
  public byte[] toByteArray()
  {
    ByteArrayOutputStream dBuffer = new ByteArrayOutputStream(sizeInBytes);
    try
    {
      int i, len;
      DataOutputStream ds = new DataOutputStream(dBuffer);
      byte[] bstr = new byte[64];
      if (os != null)
      {
        if((len=os.length()) > 12) len = 12;
        System.arraycopy(os.getBytes(),0,bstr,0,len);
      }
      else len = 0;
      for (i=len; i<12; i++) bstr[i] = 0;
      ds.write(bstr,0,12);
      if (desc != null)
      {
        if ((len=desc.length()) > 64) len = 64;
        System.arraycopy(desc.getBytes(),0,bstr,0,len);
      }
      else len = 0;
      for (i=len; i<64; i++) bstr[i] = 0;
      ds.write(bstr,0,64);
      if (loc != null)
      {
        if ((len=loc.length()) > 32) len = 32;
        System.arraycopy(loc.getBytes(),0,bstr,0,len);
      }
      else len = 0;
      for (i=len; i<32; i++) bstr[i] = 0;
      ds.write(bstr,0,32);
      if (hdw != null)
      {
        if ((len=hdw.length()) > 32) len = 32;
        System.arraycopy(hdw.getBytes(),0,bstr,0,len);
      }
      else len = 0;
      for (i=len; i<32; i++) bstr[i] = 0;
      ds.write(bstr,0,32);
      if (sub != null)
      {
        if ((len=sub.length()) > 16) len = 16;
        System.arraycopy(sub.getBytes(),0,bstr,0,len);
      }
      else len = 0;
      for (i=len; i<16; i++) bstr[i] = 0;
      ds.write(bstr,0,16);
      if (resp != null)
      {
        if ((len=resp.length()) > 32) len = 32;
        System.arraycopy(resp.getBytes(),0,bstr,0,len);
      }
      else len = 0;
      for (i=len; i<32; i++) bstr[i] = 0;
      ds.write(bstr,0,32);
      ds.close(); 
    }
    catch (IOException e)
    {
      e.printStackTrace();
      System.out.println("could not prepare byte stream");
      return null;
    }  
    return dBuffer.toByteArray();
  }
  public void toStruct(byte[] hByteArray)
  {
    try
    {
      ByteArrayInputStream dis = new ByteArrayInputStream(hByteArray);
      DataInputStream ds = new DataInputStream(dis);
      // Export resolution information:
      byte[] bstr = new byte[64];
      ds.read(bstr,0,12);
      os = new String(bstr);
      ds.read(bstr,0,64);
      desc = new String(bstr);
      ds.read(bstr,0,32);
      loc = new String(bstr);
      ds.read(bstr,0,32);
      hdw = new String(bstr);
      ds.read(bstr,0,16);
      sub = new String(bstr);
      ds.read(bstr,0,32);
      resp = new String(bstr);

      ds.close(); dis.close();
    }
    catch (IOException e)
    {
      e.printStackTrace();
      System.out.println("could not prepare byte stream");
    }  
  }
  public String toString()
  {
    String msg = new String("FEC os   : " + os);
    msg = msg.concat("\nFEC loc  : " + loc);
    msg = msg.concat("\nFEC hdw  : " + hdw);
    msg = msg.concat("\nFEC sub  : " + sub);
    msg = msg.concat("\nFEC resp : " + resp);
    msg = msg.concat("\nFEC desc : " + desc);
    return msg;  
  }
  public String getDesc()
  {
    return desc;
  }
  public String getHdw()
  {
    return hdw;
  }
  public String getLoc()
  {
    return loc;
  }
  public String getOs()
  {
    return os;
  }
  public String getResp()
  {
    return resp;
  }
  public String getSub()
  {
    return sub;
  }
 }
