//: TLink.java
// TODO: get rid of some of the hard-wired numbers below, such as '200' for the addr cache limit
package de.desy.tine.addrUtils;
import java.io.BufferedReader;
import java.net.InetAddress;
import java.net.UnknownHostException;
import de.desy.tine.client.TLinkFactory;
import de.desy.tine.client.TLink;
import de.desy.tine.client.TLinkFactory.TFactoryThread;
import de.desy.tine.csvUtils.csv;
import de.desy.tine.dataUtils.TDataType;
import de.desy.tine.definitions.*;
import de.desy.tine.io.TPacket;
import de.desy.tine.startup.DefaultTInitializerFactory;
import de.desy.tine.startup.TInitializer;
import de.desy.tine.startup.TInitializerFactory;
import de.desy.tine.types.NAME16;

// TODO:  change all of the hardwired 200s and 100s below ...
public final class TModAddress
{
  private static final int CACHE_TABLE_LENGTH = 1000;
  public static final String SRVEQM_NAME = "_SRV__";
  public static final String SRVFEC_NAME = "NETWORK";
  public static final String SRVEXP_NAME = "NETWORK";
  private static BufferedReader addrR = null;
  private static BufferedReader hostsR = null;
  private static BufferedReader eqpR = null;
  private static boolean initialized = false;
  private static boolean initializing = false;
  private static int ensSrvCacheIndex = -1;
  private static int ensDevCacheIndex = -1;
  public String devName;
  public String modName;
  public String srvName;
  public String cntName;
  static NameCache[] devNameCache = new NameCache[CACHE_TABLE_LENGTH];
  static String[] modNameCache = new String[CACHE_TABLE_LENGTH];
  static TSrvAddress[] srvAddrCache = new TSrvAddress[CACHE_TABLE_LENGTH];
  static int modNameCacheLength = 0;
  static int srvAddrCacheLength = 0;
  static int NameCacheLength = 0;
  static int numConfiguredNameServers = 0;
  static int currentConfiguredNameServer = 0;
  public static String currentConfiguredNameServerTag;
  public TSrvAddress srvAddress;
  static csv modFile;
  static String modDBFileName;
  static int debugLevel = 0;
  public static void reset()
  {
    // leave the configured ENS and GENS in the table ..
    if (modNameCacheLength > 2) modNameCacheLength = 2;
    if (srvAddrCacheLength > 2) srvAddrCacheLength = 2;
    if (NameCacheLength > 2) NameCacheLength = 2;
  }
  public String toString(String dname,String cname)
  {
    if (modName == null) return new String("module does not exist");
    StaticAddress(dname,cname);
    String modstr = new String("");
    modstr += "Local Equipment Module : " + modName.trim();
    modstr += "\nFront End Computer :" + srvName.trim();
    if (srvAddress != null && srvAddress.srvHost != null)
    {
      modstr += "\nIP Address : " + srvAddress.srvHost.getHostAddress();
      modstr += "\nPort Offset : " + srvAddress.srvPortOffset;
      modstr += "\nHost Name : " + srvAddress.srvHost.getHostName();
    }
    return modstr;
  }
  void StaticAddress(String dname,String cname)
  {
    int i;
    if (dname == null || cname == null) 
    {
      modName = ""; srvName = ""; cntName = "";
      return;
    }
    for (i=0; i<NameCacheLength; i++) 
    {
      if (cname.length() > 0 && 
          cname.compareTo("DEFAULT") != 0 &&
          cname.compareTo(devNameCache[i].cntName) != 0) continue;
      if (dname.compareTo(devNameCache[i].devName) == 0)
      {
        modName = modNameCache[devNameCache[i].modNameIndex];
        srvName = srvAddrCache[devNameCache[i].srvNameIndex].srvName;
        srvAddress = srvAddrCache[devNameCache[i].srvNameIndex];
    	return;
      }
    }
    // acquire name info from ens or file:
    if (dname.startsWith("ENS"))
    {
      modName = new String("ENSEQM");
      srvName = new String("ENS");
      cntName = new String("SERVICE");
    }
    if (dname.compareTo("NAMEQRY") == 0)
    {
      modName = new String("ENSEQM");
      srvName = new String("ENS");
      cntName = new String("SERVICE");
    }
    if (dname.startsWith("GENS"))
    {
      modName = new String("GRPEQM");
      srvName = new String("GENS");
      cntName = new String("SERVICE");
    }
    if (modName == null) return;
    if (modNameCacheLength >= CACHE_TABLE_LENGTH) return;
    if (srvAddrCacheLength >= CACHE_TABLE_LENGTH) return;
    if (NameCacheLength < CACHE_TABLE_LENGTH) devNameCache[NameCacheLength] = new NameCache();
    for (i=0; i<modNameCacheLength; i++) 
      if (modName.compareTo(modNameCache[i]) == 0) break;
    if (i == modNameCacheLength) modNameCache[modNameCacheLength++] = modName;
    devNameCache[NameCacheLength].modNameIndex = i;
    for (i=0; i<srvAddrCacheLength; i++) 
      if (srvName.compareTo(srvAddrCache[i].srvName) == 0) break;
    if (i == srvAddrCacheLength)
    {
      srvAddrCache[srvAddrCacheLength] = new TSrvAddress(srvName);
      srvAddress = srvAddrCache[srvAddrCacheLength++];
      if (srvName.startsWith("ENS")) numConfiguredNameServers++;
    }
    devNameCache[NameCacheLength].srvNameIndex = i;
    devNameCache[NameCacheLength].devName = dname;
    devNameCache[NameCacheLength].cntName = cntName;
    if (NameCacheLength < CACHE_TABLE_LENGTH) NameCacheLength++;
  }
  static int addNameServerToServerCache(TSrvAddress sa)
  {
    if (srvAddrCacheLength > CACHE_TABLE_LENGTH || NameCacheLength > CACHE_TABLE_LENGTH || numConfiguredNameServers > 10)
      return -1;
    if (debugLevel > 1) System.out.println("Adding ENS " + numConfiguredNameServers + " to address cache");
    if (ensSrvCacheIndex == -1) ensSrvCacheIndex = srvAddrCacheLength;
    if (ensDevCacheIndex == -1) ensDevCacheIndex = NameCacheLength;
    srvAddrCache[srvAddrCacheLength] = sa;
    devNameCache[NameCacheLength] = new NameCache();
    devNameCache[NameCacheLength].srvNameIndex = srvAddrCacheLength;
    devNameCache[NameCacheLength].modNameIndex = modNameCacheLength;
    devNameCache[NameCacheLength].devName = sa.srvName;
    devNameCache[NameCacheLength].cntName = "SERVICE";
    modNameCache[modNameCacheLength] = "ENSEQM";
    srvAddrCacheLength++;
    modNameCacheLength++;
    NameCacheLength++;
    numConfiguredNameServers++;
    if (numConfiguredNameServers == 1)  // been called at least once ...
    {
      currentConfiguredNameServerTag = new String(sa.srvName);
    }
    return 0;
  }
  static int addGroupServerToServerCache(TSrvAddress sa)
  { // TODO: meld this cut-and-paster with the above routine ...
    if (srvAddrCacheLength > CACHE_TABLE_LENGTH || NameCacheLength > CACHE_TABLE_LENGTH || numConfiguredNameServers > 10)
      return -1;
    if (debugLevel > 1) System.out.println("Adding GENS " + numConfiguredNameServers + " to address cache");
    srvAddrCache[srvAddrCacheLength] = sa;
    devNameCache[NameCacheLength] = new NameCache();
    devNameCache[NameCacheLength].srvNameIndex = srvAddrCacheLength;
    devNameCache[NameCacheLength].modNameIndex = modNameCacheLength;
    devNameCache[NameCacheLength].devName = sa.srvName;
    devNameCache[NameCacheLength].cntName = "SERVICE";
    modNameCache[modNameCacheLength] = "GRPEQM";
    srvAddrCacheLength++;
    NameCacheLength++;
    modNameCacheLength++;
    return 0;
  }
  static int addNameServer(String ip)
  {
    TSrvAddress sa;
    DevAddr da;
    da = new DevAddr();
    da.FecName = new String("ENS#" + numConfiguredNameServers);
    da.Context = new String("SERVICE");
    da.EqName = new String("ENSEQM");
    da.IP = new String(ip);
    da.PortOffset = 0;
    da.Prot = 2;
    sa = new TSrvAddress(da);
    if (!sa.srvRegistered) return -1;
    addNameServerToServerCache(sa);
    // now add the GENS ...
    da.FecName = new String("GENS#" + numConfiguredNameServers);
    da.EqName = new String("GRPEQM");    
    da.PortOffset = 101;
    sa = new TSrvAddress(da);
    if (!sa.srvRegistered) return -1;
    addGroupServerToServerCache(sa);
    return 0;
  }
  static synchronized void SetAddrFileLocation()
  {
    if (initialized) return;
    if (initializing) return;
    initializing = true;
    TInitializer initializer = TInitializerFactory.getInstance().getInitializer();
    addrR = initializer.getAddressResource();
    eqpR = initializer.getEquipmentResource();

    String ensName;
    TSrvAddress sa;
    currentConfiguredNameServerTag = new String("ENS");  // default
    
    for (int i=0; i<5; i++)  // don't allow more than 5 configured name servers ...
    {
      ensName = new String("ENS#" + i);	
      if (debugLevel > 1) System.out.println("ENS: looking for " + ensName);
      hostsR = initializer.getHostsResource();
      if (hostsR != null)   
      {
        sa = new TSrvAddress(hostsR,ensName);
        if (!sa.srvRegistered)
        { // maybe a simple name is entered in the cshosts.csv file ?
          sa = new TSrvAddress(hostsR,"ENS");
        }
      }
      else 
      { // try to discover it 
        findNameServerOnNetwork();
        if (numConfiguredNameServers > 0) break;
        findNameServerFromDNS();
        if (numConfiguredNameServers > 0) break;
        // not found on network: use a hard-wired address
        sa = new TSrvAddress("ENS");
      }
      if (!sa.srvRegistered) 
      { 
        if (debugLevel > 1) System.out.println(ensName + " Not Registered");
        continue;
      } 
      addNameServerToServerCache(sa);
      if (hostsR == null) break;
    }
    initialized = true;
    initializing = false;
}
  public TModAddress()
  {
    modName = ""; devName = ""; cntName = ""; srvName = "";
    SetAddrFileLocation();
  }
  int getAddressFromFileCache(String dname,String cname)
  {
    String lkupname;
    SetAddrFileLocation();
    if (debugLevel > 1) System.out.println("FILE lookup: looking for \\" + cname + "\\" + dname);
    if (dname.startsWith("ENS") && numConfiguredNameServers > 0)
    {
      lkupname = currentConfiguredNameServerTag;
    }
    else if (dname.startsWith("GENS") && numConfiguredNameServers > 0)
    {
      lkupname = "G" + currentConfiguredNameServerTag;
    }
    else
    {
      lkupname = dname;
    }
    for (int i=0; i<NameCacheLength; i++)
    {
      if (cname.length() > 0 && 
          cname.compareTo("DEFAULT") != 0 &&
          cname.compareToIgnoreCase(devNameCache[i].cntName) != 0) continue;
      if (lkupname.compareToIgnoreCase(devNameCache[i].devName) == 0)
      {
        modName = modNameCache[devNameCache[i].modNameIndex];
        srvName = srvAddrCache[devNameCache[i].srvNameIndex].srvName;
        srvAddress = srvAddrCache[devNameCache[i].srvNameIndex];
        return 0;
      }
    }
    modFile = new csv(eqpR);
    try
    {
      String s, hdr;
      int i, nam_col = -1,eqn_col = -1 ,srv_col = -1,ctxt_col = -1;
      boolean done = false;
      while((s=modFile.readLine()) != null)
      {
        if (s.length() == 0) continue;
        if (s.startsWith("#") || s.startsWith(";") || s.startsWith("%")) continue;
        if (!done)
        {
            hdr = s;
            if ((nam_col=modFile.findcol(hdr,"NAME")) < 0) throw new NoSuchFieldException();
            if ((eqn_col=modFile.findcol(hdr,"EQPMODULE")) < 0) throw new NoSuchFieldException();
            if ((srv_col=modFile.findcol(hdr,"FECNAME")) < 0) throw new NoSuchFieldException();
            if ((ctxt_col=modFile.findcol(hdr,"CONTEXT")) < 0) throw new NoSuchFieldException();
            done = true;
            continue;
        }
        if (modFile.namcmp(dname,s,nam_col) == 0)
        {
            modName = modFile.colptr(eqn_col,s);
            srvName = modFile.colptr(srv_col,s);
            cntName = modFile.colptr(ctxt_col,s);
            if (modNameCacheLength >= CACHE_TABLE_LENGTH) break;
            if (srvAddrCacheLength >= CACHE_TABLE_LENGTH) break;
            if (NameCacheLength < CACHE_TABLE_LENGTH) devNameCache[NameCacheLength] = new NameCache();
            for (i=0; i<modNameCacheLength; i++) 
              if (modName.compareTo(modNameCache[i]) == 0) break;
            if (i == modNameCacheLength) modNameCache[modNameCacheLength++] = modName;
            devNameCache[NameCacheLength].modNameIndex = i;
            for (i=0; i<srvAddrCacheLength; i++) 
              if (srvName.compareToIgnoreCase(srvAddrCache[i].srvName) == 0) break;
            if (i == srvAddrCacheLength)
            {
              srvAddrCache[srvAddrCacheLength] = new TSrvAddress(addrR,srvName);
              srvAddress = srvAddrCache[srvAddrCacheLength++];
            }
            devNameCache[NameCacheLength].srvNameIndex = i;
            devNameCache[NameCacheLength].devName = dname;
            devNameCache[NameCacheLength].cntName = cname;
            if (NameCacheLength < CACHE_TABLE_LENGTH) NameCacheLength++;
            modFile.close();
            return 0;
            // found it
        }
      }
      modFile.close();
      return TErrorList.non_existent;
    }
    catch (NoSuchFieldException e)
    {
      // database corrupt
      return TErrorList.database_not_loaded;
    }    
  }
  public TModAddress(String fname,String dname,String cname)
  {
    getAddressFromFileCache(dname,cname);
  }  
  public TModAddress(TLinkFactory tf,String dname,String cname)
  {
    getAddress(tf,dname,cname);
  }
  public synchronized void getAddress(TLinkFactory tf,String dname,String cname)
  {
    int i;
    debugLevel = tf.debugLevel;
    if (tf.debugLevel > 1) System.out.println("TModAddress() has been called from factory");
    if (dname.compareTo("GLOBAL") == 0) return;
    SetAddrFileLocation();
    
    if (tf.debugLevel > 1) System.out.println("looking for /" + cname + "/" + dname);

    boolean isENSRequest = (dname.startsWith("ENS") && cname.compareToIgnoreCase("DEFAULT") == 0);
    if (isENSRequest)
    {
      if (numConfiguredNameServers == 0)
      { // if I'm looking for the ENS and it's not configured, add static address to cache
        if (tf.debugLevel > 1) System.out.println("add static ENS address");
        StaticAddress(dname,cname);
        return;
      }
    }
    String dnam = dname;
    if (dname.compareTo("GENS") == 0) 
    {
      dnam = "G" + currentConfiguredNameServerTag;
      if (tf.debugLevel > 1) System.out.println("setting GENS entry to " + dnam);
    }
    
    for (i=0; i<NameCacheLength; i++) 
    { // check address cache for requested device server
      //System.out.println("cache : cnt " + devNameCache[i].cntName + " dev " + devNameCache[i].devName);
      if (cname.length() > 0 && 
          cname.compareToIgnoreCase("DEFAULT") != 0 &&
          cname.compareToIgnoreCase(devNameCache[i].cntName) != 0) continue;
      if (dnam.compareToIgnoreCase(devNameCache[i].devName) == 0)
      {
        modName = modNameCache[devNameCache[i].modNameIndex];
        srvName = srvAddrCache[devNameCache[i].srvNameIndex].srvName;
        srvAddress = srvAddrCache[devNameCache[i].srvNameIndex];
        if (tf.debugLevel > 1) System.out.println("found it in cache");
        return;
      }
    }

    if (isENSRequest)
    { // ENS request made it this far without a hit, so return canonical entry
      i = ensDevCacheIndex == -1 ? 0 : ensDevCacheIndex;
      modName = modNameCache[devNameCache[i].modNameIndex];
      srvName = srvAddrCache[devNameCache[i].srvNameIndex].srvName;
      srvAddress = srvAddrCache[devNameCache[i].srvNameIndex];
      return;      
    }
    if (dname.compareTo(SRVEXP_NAME) == 0)
    { // asking the NETWORK for the address
      if (NameCacheLength < CACHE_TABLE_LENGTH && modNameCacheLength < CACHE_TABLE_LENGTH && srvAddrCacheLength < CACHE_TABLE_LENGTH)
      { // add to cache ...
        DevAddr da = new DevAddr();
        da.IP = TLinkFactory.getInstance().getInitializer().getNetCastAddress();
        da.PortOffset = 0;
        da.FecName = SRVFEC_NAME; da.Context = "";
        da.EqName = SRVEQM_NAME; da.TagName = SRVEXP_NAME;
        srvAddrCache[srvAddrCacheLength] = new TSrvAddress(da);
        modNameCache[modNameCacheLength] = SRVEQM_NAME;
        devNameCache[NameCacheLength] = new NameCache();
        devNameCache[NameCacheLength].cntName = "";
        devNameCache[NameCacheLength].devName = SRVEXP_NAME;
        devNameCache[NameCacheLength].modNameIndex = modNameCacheLength;
        devNameCache[NameCacheLength].srvNameIndex = srvAddrCacheLength;
        srvAddress = srvAddrCache[srvAddrCacheLength];
        srvName = srvAddrCache[srvAddrCacheLength].srvName;
        modName = SRVEQM_NAME;
        NameCacheLength++; modNameCacheLength++; srvAddrCacheLength++;
      }
      return;
    }
    if (numConfiguredNameServers == 0)
    { // I don't have a name server, so there's no point in looking
      if (tf.debugLevel > 1) System.out.println("No configured ENS");
      return;
    }
    if (getAddressFromENS(tf,dname,cname) != 0)
    {
      getAddressFromFileCache(dname,cname);
    }
  }
  private static synchronized DevAddr getDevAddrFromENS(TLinkFactory tf,String dname,String cname)
  {
    String tagName;
    int cc = 0;
    tagName = new String(currentConfiguredNameServerTag + "/");
    tagName = cname.length() > 0 ? tagName.concat(cname) : tagName.concat("#2");
    DevAddr da = new DevAddr();
    TDataType d_null = new TDataType();
    TDataType d_da = new TDataType(da.toByteArray(),"");
    TLink ma = tf.createTLink(tagName,dname,d_da,d_null,(short)1);
    if (ma == null)
    {
      if (tf.debugLevel > 1) System.out.println("cannot create link to ENS");
      return null;          
    }
    if ((cc=ma.execute(200,true)) == 0)
    {
      da.toStruct();
      ma.cancel();
      return da;
    }
    ma.cancel();
    if (tf.debugLevel > 1) System.out.println("link to ENS : " + TErrorList.toString(cc));
    return null;          
  }
  private synchronized int getAddressFromENS(TLinkFactory tf,String dname,String cname)
  {
    int i, n = 0, cc = 0;
    do 
    {
      DevAddr da = getDevAddrFromENS(tf,dname,cname);
      if (da != null)
      {
        if (modNameCacheLength >= CACHE_TABLE_LENGTH) return TErrorList.resources_exhausted;
        if (srvAddrCacheLength >= CACHE_TABLE_LENGTH) return TErrorList.resources_exhausted;
        if (NameCacheLength < CACHE_TABLE_LENGTH) devNameCache[NameCacheLength] = new NameCache();
        modName = da.EqName;
        for (i=0; i<modNameCacheLength; i++) 
          if (modName.compareTo(modNameCache[i]) == 0) break;
        if (i == modNameCacheLength) modNameCache[modNameCacheLength++] = modName;
        devNameCache[NameCacheLength].modNameIndex = i;
        srvName = da.FecName;
        for (i=0; i<srvAddrCacheLength; i++) 
          if (srvName.compareToIgnoreCase(srvAddrCache[i].srvName) == 0) break;
        if (i == srvAddrCacheLength)
        {
          srvAddrCache[srvAddrCacheLength++] = new TSrvAddress(da);
        }
        srvAddress = srvAddrCache[i];
        devNameCache[NameCacheLength].srvNameIndex = i;
        devNameCache[NameCacheLength].devName = dname;
        devNameCache[NameCacheLength].cntName = cname;
        if (NameCacheLength < CACHE_TABLE_LENGTH) NameCacheLength++;
        if (tf.debugLevel > 1) System.out.println("ENS success");
        return 0;
      }
      currentConfiguredNameServer = (currentConfiguredNameServer+1) % numConfiguredNameServers;
      currentConfiguredNameServerTag = new String("ENS#" + currentConfiguredNameServer);
      if (tf.debugLevel > 1) System.out.println("trying ENS " + currentConfiguredNameServerTag);
    } while (++n < numConfiguredNameServers);
    if (tf.debugLevel > 1) System.out.println("ens failure");
    return cc;
  }
  private static int findNameServerFromDNS()
  {
    int cc = 0;
    if (numConfiguredNameServers > 0) return 0;
    try
    {
      InetAddress iaddr = java.net.Inet4Address.getByName("tineens");
      addNameServer(iaddr.getHostAddress());
    }
    catch (UnknownHostException e)
    {
      cc = TErrorList.host_not_resolved;
    }
    return cc;
  }
  private static int findNameServerOnNetwork()
  {
    int cc = 0;
    FECAddr fec = new FECAddr();
    DevAddr srv = new DevAddr();
    if (numConfiguredNameServers > 0) return 0;
    if ((cc=findServerOnNetwork("", "ENSEQM", "", fec, srv)) == 0)
    {
      addNameServer(fec.IP);
    }
    return cc;
  }
  private static int findServerOnNetwork(String context,String eqmName,String exportName,FECAddr fec,DevAddr srv)
  {
    int i,p,cc=0;
    NAME16[] n16in = new NAME16[3];
    NAME16[] n16out = new NAME16[5];
    
    n16in[0] = new NAME16(context);
    n16in[1] = new NAME16(eqmName);
    n16in[2] = new NAME16(exportName);
    
    TDataType dout = new TDataType(n16out);
    TDataType din = new TDataType(n16in);

    TLink tl = new TLink(SRVEXP_NAME,"SRVADDR",dout,din,TAccess.CA_READ);
    cc = tl.execute(500, true);
    if (cc == 0)
    {
      if (fec != null)
      {
        p = Integer.valueOf(n16out[0].getName());
        fec.Name = n16out[1].getName();
        fec.PortOffset = (byte)p;
        fec.Port[0] = (byte)(p&0xff);
        fec.Port[1] = (byte)((p>>8)&0xff);
        System.arraycopy(tl.linkPeer.getAddress(), 0, fec.IPh_addr, 0, 4);
        fec.IP = tl.linkPeer.getHostAddress();
      }
      if (srv != null)
      {
        srv.FecName = n16out[1].getName();
        srv.Context = n16out[2].getName();
        srv.EqName = n16out[3].getName();
        srv.TagName = n16out[4].getName();
      }
    }
    return cc;
  }
  
}