//: TLink.java
package de.desy.tine.addrUtils;
import java.io.BufferedReader;
import java.io.IOException;
import java.net.InetAddress;
import java.net.UnknownHostException;
import de.desy.tine.csvUtils.csv;
import de.desy.tine.csvUtils.csvColumn;
import de.desy.tine.csvUtils.csvHandler;
import de.desy.tine.startup.TInitializerFactory;
public final class TSrvAddress
{
  String srvName;
//
////  Not used (mkadunc)
//
//  String srvLocation;
//  String srvDescription;
//
  csv srvFile;
  public static final short BCAST_ID = 255;
  public static final short ENS_ID = 4096;
  public short srvPortOffset;
  public boolean srvRegistered;
  public InetAddress srvHost;

  public TSrvAddress(DevAddr da)
  {
    try 
    {
      srvName = da.FecName;
      srvHost = InetAddress.getByName(da.IP.trim());
      srvPortOffset = da.getPortOffset();
      srvRegistered = true;
    }
    catch (UnknownHostException e)
    {
      System.err.println("cannot find host");
      srvRegistered = false;
    }
  }  
  public TSrvAddress(String name)
  {
    srvName = new String(name);
    try 
    {
      // acquire address from ens or file:
      if (name.compareTo("ENS") == 0)
      {
        srvHost = InetAddress.getByName(TInitializerFactory.getInstance().getInitializer().getENSAddress());
        srvPortOffset = 0;
        srvRegistered = true;
      }
    }
    catch (UnknownHostException e)
    {
      System.err.println("cannot find host");
      srvRegistered = false;
    }
  }
  // csv file FECNAME handler:
  class fecNameHndlr implements csvHandler
  {
    String target;
    fecNameHndlr(String name) { target = name; }
    public int process(String strValue,int index)
    {
      if (strValue.compareTo(target) == 0) 
      { // found it, halt iteration !
        srvName = new String(target);
        srvRegistered = true;
        return -1; 
      }
      return 0;
    }
  }
  // csv file IP Address handler:
  class ipAddrHndlr implements csvHandler
  {
    public int process(String strValue,int index)
    {
      try
      {
        srvHost = InetAddress.getByName(strValue);
      }
      catch (IOException e) {}
      return 0;
    }    
  }
  // csv file Port Offset Handler:
  class portHndlr implements csvHandler
  {
    public int process(String strValue,int index)
    {
      srvPortOffset = (short)(new Integer(strValue)).intValue();
      return 0;
    }    
  }
  public TSrvAddress(BufferedReader in,String name)
  {
    if (in == null) 
    { 
      System.out.println("looking for " + name + " in null file !");
      return;
    }
    // register the csv database structure: 
    csvColumn[] srvCols = new csvColumn[3];
    srvCols[0] = new csvColumn("FEC_NAME","",new fecNameHndlr(name));
    srvCols[1] = new csvColumn("IP_ADDR","",new ipAddrHndlr());
    srvCols[2] = new csvColumn("PORT_OFFSET","0",new portHndlr());
    // open it
    srvFile = new csv(in);
    // read it
    srvFile.readFile(srvCols);
    // close it
    srvFile.close();
  }
}