//: TLink.java
package de.desy.tine.headers;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import de.desy.tine.endianUtils.Swap;
public final class Theader
{
  private String username = null; 
  private short  protocol;
  private short  numInPacket;
  static public final short  hdrSizeInBytes = 2 + 16 + 2 + 2; // network header size
  private short totalSizeInBytes;
  private short msgSizeInBytes;
  ByteArrayOutputStream dBuffer;
  public Theader(String u)
  {
    username = u.toUpperCase();
    protocol = 5;
    numInPacket = 1;
    dBuffer = new ByteArrayOutputStream(hdrSizeInBytes);
  }
  public String getUserName() { return username; }
  public short getTotalSizeInBytes() { return totalSizeInBytes; }
  public short getMsgSizeInBytes() { return msgSizeInBytes;}
  public void setMsgSizeInBytes(short sizeInBytes) 
  { 
    msgSizeInBytes = sizeInBytes;
  }
  public byte[] toByteArray()
  {
    totalSizeInBytes = (short)(msgSizeInBytes + hdrSizeInBytes);
    try
    {
      dBuffer.reset();
      DataOutputStream ds = new DataOutputStream(dBuffer);
      ds.writeShort(Swap.Short(totalSizeInBytes));
      byte[] bstr = new byte[16];
      byte[] tmp  = username.getBytes();
      for (int i=0; i<16 && i<tmp.length; i++) bstr[i] = tmp[i];
      ds.write(bstr,0,16);
      ds.writeShort(Swap.Short(protocol));
      ds.writeShort(Swap.Short(numInPacket));
      ds.close();
      return dBuffer.toByteArray();
    }
    catch (IOException e)
    {
      e.printStackTrace();
    }
    return null;  
  }
  void removeThisMethod(short msgsize)  // prepare outgoing ...
  {
    msgSizeInBytes = msgsize;
    totalSizeInBytes = (short)(msgsize + hdrSizeInBytes);
    try
    {
      dBuffer.reset();
      DataOutputStream ds = new DataOutputStream(dBuffer);
      ds.writeShort(Swap.Short(totalSizeInBytes));
      byte[] bstr = new byte[16];
      byte[] tmp  = username.getBytes();
      for (int i=0; i<16 && i<tmp.length; i++) bstr[i] = tmp[i];
      ds.write(bstr,0,16);
      ds.writeShort(Swap.Short(protocol));
      ds.writeShort(Swap.Short(numInPacket));
      ds.close();
    }
    catch (IOException e)
    {
      e.printStackTrace();
    }	 
  }
  public Theader(byte[] data,int off, int len)  // prepare incoming ...
  {
    int bytesread = 0;
    try
    {
      ByteArrayInputStream dinBuffer = new ByteArrayInputStream(data,off,len);
      DataInputStream ds = new DataInputStream(dinBuffer);
      // overall message length:
      totalSizeInBytes = Swap.Short(ds.readShort());
      bytesread = 2;
      byte[] bstr = new byte[16];
      while (bytesread < hdrSizeInBytes)
      {
        ds.read(bstr,0,16);
        username = (new String(bstr)).trim();
        protocol = Swap.Short(ds.readShort());
        numInPacket = Swap.Short(ds.readShort());
        bytesread += 20;
      }
      ds.close();
      dinBuffer.close();
    }
    catch (IOException e)
    {
      e.printStackTrace();
    }
  }      
  public String toString()
  {
    return "User : " + username + "\nTotal size : " + totalSizeInBytes + "\nTotal number : " + numInPacket;
  }
  public short getProtocol()
  {
    return protocol;
  }
}