/*
 * Created on Nov 10, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package de.desy.tine.io;
import java.io.*;
import java.net.*;
import de.desy.tine.startup.TInitializer;
import de.desy.tine.startup.TInitializerFactory;

/**
 * \internal
 * 
 * @author duval
 *
 */
public class TPacket
{
  private TInitializer initializer=TInitializerFactory.getInstance().getInitializer();
  public MulticastSocket s; //DatagramSocket s;
  public MulticastSocket m;    
  InetAddress hostAddress;
  byte[] bufOut = new byte[1472];
  public DatagramPacket dpOut;
  byte[] bufIn = new byte[1472];
  public DatagramPacket dpIn = new DatagramPacket(bufIn, bufIn.length);
  public TPacket()
  {
    boolean socketBound = false;
    int port = initializer.getClnPort();
    for (int i=0; !socketBound && i<1000; i++)
    {
      try
      {
        //s = new DatagramSocket(port+i);
        InetAddress localAddr = InetAddress.getLocalHost();
        InetSocketAddress addr = new InetSocketAddress(localAddr, port+i);
        s = new MulticastSocket(null);
        s.setReuseAddress(false);
        s.bind(addr);
        s.setSoTimeout(0);
        s.setReceiveBufferSize(0x10000);
        s.setTimeToLive(16);
        socketBound = true;
      }
      catch (SocketException e)
      {
        if (i == 999)
        {
          System.err.println("Can't open socket");
          e.printStackTrace();
        }
      }
      catch (IOException e)
      {
        e.printStackTrace();
      }
    }
  }
  public TPacket(int port)
  {
    int clnport = initializer.getClnPort();
    boolean useNextPort = false;
    boolean socketBound = false;
    InetAddress grp;
    for (int i=0; !socketBound && i<1000; i++)
    {
      try
      {
        if (port == 0) 
        {
          useNextPort = true;
          //s = new DatagramSocket(clnport+i);
          InetAddress localAddr = InetAddress.getLocalHost();
          InetSocketAddress addr = new InetSocketAddress(localAddr, clnport+i);
          s = new MulticastSocket(null);
          s.setReuseAddress(false);
          s.bind(addr);
          s.setSoTimeout(0);
          s.setReceiveBufferSize(0x10000);
          s.setTimeToLive(16);
          socketBound = true;
        } 
        else if (port == initializer.getGCastPort()) 
        {
          grp = InetAddress.getByName(initializer.getGCastAddress());
          m = new MulticastSocket(port);
          m.joinGroup(grp);
          m.setSoTimeout(0);
          m.setTimeToLive(16);
          socketBound = true;
        } 
        else if (port == initializer.getMCastPort()) 
        {
          grp = InetAddress.getByName(initializer.getMCastAddress());
          m = new MulticastSocket(port);
          m.joinGroup(grp);
          m.setSoTimeout(0);
          m.setReceiveBufferSize(0x10000);
          m.setTimeToLive(16);
          socketBound = true;
        } 
        else if (port == initializer.getNetCastPort()) 
        {
          grp = InetAddress.getByName(initializer.getNetCastAddress());
          m = new MulticastSocket(port);
          m.joinGroup(grp);
          m.setSoTimeout(0);
          m.setReceiveBufferSize(0x10000);
          socketBound = true;
        } 
        else 
        {
          //s = new DatagramSocket(port);
          InetAddress localAddr = InetAddress.getLocalHost();
          InetSocketAddress addr = new InetSocketAddress(localAddr, port);
          s = new MulticastSocket(null);
          s.setReuseAddress(false);
          s.bind(addr);
          s.setReuseAddress(true);
          s.setSoTimeout(0);
          s.setReceiveBufferSize(0x10000);
          s.setTimeToLive(16);
          socketBound = true;
        }
      }
      catch (Exception e)
      {
        if (!useNextPort)
        {
          System.err.println("Can't open socket");
          e.printStackTrace();
        }
      }
    }
  }
}
