/*
 * Created on Aug 23, 2005
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package de.desy.tine.server.alarms;

import de.desy.tine.server.devices.TDevice;
import de.desy.tine.server.equipment.TEquipmentModule;

// each device has a (rather dynamic) linked list of these at any given time ...
public class TAlarm
{
  private long almTimestamp; // alarm timestamp
  private int almCode; // alarm code;
  private boolean almRemovalBlocked; // flag to keep alarm in table for CAS readout
  private byte almDescriptor; // alarm descriptor
  private byte almClearCount; // alarm's clear counter
  private byte[] almData = null;
  private TAlarmDefinition almDef = null;
  private TDevice almDevice = null;
  private boolean isTerminated = false;
  private int almTerminationWindow = 4; // seconds
  private int almHeartbeatWindow = 1200; // seconds
  public int getAlmHeartbeatWindow() { return almHeartbeatWindow; }
  public void setAlmHeartbeatWindow(int window) { almHeartbeatWindow = window; }
  public int getTerminationWindow () { return almTerminationWindow; }
  public void setTerminationWindow(int window) { if (window > 0) almTerminationWindow = window; }
  public int getTimeStamp() { return (int)(almTimestamp/1000); }
  public void setTimeStamp(long timestamp) { if (timestamp > 0) almTimestamp = timestamp; } 
  public void setTimeStamp(int timestamp) { if (timestamp > 0) almTimestamp = ((long)timestamp)*1000; } 
  public int getCode() { return almCode; }
  public boolean isRemovalBlocked() { return almRemovalBlocked; }
  public void blockRemoval() { almRemovalBlocked = true; }
  public void allowRemoval() { almRemovalBlocked = false; }
  public byte getDescriptor() { return almDescriptor; }
  public void setDescriptor(byte flags) { almDescriptor = flags; }
  public byte getClearCount() { return almClearCount; }
  public void resetClearCount() { almClearCount = 0; }
  public void clear() { if (almClearCount <64) almClearCount++; }
  public byte[] getData() { return almData; }
  public void setData(byte[] data) { almData = data; }
  public short getSeverity() { return almDef == null ? 0 : almDef.getAlmSeverity(); }
  public String getTag() { return almDef == null ? "" : almDef.getAlmTag(); }
  public TAlarm(int code, byte flags, byte[] data,TDevice device) 
  {
    almTimestamp = System.currentTimeMillis();
    almClearCount = 0;
    almRemovalBlocked = false;
    almCode = code;
    almDescriptor = flags;
    almData = data;
    almDevice = device;
    TEquipmentModule eqm = null;
    if (almDevice != null && (eqm=almDevice.getEqm()) != null)
    {
      almDef = (TAlarmDefinition)eqm.getAlarmDefinitionList().get(Integer.toString(code));
    }
    if (almDef == null)
    {
      almDef = (TAlarmDefinition)eqm.getEquipmentModuleFactory().getStockAlarmDefinitions().get(Integer.toString(code));
    }
    if (almDef == null)
    {
      almDef = new TAlarmDefinition("alarm text","text","device text",0,0,0);
    }
    if ((flags & TAlarmDescriptor.TERMINATE) == TAlarmDescriptor.TERMINATE)
      isTerminated = true;
  }
  public TAlarmDefinition getAlmDef() { return almDef; }
  public void setAlmDef(TAlarmDefinition almDef)
  {
    this.almDef = almDef;
  }
  // see XPropertyQuery for template to make an Alarm Message Structure on the fly from
  // a stock property query !
  public boolean isTerminated()
  {
    return isTerminated;
  }
  public void setTerminated(boolean isTerminated)
  {
    this.isTerminated = isTerminated;
  }
}
