/*
 * Created on Aug 31, 2005
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package de.desy.tine.server.alarms;

import de.desy.tine.server.equipment.TEquipmentModule;

public class TAlarmWatchEntry
{
  private TEquipmentModule eqm;
  private String dev;
  private String prp;
  private int  siz;
  private int  fmt;
  private int  atyp;              /* array type */
  private int  asys;              /* alarm system id */
  private int  sev;               /* of hi and low (warn is sev - 2) */
  private boolean chkNormal;      /* true => check masked values vs normal; false => check versus threshold */
  private int mask;               /* value mask */
  private int normal;             /* normal value setting for non-alarm state */
  private int  cnt;
  private int  cntThreshold;      /* set alarm when counter > threshold */
  private float hi;               /* high threshold */
  private float lo;               /* low threshold */
  private float hiwarn;           /* high warn threshold */
  private float lowarn;           /* low warn threshold */
  public TAlarmWatchEntry(TEquipmentModule equipmentModule,String devName,String devProperty,int size,
                   int format,int arrayType,int almSystem,int almSeverity,TAlarmWatchThreshold almThreshold)
  {
    eqm = equipmentModule;
    dev = devName;
    prp = devProperty;
    siz = size;
    fmt = format;
    atyp = arrayType;
    asys = almSystem;
    sev = almSeverity;
    cnt = 0;
    cntThreshold = almThreshold.getCnt();
    hi = almThreshold.getHi();
    lo = almThreshold.getLo();
    hiwarn = almThreshold.getHiwarn();
    lowarn = almThreshold.getLowarn();
    mask = almThreshold.getValueMask();
    normal = almThreshold.getValueNormal();
    if (mask != 0) chkNormal = true;
  }
  public int getAsys()
  {
    return asys;
  }
  public int getAtyp()
  {
    return atyp;
  }
  public int getCnt()
  {
    return cnt;
  }
  public void setCnt(int count) { cnt = count; }
  public int getCntThreshold()
  {
    return cntThreshold;
  }
  public String getDev()
  {
    return dev;
  }
  public TEquipmentModule getEqm()
  {
    return eqm;
  }
  public int getFmt()
  {
    return fmt;
  }
  public float getHi()
  {
    return hi;
  }
  public float getHiwarn()
  {
    return hiwarn;
  }
  public float getLo()
  {
    return lo;
  }
  public float getLowarn()
  {
    return lowarn;
  }
  public String getPrp()
  {
    return prp;
  }
  public int getSev()
  {
    return sev;
  }
  public int getSiz()
  {
    return siz;
  }
  public boolean checkNormal()
  {
    return chkNormal;
  }
  public int getMask()
  {
    return mask;
  }
  public int getNormal()
  {
    return normal;
  }
}
