/*
 * Created on Nov 9, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package de.desy.tine.server.connections;

import java.io.DataInput;
import java.io.DataOutput;
import java.io.IOException;
import java.io.OutputStream;
import java.net.InetAddress;
import java.net.Socket;
import de.desy.tine.definitions.TFormat;
import de.desy.tine.stringUtils.StringToBytes;
import de.desy.tine.structUtils.TStructBase;
import de.desy.tine.structUtils.TStructDescription;
import de.desy.tine.structUtils.TStructRegistry;

/**
 * \internal
 * 
 * @author duval
 */
public class TClient extends TStructBase
{
  // below used in queries ...
  public String userName; // 16 char
  byte[] IPXaddress = new byte[12]; //[4]; // 4 bytes
  byte[] node = new byte[6]; // 6 bytes IPX Immediate Address
  short IPfamily = 2;
  short IPport;
  public InetAddress IPaddress; // 4 bytes struct sockaddr_in
  byte[] IPsine_zero = new byte[8];
  public short ncontracts; // number of registrations
  public short protocol; // target client protocol level
  // above used in queries ...
  public short transport; // transport protocol
  public int port; // communication port
  public OutputStream output; // return communication stream if connected
  public Socket sck;
  static private TStructDescription myStructDsc; // Export Data structure
  static private final int ARRAY_SIZE_HINT = 20;
  static
  {
    initClientStruct();
  }
  public static TStructDescription getStructDescription()
  {
    return myStructDsc;
  }
  private static void initClientStruct()
  {
    if (TStructRegistry.contains("CLNQS")) return;
    myStructDsc = new TStructDescription("CLNQS"); //("XCLNS");
    myStructDsc.beginDefinition();
    myStructDsc.addField(TFormat.CF_TEXT, 16);
    myStructDsc.addField(TFormat.CF_BYTE, 12);
    myStructDsc.addField(TFormat.CF_BYTE, 6);

    myStructDsc.addField(TFormat.CF_SHORT, 1);
    myStructDsc.addField(TFormat.CF_SHORT, 1);
    
    myStructDsc.addField(TFormat.CF_BYTE, 4);

    myStructDsc.addField(TFormat.CF_BYTE, 8);
    
    myStructDsc.addField(2, TFormat.CF_SHORT, 1);
    myStructDsc.setArraySize(ARRAY_SIZE_HINT);
    myStructDsc.endDefinition();
    TStructRegistry.add(myStructDsc);
  }
  public void writeData(DataOutput dout) throws IOException
  {
    dout.write(StringToBytes.stringToFixedBytes(userName, 16));
    dout.write(IPXaddress);
    dout.write(node);
    dout.writeShort(IPfamily);
    dout.writeShort(port);
    // TODO unsure if bytes have to be swapped (writeInt?)
    // FIXME Trouble with IPV6? (6 Bytes)
    dout.write(IPaddress.getAddress(), 0, 4);
    dout.write(IPsine_zero);
    dout.writeShort(ncontracts);
    dout.writeShort(protocol);
  }
  /*
   * (non-Javadoc)
   * 
   * @see de.desy.tine.client.TStructIfc#readData(java.io.DataInput)
   */
  public void readData(DataInput din) throws IOException
  {
    // FIXME Not implemented
  }
}
