/*
 * Created on Nov 9, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 * 
 * CHANGES
 * 2005-02-10 JW * registerStockProperties() put into constructor
 * 13.7.05 PD * added getFecInformationFromFile() and overloaded method SystemInit() 
 */
package de.desy.tine.server.equipment;

import java.io.*;
import java.net.*;
import java.nio.channels.ServerSocketChannel;
import java.util.Date;
import java.util.HashMap;
import java.util.Iterator;
import java.util.LinkedList;
import de.desy.tine.addrUtils.*;
import de.desy.tine.client.*;
import de.desy.tine.csvUtils.*;
import de.desy.tine.dataUtils.TDataType;
import de.desy.tine.definitions.*;
import de.desy.tine.endianUtils.Swap;
import de.desy.tine.headers.*;
import de.desy.tine.io.*;
import de.desy.tine.queryUtils.*;
import de.desy.tine.server.*;
import de.desy.tine.server.alarms.*;
import de.desy.tine.server.connections.*;
import de.desy.tine.server.devices.TDevice;
import de.desy.tine.server.histories.*;
import de.desy.tine.server.logger.TFecLog;
import de.desy.tine.server.properties.*;
import de.desy.tine.startup.*;
import de.desy.tine.stringUtils.*;
import de.desy.tine.structUtils.TStructRegistry;
import de.desy.tine.structUtils.TTaggedStructure;
import de.desy.tine.types.*;

//import java.io.*;
/**
 * \internal
 * 
 * @author duval 
 */
public class TEquipmentModuleFactory
{
  private String gFecContext;
  private String gFecName;
  private String gFecDescription = "unknown";
  private String gFecLocation = "unknown";
  private String gFecSubsystem = "TEST";
  private String gFecHardware = "none";
  private String gFecResponsible = "unknown";
  private FECAddr gFecAddr;
  private FECInfo gFecInfo;
  private boolean gIsFecNameRegistered = false;
  private TLinkFactory gLinkFactory = null;
  private LinkedList clnInputDataTable = new LinkedList();
  private LinkedList gAliasList = new LinkedList();
  private TInitializer initializer = TInitializerFactory.getInstance().getInitializer();
  public TInitializer getInitializer() { return initializer;}
  private static TEquipmentModuleFactory instance = new TEquipmentModuleFactory();
  private TPacket srvp = null; // udp server socket for handling requests
  private ServerSocket srvs = null; // tcp server socket for handling requests
  private LinkedList bucketList = new LinkedList(); // do we need this ?
  private int gPortOffset = 0;
  static final int maxNumEqmTableEntries = 16;
  private int numEqmTableEntries = 0;
  private TEquipmentModule[] eqmTable = new TEquipmentModule[maxNumEqmTableEntries];
  private int numContractTableEntries = 0;
  private int numExpiredContracts = 0;
  private LinkedList conTable = new LinkedList();
  private int numClientEntries = 0;
  private LinkedList clnTable = new LinkedList();
  private TContractTable currentContractEntry = null;
  protected HashMap stkAlarmDefinitions = new HashMap();
  public HashMap getStockAlarmDefinitions() { return stkAlarmDefinitions; }
  private int gSystemTick = 10;
  private int gStaleData = 0;
  private int gBurstLimit = 1024;
  private int gCycleDelay = STD_CYCLE_INTERVAL;
  private int gBurstLimitReachedCount = 0;
  private int gClientReconnects = 0;
  private int gClientRetries = 0;
  private int gContractMisses = 0;
  private int gContractDelays = 0;
  private int gClientMisses = 0;
  private int gSingleLinkCount = 0;
  private long gDataTimeStamp = 0;
  private long gDataTimeStampOffset = 0;
  private long gSrvStartupTime = 0;
  private long gAppCompilationTime = 0;
  private int gAppVersionMajor = 1;
  private int gAppVersionMinor = 0;
  private int gAppVersionRevision = 0;
  private int[] gSrvStatsBuffer = new int[16];
  private String gLastErrorString;
  private String gLastMessage;
  private long gLastWriteAccessTime = 0;
  private String gLastWriteAccessUser = null;
  private InetAddress gLastWriteAccessAddr = null;
  private String gLastWriteAccessPrp = null;
  private String gLastWriteAccessDev = null;
  private String gLastWriteAccessEqm = null;
  private int debugLevel = 0;
  private int gTotalUdpPackets = 0;
  private int gTotalTcpPackets = 0;
  private TAcceptorThread acceptThrd;
  private TCycleThread cycleThrd;
  private boolean gLinkTablesAccessed = false;
  private boolean gSystemExitCondition = false;
  private boolean isInsideCycle = false;
  public boolean isInitialized = false;
  public boolean registrationPending = false;
  public boolean gSynchronizeContracts = true;
  public boolean gRequireAcknowledgments = true;
  public boolean gEqpFcnBusySemaphore = false;
  public boolean gSystemPresetMemory = false;
  public boolean gRetardSingleContractRemoval = true;
  public boolean gPutCommandsInFeclog = true;
  private String gCasName;
  public boolean gCasConfigured = false;
  private static final short ACK_PENDING = 0x7fff;
  private static final short SUB_PENDING = 0x3fff;
  private static final short BCAST_ID = 255;
  private static final short PRP_SCHEDULE_SIGNAL = 0;
  private static final short PRP_RETRY_SIGNAL = 1;
  private static final short PRP_CANCEL_SIGNAL = 2;
  private static final short RENEWAL = 60;
  private static final short REMINDER = 5;
  private static final short ACK_REQUEST = (2 * REMINDER);
  private static final short HEARTBEAT = 60;
  private static final short REPLY_PENDING = 3;
  private static final int STD_CYCLE_INTERVAL = 1;
  private int gMinPollingRate = 10;
  private int gMaxPollingRate = 60000;
  private int gBkgPollingRate = 1000;
  private int gNumBkgTasks = 0;
  private TEquipmentModuleHook tEqmHook = null;
  public void setTEquipmentModuleHook(TEquipmentModuleHook hook) 
  { 
    tEqmHook = hook;
    // if this is called after the factory's systemInit() has been called ...
    if (isInitialized) hook.SystemInit();
  }
  public TEquipmentModuleHook getTEquipmentModuleHook() { return tEqmHook; }
  private String tRedirectedServer;
  private boolean isDeviceRedirected(String redirString,String devName)
  {
    if (redirString == null || redirString.length() == 0) return false;
    if (devName == null || devName.length() == 0) return true;
    int idx = redirString.lastIndexOf('/');
    if (idx == -1) return true; // not given in redirection string
    int edx = redirString.indexOf('[');
    if (edx == -1) edx = redirString.length(); else edx--;
    if (redirString.substring(idx+1,edx).compareTo(devName) == 0) return true;
    return false;
  }
  private byte[] redirectionStringToBytes(String redirString)
  { // parse strings of form "/<context>/<server>/<device>[<property>] into byte array ...
    byte[] b = new byte[32];
    String s, srv, dev, prp = "";    
    int indx = redirString.indexOf('[');
    if (indx != -1)
    { // property given !
      if (indx == 0) return b; // invalid string
      s = redirString.substring(0,indx-1);
      prp = redirString.substring(indx+1);
      if ((indx=prp.indexOf(']')) == -1) return b; // invalid string
      prp = indx > 0 ? prp.substring(0,indx-1) : "";
    }
    else 
    {
      s = redirString;
    }
    indx = s.indexOf('/');
    if (indx == 0)  
    { // context given, peel it off 
      indx = s.substring(1).indexOf('/');
      if (indx == -1) return b; // invalid string 
      s = s.substring(indx+1);
      indx = s.indexOf('/');
    }
    // s is now of the form <server>/<device>
    if (indx == -1)
    {
      srv = s;
      dev = "";
    }
    else
    {
      srv = indx > 0 ? s.substring(0,indx-1) : "";
      dev = s.substring(indx+1);
    }
    // this is the way it's done in release 3 ...
    int len = srv.length();
    System.arraycopy(srv.getBytes(),0,b,0,len);    
    len = prp.length();
    System.arraycopy(prp.getBytes(),0,b,16,len);    
    return b;
  }
  private TServerStatistics serverStatistics = new TServerStatistics(this);
  public int setRedirectionString(String redirectionString) 
  { 
    tRedirectedServer = redirectionString;
    return TErrorList.server_redirection;
  }
  public TContractTable getCurrentContractEntry() { return currentContractEntry; }
  TPropertyList stockList = new TPropertyList(); // a list or a query fcn
  public TPropertyList getStockList() { return stockList; }
  TMetaProperties metaProps = new TMetaProperties();
  class AliasTableEntry 
  {
    private String name;
    private String alias;
    AliasTableEntry(String thisName,String thisAlias)
    {
      name = thisName;
      alias = thisAlias;
    }
    public String getTag() { return name; }
    public String getAlias() { return alias; }
  }
  public int addAliasToList(String name, String alias)
  {
    if (name == null || name.length() == 0) return TErrorList.argument_list_error;
    if (alias == null || alias.length() == 0) return TErrorList.argument_list_error;
    gAliasList.add(new AliasTableEntry(name,alias));
    return 0;
  }
  /**
   * Register common stock properties.
   */
  void registerStockProperties()
  {
    /*
     * HOW TO ADD A STOCK PROPERTY 1. Create Stock Property (see
     * TStockProperties) 2. Add a property handler here
     */
    stockList.addProperty(TStockProperties.NSTOCKPROPS, new TPropertyHandler()
    {
      public int call(String devName, TDataType dout, TDataType din, TAccess devAccess)
      {
        return (short) dout.putData(TStockProperties.getNumStockProperties());
      }
    });
    // Returns all known stock properties, if available or not.
    stockList.addProperty(TStockProperties.STOCKPROPS, new TPropertyHandler()
    {
      public int call(String devName, TDataType dout, TDataType din, TAccess devAccess)
      {
        return (short) dout.putData(StringToName.stringSetToName32(TStockProperties.getPropertyNames()));
      }
    });
    stockList.addProperty(TStockProperties.STOCKPROPS_USTRING, new TPropertyHandler()
        {
          public int call(String devName, TDataType dout, TDataType din, TAccess devAccess)
          {
            boolean checkWildCard = (devName.compareTo("*") != 0 && devName.indexOf("*") != -1);
            TPropertyList lst = TStockProperties.getPropertyList();            
            String[] slst = new String[lst.countUniqueProperties()];
            lst.getPropertyNames().toArray(slst);
            if (checkWildCard) slst = StringToName.matchStringsInArray(slst,devName);
            USTRING[] ustr = new USTRING[slst.length];
            char[] cha;
            StringBuffer sb = new StringBuffer(80);
            TExportProperty prp;
            for (int i = 0; i<slst.length; i++)
            {
              ustr[i] = new USTRING();
              if ((prp = lst.getFirstProperty(slst[i])) == null) continue;
              cha = prp.getName().toCharArray();
              sb.insert(0,cha);
              for (int c=cha.length; c<32; c++) sb.insert(c,(char)0);
              cha = prp.getDescription().getText().toCharArray();
              sb.insert(32,cha);
              ustr[i].setValues(prp.getOutputSize(),0,0,prp.getOutputFormat(),new String(sb));
            }
            return (short) dout.putData(ustr);
          }
        });
    stockList.addProperty(TStockProperties.STOCKPROPS_STRUCT, new TPropertyHandler()
    {
      protected int call(String devName, TDataType dout, TDataType din, TAccess devAccess)
      {
        return callPropertyStockProps(devName, dout, din, devAccess);
      }
    });
    stockList.addProperty(TStockProperties.SRVSTARTTIME, new TPropertyHandler()
    {
      protected int call(String devName, TDataType dout, TDataType din, TAccess devAccess)
      {
        return (short) dout.putData(new Date(getServerStartTime()).toString());
      }
    });
    stockList.addProperty(TStockProperties.SRVSTARTTIME_LONG, new TPropertyHandler()
    {
      protected int call(String devName, TDataType dout, TDataType din, TAccess devAccess)
      {
        return (short) dout.putData((int) (getServerStartTime() / 1000));
      }
    });
    stockList.addProperty(TStockProperties.STRUCTFORMAT, new TPropertyHandler()
    {
      protected int call(String devName, TDataType dout, TDataType din, TAccess devAccess)
      {
        return callPropertyStructFormat(devName, dout, din, devAccess);
      }
    });
    stockList.addProperty(TStockProperties.CONTRACTS, new TPropertyHandler()
    {
      protected int call(String devName, TDataType dout, TDataType din, TAccess devAccess)
      {
        return callPropertyContracts(devName, dout, din, devAccess);
      }
    });
    stockList.addProperty(TStockProperties.CLIENTS, new TPropertyHandler()
    {
      protected int call(String devName, TDataType dout, TDataType din, TAccess devAccess)
      {
        return callPropertyClients(devName, dout, din, devAccess);
      }
    });
    stockList.addProperty(TStockProperties.ACTIVITY, new TPropertyHandler()
    {
      protected int call(String devName, TDataType dout, TDataType din, TAccess devAccess)
      {
        return callPropertyActivity(devName, dout, din, devAccess);
      }
    });
    stockList.addProperty(TStockProperties.SRVDESC, new TPropertyHandler()
    {
      protected int call(String devName, TDataType dout, TDataType din, TAccess devAccess)
      {
        return (short) dout.putData(getFecDescription());
      }
    });
    stockList.addProperty(TStockProperties.SRVLOCATION, new TPropertyHandler()
    {
      protected int call(String devName, TDataType dout, TDataType din, TAccess devAccess)
      {
        return (short) dout.putData(getFecLocation());
      }
    });
    stockList.addProperty(TStockProperties.SRVALIASLIST, new TPropertyHandler()
    {
      protected int call(String devName, TDataType dout, TDataType din, TAccess devAccess)
      {
        if (gAliasList == null) return TErrorList.not_implemented;
        int len = gAliasList.size()*2;
        if (len == 0) return TErrorList.not_defined;
        NAME32 n32[] = new NAME32[len];
        AliasTableEntry ate;
        for (int i=0; i<len/2; i++)
        {
          ate = (AliasTableEntry)gAliasList.get(i);
          n32[2*i] = new NAME32(ate.name);
          n32[2*i+1] = new NAME32(ate.alias);
        }
        return (short) dout.putData(n32);
      }
    });
    stockList.addProperty(TStockProperties.SRVLASTACCESS, new TPropertyHandler()
    {
      protected int call(String devName, TDataType dout, TDataType din, TAccess devAccess)
      {
        NAME32[] n32 = new NAME32[dout.dArrayLength];
        String s = null;
        switch (dout.dArrayLength)
        {
          case 6:
            s = getLastAccessEqm();
            n32[5] = new NAME32(s != null ? s : "");
          case 5: 
            n32[4] = new NAME32(new Date(getLastAccessTime()).toString());
          case 4:
            s = getLastAccessDev();
            n32[3] = new NAME32(s != null ? s : "");
          case 3: 
            s = getLastAccessPrp();
            n32[2] = new NAME32(s != null ? s : "");
          case 2: 
            InetAddress iaddr = getLastAccessAddress();
            s = iaddr != null ? getLastAccessAddress().getHostAddress() : "";
            n32[1] = new NAME32(s);
          case 1: 
            s = getLastAccessUser();
            n32[0] = new NAME32(s != null ? s : "");
            break;
          default:
            return TErrorList.dimension_error;
        }
        return (short) dout.putData(n32);
      }
    });
    stockList.addProperty(TStockProperties.SRVLASTACCESS_LONG, new TPropertyHandler()
    {
      protected int call(String devName, TDataType dout, TDataType din, TAccess devAccess)
      {
        return (short) dout.putData((int)(getLastAccessTime()/100));
      }
    });
    stockList.addProperty(TStockProperties.SRVSTATS, new TPropertyHandler()
    {
      protected int call(String devName, TDataType dout, TDataType din, TAccess devAccess)
      {
        return (short) dout.putData(getServerStats());
      }
    });
    stockList.addProperty(TStockProperties.SRVEXIT, new TPropertyHandler()
    {
      protected int call(String devName, TDataType dout, TDataType din, TAccess devAccess)
      {
        if (devAccess.isWrite())
        {
          gSystemExitCondition = true;
          return 0;
        }
        return TErrorList.illegal_read_write;
      }
    });
    stockList.addProperty(TStockProperties.DEBUGLEVEL, new TPropertyHandler()
    {
      protected int call(String devName, TDataType dout, TDataType din, TAccess devAccess)
      {
        int cc = 0;
        short[] dbglvl = new short[1]; 
        if (din != null && devAccess.isWrite())
        {
          if  ((cc=din.getData(dbglvl)) == 0) 
          {
            debugLevel = dbglvl[0];
            if (gLinkFactory != null) gLinkFactory.setDebugLevel(debugLevel);
          }
        }
        if (cc == 0 && dout != null)
        {
          dbglvl[0] = (short)debugLevel;
          cc = dout.putData(dbglvl);
        }
        return cc;
      }
    });
    stockList.addProperty(TStockProperties.LOGCOMMANDS, new TPropertyHandler()
    {
      protected int call(String devName, TDataType dout, TDataType din, TAccess devAccess)
      {
        int cc = 0;
        short[] logcmds = new short[1]; 
        if (din != null && devAccess.isWrite())
        {
          if  ((cc=din.getData(logcmds)) == 0) 
            gPutCommandsInFeclog = logcmds[0] != 0 ? true : false;
        }
        if (cc == 0 && dout != null)
        {
          logcmds[0] = (short)(gPutCommandsInFeclog ? -1 : 0);
          cc = dout.putData(logcmds);
        }
        return cc;
      }
    });
    stockList.addProperty(TStockProperties.MESSAGE, new TPropertyHandler()
    {
      protected int call(String devName, TDataType dout, TDataType din, TAccess devAccess)
      {
        int cc = 0;
        char[] msg = new char[128]; 
        if (din != null && devAccess.isWrite())
        {
          if  ((cc=din.getData(msg)) == 0)
          {
            gLastMessage = new String(msg).substring(0, din.dCompletionLength);
            String s = "MSG: " + gLastMessage;
            System.out.println(s);
            TFecLog.log(s);
          }
        }
        if (cc == 0 && dout != null)
        {
          cc = dout.putData(gLastMessage);
        }
        return cc;
      }
    });
    stockList.addProperty(TStockProperties.LOGFILE, new TPropertyHandler()
    {
      protected int call(String devName, TDataType dout, TDataType din, TAccess devAccess)
      {
        if (dout.getFormat() != TFormat.CF_TEXT) return TErrorList.illegal_format;
        int nlines = dout.getArrayLength()/80;
        return (short) dout.putData(TFecLog.getLines(nlines));
      }
    });
    stockList.addProperty(TStockProperties.LOGDEPTH, new TPropertyHandler()
    {
      protected int call(String devName, TDataType dout, TDataType din, TAccess devAccess)
      {
        int cc = 0;
        int[] depth = new int[1]; 
        if (din != null && devAccess.isWrite())
        {
          if  ((cc=din.getData(depth)) == 0) 
          {
            TFecLog.setLogDepth(depth[0]);
          }
        }
        if (cc == 0 && dout != null)
        {
          depth[0] = TFecLog.getLogDepth();
          cc = dout.putData(depth);
        }
        return cc;
      }
    });
    stockList.addProperty(TStockProperties.APPDATE_STRING, new TPropertyHandler()
    {
      protected int call(String devName, TDataType dout, TDataType din, TAccess devAccess)
      {
        return (short) dout.putData(new Date(getAppCompilationTime()).toString());
      }
    });
    stockList.addProperty(TStockProperties.APPDATE, new TPropertyHandler()
    {
      protected int call(String devName, TDataType dout, TDataType din, TAccess devAccess)
      {
        return (short) dout.putData((int) (getAppCompilationTime() / 1000));
      }
    });
    stockList.addProperty(TStockProperties.APPVERSION, new TPropertyHandler()
    {
      protected int call(String devName, TDataType dout, TDataType din, TAccess devAccess)
      {
        return (short) dout.putData(getAppVersion());
      }
    });
    stockList.addProperty(TStockProperties.SRVLOGFILES, new TPropertyHandler()
    {
      public int call(String devName, TDataType dout, TDataType din, TAccess devAccess)
      {
        return (short) dout.putData(StringToName.stringArrayToName64(TFecLog.getFiles()));
      }
    });
    stockList.addProperty(TStockProperties.SRVLOGFILE, new TPropertyHandler()
    {
      protected int call(String devName, TDataType dout, TDataType din, TAccess devAccess)
      {
        String tgtLogFile = null;
        if (din == null || din.getArrayLength() == 0)
        {
          tgtLogFile = "fec.log.0";
        }
        else
        {
          char[] fileName = new char[128];
          int cc = din.getData(fileName);
          if (cc != 0) return cc;
          tgtLogFile = fileName.toString();
        }
        if (dout.getFormat() != TFormat.CF_TEXT) return TErrorList.illegal_format;
        int nlines = dout.getArrayLength()/80;
        return (short) dout.putData(TFecLog.getLines(tgtLogFile,nlines));
      }
    });

  }
  private short callPropertyActivity(String devName, TDataType dout, TDataType din,TAccess devAccess)
  {
    short cc = 0;
    ByteArrayOutputStream bsout = new ByteArrayOutputStream(1024);
    TDataOutputStream dsout = new TDataOutputStream(bsout);
    try
    {
      serverStatistics.setNumTotalContracts((short)(conTable.size()));
      serverStatistics.setNumTotalClients((short)clnTable.size());
      serverStatistics.setNumTargetClients((short)getCurrentContractEntry().eqm.numClients);
      serverStatistics.setNumTargetContracts((short)getCurrentContractEntry().eqm.numContracts);
      serverStatistics.setNumBkgTsks((short)gNumBkgTasks);
      serverStatistics.setNumConnectionTimeouts(TLinkFactory.getInstance().getTotalLinkTimeouts());
      serverStatistics.setNumConnectionArrivals(TLinkFactory.getInstance().getTotalConnectionArrivals());
      serverStatistics.setNumUdpPkts(gTotalUdpPackets);
      serverStatistics.setNumTcpPkts(gTotalTcpPackets);
      serverStatistics.setSystemPollingRate(gMinPollingRate);
      serverStatistics.writeData(dsout);
      dsout.close();
      cc = (short) dout.putData(bsout.toByteArray(),TServerStatistics.getStructDescription().getTagName());
    }
    catch (IOException e)
    {
      cc = TErrorList.code_failure;
    }
    return cc;
  }
  private short callPropertyStockProps(String devName, TDataType dout, TDataType din,
      TAccess devAccess)
  {
    LinkedList matchingProps;
    ByteArrayOutputStream bsout = new ByteArrayOutputStream(1024);
    TDataOutputStream dsout = new TDataOutputStream(bsout);
    Iterator it;
    if (dout.getTag().compareTo("XPQS") == 0 || (dout.getArrayLength() % XPropertyQuery.sizeInBytes) == 0)
    {
      if (din != null)
      { // target property specified ...
        String tgt = din.toString();
        tgt = tgt.replace('\n', (char) 0).trim();
        matchingProps = TStockProperties.getPropertyList().getEqualProperties(tgt);
        if (matchingProps == null || matchingProps.size() == 0) return TErrorList.not_exported;
        // fill in the targetted property info
        try
        {
          XPropertyQuery xpq = null;
          for (it = matchingProps.iterator(); it.hasNext();)
          {
            xpq = new XPropertyQuery((TExportProperty) it.next(), matchingProps.size() - 1);
            xpq.writeData(dsout);
          }
          dsout.close();
          return (short) dout.putData(bsout.toByteArray(), "XPQS");
        }
        catch (Exception e)
        {
          return TErrorList.code_failure;
        }
      }
      else
      { // want the whole list ...
        TPropertyList lst = TStockProperties.getPropertyList();
        String[] slst = new String[lst.countUniqueProperties()];
        lst.getPropertyNames().toArray(slst);
        XPropertyQuery[] xpq = new XPropertyQuery[slst.length];
        if (slst.length == 0) return 0;
        byte[] tba = new byte[slst.length * XPropertyQuery.sizeInBytes];
        TExportProperty prp;
        for (int i=0; i<slst.length; i++)
        {
          prp = lst.getFirstProperty(slst[i]);
          xpq[i] = new XPropertyQuery(prp,1);
          System.arraycopy(xpq[i].toByteArray(), 0, tba, i * XPropertyQuery.sizeInBytes,
              XPropertyQuery.sizeInBytes);
        }
        return (short) dout.putData(tba, "XPQS");
      }
    }
    return TErrorList.illegal_format;
  }
  private short callPropertyStructFormat(String devName, TDataType dout, TDataType din,
      TAccess devAccess)
  {
    short cc = 0;
    String tag = din.toString();
    tag = tag.replace('\n', (char) 0).trim();
    INTINT[] structData = TStructRegistry.getRegisteredStructure(tag);
    if (structData != null)
    {
      cc = (short) dout.putData(structData);
    }
    else
    {
      cc = TErrorList.illegal_property;
    }
    return cc;
  }
  private short callPropertyContracts(String devName, TDataType dout, TDataType din,
      TAccess devAccess)
  {
    short cc = 0;
    Iterator it = conTable.iterator();
    ByteArrayOutputStream bsout = new ByteArrayOutputStream(1024);
    TDataOutputStream sdout = new TDataOutputStream(bsout);
    TContractTable contract = null;
    try
    {
      while (it.hasNext())
      {
        contract = (TContractTable) it.next();
        contract.writeData(sdout);
      }
      sdout.close();
      dout.putData(bsout.toByteArray(), TContractTable.getStructDescription().getTagName());
    }
    catch (Exception e)
    {
      cc = TErrorList.code_failure;
    }
    return cc;
  }
  private short callPropertyClients(String devName, TDataType dout, TDataType din, TAccess devAccess)
  {
    short cc = 0;
    Iterator it = clnTable.iterator();
    ByteArrayOutputStream bsout = new ByteArrayOutputStream(1024);
    TDataOutputStream sdout = new TDataOutputStream(bsout);
    TClient element = null;
    try
    {
      while (it.hasNext())
      {
        element = (TClient) it.next();
        element.writeData(sdout);
      }
      sdout.close();
      dout.putData(bsout.toByteArray(), TContractTable.getStructDescription().getTagName());
    }
    catch (Exception e)
    {
      cc = TErrorList.code_failure;
    }
    return cc;
  }
  private InetAddress mcastInetAddress = null;
  /**
   * ???
   * 
   * @return
   */
  private InetAddress getMCastAddr()
  {
    if (mcastInetAddress != null) return mcastInetAddress;
    try
    {
      mcastInetAddress = InetAddress.getByName(initializer.getMCastAddress());
      return mcastInetAddress;
    }
    catch (Exception e)
    {
      return null;
    }
  }
  /**
   * ???
   * 
   * @param ia
   * @return
   */
  private InetAddress getBCastAddr(InetAddress ia)
  {
    String strAddr = ia.getHostAddress();
    strAddr = strAddr.substring(0,strAddr.lastIndexOf('.')).concat("255");
    try 
    {
      return InetAddress.getByName(strAddr);
    }
    catch (Exception e)
    {
      return null;
    }
  }
  /**
   * Finds the best polling interval which satisfies 2 different client requests. 
   * For instance, if client A wants an interval of 2000 msecs and client B wants 
   * an interval of 3000 msecs, then polling every 1000 msecs can satisfy both. 
   * 
   * @param p1 is polling interval number 1
   * @param p2 is polling interval number 2
   * @return a polling interval which can satisfy the given intervals
   */
  private int findpoll(int p1, int p2)
  {
    int p3;
    if (gMinPollingRate > gMaxPollingRate) gMinPollingRate = gMaxPollingRate;
    if (p1 < gMinPollingRate) return p2 <= gMinPollingRate ? gMinPollingRate : p2;
    if (p2 < gMinPollingRate || p1 == p2) return p1;
    if (p2 < p1)
      while ((p3 = p1 % p2) >= gMinPollingRate)
      {
        p1 = p2;
        p2 = p3;
      }
    else if (p1 < p2) while ((p3 = p2 % p1) >= gMinPollingRate)
    {
      p2 = p1;
      p1 = p3;
    }
    return p1 > p2 ? p2 : p1;
  }
  /**
   * TODO keep bcast nets list in factory (not specific to an eqm); follow isMemberControlNets
   * logic
   * 
   * @param tc the Tine Client to check against the list
   * @return
   */
  private boolean isMemberBcastNets(TClient tc)
  {
    if (debugLevel > 0) System.out.println("IsMemberBcastNets : non yet implemented");
    return true;
  }
  private String[] charSplit(String str,char c)
  {
    String[] newStr = null;
    int n,i,k;
    for (i=0,n=0,k=0; i<str.length(); i = k+1)
    {
      n++; // count the segments
      if ((k=str.indexOf(c,i)) < 0) break;
    }
    newStr = new String[n];
    for (i=0,n=0,k=0; i<str.length(); i = k+1, n++)
    {
      if ((k=str.indexOf(c,i)) < 0)
      {
        newStr[n] = new String(str.substring(i));
        break;
      }
      newStr[n] = new String(str.substring(i,k));
    }
    return newStr;
  }
  private boolean isMemberControlNets(TEquipmentModule eqm, TClient tc)
  {
    if (eqm.gRegisteredNetsList == null || 
        eqm.gRegisteredNetsList.size() == 0) return true; // everyone is !
    // check vs subnet, vs specified address ...
    String tgtAddr = tc.IPaddress.getHostAddress();
    if (eqm.gRegisteredNetsList.contains(tgtAddr)) return true;
    // note : String.split(".") does NOT work !!!
    String s[] = charSplit(tgtAddr,'.');
   if (s.length < 4) return false;
    String netAddr = s[0] + "." + s[1] + "." + s[2] + ".255";
    if (eqm.gRegisteredNetsList.contains(netAddr)) return true;
    netAddr = s[0] + "." + s[1] + ".255.255";
    if (eqm.gRegisteredNetsList.contains(netAddr)) return true;
    return false;
  }
  private boolean isMemberUsersList(TEquipmentModule eqm, String userName)
  {
    if (eqm.gRegisteredUsersList == null || 
        eqm.gRegisteredUsersList.size() ==  0) return true; // everyone is !
    if (eqm.gRegisteredUsersList.contains(userName.toUpperCase())) return true;
    return false;
  }
  private boolean isMemberLockSet(TEquipmentModule eqm, TClient tc)
  {
    if (eqm.accessLock.clientCanWrite(tc)) return true;
    return false;
  }
  /**
   * Find the equipment module associated with the contract request.
   * TeqmFactory manages all registered equipment modules, and in most cases
   * this is a list of 1.  The value of numEqmTableEntries very rarely is
   * as large as 5 or 6, so a simple name check will always yield fast results.
   * 
   * @param tc is the contract for which the associated equipment module is 
   * desired.
   * @return the equipment module found or a null pointer.
   */
  private TEquipmentModule LocateEquipmentModule(TContract tc)
  {
    for (int i = 0; i < numEqmTableEntries; i++)
    {
      if (eqmTable[i] == null) continue;
      if (eqmTable[i].getModuleName().length() == 0) continue;
      if (eqmTable[i].getModuleName().compareTo(tc.EqpName) != 0) continue;
      return eqmTable[i];
    }
    return null;
  }
  /**
   * \brief finds a client entry within the contract table for the client 
   * address given
   * 
   * "Client Entries" and "Contract Entries" are two different things.  Furthermore,
   * a Client Entry is composed of a Contract-independent Client Address plus a 
   * Contract-specific Client Status.  A "Contract Entry" is composed of a Client-
   * independent Contract plus a client entry list.  This routine checks to see if 
   * the input Client Address is found within the client entry list belonging to the
   * input contract entry.  If not, it creates a new Client Entry based on the
   * input client address and appends this entry to the contract table's list.   
   * It also increments counters on the Client Entry (number of contracts the client 
   * has) and on the Contract Entry (number of clients the contract is servicing).
   * 
   * @param ct is the Contract Table Entry to be scanned
   * @param tc is the Client Address for which the Client Entry is desired
   * 
   * @return a TClientEntry object
   */
  private TClientEntry LocateClientInContract(TContractTable ct, TClient tc)
  {
    TClientEntry tce = null;
    int i = 0;
    for (i = 0; i < ct.clt.size(); i++)
    {
      tce = (TClientEntry) ct.clt.get(i);
      //if (tce.cln.IPaddress.equals(tc.IPaddress)) {
      if (tce.cln.equals(tc))
      {
        if (tc.ncontracts == 0)
        {
          ct.pending = 0;
          ct.nclients++;
          tc.ncontracts++;
          //tce.cln.ncontracts++;
          //tc.ncontracts = tce.cln.ncontracts;
          if (tc.protocol == 0)
          {
            tc.protocol = 5;
          }
        }
        if (debugLevel > 2)
            System.out.println("found client " + tc.IPaddress.getHostAddress()
                + " in contract list");
        return tce;
      }
    }
    tce = new TClientEntry();
    tce.cln = tc;
    tce.cln.ncontracts++;
    tce.cln.protocol = 5; // hard-wired for now
    tce.sts = new TClientStatus();
    tce.sts.statusCode = (short) ct.returnCode;
    tce.sts.counter = 1;
    ct.clt.add(tce);
    ct.nclients++;
    if (debugLevel > 2)
        System.out.println("added client " + tc.IPaddress.getHostAddress() + " to contract list");
    return tce;
  }
  private TContractTable LocateContractInList(TContract con, TDataType din)
  {
    TContractTable tct = null;
    int freeContractID = 1;
    for (int i = 0; i < conTable.size(); i++)
    {
      tct = (TContractTable) conTable.get(i);
      if (tct.contractID == freeContractID) freeContractID++;
      if (!tct.contract.equals(con)) continue;
      if (tct.din != null && !tct.din.equals(din)) continue;
      if (debugLevel > 2) System.out.println("found contract in list");
      return tct;
    }
    if ((tct = new TContractTable()) != null)
    {
      tct.contract = con;
      tct.contractID = freeContractID;
      tct.din = din;
      tct.dout = new TDataType(con.EqpSizeOut, con.EqpFormatOut);
      tct.dout.setTag(con.strTagOut);
      tct.drb = new TDataType(con.EqpSizeOut, con.EqpFormatOut);
      tct.drb.setTag(con.strTagOut);
      tct.eqm = LocateEquipmentModule(con);
      if (debugLevel > 2) System.out.println("added contract to list (ID = " + tct.contractID + ")");
      conTable.add(tct);
      serverStatistics.setNumTotalContracts((short) conTable.size());
    }
    return tct;
  }
  private TClient LocateClientInList(InetAddress ia, int port)
  {
    TClient tc = null;
    for (int i = 0; i < clnTable.size(); i++)
    {
      try
      {
        tc = (TClient) clnTable.get(i);
      }
      catch (Exception e)
      {
        break;
      }
      if (!tc.IPaddress.equals(ia)) continue;
      if (tc.port != port) continue;
      if (debugLevel > 2)
          System.out.println("found client" + ia.getHostAddress() + " in client list");
      return tc;
    }
    if ((tc = new TClient()) != null)
    {
      tc.IPaddress = ia;
      tc.port = port;
      clnTable.add(tc);
      if (debugLevel > 2)
          System.out.println("add client" + ia.getHostAddress() + " to client list");
      serverStatistics.setNumTotalClients((short) clnTable.size());
    }
    return tc;
  }
  private TEquipmentModuleFactory()
  {
    debugLevel = Integer.parseInt(System.getProperty("debug.level", "0"));
    cycleThrd = new TCycleThread();
    cycleThrd.start();
    acceptThrd = new TAcceptorThread(TTransport.UDP);
    acceptThrd.start();
    acceptThrd = new TAcceptorThread(TTransport.TCP);
    acceptThrd.start();
    this.registerStockProperties();
    getAliasListFromFile();
  }
  public long getServerStartTime()
  {
    return gSrvStartupTime;
  }
  public int[] getServerStats()
  {
    //TODO: put in the cyclecounts logic ...
    gSrvStatsBuffer[0] = 0; // ave busy time
    gSrvStatsBuffer[1] = 0; // gCycleCounts
    gSrvStatsBuffer[2] = 0; // gMaxCycleCounts
    gSrvStatsBuffer[3] = gSingleLinkCount;
    gSrvStatsBuffer[4] = gClientMisses;
    gSrvStatsBuffer[5] = gClientReconnects;
    gSrvStatsBuffer[6] = gClientRetries;
    gSrvStatsBuffer[7] = gContractMisses;
    gSrvStatsBuffer[8] = gContractDelays;
    gSrvStatsBuffer[9] = gBurstLimitReachedCount;
    gSrvStatsBuffer[10] = (int)gDataTimeStampOffset * 1000;
    
    return gSrvStatsBuffer;
  }
  public long getAppCompilationTime()
  {
    return gAppCompilationTime;
  }
  public String getAppVersion()
  {
    StringBuffer appv = new StringBuffer(32); 
    appv.append("" + gAppVersionMajor);
    if (gAppVersionMinor < 10)  appv.append(".0" + gAppVersionMinor);
    else appv.append("." + gAppVersionMinor);
    if (gAppVersionRevision < 10) appv.append(".000" + gAppVersionRevision);  
    else if (gAppVersionRevision < 100) appv.append(".00" + gAppVersionRevision);  
    else if (gAppVersionRevision < 1000) appv.append(".0" + gAppVersionRevision);  
    else appv.append("." + gAppVersionRevision);
    return appv.toString();  
  }
  public int getAppVersionMajor() { return gAppVersionMajor; }
  public int getAppVersionMinor() { return gAppVersionMinor; }
  public int getAppVersionRevision() { return gAppVersionRevision; }
  public void setAppVersionMajor(int major) { gAppVersionMajor = major; }
  public void setAppVersionMinor(int minor) { gAppVersionMinor = minor; }
  public void setAppVersionRevision(int revision) { gAppVersionRevision = revision; }
  public static TEquipmentModuleFactory getInstance()
  {
    if (instance == null) instance = new TEquipmentModuleFactory();
    return instance;
  }
  public int setFecName(String name)
  {
    if (name.length() <= 16)
      gFecName = new String(name);
    else
      gFecName = new String(name.substring(0, 15));
    return 0;
  }
  public String getFecName() { return gFecName; }
  public String getCasName() { return gCasName; }
  public void setCasName(String name) { gCasName = name; } 
  public int setFecContext(String context)
  {
    if (context.length() <= 16)
      gFecContext = new String(context);
    else
      gFecContext = new String(context.substring(0, 15));
    return 0;
  }
  public String getFecContext() { return gFecContext; }
  public void setFecDescription(String description) { if (description != null) gFecDescription = description; }
  public String getFecDescription() { return gFecDescription; }
  public void setFecLocation(String location) { if (location != null) gFecLocation = location; }
  public String getFecLocation() { return gFecLocation; }
  public void setFecSubsystem(String subsystem) { if (subsystem != null) gFecSubsystem = subsystem; }
  public String getFecSubsystem() { return gFecSubsystem; }
  public void setFecHardware(String hardware) { if (hardware != null) gFecHardware = hardware; }
  public String getFecHardware() { return gFecHardware; }
  public void setFecResponsible(String responsible) { if (responsible != null) gFecResponsible = responsible; }
  public String getFecResponsible() { return gFecResponsible; }
  public long getLastAccessTime() { return gLastWriteAccessTime; }
  public String getLastAccessUser() { return gLastWriteAccessUser; }
  public InetAddress getLastAccessAddress() { return gLastWriteAccessAddr; }
  public String getLastAccessEqm() { return gLastWriteAccessEqm; }
  public String getLastAccessPrp() { return gLastWriteAccessPrp; }
  public String getLastAccessDev() { return gLastWriteAccessDev; }
  public String makeModuleName(String suggestedModuleName)
  {
    String modName;
    int n;
    if (suggestedModuleName.length() <= 6)
    {
      modName = suggestedModuleName;
    }
    else
    {
      //TODO What's this?
      if ((n = (suggestedModuleName.hashCode() % 211)) < 0) n += 256;
      modName = suggestedModuleName.substring(suggestedModuleName.length()-3,suggestedModuleName.length())
                + n;
    }
    for (n=0; n < numEqmTableEntries && eqmTable[n].getModuleName().compareTo(modName) != 0; n++);
    if (n == numEqmTableEntries) return modName;
    System.out.println("equipment module name conflict !");
    System.out.println("Please use a different name for " + suggestedModuleName + " and try again!");
    return null;
  }
  public int addEquipmentBackgroundTask(TEquipmentBackgroundTask tbkg)
  {
    TBackgroundThread tbt = new TBackgroundThread(tbkg);
    if (tbt == null) return -1;
    TFecLog.log("add Equipment Background task " + tbkg.getClass().getSimpleName());
    tbkg.startup();
    tbt.start();
    gNumBkgTasks++;
    return 0;
  }
  public int addEquipmentModule(TEquipmentModule teqm)
  {
    int i;
    for (i = 0; i < numEqmTableEntries; i++)
    {
      if (eqmTable[i] == teqm) return i;
    }
    if (i < maxNumEqmTableEntries)
    {
      TFecLog.log("add Equipment Module (" + i + ") " + teqm.getClass().getSimpleName());
      numEqmTableEntries++;
      eqmTable[i] = teqm;
      if (teqm.getLocalName().length() > 0) registrationPending = true;
      return i;
    }
    return -1;
  }
  private int maxDeadTime(short mode, int pollingRate)
  {
    if (mode == TMode.CM_REFRESH) return HEARTBEAT + pollingRate;
    return 2 * pollingRate;
  }
  /**
   * Geht alle Contracts durch und schickt Daten an die Clients. Wird aufgerufen
   * aus TEquipmentModuleFactory.systemSrvCycle. TODO Unklar, was im Einzelnen passiert.
   * 
   * @return
   */
  private int deliverData()
  {
    int i, j, n, gapptr, gapsize, msgsize, stepsize, packetmtu;
    int fsize, dsize, dptr;
    boolean passed = false, snddata = false, actionTaken = false;
    short totalsize = 0, basemode;
    TContractTable tct = null;
    TClientEntry tce = null;
    TClient tc = null;
    TPublishedData tpd = null;
    byte[] payload = new byte[1500];
    long t_now = System.currentTimeMillis(), delta_t;
    if (debugLevel > 0 && clnTable.size() == 0)
        System.out.println("no client table in deliver data !");
    for (int k = 0; k < clnTable.size(); k++)
    {
      if ((tc = (TClient) clnTable.get(k)) == null) continue;
      if (tc.ncontracts == 0)
      {
        if (debugLevel > 0) System.out.println("remove dangling client " + tc.userName);
        clnTable.remove(k--);
        continue;
      }
      passed = true;
      totalsize = 2;
      for (i = 0, n = 0; i < conTable.size() && n < tc.ncontracts; i++)
      {
        tct = (TContractTable) conTable.get(i);
        for (j = 0; j < tct.clt.size(); j++)
        {
          tce = (TClientEntry) tct.clt.get(j);
          if (tc.equals(tce.cln)) break;
        }
        if (j == tct.clt.size())
        {
          tct.pending = 0;
          continue;
        }
        if (debugLevel > 0) System.out.println("delivering data");
        if (tc.transport == TTransport.TCP && tc.output == null) tce.sts.counter = 0;
        n++;
        snddata = true;
        gapptr = gapsize = 0;
        basemode = tce.sts.mode;
        if (tce.sts.Stale != 0)
        {
          actionTaken = true;
          stepsize = TPublishedData.hdrSizeInBytes;
          packetmtu = 2 + stepsize + tce.sts.mtu;
          snddata = (tce.sts.statusCode == 0) || (tce.sts.statusCode & TErrorList.CE_SENDDATA) != 0;
          if (snddata)
          {
            dsize = (short) tce.sts.nextDataSize;
            dptr = tce.sts.nextDataPtr;
          }
          else
          {
            gapsize = TErrorList.ERROR_SIZE;
            dsize = (short) gapsize;
            dptr = 0;
          }
          if ((msgsize = dsize + stepsize) > packetmtu)
          {
            tce.sts.counter = 0;
            continue;
          }
          if (msgsize % 2 != 0) msgsize++; // make sure of even boundaries
          if ((totalsize + msgsize) > packetmtu)
          { // msgsize too big to fit in this packet !
            passed = false;
          }
          else
          {
            tpd = new TPublishedData(msgsize, tce, tct);
            System.arraycopy(tpd.dBuffer.toByteArray(), 0, payload, totalsize, stepsize);
            fsize = TFormat.formatSizeOf(tct.contract.EqpFormatOut);
            if (snddata && fsize > 0)
            {
              if ((tce.sts.statusCode & 0xfff) != 0)
              {
                gapsize = (int) (tce.sts.nextDataPtr + tce.sts.nextDataSize - tct.contract.EqpSizeOut * fsize);
                // shouldn't be possible ...
                if (gapsize > TErrorList.ERROR_SIZE) gapsize = TErrorList.ERROR_SIZE;
                if (gapsize > dsize) /* err string remainder */
                {
                  gapsize = dsize;
                  gapptr = TErrorList.ERROR_SIZE - gapsize;
                }
                if (gapsize > 0) dsize -= (short)gapsize; else gapsize = 0;
              }
              if (dsize > 0)
              {
                byte[] b = tct.dout.getDataBuffer();
                int thissize = b.length - dptr;
                if (thissize < 0) thissize = 0;
                if (dsize > thissize) dsize = thissize;
                if (debugLevel > 1)
                    System.out.println("dout size :" + b.length + " payload size : " + payload.length
                        + "  data size : " + dsize);
                try
                {
                  if (b != null && dsize > 0) 
                    System.arraycopy(b, dptr, payload, totalsize + stepsize, dsize);
                }
                catch (ArrayIndexOutOfBoundsException e)
                {
                  e.printStackTrace();
                  System.out.println("b len " + b.length + " dptr " + dptr + 
                      " payload " + payload.length + " offset " + totalsize + stepsize + " size " + dsize);
                }
              }
            }
          }
          if (passed)
          {
            totalsize += msgsize;
            if (gapsize > 0) // insert err string
            {
              byte b[] = null;
              if (tce.sts.statusCode == TErrorList.server_redirection)
              { // the property handler has handled the call and is returning this information!
                gLastErrorString = tct.compString;
                tce.sts.counter = 1;
                b = redirectionStringToBytes(tct.compString);
              }
              else if ((tce.sts.statusCode & 0xfff) < TErrorList.errorString.length)
              {
                gLastErrorString = TErrorList.getErrorString(tce.sts.statusCode & 0xff);
                b = gLastErrorString.getBytes();
              }
              else if (tct.compString != null)
              {
                gLastErrorString = tct.compString;
                b = gLastErrorString.getBytes();
              }
              if (b == null) b = "error unknown".getBytes();
              // only copy size of gLastErrorString (not gapsize !)
              System.arraycopy(b, gapptr, payload, totalsize - gapsize,b.length);
            }
            if (debugLevel > 2)
            {
              String dbgstr = "" + totalsize + " bytes to " + tce.cln.userName + 
                " (" + tce.sts.counter + ") <" + tce.sts.statusCode + ">";
              System.out.println(dbgstr);
            }
            if (!snddata || tce.sts.numblks == tce.sts.blknum)
            { // datablock finished and/or error code
              if (debugLevel > 2) System.out.println("data delivery finished");
              tce.sts.Stale = 0;
              if (tce.sts.counter > 0) tce.sts.counter--;
              if (tce.sts.mode == TMode.CM_CANCEL) tce.sts.counter = 0;
              tce.sts.blknum = 1;
              tce.sts.nextDataPtr = 0;
              tce.sts.BytesRemaining = tce.sts.BytesTotal;
              tct.pending--;
              if ((delta_t = (t_now - tce.sts.lasttime)) > maxDeadTime(tce.sts.mode,
                  tce.sts.PollingRate))
              {
                tce.sts.misses++;
                gClientMisses++;
              }
            }
            else
            {
              tce.sts.blknum++;
              tce.sts.nextDataPtr += tce.sts.nextDataSize;
              tce.sts.BytesRemaining = tce.sts.BytesTotal - tce.sts.nextDataPtr;
              gStaleData++;
            }
            tce.sts.nextDataSize = tce.sts.mtu < tce.sts.BytesRemaining ? tce.sts.mtu
                : tce.sts.BytesRemaining;
          }
        }
        else
        {
          if (tce.sts.counter > 0) tce.sts.counter--;
        }
        if (passed && tce.sts.counter <= 0)
        {
          if (debugLevel > 0)
              System.out.println("remove " + tce.cln.userName + " from contract "
                  + tct.contract.EqpProperty);
          actionTaken = true;
          tce.cln.ncontracts--;
          tct.clt.remove(tce);
          tct.nclients--;
          n--;
          if (debugLevel > 1)
              System.out.println(" contract " + tct.contract.EqpProperty + " now has "
                  + tct.nclients + " clients");
        }
        if (passed && tct.nclients == 0)
        {
          actionTaken = true;
          if (gRetardSingleContractRemoval && basemode == TMode.CM_SINGLE)
          {
            if (debugLevel > 0)
                System.out.println("mark contract " + tct.contract.EqpProperty + " as expired");
            tct.expired = true;
            tct.contract.EqpAccess &= ~(TAccess.CA_FIRST | TAccess.CA_LAST);
            numExpiredContracts++;
          }
          else
          {
            if (debugLevel > 0) System.out.println("remove contract " + tct.contract.EqpProperty);
            conTable.remove(i--);
          }
        }
      }
      if (totalsize > 2 && tc != null)
      {
        actionTaken = true;
        payload[0] = (byte) (totalsize & 0xff);
        payload[1] = (byte) (totalsize >> 8);
        sendToPeer(tc, payload, totalsize);
      }
      if (passed && tc.ncontracts == 0)
      {
        if (debugLevel > 0) System.out.println("remove client " + tc.userName);
        clnTable.remove(k--);
      }
      if (!passed) k--;
    }
    if (gStaleData > 0) gStaleData--; else gStaleData = 0;
    if (!actionTaken) 
    {
      if (debugLevel > 2) System.out.println("empty pass through deliverData()");
      gStaleData = 0;
    }
    return gStaleData;
  }
  /**
   * Schickt Daten an einen Client. Wird aufgerufen aus deliverData().
   * 
   * @param tc
   * @param payload
   * @param length
   */
  private void sendToPeer(TClient tc, byte[] payload, int length)
  {
    if (debugLevel > 1)
        System.out.println("sendToPeer: " + tc.IPaddress.getHostAddress() + ":" + tc.port);
    try
    {
      switch (tc.transport)
      {
        case TTransport.UDP:
          srvp.dpOut = new DatagramPacket(payload, length, tc.IPaddress, tc.port);
          srvp.s.send(srvp.dpOut);
          break;
        case TTransport.TCP:
          //if (!tc.sck.isConnected()) break;
          byte[] buf = new byte[length];
          System.arraycopy(payload,0,buf,0,length);
          //tc.output.write(payload,0,length);
          //tc.output.write(buf); // more efficient ?
          tc.output.write(buf); // more efficient ?
          //tc.sck.getOutputStream().write(buf);
          break;
      }
    }
    catch (Exception e)
    {
      System.out.println("sendToPeer: " + e.toString());
      // TODO: TCP -> close the socket if the endpoint has closed !!
    }
  }
  /**
   * Wird aufgerufen aus systemSrvCycle. TODO Was macht diese Methode? Sie
   * scheint unter anderem Daten zu kopieren, die an Clients verschickt werden
   * sollen. Vielleicht auch nicht. Anscheinend ist sie aber auch fr das
   * Verschicken von Daten zustndig. Vielleicht auch nicht. Sie hat etwas mit
   * Contracts zu tun.
   */
  private synchronized void produceData()
  {
    TContractTable tct = null;
    TClientEntry tce = null;
    int cc = 0, datasize = 0, msec = 0;
    boolean isScheduled = false, stale = false, dirty = false, hasData = false;
    long delta_t = 0, t_now = System.currentTimeMillis(), t_stamp = 0;
    for (int i = 0; i < conTable.size(); i++)
    {
      tct = (TContractTable) conTable.get(i);
      if (debugLevel > 3)
          System.out.println("looking at contract " + tct.contract.toString() + " with "
              + tct.nclients + " clients @ " + new Date(t_now).toString());
      if (tct.clt.size() == 0 && !tct.expired)
      {
        if (debugLevel > 3) System.out.println("contract has no clients");
        if ((((short) tct.contract.EqpAccess) & TAccess.CA_LAST) != 0)
        { // going out of scope
          doContract(tct);
          conTable.remove(i--);
        }
        tct.expired = true;
        tct.pending = 0;
        gStaleData++; // Ensure pass thru deliverData
        continue;
      }
      isScheduled = false;
      cc = 0;
      datasize = tct.contract.getOutputDataSize();
      if ((delta_t = t_now - tct.lasttime) < 0) tct.lasttime = t_now;
      if (delta_t <= (long) tct.pollingRate - gSystemTick) continue;
      if (debugLevel > 2) System.out.println("contract needs attention : polling interval " + tct.pollingRate +  " last accessed : " + tct.lasttime);
      if (tct.expired)
      {
        if (delta_t > 3 * tct.pollingRate)
        {
          if (debugLevel > 1) System.out.println("removing expired contract");
          conTable.remove(i--);
          continue;
        }
        if (tct.clt.size() == 0) continue; // expired, no clients
      }
      if (delta_t < gMaxPollingRate && delta_t >= 2 * tct.pollingRate)
      {
        tct.misses++;
        gContractMisses++;
      }
      if (tct.pending > 0 && clnTable.size() > 0)
      {
        if (debugLevel > 2) System.out.println("still sending out contract to clients");
        tct.delays++;
        gContractDelays++;
        if (gStaleData == 0) gStaleData++;
        for (int j = 0; j < tct.clt.size(); j++)
        {
          tce = (TClientEntry) tct.clt.get(j);
          tce.sts.Stale = (byte) tct.pending;
        }
        continue; // still sending out the last round
      }
      if (tct.starttime == 0) tct.starttime = t_now;
      t_stamp = t_now;
      msec = (int) (t_now % 1000);
      // Synchronize on 1000 msec boundaries if possible
      if (gSynchronizeContracts && (tct.pollingRate % 1000 == 0)
          && msec < (1000 - (int) gSystemTick)) t_stamp = t_now - msec;
      gDataTimeStamp = t_now + gDataTimeStampOffset;
      if (tct.nclients == 1)
      {
        tce = (TClientEntry) tct.clt.getFirst();
        // dangling client going out of scope ?
        if (tce.sts.counter == 1) tct.contract.EqpAccess |= TAccess.CA_LAST;
      }
      hasData = true; // be optimistic !
      if (debugLevel > 2) System.out.println("processing contract");
      switch (cc = doContract(tct))
      {
        case 0:
          break;
        case TErrorList.not_ready:
          // call returned not_ready or still not_signalled
          if (!gEqpFcnBusySemaphore
              || ((t_now - tct.starttime) < tct.pollingRate + 500 && gEqpFcnBusySemaphore))
          {
            tct.setStale((byte) 0);
            tct.pending = 0;
            continue; // don't send out
          }
          break;
        case TErrorList.server_redirection:
          // the property handler is handling the call and has filled in tRedirectedServer
          tct.compString = new String(tRedirectedServer);
        default:
          if ((cc & 0xf000) != 0) // CE_RENEGOTIATE or CE_SENDDATA
          {
            int rc = 0;
            if ((rc = tct.renegotiateContract((short) (cc & 0xfff))) != 0)
              cc = rc;
            else
              cc &= ~TErrorList.CE_RENEGOTIATE;
            datasize = tct.contract.getOutputDataSize();
            //if (tct.contract.EqpFormatOut == CF_SPECTRUM) datasize += 96;
          }
          else
          {
            hasData = false;
          }
      }
      if ((tct.contract.EqpAccess & TAccess.CA_WRITE) == TAccess.CA_WRITE )
      {
        gLastWriteAccessTime = System.currentTimeMillis();
        gLastWriteAccessUser = ((TClientEntry)tct.clt.getFirst()).cln.userName;
        gLastWriteAccessAddr = ((TClientEntry)tct.clt.getFirst()).cln.IPaddress;
        gLastWriteAccessPrp = tct.contract.EqpProperty;
        gLastWriteAccessDev = tct.contract.EqpDeviceName;
        gLastWriteAccessEqm = tct.contract.EqpName;
      }
      if (hasData)
      {
        if (debugLevel > 3) System.out.println("Contract has data");
        if (datasize > 0 && !tct.dout.equals(tct.drb))
        {
          tct.dout.copy(tct.drb);
          // Data have changed; the cached data are dirty
          stale = dirty = true;
        }
        else
        {
          if (t_now - tct.lastmarked > (HEARTBEAT - 1) * 1000) stale = true;
          dirty = false; // Cached data have not changed
        }
      }
      if (cc != 0) stale = true;
      if (stale) tct.lastmarked = t_stamp; // Last marked as Stale
      if (debugLevel > 2)
          System.out.println("contract data is " + (stale ? "stale" : "not stale"));
      if (tct.lasttime == PRP_SCHEDULE_SIGNAL) isScheduled = true;
      if (cc == TErrorList.not_ready)
      {
        cc = TErrorList.operation_busy;
      }
      else
      {
        tct.starttime = 0;
        tct.lasttime = t_stamp; // Last polled
        tct.compStatus = TErrorList.not_signalled;
      }
      tct.dtimestamp = gDataTimeStamp;
      tct.returnCode = cc;
      for (int j = 0; j < tct.clt.size(); j++)
      {
        tce = (TClientEntry) tct.clt.get(j);
        tce.sts.statusCode = (short) cc;
        if (isScheduled) tce.sts.lasttime = PRP_SCHEDULE_SIGNAL;
        if (cc != 0) tce.sts.Stale = 1; // stale because of error code
        if (tce.sts.mode == TMode.CM_REFRESH)
        {
          if (stale) 
          { // stale because of data change or system heartbeat
            tce.sts.Stale = 1;
            // force acknowledgment
            if (dirty && gRequireAcknowledgments) tce.sts.counter = ACK_REQUEST; 
          }
        }
        else // honor polling rate
        { // stale because of polling rate ?
          if ((t_now - tce.sts.lasttime) > tce.sts.PollingRate - gSystemTick) tce.sts.Stale = 1; 
        }
        if (tce.sts.Stale > 0) // client for this contract is to be refreshed
        { 
          if (debugLevel > 2) System.out.println("refresh client with new data");
          tct.pending++;
          tce.sts.lasttime = t_stamp;
          if (gStaleData == 0) gStaleData++; // ensure pass thru deliverData
        }
        if (tce.sts.counter == ACK_REQUEST) // get serious until an acknowledgment comes
        { 
          tce.sts.mode = ACK_PENDING; // reset by renewal
          tce.sts.PollingRate = tct.pollingRate;
        }
      }
    }
    for (int i = 0; gStaleData > 0 && i < gBurstLimit; i++)
    { // send data to clients ...
      deliverData(); 
    }
    if (gStaleData > 0) 
    { // caught by burst limit ...
      if (debugLevel > 0) System.out.println("deliverData() : burst limit exceeded");
      gBurstLimitReachedCount++;
    }
    return;
  }
  private boolean isWildcardContract(String deviceString)
  {
    if (deviceString == null) return false;
    return deviceString.indexOf('*') != -1;
  }
  private int doContractWithWildcardDevice(TContractTable tct)
  {
    TDataType drdb;
    int start = 0, len = 0;
    boolean isCont = false;
    int cc = TErrorList.not_allowed, i, k;
    TAccess acc = new TAccess(tct.contract.EqpAccess);
    int devlistsize = 0;   
    String[] devlist = null;
    int atype;
    NAME16FI[] nfi;
    NAME16II[] nii;

    TEquipmentModule eqm = tct.eqm;
    String devprp = tct.contract.EqpProperty;
    String devnam = tct.contract.EqpDeviceName;
    TExportProperty prp = eqm.propertyList.getFirstProperty(devprp);
    if ((atype=prp.getDescription().getArrayType()) == TArrayType.AT_SPECTRUM) 
      return TErrorList.not_allowed;
    if (tct.dout == null || tct.dout.dArrayLength < 1) return TErrorList.not_allowed;
    if (!eqm.isDeviceSetLocal(devnam,devprp)) return TErrorList.data_not_local;

    if (prp.getDeviceList() != null)
    {
      devlistsize = prp.getDeviceList().size();
      devlist = new String[devlistsize];
      prp.getDeviceList().toArray(devlist);
    }
    if (devlistsize == 0)
    {
      devlist = eqm.getDeviceList().getDeviceNameList();
      //eqm.getDeviceNames().toArray(devlist);
      devlistsize = devlist.length;
    }
    if ((atype & TArrayType.AT_CHANNEL) == TArrayType.AT_CHANNEL)
    {
      len = devlistsize;
      int endpoints[] = StringToName.getContiguousEndpoints(devlist,devnam);
      if (endpoints != null)
      {
        isCont = true;
        start = endpoints[0];
        len = endpoints[1] - endpoints[0] + 1;
      }
    }
    WildcardMatch wc = new WildcardMatch(devnam);

    switch (tct.dout.dFormat)
    {
      case TFormat.CF_NAME16DBLDBL:
      case TFormat.CF_NAME32DBLDBL:
      case TFormat.CF_NAME64DBLDBL:
      case TFormat.CF_USTRING:
      case TFormat.CF_NAME16FI:
        if (isCont)
        {
          int dsiz = tct.contract.EqpSizeOut > len ? len : tct.contract.EqpSizeOut;
          nfi = new NAME16FI[dsiz];
          float[] frb = new float[dsiz];
          drdb = new TDataType(frb);
          cc = tct.eqm.callProperty(devprp, devlist[start], drdb, tct.din, acc);
          if (cc != 0) return cc;
          for (i=0; i<drdb.dArrayLength; i++)
          {
            nfi[i] = new NAME16FI(devlist[start+i],0,frb[i]);
          }
          tct.drb.dArrayLength = drdb.dArrayLength;
        }
        else
        {
          int dsiz = tct.contract.EqpSizeOut;
          nfi = new NAME16FI[dsiz];
          float[] frb = new float[1];
          drdb = new TDataType(frb);
          for (i=0, k=0; i<devlistsize && k<tct.dout.dArrayLength; i++)
          {
            if (!wc.matches(devlist[i])) continue;
            cc = tct.eqm.callProperty(devprp, devlist[i], drdb, tct.din, acc);
            if (cc == TErrorList.server_redirection) return TErrorList.data_not_local;
            nfi[k] = new NAME16FI(devlist[i],cc,frb[0]);
            k++;
          }
          tct.drb.dArrayLength = k;
        }
        tct.drb.putData(nfi);
        return 0;
      case TFormat.CF_NAME16II:
        if (isCont) 
        {
          int dsiz = tct.contract.EqpSizeOut > len ? len : tct.contract.EqpSizeOut;
          nii = new NAME16II[dsiz];
          int[] irb = new int[dsiz];
          drdb = new TDataType(irb);
          cc = tct.eqm.callProperty(devprp, devlist[start], drdb, tct.din, acc);
          if (cc != 0) return cc;
          for (i=0; i<drdb.dArrayLength; i++)
          {
            nii[i] = new NAME16II(devlist[start+i],0,irb[i]);
          }
          tct.drb.dArrayLength = drdb.dArrayLength;
        }
        else
        {
          int dsiz = tct.contract.EqpSizeOut;
          nii = new NAME16II[dsiz];
          int[] irb = new int[1];
          drdb = new TDataType(irb);
          for (i=0, k=0; i<devlistsize && k<tct.dout.dArrayLength; i++)
          {
            if (!wc.matches(devlist[i])) continue;
            cc = tct.eqm.callProperty(devprp, devlist[i], drdb, tct.din, acc);
            if (cc == TErrorList.server_redirection) return TErrorList.data_not_local;
            nii[k] = new NAME16II(devlist[i],irb[0],cc);
            k++;
          }
          tct.drb.dArrayLength = k;
        }
        tct.drb.putData(nii);
        return 0;
      default:
        if (tct.dout.dFormat <= TFormat.CF_NAME32 && devnam.compareTo("*") == 0)
        { /* primitive format allowed in this case */
          if (isCont) 
          {
            if (tct.dout.dArrayLength > len) tct.dout.dArrayLength = len;
            return tct.eqm.callProperty(devprp, devlist[0], tct.dout, tct.din, acc);
          }
          drdb = new TDataType(1,tct.dout.dFormat);
          for (i=0; i<devlistsize && i<tct.dout.dArrayLength; i++)
          {
            cc = tct.eqm.callProperty(devprp, devlist[i], drdb, tct.din, acc);
            if (cc != 0) break;
          }
          if (cc == TErrorList.server_redirection) return TErrorList.data_not_local;
          tct.drb.dArrayLength = i;
          tct.drb.putData(drdb);
          return cc;
        }
    }
    return cc;
  }
  private int doContractWithWildcardProperty(TContractTable tct)
  {
    LinkedList lst = null;
    TDataType drdb;
    int cc = TErrorList.not_allowed, i, k, devnr;
    TAccess acc = new TAccess(tct.contract.EqpAccess);
    int prplistsize = 0;   
    String[] prplist = null;
    NAME32DBLDBL[] ndd;
   
    TEquipmentModule eqm = tct.eqm;
    String devprp = tct.contract.EqpProperty;
    String devnam = tct.contract.EqpDeviceName;
    TExportProperty prp;
    if (tct.dout == null || tct.dout.dArrayLength < 1) return TErrorList.not_allowed;
    if ((devnr=eqm.getDeviceList().getDeviceNumber(tct.contract.EqpDeviceName)) < 0)
      return TErrorList.illegal_equipment_number;

    lst = eqm.getDeviceList().getDevice(devnr).getPropertyList();
    if (lst != null) 
    {
      prplistsize = lst.size();
      prplist = new String[prplistsize];
      lst.toArray(prplist);
    }
    else 
    {
      if (eqm.gPropertyNameList == null)
      { // just do this once
        if ((lst = eqm.getPropertyNames()) == null) return TErrorList.code_failure;
        prplistsize = lst.size();
        prplist = new String[prplistsize];
        lst.toArray(prplist);
        eqm.gPropertyNameList = prplist;
      }
      prplistsize = eqm.gPropertyNameList.length;
      prplist = eqm.gPropertyNameList;
    }
    
    WildcardMatch wc = new WildcardMatch(devprp);

    switch (tct.dout.dFormat)
    {
      case TFormat.CF_NAME16DBLDBL:
      case TFormat.CF_NAME32DBLDBL:
      case TFormat.CF_NAME64DBLDBL:
      case TFormat.CF_USTRING:
      case TFormat.CF_NAME16FI:
      case TFormat.CF_NAME16II:
        int dsiz = tct.contract.EqpSizeOut;
        ndd = new NAME32DBLDBL[dsiz];
        double[] drb = new double[1];
        drdb = new TDataType(drb);
        for (i=0, k=0; i<prplistsize && k<tct.dout.dArrayLength; i++)
        {
          if (!wc.matches(prplist[i])) continue;
          prp = eqm.propertyList.getFirstProperty(prplist[i]);
          if (prp.getDescription().getArrayType() == TArrayType.AT_SPECTRUM) continue;
          cc = tct.eqm.callProperty(prplist[i], devnam, drdb, tct.din, acc);
          if (cc == TErrorList.server_redirection) return TErrorList.data_not_local;
          ndd[k] = new NAME32DBLDBL(prplist[i],drb[0],cc);
          k++;
        }
        tct.drb.dArrayLength = k;
        tct.drb.putData(ndd);
        return 0;
      default:
        break;
    }
    return cc;
  }
  
  /**
   * Wird von produceData() aufgerufen. Ruft offenbar die passende
   * Equipment-Funktion zu einer ContractTable auf, nicht zu einem Contract.
   * Unverstndlich: Die gesamte Contract-Table hat ein Equipment-Modul, nicht
   * der einzelne Contract. Trotzdem gibt es die Methode LocateEquipmentModule,
   * die noch einmal ein Equipment-Modul sucht (????)
   * 
   * @param tct
   * @return
   */
  private int doContract(TContractTable tct)
  {
    if (tct.expired) return tct.compStatus;
    int cc = TErrorList.non_existent_elem; // return code
    String devnam = new String(tct.contract.EqpDeviceName);
    String devprp = new String(tct.contract.EqpProperty);
    TAccess acc = new TAccess((short) tct.contract.EqpAccess);
    int datasize = tct.contract.getOutputDataSize();
    boolean isRegisteredProperty = false;
    int gate = 0;
    tct.dout.dArrayLength = tct.drb.dArrayLength = tct.contract.EqpSizeOut;
    tct.drb.dTimestamp = gDataTimeStamp + gDataTimeStampOffset;
    if (debugLevel > 0) 
      System.out.println("process " + tct.contract.EqpName + "/" + 
        tct.contract.EqpDeviceName + "[" + tct.contract.EqpProperty + "]");
    currentContractEntry = tct;
    tct.compString = null;
    if (devprp.indexOf("*") != -1) 
    {
      if (TFormat.isSimpleFormat(tct.contract.EqpFormatOut))
      {
        devnam = devprp;
        devprp = new String("PROPERTIES");
      }
      else
      {
        isRegisteredProperty = true; // wildcard call 
      }
    }
    if (tct.eqm == null)
    {
      System.out.println("No Equipment Module found.");
      cc = TErrorList.non_existent_elem;
    }
    else if (tct.eqm.hasStockProperty(devprp))
    { // check stock properties of equipment module ...
      if (debugLevel > 1) System.out.println("Stock Property found: " + tct.contract.EqpProperty);
      gDataTimeStamp = gSrvStartupTime + gDataTimeStampOffset;
      if (datasize > 0) tct.drb.dataFill(0);
      cc = tct.eqm.callStockProperty(devprp, devnam, tct.drb, tct.din, acc);
    }
    else if (stockList.hasProperty(devprp))
    { // Check common stock properties
      if (debugLevel > 1) System.out.println("Common Stock Property found: " + tct.contract.EqpProperty);
      gDataTimeStamp = gSrvStartupTime + gDataTimeStampOffset;
      if (datasize > 0) tct.drb.dataFill(0);
      cc = stockList.callPropertyHandler(devprp, devnam, tct.drb, tct.din, acc);
    }
    else if (tct.eqm.propertyList.hasProperty(devprp) == false)
    { // not a registered property; is it a meta-property ?
      if ((gate=metaProps.getGate(tct.contract.EqpProperty)) > 0)
      {
        devprp = metaProps.getTargetProperty(tct.contract.EqpProperty);
        isRegisteredProperty = true;
      }
      else
      {
        cc = tct.eqm.callMetaProperty(devprp, devnam, tct.drb, tct.din, acc);
      }
    }
    else if (tct.compStatus == TErrorList.not_signalled && gEqpFcnBusySemaphore)
    { // check if re-entering a busy call ...
      cc = gEqpFcnBusySemaphore ? TErrorList.operation_busy : TErrorList.not_ready;
    }
    else 
    {
      devprp = tct.contract.EqpProperty;
      isRegisteredProperty = true;
    }
    if (isRegisteredProperty)
    { // Call Equipment module's properties
      if (isWildcardContract(devnam))
      {
        cc = doContractWithWildcardDevice(tct);
      }
      else if (isWildcardContract(devprp))
      {
        cc = doContractWithWildcardProperty(tct);
      }
      else
      {
        /* TODO get this working !
        int ssiz = 0;
        if (tct.drb.getFormat() == TFormat.CF_STRUCT &&
            (ssiz=TStructRegistry.getSizeInBytes(tct.drb.getTag())) > 0)
          tct.drb.dArrayLength /= ssiz;
        */
        gEqpFcnBusySemaphore = true;
        cc = tct.eqm.callProperty(devprp, devnam, tct.drb, tct.din, acc);
        gEqpFcnBusySemaphore = false;
        /* TODO get this working !
        if (ssiz > 0) tct.drb.dArrayLength *= ssiz;
        */
      }
      if (gate > 0)
      {
        gateOutputData(tct.drb,gate,metaProps.getIndex(tct.contract.EqpProperty) != TMetaProperties.GAT_ID);
      }
    }
    // DEBUG INFO
    if (tct.eqm.propertyList == null)
    {
      if (debugLevel > 1) System.out.println("Module has no property list");
      //} else if (tct.eqm.propertyList.getPropertyId(devprp) >= 0) {
      //  System.out.println("PropertyID = "
      //      + tct.eqm.propertyList.getPropertyId(devprp));
      //    } else if (tct.eqm.eqpFcn == null) {
      //      if (debugLevel > 1) System.out.println("Module has no EqpFcn");
    }
    if (tct.dout.dArrayLength > tct.drb.dArrayLength)
    {
      if (!gSystemPresetMemory) // zero out the remainder for later data comparisons
      {
        tct.dout.dataFill(0, tct.drb.dArrayLength);
      }
      tct.dout.dArrayLength = tct.drb.dArrayLength;
    }
    if ((tct.contract.EqpAccess & TAccess.CA_FIRST) != 0)
        tct.contract.EqpAccess &= ~(TAccess.CA_FIRST);
    if (cc < 0) cc = TErrorList.ambiguous;
    // record possible new data output length
    tct.dataSizeOut = tct.contract.EqpSizeOut;
    if (tct.contract.EqpSizeOut != tct.dout.dArrayLength)
    {
      cc |= TErrorList.CE_RENEGOTIATE;
    }
    tct.compStatus = cc;
    currentContractEntry = null;
    return cc;
  }
  private void gateOutputData(TDataType dout, int gate, boolean outputBoolean)
  {
    int i;
    Object hDataObject = dout.getDataObject();
    switch (dout.getFormat())
    {
      case TFormat.CF_BYTE:
      {
        byte[] data = (byte[])hDataObject; 
        for (i=0; i<dout.getArrayLength(); i++) 
        {
          data[i] &= gate;
          if (outputBoolean) data[i] = (byte)(data[i] == (byte)gate ? 1 : 0);
        }
        dout.putData(data);
        break;
      }
      case TFormat.CF_SHORT:
      {
        short[] data = (short[])hDataObject; 
        for (i=0; i<dout.getArrayLength(); i++) 
        {
          data[i] &= gate;
          if (outputBoolean) data[i] = (short)(data[i] == (short)gate ? 1 : 0);
        }
        dout.putData(data);
        break;
      }
      case TFormat.CF_LONG:
      {
        int[] data = (int[])hDataObject; 
        for (i=0; i<dout.getArrayLength(); i++) 
        {
          data[i] &= gate;
          if (outputBoolean) data[i] = (int)(data[i] == (int)gate ? 1 : 0);
        }
        dout.putData(data);
        break;
      }
    }
  }
  public static TClient getCaller()
  {
    TContractTable tct = getInstance().getCurrentContractEntry();
    return tct != null ? ((TClientEntry)tct.clt.getFirst()).cln : null;
  }   
  public static TClientEntry[] getClientList()
  {
    TContractTable tct = getInstance().getCurrentContractEntry();
    return tct != null ? ((TClientEntry[])tct.clt.toArray(new TClientEntry[0])) : null;
  }
  private class clnInputData
  {
    TDataType din;
    TClient tc;
    int id;
    int starttime;
  }
  private short isIllegalProperty(TClient tc, TSubscription ts,byte[] errorData)
  {
    // note: wildcard properties such as "PROP*" no longer allowed !
    TEquipmentModule eqm = LocateEquipmentModule(ts.contract);
    String tgtProperty = ts.contract.EqpProperty;
    String tgtDevice = ts.contract.EqpDeviceName;
    String rdirStr = null;
    if (eqm == null) // subscription must point to something being managed
    {
      return TErrorList.non_existent_elem;
    }
    if (ts.contract.EqpProperty.indexOf(".") >= 0)
    {
      tgtProperty = metaProps.getTargetProperty(ts.contract.EqpProperty);
    }
    // check if device is categorically redirected ...
    TDevice td = eqm.getDeviceList().getDevice(tgtDevice);
    if (td != null && (rdirStr=td.getRedirection()) != null)
    {
      byte[] rdb = redirectionStringToBytes(rdirStr);
      System.arraycopy(rdb,0,errorData,0,rdb.length);
      return TErrorList.server_redirection;      
    }
    // check if registered
    if (eqm.propertyList.hasProperty(tgtProperty) == true)
    {
      // check for property redirection
      rdirStr = eqm.propertyList.getFirstProperty(tgtProperty).getDescription().getRedirection();
      if (rdirStr != null && isDeviceRedirected(rdirStr,ts.contract.EqpDeviceName))
      { // registered as a redirected property !
        byte[] rdb = redirectionStringToBytes(rdirStr);
        System.arraycopy(rdb,0,errorData,0,rdb.length);
        return TErrorList.server_redirection;      
      }
    }
    else 
    {
      // check if stock
      if (tgtProperty.indexOf("*") == -1 && // mapped as "PROPERTIES"
          stockList.hasProperty(tgtProperty) == false &&
          eqm.stockList.hasProperty(tgtProperty) == false) return TErrorList.illegal_property;
    }
    // check if WRITE (and not MESSAGE)
    if (((ts.contract.EqpAccess & TAccess.CA_WRITE) == TAccess.CA_WRITE) &&
        tgtProperty.compareTo("MESSAGE") != 0)
    {
      String cmdString = "COMMAND " + tgtProperty + " called by " + tc.userName + 
                         " from addr " + tc.IPaddress.getHostAddress() + " : ";
      if (!isMemberUsersList(eqm,tc.userName))
      {
        TFecLog.log(cmdString + "user refused access");
        return TErrorList.access_denied;
      }
      if (!isMemberControlNets(eqm,tc))
      {
        TFecLog.log(cmdString + "network refused access");
        return TErrorList.access_denied;
      }
      if (tgtProperty.compareTo("ACCESSLOCK") != 0 && !isMemberLockSet(eqm,tc))
      {
        TFecLog.log(cmdString + "access lock refused access");
        return TErrorList.access_denied;
      }
      if (gPutCommandsInFeclog) TFecLog.log(cmdString);
    }
    return 0;
  }
  private short fixOutputDataTypeAndSize(TSubscription ts)
  {
    TEquipmentModule eqm = LocateEquipmentModule(ts.contract);
    if (eqm == null) return TErrorList.non_existent_elem;
    short df = ts.contract.EqpFormatOut >= 0 ? 
               ts.contract.EqpFormatOut : (short)(256 + ts.contract.EqpFormatOut); 
    if (df == TFormat.CF_DEFAULT)
    { // caller wants default settings
      TExportProperty prop = eqm.propertyList.getFirstProperty(ts.contract.EqpProperty);
      ts.contract.EqpFormatOut = (byte) prop.getOutputFormat();
      int fmtsize = TFormat.formatSizeOf(prop.getOutputFormat());
      int datasize = prop.getOutputSize() * fmtsize;
      if (prop.getOutputFormat() == TFormat.CF_SPECTRUM) datasize += SPECTRUM.hdrSizeInBytes;
      // EqpSizeOut is in bytes ...
      if (ts.contract.EqpSizeOut < datasize) return TErrorList.buffer_too_small;
      ts.contract.EqpSizeOut = datasize;
      if (fmtsize != 0)
      {
        if (prop.getOutputFormat() == TFormat.CF_SPECTRUM)
            ts.contract.EqpSizeOut -= SPECTRUM.hdrSizeInBytes;
        ts.contract.EqpSizeOut -= ts.contract.EqpSizeOut % fmtsize;
        ts.contract.EqpSizeOut /= fmtsize;
      }
    }
    return 0;
  }
  private void shrinkInputDataTypeRepository()
  {
    clnInputData cip = null;
    for (int i = 0; i < clnInputDataTable.size(); i++)
    {
      cip = (clnInputData) clnInputDataTable.get(i);
      if (cip.din.blksin == cip.din.numblks)
      {
        clnInputDataTable.remove(i--);
      }
    }
  }
  private TDataType getInputDataTypeRepository(TClient tc, TSubscription ts)
  {
    if (ts.numblks == 1) // just this one ...
    {
      TDataType tdt;
      tdt = new TDataType(ts.contract.EqpSizeIn, ts.contract.EqpFormatIn);
      tdt.setTag(ts.contract.strTagIn);
      return tdt;
    }
    if (debugLevel > 1) System.out.println("in-coming long datagram ...");
    clnInputData cip = null;
    for (int i = 0; i < clnInputDataTable.size(); i++)
    {
      cip = (clnInputData) clnInputDataTable.get(i);
      if (!cip.tc.IPaddress.equals(tc.IPaddress)) continue;
      if (cip.id != ts.id) continue;
      if (cip.starttime != ts.starttime) continue;
      if (debugLevel > 1) System.out.println("found it in list ...");
      return cip.din;
    }
    cip = new clnInputData();
    cip.id = ts.id;
    cip.starttime = ts.starttime;
    cip.tc = tc;
    cip.din = new TDataType(ts.contract.EqpSizeIn, ts.contract.EqpFormatIn);
    cip.din.setTag(ts.contract.strTagIn);
    clnInputDataTable.add(cip);
    if (debugLevel > 1) System.out.println("add it to list ...");
    return cip.din;
  }
  public String getNameFromAlias(String alias)
  {
    if (gAliasList == null) return null;
    // TODO: is this faster than a hash map?
    AliasTableEntry ate;
    for (int i=0; i<gAliasList.size(); i++)
    {
      ate = (AliasTableEntry)gAliasList.get(i);
      if (ate.alias.compareTo(alias) == 0) return ate.name;
    }
    return null;
  }
  public String getAliasFromName(String name)
  { // TODO: as is, this only allows 1 alias per name
    if (gAliasList == null) return null;
    // TODO: is this faster than a hash map?
    AliasTableEntry ate;
    for (int i=0; i<gAliasList.size(); i++)
    {
      ate = (AliasTableEntry)gAliasList.get(i);
      if (ate.name.compareTo(name) == 0) return ate.alias;
      if (metaProps.isMetaProperty(ate.name))
      { // there's an alias for a meta property ...
        if (metaProps.getTargetProperty(ate.name).compareTo(name) == 0)
          return ate.alias;
      }
    }
    return null;
  }
  private void getRequest(TClient tc, byte[] data)
  {
    byte[] d = new byte[64];
    TDataType din = null;
    int offset = 0, datasize = 0;
    int renewalMultiplier;
    int cc = 0;
    boolean isTrueMCast = false;
    TClientEntry tce = null;
    String astr = null;
    // peel off the Theader
    Theader hdr = new Theader(data, 0, Theader.hdrSizeInBytes);
    tc.userName = hdr.getUserName();
    if (hdr.getProtocol() != 5) 
    {
      SendMessageToCaller(tc, null, TErrorList.illegal_protocol,null);
    }
    int totalsize = hdr.getTotalSizeInBytes();
    offset += Theader.hdrSizeInBytes;
    if (debugLevel > 3) System.out.println(hdr.toString());
    while (offset < totalsize)
    {
      //replaceContractAliasNames(&regEx->contract);
      // peel off the TSubscription
      TSubscription sub = new TSubscription(data, offset, TSubscription.hdrSizeInBytes);
      // Is the caller using alias names ?
      if ((astr=getNameFromAlias(sub.contract.EqpDeviceName)) != null) sub.contract.EqpDeviceName = astr;
      if ((astr=getNameFromAlias(sub.contract.EqpProperty)) != null) sub.contract.EqpProperty = astr;
      offset += TSubscription.hdrSizeInBytes + TContract.hdrSizeInBytes;
      if (debugLevel > 3) System.out.println(sub.toString());
      // prepare incoming data ...
      if ((datasize = sub.getInputDataSize()) > 0)
      {
        din = getInputDataTypeRepository(tc, sub);
        din.update(data, offset, datasize, sub.blknum, sub.blkid);
        offset += datasize;
        if (din.blksin < din.blknum) continue;
        // when finished ...
        din.getData();
        if (debugLevel > 3) System.out.println("input data : \n" + din.toString());
      }
      // requested output data ...
      fixOutputDataTypeAndSize(sub); // default format ?
      // is contract in list ? if no -> add to list
      TContractTable tct = LocateContractInList(sub.contract, din);
      // finished with TDataType repository entry ?
      shrinkInputDataTypeRepository();
      // have I got a contract table entry ?
      if (tct == null)
      {
        SendMessageToCaller(tc, sub, TErrorList.resources_exhausted, null);
        continue;
      }
      // can caller access the property ?
      if ((cc = isIllegalProperty(tc, sub, d)) != 0)
      {
        SendMessageToCaller(tc, sub, cc, d);
        continue;
      }
      // is a new link attaching to an expired contract ?
      if (tct.expired && ((sub.mode & TMode.CM_RETRY) == 0))
      {
        tct.expired = false;
        if (numExpiredContracts > 0) numExpiredContracts--;
      }
      // is broadcast or multicast request ?
      if ((sub.mode & (TMode.CM_BCAST | TMode.CM_MCAST)) != 0)
      {
        isTrueMCast = (sub.mode & TMode.CM_MCAST) != 0;
        sub.mode = TMode.getBaseMode(sub.mode); // strip off
        if (sub.mode == TMode.CM_CANCEL) continue; // don't do anything ...
        if (isTrueMCast || isMemberBcastNets(tc))
        {
          // send subscription ID to caller
          ByteArrayOutputStream boas = new ByteArrayOutputStream(2);
          DataOutputStream dos = new DataOutputStream(boas);
          try
          {
            dos.writeShort((short) tct.contractID);
          }
          catch (Exception e) {}
          byte[] subid = boas.toByteArray();
          Swap.Bytes(subid, TFormat.CF_SHORT);
          SendMessageToCaller(tc, sub, TErrorList.get_subscription_id, subid);
          // add network to client list and replace cln
          tc.IPaddress = isTrueMCast ? getMCastAddr() : getBCastAddr(tc.IPaddress);
          tc.port = initializer.getMCastPort();
          tc = LocateClientInList(tc.IPaddress, tc.port);
          tc.userName = "NETWORK";
          sub.id = (short) tct.contractID;
          sub.starttime = BCAST_ID;
        }
      }
      // is client in contractList?
      tce = LocateClientInContract(tct, tc);
      if (tce == null)
      {
        SendMessageToCaller(tc, sub, TErrorList.resources_exhausted, null);
        continue;
      }
      // fill in renewed fields ...
      tce.sts.reset(sub);
      renewalMultiplier = 1;
      if (sub.pollingRate < 500) renewalMultiplier = 3;
      // Force Contract execution
      if (tce.sts.mode != ACK_PENDING)
      {
        if ((tce.sts.counter == 0 && sub.starttime != BCAST_ID) || sub.mode == TMode.CM_REFRESH)
        {
          tce.sts.Stale = 1;
          tce.sts.lasttime = System.currentTimeMillis();
        }
        // update counters ? ...
        if (sub.mode != TMode.CM_CANCEL && sub.mode != TMode.CM_REFRESH
            && tce.sts.counter > ACK_REQUEST * renewalMultiplier
            && tce.sts.counter < RENEWAL * renewalMultiplier)
        {
          tce.sts.reconnects++;
          gClientReconnects++;
        }
        gStaleData++;
      }
      // is retry ?
      if ((sub.mode & TMode.CM_RETRY) != 0)
      {
        // if expired, DeliverData() will send the last payload again
        tce.sts.Stale = 1;
        gStaleData++;
        tce.sts.isRetry = true;
        gClientRetries++;
        tce.sts.mode = TMode.getBaseMode(sub.mode);
      }
      if (tct.nclients == 0) // just turned off, turn it back on
      {
        tct.nclients++;
        tct.contract.EqpAccess &= ~(TAccess.CA_LAST);
      }
      // switch on mode
      switch (tce.sts.mode = sub.mode)
      {
        case TMode.CM_SINGLE:
          gSingleLinkCount++;
          tce.sts.counter = 1;
          if (!(tct.expired && tce.sts.isRetry))
          {
            // a RETRY marked as expired should not be called
            tct.lasttime = PRP_RETRY_SIGNAL;
          }
          if (tct.pollingRate == 0) tct.pollingRate = tce.sts.PollingRate;
          if (tct.nclients == 1)
          {
            // turn on LAST bit
            tct.contract.EqpAccess |= TAccess.CA_LAST;
          }
          break;
        case TMode.CM_POLL:
        case TMode.CM_REFRESH:
          tce.sts.counter = (short) (RENEWAL * renewalMultiplier);
          tct.pollingRate = findpoll(sub.pollingRate, tct.pollingRate);
          break;
        default:
        case TMode.CM_CANCEL:
          if (tce.cln.userName.compareTo("NETWORK") == 0) break;
          if (tct.nclients == 1)
          {
            if (tce.sts.counter > 0) // was active (turn on the LAST bit
                tct.contract.EqpAccess |= TAccess.CA_LAST;
            tct.lasttime = PRP_CANCEL_SIGNAL;
            tct.pending = 0;
          }
          tce.sts.counter = 0;
          break;
      }
    }
  }
  private void SendRegisteredExportToENS(TEquipmentModule eqm)
  {
    if (eqm == null) return;
    if (eqm.getLocalName() == null || eqm.getLocalName().length() == 0) 
    {
      System.out.println("attempt to register equipment module with empty local name !");
      eqm.isRegistered = true;
      return;
    }
    if ( eqm.getExportName() == null || eqm.getExportName().length() == 0) 
    {
      System.out.println("attempt to register equipment module with empty export name !");
      eqm.isRegistered = true;
      return;
    }
    if (gFecName == null) return; // not yet known !
    if (gFecAddr == null)
    {
      // TODO ???
      new TModAddress();
      gFecAddr = new FECAddr();
      gFecAddr.Name = gFecName;
      try
      {
        gFecAddr.IP = InetAddress.getLocalHost().getHostAddress().toString();
      }
      catch (UnknownHostException e) {}
      gFecAddr.PortOffset = (byte) gPortOffset;
      gFecAddr.Port[0] = (byte) (gPortOffset & 0xff);
      gFecAddr.Port[1] = (byte) ((gPortOffset >> 8) & 0xff);
    }
    if (gFecInfo == null)
    {
      gFecInfo = new FECInfo("JAVA",getFecDescription(),getFecLocation(),
          getFecHardware(),getFecSubsystem(),getFecResponsible());
    }
    if (eqm.getContext() == null || eqm.getContext().length() == 0)
    { // fill this in if it hasn't been set ...
      eqm.setContext(getFecContext());
    }
    if (eqm.getSubsystem() == null || eqm.getSubsystem().length() == 0)
    { // fill this in if it hasn't been set ...
      eqm.setSubsystem(getFecSubsystem());
    }
    DevAddr da = new DevAddr(gFecAddr);
    da.TagName = eqm.getExportName();
    da.Context = eqm.getContext(); // getFecContext();
    da.EqName = eqm.getModuleName();
    da.SubSystem = eqm.getSubsystem();
    // prepare it and send it out ...
    // devAddr-- + FecAddr + FecInfo
    byte[] expAddr = new byte[DevAddr.sizeInBytes + FECInfo.getSizeInBytes()];
    System.arraycopy(da.toByteArray(), 0, expAddr, 0, DevAddr.sizeInBytes);
    System.arraycopy(gFecInfo.toByteArray(), 0, expAddr, DevAddr.sizeInBytes, FECInfo.getSizeInBytes());
    TDataType din = new TDataType(expAddr, "");
    TDataType dout = new TDataType(expAddr, "");
    if (debugLevel > 0)
    {
      System.out.println("fec -> " + gFecAddr.toString());
      System.out.println("dev -> " + da.toString());
      System.out.println("fec info -> " + gFecInfo.toString());
    }
    // this should always point to the primary ENS
    if (TModAddress.currentConfiguredNameServerTag != null)
    {
      if (debugLevel > 2)
          System.out.println("Using ENS : " + TModAddress.currentConfiguredNameServerTag);
      TLink expLnk = new TLink(TModAddress.currentConfiguredNameServerTag,"EXPORT",dout,din,TAccess.CA_WRITE);
      if (gLinkFactory == null) gLinkFactory = expLnk.tf;
      int rc = expLnk.execute(500, true);
      if (rc == 0) 
      {
        eqm.isRegistered = true;
        TFecLog.log("FEC " + getFecName() + ", Server " + 
            da.TagName + "(" + da.EqName + ") registered with equipment name server");
        TFecLog.log("Context is " + da.Context);
      }
    }
    else
    {
      System.out.println("No configured ENS !");
    }
  }
  private void joinEnsGroup(TEquipmentModule eqm)
  {
    if (gFecName == null) return; // not yet known !
    if (eqm == null) return; // huh ?
    if (!eqm.isRegistered) return;
    String grp = eqm.getGroupName();
    if (grp == null || grp.length() == 0) 
    {
      eqm.grpRegistered = true; // mark it
      return;
    }
    if (eqm.grpRegistered) return;
    String exp = eqm.getExportName(); if (exp == null) return;
    String cnt = eqm.getContext(); if (cnt == null) cnt = new String("");
    String sub = eqm.getEquipmentModuleFactory().getFecSubsystem();
    NAME16[] n16 = new NAME16[5];
    n16[0] = new NAME16(exp);
    n16[1] = new NAME16(grp);
    n16[2] = new NAME16(cnt);
    n16[3] = new NAME16(String.valueOf(eqm.getGroupIndex()));
    n16[4] = new NAME16(sub);
    TDataType din = new TDataType(n16);
    TDataType dout = new TDataType();
    if (debugLevel > 0)
    {
      System.out.print("/" + cnt + "/" + exp + " -> ");
      System.out.println("joining group " + grp + " (index " + eqm.getGroupIndex() + ")");
    }
    // this should always point to the primary ENS
    if (TModAddress.currentConfiguredNameServerTag != null)
    {
      //String gensTag = "G" + TModAddress.currentConfiguredNameServerTag;
      //if (debugLevel > 2) System.out.println("Using GENS : " + gensTag);
      TLink expLnk = new TLink("GENS","JOIN",dout,din,TAccess.CA_WRITE);
      if (gLinkFactory == null) gLinkFactory = expLnk.tf;
      int rc = expLnk.execute(500, true);
      if (rc == 0) 
      {
        eqm.grpRegistered = true;
        TFecLog.log(exp + " joined group " + grp);
      }
    }
    else
    {
      System.out.println("No configured GENS !");
    }
  }
  private void SendMessageToCaller(TClient tc, TSubscription s, int cc, byte[] data)
  {
    TClientEntry tce = new TClientEntry();
    TContractTable tct = new TContractTable(); 
    short totalsize = 2;
    short msgsize = TPublishedData.hdrSizeInBytes + TErrorList.ERROR_SIZE;
    byte[] payload = new byte[1500];
    int len;
    tct.dtimestamp = System.currentTimeMillis() + gDataTimeStampOffset;
    tce.sts = new TClientStatus();
    if (s != null)
    {
      tct.contract = s.contract;
      tce.sts.starttime = ((long)s.starttime) * 1000;
      tce.sts.id = s.id;
    }
    tce.sts.statusCode = (short)cc;
    tce.sts.numblks = 1;
    tce.cln = tc;
    TPublishedData tpd = new TPublishedData(msgsize, tce, tct);
    System.arraycopy(tpd.dBuffer.toByteArray(),0,payload,totalsize,TPublishedData.hdrSizeInBytes);
    totalsize += TPublishedData.hdrSizeInBytes;
    switch (cc)
    {
      case TErrorList.get_subscription_id:
       if (data == null) return;
       len = 2;
       break;
      case TErrorList.call_redirection:
      case TErrorList.server_redirection:
        if (data == null) return;
        len = data.length;
        break;
      default:
        data = TErrorList.getErrorString(cc).getBytes();
        len = data.length;
        break;
    }
    System.arraycopy(data,0,payload,totalsize,len);
    totalsize += TErrorList.ERROR_SIZE;
    if (debugLevel > 0) 
    {
      switch (cc)
      {
        case TErrorList.illegal_property:
        case TErrorList.illegal_equipment_name:
        case TErrorList.non_existent_elem:
        case TErrorList.call_redirection:
        case TErrorList.server_redirection:
        case TErrorList.access_denied:
          System.out.println("MSG : " + s.contract.EqpName + " " + s.contract.EqpProperty + 
                             " -> " + TErrorList.getErrorString((short) cc));
          break;
        default: 
          System.out.println("MSG : " + TErrorList.getErrorString((short) cc));
          break;
      }
    }
    payload[0] = (byte) (totalsize & 0xff);
    payload[1] = (byte) (totalsize >> 8);
    sendToPeer(tc,payload,totalsize); 
  }
  public class TAcceptorThread extends Thread
  {
    private int transportProtocol = TTransport.UDP; // default
    TAcceptorThread(int transport)
    {
      transportProtocol = transport;
      this.setName("Equipment Module " + TTransport.toString((short)transport) + " acceptor");
    }
    TAcceptorThread()
    {
      transportProtocol = TTransport.UDP;
      this.setName("Equipment Module UDP acceptor");
    }
    public synchronized void run()
    {
      if (debugLevel > 0) System.out.println("Acceptor Thread started ...");
      while (!gSystemExitCondition)
      {
        try
        {
          if (!isInitialized) sleep(200);
          switch (transportProtocol)
          {
            case TTransport.UDP:
              systemAcceptDataGramRequest();
              gTotalUdpPackets++;
              break;
            case TTransport.TCP:
              systemAcceptDataStreamRequest();
              systemCleanupDataStreams();  // do this as a matter of course (kills inactive streams)
              gTotalTcpPackets++;
              break;
            default:
              System.out.println("transportProtocol "
                  + TTransport.toString((short) transportProtocol) + " not supported");
              gSystemExitCondition = true;
          }
        } 
        catch (Exception e) 
        {
          if (debugLevel > 0) e.printStackTrace();
        }
      }
      if (debugLevel > 0) System.out.println("Acceptor Thread terminating ...");
    }
  }
  public class TCycleThread extends Thread
  {
    public synchronized void run()
    {
      String s = null;
      this.setName("Equipment Module Cycle" + s);
      if (debugLevel > 0) System.out.println("Cycle Thread started ...");
      while (!gSystemExitCondition)
      {
        try
        {
          sleep(systemSrvCycle());
        }
        catch (Exception e)
        {
          e.printStackTrace();
          System.out.println("cycle thread execution error");
        }
      }
      TFecLog.log("System halted");
    }
  }
  public class TBackgroundThread extends Thread
  {
    private TEquipmentBackgroundTask tbkg;
    TBackgroundThread(TEquipmentBackgroundTask tBkgTask)
    {
      tbkg = tBkgTask;
      this.setName("Equipment Module background " + tbkg.getClass().getSimpleName());
   }
    public synchronized void run()
    {
      long interim = 0, deadTimeInMsec = 0;
      if (debugLevel > 0) System.out.println("Background Thread started ...");
      while (!gSystemExitCondition)
      {
        try
        {
          interim = System.currentTimeMillis();
          tbkg.call();
          deadTimeInMsec = tbkg.getBackgroundTaskInterval()
              - (System.currentTimeMillis() - interim);
          if (deadTimeInMsec < 0) deadTimeInMsec = 0;
          if (debugLevel > 3) 
            System.out.println("sleeping " + deadTimeInMsec + " msec in background task");
          sleep(deadTimeInMsec);
        }
        catch (Exception e)
        {
          e.printStackTrace();
          System.out.println("thread execution error");
        }
      }
    }
  }
  private void systemCleanupDataStreams()
  {
    for (int i=0; i<bucketList.size(); i++)
    {
      if (((TContractBucket)bucketList.get(i)).active == false)
        bucketList.remove(i);
    }
  }
  private void systemAcceptDataStreamRequest()
  {
    if (!isInitialized) return;
    try
    {
      Socket sck = srvs.accept();
      sck.setTcpNoDelay(true);
      sck.setTrafficClass(0x18);
      // TODO: there's got to be a more efficient way than waking the stupid thread up every
      // 10 msec ! a .notify() from SendToPeer() doesn't work since it's not the owner of the 
      // thread. BUT this can't block waiting for input when the scheduler needs to send 
      // something out !!!
      sck.setSoTimeout(10); 
      bucketList.add(new TContractBucket(sck));
    }
    catch (Exception e)
    {
      if (debugLevel > 0) System.out.println("systemAcceptRequest: interrupted IO");
    }
  }  
  private void systemAcceptDataGramRequest()
  {
    if (!isInitialized) return;
    try
    {
      srvp.s.receive(srvp.dpIn);
      // fill in the client entry ...
      gLinkTablesAccessed = true;
      while (isInsideCycle)
        java.lang.Thread.sleep(1);
      TClient tc = LocateClientInList(srvp.dpIn.getAddress(), srvp.dpIn.getPort());
      tc.transport = TTransport.UDP;
      // pass it on ...
      getRequest(tc, srvp.dpIn.getData());
      gLinkTablesAccessed = false;
    }
    catch (IOException e)
    {
      if (debugLevel > 0) System.out.println("systemAcceptRequest: socket error");
    }
    catch (Exception e)
    {
      if (debugLevel > 0) System.out.println("systemAcceptRequest: interrupted IO");
    }
  }
  private long systemSrvCycle()
  {
    long msecToSleep = 10;
    if (!isInitialized) return STD_CYCLE_INTERVAL*200;
    if (gLinkTablesAccessed) return STD_CYCLE_INTERVAL;
    if (isInsideCycle) return STD_CYCLE_INTERVAL;
    isInsideCycle = true;
    if (debugLevel > 25) System.out.println("SystemCycle called at " + new Date().toString());
    // basic server service engine (called at the polling rate)
    // call each module's update routine ...
    for (int i=0; i<numEqmTableEntries; i++) eqmTable[i].update();
    // process all external requests ...
    produceData(); // check contract list ...
    if (registrationPending)
    { // anything still need to be sent out ?
      int doneCounter=0;
      for (int i=0; i<numEqmTableEntries; i++) 
      {
        if (eqmTable[i] == null) continue;
        if (!eqmTable[i].isRegistered) SendRegisteredExportToENS(eqmTable[i]);
        else if (!eqmTable[i].grpRegistered) joinEnsGroup(eqmTable[i]);
        else doneCounter++;        
      }
      if (doneCounter == numEqmTableEntries) registrationPending = false;
    }
    if (gCycleDelay > 10) msecToSleep = gCycleDelay;
    isInsideCycle = false;
    return msecToSleep;
  }
  public int systemInit(String fecName, int portOffset)
  {
    return systemInit(fecName,portOffset,null); 
  }
  public int systemInit(String fecName, int portOffset, String expName)
  {
    TFecLog.log("VERSION   : " + TStockProperties.getStockSrvVersion());
    TFecLog.log("OS        : JAVA");    
    TFecLog.log("TINE HOME : " + instance.getInitializer().getTineHome());
    TFecLog.log("FEC HOME  : " + instance.getInitializer().getFecHome());

    String lclName = null;
    if (expName == null)
    { // export name not given so try it this way ...
      for (int i = 0; lclName == null && i < numEqmTableEntries; i++)
      { // if there's already an entry then find it's eqm name
        if (eqmTable[i] == null) continue;
        lclName = eqmTable[i].getModuleName();
        expName = eqmTable[i].getExportName();
      }
    }
    if (fecName != null) setFecName(fecName);
    int rc = getFecInformationFromFile(expName,lclName);
    if (rc != 0 && (fecName == null || fecName.length() == 0))
    {
      System.out.println("Needed to read fecid.csv and couldn't!");
    }
    if (portOffset > 0) gPortOffset = portOffset;
    int port = initializer.getSrvPort() + gPortOffset;
    srvp = new TPacket(port);
    port = initializer.getTCPPort() + gPortOffset;
    if (gFecName != null) 
    {
      //setFecName(fecName);
      TLinkFactory.getInstance().setUserName(getFecName());
    }
    else
    {
      System.out.println("FEC Name unknown at start time !");
    }
    try
    {   
      ServerSocketChannel srvsChannel = ServerSocketChannel.open(); 
      srvs = srvsChannel.socket();
      srvs.setReuseAddress(true);
      srvs.setReceiveBufferSize(0x10000);
      srvs.bind(new InetSocketAddress(port));
    }
    catch (Exception e) 
    {
      e.toString();
      System.out.println("Cannot start server; closing down!");
      return TErrorList.not_running;
    }
    // is there a hook ?
    if (tEqmHook != null) tEqmHook.SystemInit();
    // send what we've got to the ENS ...
    for (int i = 0; i < numEqmTableEntries; i++)
    {
      // is there a devices file (needs to be done late) ?
      eqmTable[i].getRegisteredDevicesFromFile();
      if (!eqmTable[i].isRegistered) SendRegisteredExportToENS(eqmTable[i]);
      // is there a general alarm watch file ?
      getAlarmWatchListFromFile(eqmTable[i].getLocalName());
      // is there a local history file ?
      getHistoryListFromFile(eqmTable[i].getLocalName());
    }
    gSrvStartupTime = System.currentTimeMillis();
    // the server starttime is systematically a 4-byte integer (UTC) across ALL platfroms ...
    serverStatistics.setStarttime((int) (gSrvStartupTime/1000));
    // is there a configured CAS ?
    getCasHostFromFile();
    // is there a general alarm watch file ?
    //getAlarmWatchListFromFile(null);
    // is there a local history file ?
    //getHistoryListFromFile(null);
    // signal the 'all clear' :
    isInitialized = true;
    return 0;
  }
  public int systemInit(int portOffset)
  {
    return systemInit(null, portOffset, null);
  }
  public int systemInit()
  {
    return systemInit(null, 0, null);
  }
  public void systemWait(long milliseconds)
  {
    try
    {
      if (milliseconds < 0)
        while (true)
          Thread.sleep(1000);
      else
        Thread.sleep(milliseconds);
    }
    catch (Exception e)
    {
    }
  }
  public void shutdown()
  {
    TLinkFactory.getInstance().shutdown();
    gSystemExitCondition = true; 
  }
  // csv file FECID handlers:
  class tgtHndlr implements csvHandler
  {
    String target;
    tgtHndlr(String name) { target = name; }
    public int process(String strValue,int index)
    {
      if (target == null ||  // target not given 
          strValue.length() == 0) // empty string is as good as a match
      { // not given, halt iteration !
        TFecLog.log("accept first entry in fecid.csv as valid!");
        return -1; 
      }
      if (strValue.compareTo(target) == 0) // got it !
      { // found it, halt iteration !
        TFecLog.log("found target " + target + " in fecid.csv!");
        return -1; 
      }
      return 0;
    }
  }
  class fecHndlr implements csvHandler
  {
    public int process(String strValue,int index)
    {
      if (strValue == null || strValue.length() == 0) return TErrorList.argument_list_error;
      String nm = (strValue.length() > 16) ? strValue.substring(0,16) : strValue;
      setFecName(nm);
      return 0;
    }
  }
  class fecPortHndlr implements csvHandler
  {
    public int process(String strValue,int index)
    {
      try
      {
        gPortOffset = (short)(new Integer(strValue)).intValue();
      }
      catch (NumberFormatException e)
      {
        gPortOffset = 0;
      }
      return 0;
    }    
  }
  class contextHndlr implements csvHandler
  {
    public int process(String strValue,int index)
    {
      if (strValue == null || strValue.length() == 0) return TErrorList.argument_list_error;
      String nm = (strValue.length() > 16) ? strValue.substring(0,16) : strValue;
      setFecContext(nm);
      return 0;
    }
  }
  class descHndlr implements csvHandler
  {
    public int process(String strValue,int index)
    {
      setFecDescription(strValue);
      return 0;
    }
  }
  class locHndlr implements csvHandler
  {
    public int process(String strValue,int index)
    {
      setFecLocation(strValue);
      return 0;
    }
  }
  class hdwHndlr implements csvHandler
  {
    public int process(String strValue,int index)
    {
      setFecHardware(strValue);
      return 0;
    }
  }
  class subHndlr implements csvHandler
  {
    public int process(String strValue,int index)
    {
      setFecSubsystem(strValue);
      return 0;
    }
  }
  class rspHndlr implements csvHandler
  {
    public int process(String strValue,int index)
    {
      setFecResponsible(strValue);
      return 0;
    }
  }
  int getFecInformationFromFile(String targetExportName,String targetLocalName)
  {
    TInitializer initializer = TInitializerFactory.getInstance().getInitializer();
    // register the csv database structure: 
    csvColumn[] fecCols = new csvColumn[9];
    fecCols[0] = new csvColumn("FEC_NAME",null,new fecHndlr());
    fecCols[1] = new csvColumn("PORT_OFFSET","0",new fecPortHndlr());
    fecCols[2] = new csvColumn("CONTEXT","",new contextHndlr());
    if (targetExportName != null)
    {
      TFecLog.log("trying to latch export name " + targetExportName + " in fecid.csv");
      fecCols[3] = new csvColumn("EXPORT_NAME","",new tgtHndlr(targetExportName));
    }
    else
    {
      TFecLog.log("trying to latch local name " + targetLocalName + " in fecid.csv");
      fecCols[3] = new csvColumn("LOCAL_NAME","",new tgtHndlr(targetLocalName));
    }
    fecCols[4] = new csvColumn("DESCRIPTION","",new descHndlr());
    fecCols[5] = new csvColumn("LOCATION","",new locHndlr());
    fecCols[6] = new csvColumn("HARDWARE","none",new hdwHndlr());
    fecCols[7] = new csvColumn("SUBSYSTEM","TST",new subHndlr());
    fecCols[8] = new csvColumn("RESPONSIBLE","",new rspHndlr());
    
    // open it
    csv fecFile = new csv(initializer.getFecIdResource());
    // read it
    int rc = fecFile.readFile(fecCols);
    // close it
    fecFile.close();  
    if (rc != TErrorList.no_such_file)
      TFecLog.log("get fec information from fecid.csv : " + TErrorList.errorString[rc]);
    return rc;
  }
  // csv ALIAS list handlers:
  class aliasListRowHndlr implements csvRowHandler
  { // the Row Handler will be called when all columns have been read in
    private String aName;
    private String aAlias;
    public int process(int index)
    {
      AliasTableEntry ate = new AliasTableEntry(aName,aAlias);
      gAliasList.add(ate);
      return 0;
    }
  }
  class aliasListTagHndlr implements csvHandler
  {
    private aliasListRowHndlr rHndlr;
    aliasListTagHndlr(aliasListRowHndlr rowHndlr) { rHndlr = rowHndlr; }
    public int process(String strValue,int index)
    {
      rHndlr.aName = strValue != null ? strValue : "";
      return 0;
    }
  }
  class aliasListAliasHndlr implements csvHandler
  {
    private aliasListRowHndlr rHndlr;
    aliasListAliasHndlr(aliasListRowHndlr rowHndlr) { rHndlr = rowHndlr; }
    public int process(String strValue,int index)
    {
      rHndlr.aAlias = strValue != null ? strValue : "";
      return 0;
    }
  }
  int getAliasListFromFile()
  {
    TInitializer initializer = TInitializerFactory.getInstance().getInitializer();
    // register the csv database structure: 
    csvColumn[] aliasCols = new csvColumn[2];
    aliasListRowHndlr aliasRows = new aliasListRowHndlr();
    aliasCols[0] = new csvColumn("NAME","",new aliasListTagHndlr(aliasRows));
    aliasCols[1] = new csvColumn("ALIAS","0",new aliasListAliasHndlr(aliasRows));
    // open it
    csv aliasFile = new csv(initializer.getAliasResource(null));
    // read it
    aliasFile.readFile(aliasCols,aliasRows);
    // close it
    aliasFile.close();  
    //TFecLog.log("get alias information from alias.csv : " + TErrorList.errorString[rc]);
    return 0;
  }
  // csv CASHOSTS handlers:
  class casHndlr implements csvHandler
  {
    public int process(String strValue,int index)
    {
      if (strValue == null || strValue.length() == 0) return TErrorList.illegal_string_set;
      setCasName(strValue);
      gCasConfigured = true;
      return 0;
    }
  }
  int getCasHostFromFile()
  {
    TInitializer initializer = TInitializerFactory.getInstance().getInitializer();
    // register the csv database structure: 
    csvColumn[] casCols = new csvColumn[1];
    casCols[0] = new csvColumn("CAS","",new casHndlr());
    // open it
    csv casHostFile = new csv(initializer.getCasHostResource());
    // read it
    int rc = casHostFile.readFile(casCols);
    // close it
    casHostFile.close();  
    if (rc != TErrorList.no_such_file)
      TFecLog.log("get CAS hosts from cashosts.csv : " + TErrorList.errorString[rc]);
    return 0;
  }  
  // csv ALMWATCH handlers:
  class almwRowHndlr implements csvRowHandler
  { // the Row Handler will be called when all columns have been read in
    private TEquipmentModule eqm;
    private String dev;
    private String prp;
    private int  siz;
    private int  fmt;
    private int  atyp;              /* array type */
    private int  asys;              /* alarm system id */
    private int  sev;               /* of hi and low (warn is sev - 2) */
    private int  cnt;
    private int mask;
    private int normal;
    private float hi;               /* high threshold */
    private float lo;               /* low threshold */
    private float hiwarn;           /* high warn threshold */
    private float lowarn;           /* low warn threshold */
    public int process(int index)
    {
      if (eqm == null) return TErrorList.non_existent_elem;
      TAlarmWatchThreshold awt;
      if (mask == 0)
      {
        awt = new TAlarmWatchThreshold(cnt,hi,hiwarn,lo,lowarn);
      }
      else
      {
        awt = new TAlarmWatchThreshold(cnt,mask,normal);
      }
      TAlarmWatchEntry awe = new TAlarmWatchEntry(eqm,dev,prp,siz,fmt,atyp,asys,sev,awt);
  
      eqm.gAlarmWatchList.add(awe);
      return 0;
    }
  }
  class almwEqmHndlr implements csvHandler
  {
    private almwRowHndlr rHndlr;
    almwEqmHndlr(almwRowHndlr rowHndlr) { rHndlr = rowHndlr; }
    public int process(String strValue,int index)
    {
      for (int i=0; i<numEqmTableEntries; i++) 
        if (eqmTable[i].getLocalName().compareTo(strValue) == 0) 
        {
          rHndlr.eqm = eqmTable[i]; 
          return 0;
        }
      return 0; //TErrorList.non_existent_elem;
    }
  }
  class almwDevHndlr implements csvHandler
  {
    private almwRowHndlr rHndlr;
    almwDevHndlr(almwRowHndlr rowHndlr) { rHndlr = rowHndlr; }
    public int process(String strValue,int index)
    {
      rHndlr.dev = strValue;
      return 0;
    }
  }
  class almwPrpHndlr implements csvHandler
  {
    private almwRowHndlr rHndlr;
    almwPrpHndlr(almwRowHndlr rowHndlr) { rHndlr = rowHndlr; }
    public int process(String strValue,int index)
    {
      rHndlr.prp = strValue;
      return 0;
    }
  }
  class almwSizHndlr implements csvHandler
  {
    private almwRowHndlr rHndlr;
    almwSizHndlr(almwRowHndlr rowHndlr) { rHndlr = rowHndlr; }
    public int process(String strValue,int index)
    {
      try
      {
        rHndlr.siz = Integer.parseInt(strValue);
      }
      catch (NumberFormatException e)
      {
        rHndlr.siz = 0;
      }
      return 0;
    }
  }
  class almwFmtHndlr implements csvHandler
  {
    private almwRowHndlr rHndlr;
    almwFmtHndlr(almwRowHndlr rowHndlr) { rHndlr = rowHndlr; }
    public int process(String strValue,int index)
    {
      rHndlr.fmt = TFormat.getFormatCode(strValue);
      return 0;
    }
  }
  class almwSevHndlr implements csvHandler
  {
    private almwRowHndlr rHndlr;
    almwSevHndlr(almwRowHndlr rowHndlr) { rHndlr = rowHndlr; }
    public int process(String strValue,int index)
    {
      try
      {
        rHndlr.sev = Integer.parseInt(strValue);
      }
      catch (NumberFormatException e)
      {
        rHndlr.sev = 0;
      }
      return 0;
    }
  }
  class almwSysHndlr implements csvHandler
  {
    private almwRowHndlr rHndlr;
    almwSysHndlr(almwRowHndlr rowHndlr) { rHndlr = rowHndlr; }
    public int process(String strValue,int index)
    {
      try
      {
        rHndlr.asys = Integer.parseInt(strValue);
      }
      catch (NumberFormatException e)
      {
        rHndlr.asys = 0;
      }
      return 0;
    }
  }
  class almwCntHndlr implements csvHandler
  {
    private almwRowHndlr rHndlr;
    almwCntHndlr(almwRowHndlr rowHndlr) { rHndlr = rowHndlr; }
    public int process(String strValue,int index)
    {
      try
      {
        rHndlr.cnt = Integer.parseInt(strValue);
      }
      catch (NumberFormatException e)
      {
        rHndlr.cnt = 0;
      }
        
      return 0;
    }
  }
  class almwMaskHndlr implements csvHandler
  {
    private almwRowHndlr rHndlr;
    almwMaskHndlr(almwRowHndlr rowHndlr) { rHndlr = rowHndlr; }
    public int process(String strValue,int index)
    {
      try
      {
        if (strValue.startsWith("0x") || strValue.startsWith("0X"))
          rHndlr.mask = Integer.parseInt(strValue.substring(2),16);
        else
          rHndlr.mask = Integer.parseInt(strValue);
      }
      catch (NumberFormatException e)
      {
        rHndlr.mask = 0;
      }
      return 0;
    }
  }
  class almwNormHndlr implements csvHandler
  {
    private almwRowHndlr rHndlr;
    almwNormHndlr(almwRowHndlr rowHndlr) { rHndlr = rowHndlr; }
    public int process(String strValue,int index)
    {
      try
      {
        if (strValue.startsWith("0x") || strValue.startsWith("0X"))
          rHndlr.normal = Integer.parseInt(strValue.substring(2),16);
        else
          rHndlr.normal = Integer.parseInt(strValue);
      }
      catch (NumberFormatException e)
      {
        rHndlr.normal = 0;
      }
      return 0;
    }
  }
  class almwHiHndlr implements csvHandler
  {
    private almwRowHndlr rHndlr;
    almwHiHndlr(almwRowHndlr rowHndlr) { rHndlr = rowHndlr; }
    public int process(String strValue,int index)
    {
      try
      {
        rHndlr.hi = Float.parseFloat(strValue);
      }
      catch (NumberFormatException e)
      {
        rHndlr.hi = 0;
      }
      return 0;
    }
  }
  class almwLoHndlr implements csvHandler
  {
    private almwRowHndlr rHndlr;
    almwLoHndlr(almwRowHndlr rowHndlr) { rHndlr = rowHndlr; }
    public int process(String strValue,int index)
    {
      try
      {
        rHndlr.lo = Float.parseFloat(strValue);
      }
      catch (NumberFormatException e)
      {
        rHndlr.lo = 0;
      }
      return 0;
    }
  }
  class almwHiWarnHndlr implements csvHandler
  {
    private almwRowHndlr rHndlr;
    almwHiWarnHndlr(almwRowHndlr rowHndlr) { rHndlr = rowHndlr; }
    public int process(String strValue,int index)
    {
      try
      {
        rHndlr.hiwarn = Float.parseFloat(strValue);
      }
      catch (NumberFormatException e)
      {
        rHndlr.hiwarn = 0;
      }
      return 0;
    }
  }
  class almwLoWarnHndlr implements csvHandler
  {
    private almwRowHndlr rHndlr;
    almwLoWarnHndlr(almwRowHndlr rowHndlr) { rHndlr = rowHndlr; }
    public int process(String strValue,int index)
    {
      try
      {
        rHndlr.lowarn = Float.parseFloat(strValue);
      }
      catch (NumberFormatException e)
      {
        rHndlr.lowarn = 0;
      }
      return 0;
    }
  }
  int getAlarmWatchListFromFile(String eqmName)
  {
    TInitializer initializer = TInitializerFactory.getInstance().getInitializer();
    // register the csv database structure: 
    csvColumn[] almwCols = new csvColumn[14];
    almwRowHndlr almwRows = new almwRowHndlr();
    almwCols[0] = new csvColumn("LOCAL_NAME","",new almwEqmHndlr(almwRows));
    almwCols[1] = new csvColumn("DEVICE_NAME","#0",new almwDevHndlr(almwRows));
    almwCols[2] = new csvColumn("PROPERTY","",new almwPrpHndlr(almwRows));
    almwCols[3] = new csvColumn("SIZE","0",new almwSizHndlr(almwRows));
    almwCols[4] = new csvColumn("FORMAT","null",new almwFmtHndlr(almwRows));
    almwCols[5] = new csvColumn("SEVERITY","0",new almwSevHndlr(almwRows));
    almwCols[6] = new csvColumn("ALARM_SYSTEM","0",new almwSysHndlr(almwRows));
    almwCols[7] = new csvColumn("COUNT_THRESHOLD","3",new almwCntHndlr(almwRows));
    almwCols[8] = new csvColumn("HIGH","1.0",new almwHiHndlr(almwRows));
    almwCols[9] = new csvColumn("LOW","0.0",new almwLoHndlr(almwRows));
    almwCols[10] = new csvColumn("HIGH_WARN","0.5",new almwHiWarnHndlr(almwRows));
    almwCols[11] = new csvColumn("LOW_WARN","0.1",new almwLoWarnHndlr(almwRows));
    almwCols[12] = new csvColumn("MASK","0.1",new almwMaskHndlr(almwRows));
    almwCols[13] = new csvColumn("NORMAL","0.1",new almwNormHndlr(almwRows));
    // open it
    csv almwFile = new csv(initializer.getAlmWatchResource(eqmName));
    // read it
    int rc = almwFile.readFile(almwCols,almwRows);
    // close it
    almwFile.close();  
    stkAlarmDefinitions.put(Integer.toString(TErrorList.invalid_data), 
      new TAlarmDefinition("invalid data", "value not at set point","device",TErrorList.invalid_data,12,0, 
          -1,TFormat.CF_LONG,1,"last measured value",""));
    stkAlarmDefinitions.put(Integer.toString(TErrorList.value_too_high), 
      new TAlarmDefinition("value too high", "value exceeds threshold","device",TErrorList.value_too_high,12,0,
          -1,TFormat.CF_FLOAT,1,"last measured value",""));
    stkAlarmDefinitions.put(Integer.toString(TErrorList.warn_too_high), 
      new TAlarmDefinition("warn too high", "value is near threshold","device",TErrorList.warn_too_high,10,0,
          -1,TFormat.CF_FLOAT,1,"last measured value",""));
    stkAlarmDefinitions.put(Integer.toString(TErrorList.value_too_low), 
      new TAlarmDefinition("value too low", "value exceeds threshold","device",TErrorList.value_too_low,12,0,
          -1,TFormat.CF_FLOAT,1,"last measured value",""));
    stkAlarmDefinitions.put(Integer.toString(TErrorList.warn_too_low), 
      new TAlarmDefinition("warn too low", "value is near threshold","device",TErrorList.warn_too_low,10,0,
          -1,TFormat.CF_FLOAT,1,"last measured value",""));
    if (rc != TErrorList.no_such_file)
      TFecLog.log("get Alarm Watch information from almwatch.csv : " + TErrorList.errorString[rc]);
    return 0;
  }
  // csv HISTORY handlers:
  class hstRowHndlr implements csvRowHandler
  { // the Row Handler will be called when all columns have been read in
    private TEquipmentModule eqm;
    private String dev;
    private String prp;
    private int  siz;
    private int  fmt;
    private int  atyp;              /* array type */
    private int  pollingRate;               /* polling rate in sec */
    private int  archiveRate;               /* archive rate in sec */
    private int  depthShort;             /* for short term storage */
    private int  depthLong;               /* for long term storage */
    private int  heartbeat;            /* archive heartbeat in sec */
    private float pTolerance;                 /* percent tolerance */
    private float aTolerance;                /* absolute tolerance */
    private int  recordIndex;            /* local index identifier */
    private String redirString;
    private boolean skip = false;
    public int process(int index)
    {
      if (skip) return 0;
      if (eqm == null) return TErrorList.non_existent_elem;
      THistorySpecification spc = 
        new THistorySpecification(pollingRate,archiveRate,depthShort,depthLong,heartbeat,pTolerance,aTolerance,redirString);
      if (!THistoryRecord.isAllowableFormat((short)fmt))
      {
        TFecLog.log("history format " + TFormat.toString((short)fmt) + " read from database not archiveable");
        return 0;
      }
      THistoryRecord hst = new THistoryRecord(eqm,dev,prp,siz,fmt,atyp,recordIndex,spc);
      if (eqm.isUseMSecHistoryTimestamps()) hst.setUseMsecHistoryTimeStamps(true);
      if  (eqm.isUseMonthlyHistoryFiles()) hst.setUseMonthlyHistoryFiles(true);
      eqm.gLclHstList.add(hst);
      return 0;
    }
  }
  class hstEqmHndlr implements csvHandler
  {
    private hstRowHndlr rHndlr;
    hstEqmHndlr(hstRowHndlr rowHndlr) { rHndlr = rowHndlr; }
    public int process(String strValue,int index)
    {
      for (int i=0; i<numEqmTableEntries; i++) 
        if (eqmTable[i].getLocalName().compareTo(strValue) == 0) 
        {
          rHndlr.eqm = eqmTable[i]; 
          return 0;
        }
      return TErrorList.non_existent_elem;
    }
  }
  class hstExpHndlr implements csvHandler
  {
    private String target;
    private hstRowHndlr rHndlr;
    hstExpHndlr(hstRowHndlr rowHndlr,String name) { rHndlr = rowHndlr; target = name; }
    public int process(String strValue,int index)
    {
      if (target == null || target.length() == 0 || strValue.compareTo(target) == 0) 
      { // found it, halt iteration !
        rHndlr.skip = false; 
      }
      else
      {
        rHndlr.skip = true;
      }
      return 0;
    }
  }
  class hstDevHndlr implements csvHandler
  {
    private hstRowHndlr rHndlr;
    hstDevHndlr(hstRowHndlr rowHndlr) { rHndlr = rowHndlr; }
    public int process(String strValue,int index)
    {
      rHndlr.dev = strValue;
      return 0;
    }
  }
  class hstPrpHndlr implements csvHandler
  {
    private hstRowHndlr rHndlr;
    hstPrpHndlr(hstRowHndlr rowHndlr) { rHndlr = rowHndlr; }
    public int process(String strValue,int index)
    {
      rHndlr.prp = strValue;
      return 0;
    }
  }
  class hstSizHndlr implements csvHandler
  {
    private hstRowHndlr rHndlr;
    hstSizHndlr(hstRowHndlr rowHndlr) { rHndlr = rowHndlr; }
    public int process(String strValue,int index)
    {
      try
      {
        rHndlr.siz = Integer.parseInt(strValue);
      }
      catch (NumberFormatException e)
      {
        rHndlr.siz = 0;
      }
      return 0;
    }
  }
  class hstFmtHndlr implements csvHandler
  {
    private hstRowHndlr rHndlr;
    hstFmtHndlr(hstRowHndlr rowHndlr) { rHndlr = rowHndlr; }
    public int process(String strValue,int index)
    {
      rHndlr.fmt = TFormat.getFormatCode(strValue);
      return 0;
    }
  }
  class hstIdxHndlr implements csvHandler
  {
    private hstRowHndlr rHndlr;
    hstIdxHndlr(hstRowHndlr rowHndlr) { rHndlr = rowHndlr; }
    public int process(String strValue,int index)
    {
      try
      {
        rHndlr.recordIndex = Integer.parseInt(strValue);
      }
      catch (NumberFormatException e)
      {
        rHndlr.recordIndex = 0;
      }
      return 0;
    }
  }
  class hstHbtHndlr implements csvHandler
  {
    private hstRowHndlr rHndlr;
    hstHbtHndlr(hstRowHndlr rowHndlr) { rHndlr = rowHndlr; }
    public int process(String strValue,int index)
    {
      try
      {
        rHndlr.heartbeat = Integer.parseInt(strValue);
      }
      catch (NumberFormatException e)
      {
        rHndlr.heartbeat = 18000;
      }
      return 0;
    }
  }
  class hstPollHndlr implements csvHandler
  {
    private hstRowHndlr rHndlr;
    hstPollHndlr(hstRowHndlr rowHndlr) { rHndlr = rowHndlr; }
    public int process(String strValue,int index)
    {
      try
      {
        rHndlr.pollingRate = Integer.parseInt(strValue);
        if (rHndlr.pollingRate < 20) rHndlr.pollingRate *= 1000; // was thinking in secs 
      }
      catch (NumberFormatException e)
      {
        rHndlr.pollingRate = 1000;
      }
      return 0;
    }
  }
  class hstArchHndlr implements csvHandler
  {
    private hstRowHndlr rHndlr;
    hstArchHndlr(hstRowHndlr rowHndlr) { rHndlr = rowHndlr; }
    public int process(String strValue,int index)
    {
      try
      {
        rHndlr.archiveRate = Integer.parseInt(strValue);
        if (rHndlr.archiveRate < 20) rHndlr.archiveRate *= 1000; // was thinking in secs 
      }
      catch (NumberFormatException e)
      {
        rHndlr.archiveRate = 10000;
      }
      return 0;
    }
  }
  class hstLngHndlr implements csvHandler
  {
    private hstRowHndlr rHndlr;
    hstLngHndlr(hstRowHndlr rowHndlr) { rHndlr = rowHndlr; }
    public int process(String strValue,int index)
    {
      try
      {
        rHndlr.depthLong = Integer.parseInt(strValue);
      }
      catch (NumberFormatException e)
      {
        rHndlr.depthLong = 0;
      }
      return 0;
    }
  }
  class hstShtHndlr implements csvHandler
  {
    private hstRowHndlr rHndlr;
    hstShtHndlr(hstRowHndlr rowHndlr) { rHndlr = rowHndlr; }
    public int process(String strValue,int index)
    {
      try
      {
        rHndlr.depthShort = Integer.parseInt(strValue);
      }
      catch (NumberFormatException e)
      {
        rHndlr.depthShort = 600;
      }
      return 0;
    }
  }
  class hstTolHndlr implements csvHandler
  {
    private hstRowHndlr rHndlr;
    hstTolHndlr(hstRowHndlr rowHndlr) { rHndlr = rowHndlr; }
    public int process(String strValue,int index)
    {
      int i=0;
      try
      {
        if ((i=strValue.indexOf('%')) == -1)
        { // absolute tolerance !
          rHndlr.aTolerance = Float.parseFloat(strValue);
          rHndlr.pTolerance = 0;
        }
        else
        {
          rHndlr.aTolerance = 0;
          rHndlr.pTolerance = Float.parseFloat(strValue.substring(0,i-1));
        }
      }
      catch (Exception e)
      {
        rHndlr.pTolerance = 0;
        rHndlr.aTolerance = 0;
      }
      return 0;
    }
  }
  class hstRdrHndlr implements csvHandler
  {
    private hstRowHndlr rHndlr;
    hstRdrHndlr(hstRowHndlr rowHndlr) { rHndlr = rowHndlr; }
    public int process(String strValue,int index)
    {
      rHndlr.redirString = strValue;
      return 0;
    }
  }
  int getHistoryListFromFile(String eqmName)
  {
    TInitializer initializer = TInitializerFactory.getInstance().getInitializer();
    // register the csv database structure: 
    csvColumn[] hstCols = new csvColumn[13];
    hstRowHndlr hstRows = new hstRowHndlr();
    hstCols[0] = new csvColumn("INDEX","1",new hstIdxHndlr(hstRows));
    hstCols[1] = new csvColumn("LOCAL_NAME","",new hstEqmHndlr(hstRows));
    hstCols[2] = new csvColumn("PROPERTY","",new hstPrpHndlr(hstRows));
    hstCols[3] = new csvColumn("DEVICE","#0",new hstDevHndlr(hstRows));
    hstCols[4] = new csvColumn("DATA_LENGTH","1",new hstSizHndlr(hstRows));
    hstCols[5] = new csvColumn("FORMAT","float",new hstFmtHndlr(hstRows));
    hstCols[6] = new csvColumn("HEARTBEAT","900",new hstHbtHndlr(hstRows));
    hstCols[7] = new csvColumn("POLLING_RATE","1000",new hstPollHndlr(hstRows));
    hstCols[8] = new csvColumn("ARCHIVE_RATE","1000",new hstArchHndlr(hstRows));
    hstCols[9] = new csvColumn("TOLERANCE","0%",new hstTolHndlr(hstRows));
    hstCols[10] = new csvColumn("SHORT_DEPTH","600",new hstShtHndlr(hstRows));
    hstCols[11] = new csvColumn("LONG_DEPTH","1",new hstLngHndlr(hstRows));
    hstCols[12] = new csvColumn("REMOTE_SERVER","",new hstRdrHndlr(hstRows));
    // open it
    csv hstFile = new csv(initializer.getHistoryResource(eqmName));
    // read it
    int rc = hstFile.readFile(hstCols,hstRows);
    // close it
    hstFile.close();  
    if (rc != TErrorList.no_such_file)
      TFecLog.log("get local history information from history.csv : " + TErrorList.errorString[rc]);
    return 0;
  }
  // subclass this here in the server factory as well as in the client factory
  public class TEqmFactoryBucketThread extends Thread
  {
    private TContractBucket tb;
    boolean isWaiting = false;
    TEqmFactoryBucketThread(TContractBucket tbucket)
    {
      tb = tbucket;
      tb.active = true;
      String s = null;
      Socket sck = tb.getSocket();
      if (sck != null) s = new String("tcp port " + sck.getLocalPort());
      else s = new String("tcp unbound socket ?");
      this.setName("Equipment Module Factory " + s);
    }
    public synchronized void run()
    {
      byte[] wa = new byte[1472];
      byte[] msgsizb = new byte[2];
      int nread, nleft, n, waptr;
      if (debugLevel > 0) System.out.println("EQM Factory Bucket Thread started ...");
      try
      {
        while (tb.active)
        {
          if (gSystemExitCondition) break;
          isWaiting = true;
          try
          { // the socket blocks (both is and os) for 10 msec
            nread = tb.getInputStream().read(wa,0,1472);
          }
          catch (InterruptedIOException e) 
          {
            continue;
          }
          isWaiting = false;
          if (nread  == -1) 
          {
            tb.isDeactivating = true;
            break;
          }
          nleft = nread;
          waptr = 0;
          int ptr = tb.getBucketPointer();
          int siz = tb.getBucketSize();
          byte[] buf = tb.getBucketBuffer();
          while (nleft > 0)
          {                    
            if (ptr == 0) 
            {
              System.arraycopy(wa,waptr,msgsizb,0,2);
              siz = Swap.Short(new DataInputStream(new ByteArrayInputStream(msgsizb)).readShort());
            }
            n = siz - ptr;
            if (nleft >= n)  // at least enough
            {
              System.arraycopy(wa,waptr,buf,ptr,n);
              gLinkTablesAccessed = true;
              try
              {
                while (isInsideCycle) java.lang.Thread.sleep(1);
              }
              catch (Exception e) {}
              TClient tc = LocateClientInList(tb.getBucketEndpoint(),tb.getBucketPort());
              tc.transport = TTransport.TCP;
              tc.output = tb.getOutputStream();
              tc.sck = tb.getSocket();
              getRequest(tc, buf);
              gLinkTablesAccessed = false;
              waptr += n;                 // move the read buffer pointer along
              nleft -= n;                 // decrement what's remaining to be read
              ptr = 0;                 // reset the bucket pointer
            }
            else
            {
              System.arraycopy(wa,waptr,buf,ptr,nleft);
              ptr += nleft;
              nleft = 0;
            }
            tb.setBucketPointer(ptr);
          }                    
        }
        tb.getInputStream().close();
        tb.getOutputStream().close();
      }
      catch (IOException e)
      {
        if (debugLevel > 1) System.out.println("EQM Bucket IOException : " + e);
      }
      catch (Exception e)
      {
        if (debugLevel > 1) e.printStackTrace();
      }
      finally
      {
        tb.active = false;  // definitely !
      }
    }
  }
  public class TContractBucket extends TBucket
  {
    TContractBucket(Socket socket)
    {
      initBucket(socket,new TEqmFactoryBucketThread(this));
      activate();
    }
  }
  public long getDataTimeStampOffset()
  {
    return gDataTimeStampOffset;
  }
  public int systemScheduleProperty(TEquipmentModule eqm,String prp)
  {
    int i, listsize;
    boolean needsHistoryCycle = false;
    boolean needsScheduler = false;
    TContractTable tct = null;
    listsize = conTable.size();
    if (debugLevel > 2) System.out.println("Property " + prp + " is being scheduled");
    for (i=0; i<listsize; i++)
    {
      tct = (TContractTable) conTable.get(i);
      if (tct.expired) continue;
      if (tct.nclients > 0 && tct.contract.EqpProperty.compareToIgnoreCase(prp) == 0)
      { /* guarantee immediate execution of any contract using this property */
        tct.lasttime = PRP_SCHEDULE_SIGNAL;
        needsScheduler = true;
      }
    }
    if (needsScheduler) produceData();
    THistoryRecord lhr = null;
    listsize = eqm.gLclHstList.size();
    for (i=0; i<listsize; i++)
    {
      lhr = (THistoryRecord)eqm.gLclHstList.get(i);
      if (lhr.getPrp().compareToIgnoreCase(prp) == 0)
      {
        needsHistoryCycle = true;
        lhr.setScheduled(true);
      }
    }
    if (needsHistoryCycle) eqm.update(); 
    return 0;
  }
}