package debugTest;

import java.awt.Color;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;

import javax.swing.JFrame;
import javax.swing.JPanel;

import de.desy.acop.displayers.AcopChart;
import de.desy.acop.displayers.tools.AcopChartConsumer;

public class AcopDisplayerTest extends Object {
	
	static class Updater extends Thread {
		AcopChartConsumer c;
		double[] data= new double[100];
		int interval;
        double offset = 0;
		public Updater(AcopChartConsumer c, int i, double off) {
			this.c=c;
			interval=i;
            offset = off;
			start();
		}
		/* (non-Javadoc)
		 * @see java.lang.Thread#run()
		 */
		@Override
		public synchronized void  run() {
			while(true) {
				try {
					for (int i = 0; i < data.length; i++) {
						data[i]=offset + 100.0*Math.random();
					}

					c.updateValue(System.currentTimeMillis(),data);
	
	                sleep(interval);
	                
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		}
	}
	

	public AcopDisplayerTest() {
		super();
		// TODO Auto-generated constructor stub
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		try {
			
			JFrame f= new JFrame();
			f.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
			
			JPanel p= new JPanel();
			p.setLayout(new GridBagLayout());
			
			AcopChart dis= new AcopChart();
			
			// this setting does not seem to be working
			dis.setYMin(-10.0);
			dis.setYMax(110.0);
			
			p.add(dis,new GridBagConstraints(0,0,1,1,1.0,1.0,GridBagConstraints.CENTER,GridBagConstraints.BOTH,new Insets(4,4,4,4),0,0));
			
			f.setContentPane(p);
			f.setSize(500,300);
			f.setVisible(true);
			
			// I create first chart data series, everything ok
			AcopChartConsumer c= dis.getConsumer("A",AcopChartConsumer.class);
			c.setColor(Color.RED);
			new Updater(c,1000,0);

			// I create second chart data series, it is not working as expected
			c= dis.getConsumer("B",AcopChartConsumer.class);
			c.setColor(Color.BLUE);
			new Updater(c,3000,20);
			
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

}
