package debugTest;

import java.awt.Color;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;

import javax.swing.JFrame;
import javax.swing.JPanel;

import com.cosylab.util.CommonException;

import de.desy.acop.displayers.AcopChart;
import de.desy.acop.displayers.tools.AcopChartConsumer;
import de.desy.acop.transport.AccessMode;
import de.desy.acop.transport.AcopTransport;
import de.desy.acop.transport.AcopTransportEvent;
import de.desy.acop.transport.AcopTransportListener;

public class NewAcopDisplayerTest extends Object {
	
    static class DisplayerData
    {
      AcopChartConsumer c;
      int linkHandle = -1;
      double[] data = new double[100];
      public double[] getData() { return data; }
      public int getLinkHandle() { return linkHandle; }
      public AcopChartConsumer getAcopDataConsumer() { return c; }
      public void setLinkHandle(int handle) 
      { 
        linkHandle = handle;
      }
      public DisplayerData(AcopChartConsumer c)
      {
        this.c = c;
      }
    }
    static DisplayerData[] dataSets = new DisplayerData[2];
	public NewAcopDisplayerTest() {
		super();
		// TODO Auto-generated constructor stub
	}

	/**
	 * @param args
	 */
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		try {
			
			JFrame f= new JFrame();
			f.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
			
			JPanel p= new JPanel();
			p.setLayout(new GridBagLayout());
			
			AcopChart dis= new AcopChart();
			
			// this setting does not seem to be working
			dis.setYMin(-10.0);
			dis.setYMax(110.0);
			
			p.add(dis,new GridBagConstraints(0,0,1,1,1.0,1.0,GridBagConstraints.CENTER,GridBagConstraints.BOTH,new Insets(4,4,4,4),0,0));
			
			f.setContentPane(p);
			f.setSize(500,300);
			f.setVisible(true);
			
			// I create first chart data series, everything ok
			AcopChartConsumer c= dis.getConsumer("A",AcopChartConsumer.class);
			c.setColor(Color.RED);
            
            AcopTransport t = c.getAcop().getAcopTransport();
            t.addAcopTransportListener(new AcopTransportListener()
            {
              public void dataEventReceived(AcopTransportEvent e)
              {
                int id = e.getLinkId();
                for (int i=0; i<dataSets.length; i++)
                {
                  if (id == dataSets[i].getLinkHandle())
                  {
                    //System.out.println("update link " + id);
                    double ts = dataSets[i].getAcopDataConsumer().getAcop().getAcopTransport().getDataTimeStamp();
                    try
                    {
                      dataSets[i].getAcopDataConsumer().updateValue((long)(ts*1000),dataSets[i].getData());
                    }
                    catch (CommonException e1)
                    {
                      // TODO Auto-generated catch block
                      e1.printStackTrace();
                    }
                    break;
                  }
                }
              }
            });
            // turning grouping on will interfer with testing the different
            // updates at different rates, etc. 
            // (grouped = true would only give one receive event when all member have notified) 
            //t.setGrouped(true); < don't do this here
            t.setAccessProtocol("Simulate");
            t.setDeviceContext("TEST"); // ignored in Simulation mode
            t.setDeviceGroup("TEST");  // ignored in Simulation mode
            t.setDeviceName("Test1");  // ignored in Simulation mode
            t.setDeviceProperty("RandomData");  // ignored in Simulation mode
            t.setAccessMode(AccessMode.POLL);
            t.setAccessRate("1000");
            dataSets[0] = new DisplayerData(c);
            int id = t.attachLink(dataSets[0].getData());
            if (id >= 0) dataSets[0].setLinkHandle(id);
            // second link:
			c= dis.getConsumer("B",AcopChartConsumer.class);
			c.setColor(Color.BLUE);
            t.setAccessRate("3000");
            t.setDeviceName("Test2");
            dataSets[1] = new DisplayerData(c);
            id = t.attachLink(dataSets[1].getData());
            if (id >= 0) dataSets[1].setLinkHandle(id);
			
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

}
