/*
 * Created on Sep 14, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package instantClient;

import java.util.*;
import javax.swing.JFrame;
import de.desy.tine.client.*;
import de.desy.tine.dataUtils.*;
import de.desy.tine.definitions.*;
import de.desy.tine.queryUtils.*;
import de.desy.tine.structUtils.*;
import de.desy.tine.types.*;
import de.desy.acop.chart.*;

/**
 * @author duval To change the template for this generated type comment go to
 *         Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class InstantBrowser extends JFrame
{
  private javax.swing.JPanel jContentPane = null;
  private Acop acop = null;
  private XPropertyQuery[] xpqs = null;
  private int nxpqs = 0;
  private int ptrxpqs = 0;
  private int debugLevel = 0;
  private javax.swing.JMenuBar browserMenu = null;
  private javax.swing.JMenu browserOptions = null;
  private javax.swing.JCheckBoxMenuItem supressQueryProperties = null;
  private javax.swing.JCheckBoxMenuItem propertyQueryPrecedence = null;
  private javax.swing.JCheckBoxMenuItem deviceQueryPrecedence = null;
  private javax.swing.JMenuItem flushAddressCache = null;
  private javax.swing.JMenuItem reloadNames = null;
  private javax.swing.JComboBox deviceContextCombo = null;
  private javax.swing.JTextField deviceContrextText = null;
  private javax.swing.JTextField deviceServerText = null;
  private javax.swing.JTextField deviceSubsystemText = null;
  private javax.swing.JTextField deviceNameText = null;
  private javax.swing.JTextField devicePropertyText = null;
  private javax.swing.JCheckBox stockPropertiesChecked = null;
  private javax.swing.JComboBox deviceServerCombo = null;
  private javax.swing.JComboBox deviceSubsystemCombo = null;
  private javax.swing.JComboBox deviceNameCombo = null;
  private javax.swing.JComboBox devicePropertyCombo = null;
  private javax.swing.JTextField dataSizeText = null;
  private javax.swing.JTextField dataTypeText = null;
  private javax.swing.JTextField propertyDescriptionText = null;
  private javax.swing.JTextField timeoutText = null;
  private javax.swing.JTextArea dataSizeInput = null;
  private javax.swing.JComboBox dataTypeCombo = null;
  private javax.swing.JTextArea timeoutInput = null;
  private javax.swing.JButton readButton = null;
  private javax.swing.JButton pollButton = null;
  private javax.swing.JTextField drawModeText = null;
  private javax.swing.JComboBox drawModeCombo = null;
  private javax.swing.JCheckBox autoscaleChecked = null;
  private javax.swing.JCheckBox logScaleChecked = null;
  private java.awt.Color bkgColor = new java.awt.Color(124, 151, 223);
  private java.awt.Color bkgTextColor = new java.awt.Color(218, 229, 247);
  private boolean isSwitching = false;
  private static int PANEL_XEXTENT_SMALL = 567;
  private static int PANEL_XEXTENT_LARGE = 750;
  private static int PANEL_YEXTENT_SMALL = 388;
  private static InstantBrowser browserInstance;
  private BrowserCallback browserCallback = new BrowserCallback();
  private TLink browserLink = null;
  private TDataType dataOut = null;
  private TDataType dataIn = null;
  private String[] devlist = null;
  public static void main(String[] args)
  {
    browserInstance = new InstantBrowser();
    browserInstance.setTitle("browserInstance");
    browserInstance.show();
  }
  /**
   * This is the default constructor
   */
  public InstantBrowser()
  {
    super();
    initialize();
  }
  private void fillInContexts()
  {
    deviceContextCombo.removeAllItems();
    deviceContextCombo.addItem("DEFAULT");
    String[] contexts = TQuery.getContexts();
    if (contexts != null)
    {
      Arrays.sort(contexts);
      for (int i = 0; i < contexts.length; i++)
      {
        deviceContextCombo.addItem(contexts[i]);
      }
    }
  }
  public String[] SubSystemString = {"ALL", "Diagnostics", "Vaccum", "RF", "Magnets", "Timing", "Feedback",
      "Tunes", "Injection", "QuenchProtection", "Experiments", "Services", "Subsystems", "Netmex", "Archive",
      "Daemons", "Tests"};
  public String[] SubSystemTag = {"ALL", "DIA", "VAC", "RF", "MAG", "TIM", "FB", "TUN", "INJ", "QPS", "EXP",
      "SER", "SUB", "MEX", "HST", "DMN", "TST"};
  private void fillInSubsystems()
  {
    deviceSubsystemCombo.removeAllItems();
    for (int i = 0; i < SubSystemString.length; i++)
    {
      deviceSubsystemCombo.addItem(SubSystemString[i]);
    }
  }
  private void fillInSubsystems(String context)
  {
    deviceSubsystemCombo.removeAllItems();
    deviceSubsystemCombo.addItem("ALL");
    String subs[] = TQuery.getDeviceSubsystems(context);
    if (subs == null) return;
    for (int i = 0; i < subs.length; i++)
    {
      deviceSubsystemCombo.addItem(subs[i]);
    }
  }
  /**
   * This method initializes this
   * 
   * @return void
   */
  private void initialize()
  {
    this.setSize(560, 388);
    this.setContentPane(getJContentPane());
    this.setTitle("Java Instant Client");
    this.addWindowListener(new java.awt.event.WindowAdapter()
    {
      public void windowClosing(java.awt.event.WindowEvent e)
      {
        System.exit(0);
      }
    });
    fillInSubsystems();
    fillInContexts();
  }
  /**
   * This method initializes jContentPane
   * 
   * @return javax.swing.JPanel
   */
  private javax.swing.JPanel getJContentPane()
  {
    if (jContentPane == null)
    {
      jContentPane = new javax.swing.JPanel();
      jContentPane.setLayout(null);
      jContentPane.add(getAcop(), null);
      jContentPane.add(getBrowserMenu(), null);
      jContentPane.add(getReadButton(), null);
      jContentPane.add(getPollButton(), null);
      jContentPane.add(getDrawModeText(), null);
      jContentPane.add(getDrawModeCombo(), null);
      jContentPane.add(getAutoscaleChecked(), null);
      jContentPane.add(getLogScaleChecked(), null);
      jContentPane.add(getDeviceContextCombo(), null);
      jContentPane.add(getDeviceContrextText(), null);
      jContentPane.add(getDeviceServerText(), null);
      jContentPane.add(getDeviceSubsystemText(), null);
      jContentPane.add(getDeviceNameText(), null);
      jContentPane.add(getDevicePropertyText(), null);
      jContentPane.add(getStockPropertiesChecked(), null);
      jContentPane.add(getDeviceServerCombo(), null);
      jContentPane.add(getDeviceSubsystemCombo(), null);
      jContentPane.add(getDeviceNameCombo(), null);
      jContentPane.add(getDevicePropertyCombo(), null);
      jContentPane.add(getDataSizeText(), null);
      jContentPane.add(getDataTypeText(), null);
      jContentPane.add(getPropertyDescriptionText(), null);
      jContentPane.add(getTimeoutText(), null);
      jContentPane.add(getDataSizeInput(), null);
      jContentPane.add(getDataTypeCombo(), null);
      jContentPane.add(getTimeoutInput(), null);
      jContentPane.add(getHistoryCheckBox(), null);
      jContentPane.add(getInputPanelCheckBox(), null);
      jContentPane.add(getWriteAccessSelected(), null);
      jContentPane.add(getInputDataTypeCombo(), null);
      jContentPane.add(getInputDataTypeText(), null);
      jContentPane.add(getInputPanelText(), null);
      jContentPane.add(getDevicePropertyToggleButton(), null);
      jContentPane.setBackground(bkgColor);
    }
    return jContentPane;
  }
  /**
   * This method initializes acop
   * 
   * @return acop.Acop
   */
  private Acop getAcop()
  {
    if (acop == null)
    {
      acop = new Acop();
      acop.setBounds(11, 141, 451, 212);
      acop.setFrameRightOffset(-20);
      acop.setFrameLeftOffset(20);
      acop.setAccessProtocol("TINE");
      acop.setFont(new java.awt.Font("Dialog", java.awt.Font.BOLD, 12));
      acop.setDrawWidth(2);
      acop.setFrameFont(new java.awt.Font("Tahoma", java.awt.Font.BOLD, 12));
      acop.setBackground(java.awt.Color.white);
      acop.setCaption("");
      acop.setleftYLabel(true);
      acop.setFrameTopOffset(-10);
      acop.setFrameBottomOffset(10);
      acop.setFrameForeColor(java.awt.Color.black);
      acop.setTextDepth(1);
      acop.setScreenDepth(1);
      acop.setYBestScale(true);
      acop.setXBestScale(true);
    }
    return acop;
  }
  /**
   * This method initializes jJMenuBar
   * 
   * @return javax.swing.JMenuBar
   */
  private javax.swing.JMenuBar getBrowserMenu()
  {
    if (browserMenu == null)
    {
      browserMenu = new javax.swing.JMenuBar();
      browserMenu.add(getBrowserOptions());
      browserMenu.add(getDebugOptionsMenu());
      browserMenu.setBounds(3, 3, 555, 21);
      browserMenu.setName("BrowserMenu");
      browserMenu.setBackground(bkgColor);
    }
    return browserMenu;
  }
  /**
   * This method initializes jMenu
   * 
   * @return javax.swing.JMenu
   */
  private javax.swing.JMenu getBrowserOptions()
  {
    if (browserOptions == null)
    {
      browserOptions = new javax.swing.JMenu();
      browserOptions.add(getSupressQueryProperties());
      browserOptions.add(getPropertyQueryPrecedence());
      browserOptions.add(getDeviceQueryPrecedence());
      browserOptions.add(getFlushAddressCache());
      browserOptions.add(getReloadNames());
      browserOptions.setName("BrowserOptions");
      browserOptions.setText("Options");
      browserOptions.setBackground(bkgColor);
    }
    return browserOptions;
  }
  /**
   * This method initializes jCheckBoxMenuItem
   * 
   * @return javax.swing.JCheckBoxMenuItem
   */
  private javax.swing.JCheckBoxMenuItem getSupressQueryProperties()
  {
    if (supressQueryProperties == null)
    {
      supressQueryProperties = new javax.swing.JCheckBoxMenuItem();
      supressQueryProperties.setText("Supress Query Properties");
      supressQueryProperties.setName("SupressQueryProperties");
      supressQueryProperties.setSelected(true);
      supressQueryProperties.addItemListener(new java.awt.event.ItemListener()
      {
        public void itemStateChanged(java.awt.event.ItemEvent e)
        {
          fillInDeviceProperties();
        }
      });
    }
    return supressQueryProperties;
  }
  /**
   * This method initializes jCheckBoxMenuItem1
   * 
   * @return javax.swing.JCheckBoxMenuItem
   */
  private javax.swing.JCheckBoxMenuItem getPropertyQueryPrecedence()
  {
    if (propertyQueryPrecedence == null)
    {
      propertyQueryPrecedence = new javax.swing.JCheckBoxMenuItem();
      propertyQueryPrecedence.setName("PropertyQueryPrecedence");
      propertyQueryPrecedence.setText("Property Query Precedence");
      propertyQueryPrecedence.setSelected(false);
      propertyQueryPrecedence.addItemListener(new java.awt.event.ItemListener()
      {
        public void itemStateChanged(java.awt.event.ItemEvent e)
        {
          if (deviceQueryPrecedence.isSelected() && propertyQueryPrecedence.isSelected())
            deviceQueryPrecedence.setSelected(false);
        }
      });
    }
    return propertyQueryPrecedence;
  }
  /**
   * This method initializes jCheckBoxMenuItem2 *
   * 
   * @return javax.swing.JCheckBoxMenuItem
   */
  private javax.swing.JCheckBoxMenuItem getDeviceQueryPrecedence()
  {
    if (deviceQueryPrecedence == null)
    {
      deviceQueryPrecedence = new javax.swing.JCheckBoxMenuItem();
      deviceQueryPrecedence.setName("DeviceQueryPrecedence");
      deviceQueryPrecedence.setText("Device Query Precedence");
      deviceQueryPrecedence.addItemListener(new java.awt.event.ItemListener()
      {
        public void itemStateChanged(java.awt.event.ItemEvent e)
        {
          if (deviceQueryPrecedence.isSelected() && propertyQueryPrecedence.isSelected())
            propertyQueryPrecedence.setSelected(false);
        }
      });
    }
    return deviceQueryPrecedence;
  }
  /**
   * This method initializes jMenuItem
   * 
   * @return javax.swing.JMenuItem
   */
  private javax.swing.JMenuItem getFlushAddressCache()
  {
    if (flushAddressCache == null)
    {
      flushAddressCache = new javax.swing.JMenuItem();
      flushAddressCache.setName("FlushAddressCache");
      flushAddressCache.setText("Flush Address Cache");
      flushAddressCache.addActionListener(new java.awt.event.ActionListener()
      {
        public void actionPerformed(java.awt.event.ActionEvent e)
        {
          // System.out.println("actionPerformed()"); // TODO Auto-generated
          // Event stub actionPerformed()
        }
      });
    }
    return flushAddressCache;
  }
  /**
   * This method initializes jMenuItem1
   * 
   * @return javax.swing.JMenuItem
   */
  private javax.swing.JMenuItem getReloadNames()
  {
    if (reloadNames == null)
    {
      reloadNames = new javax.swing.JMenuItem();
      reloadNames.setText("Reload Names");
      reloadNames.setName("ReloadNames");
      reloadNames.addActionListener(new java.awt.event.ActionListener()
      {
        public void actionPerformed(java.awt.event.ActionEvent e)
        {
          fillInContexts();
//          fillInSubsystems();
        }
      });
    }
    return reloadNames;
  }
  private void fillInDeviceServers()
  {
    if (deviceContextCombo.getSelectedIndex() < 0) return;
    if (deviceSubsystemCombo.getSelectedIndex() < 0) return;
    propertyQueryPrecedence.setSelected(false);
    deviceQueryPrecedence.setSelected(false);
    deviceServerCombo.removeAllItems();
    String[] svrs = TQuery.getDeviceServers(deviceContextCombo.getSelectedItem().toString(),
        deviceSubsystemCombo.getSelectedItem().toString());
//        SubSystemTag[deviceSubsystemCombo.getSelectedIndex()]);
    if (svrs == null) return;
    Arrays.sort(svrs);
    for (int i = 0; i < svrs.length; i++)
    {
      deviceServerCombo.addItem(svrs[i]);
    }
  }
  /**
   * This method initializes jComboBox
   * 
   * @return javax.swing.JComboBox
   */
  private javax.swing.JComboBox getDeviceContextCombo()
  {
    if (deviceContextCombo == null)
    {
      deviceContextCombo = new javax.swing.JComboBox();
      deviceContextCombo.setBounds(10, 40, 150, 20);
      deviceContextCombo.setName("DeviceContextCombo");
      deviceContextCombo.setMaximumRowCount(8);
      deviceContextCombo.setLightWeightPopupEnabled(false);
      deviceContextCombo.setEditable(false);
      deviceContextCombo.setAutoscrolls(true);
      deviceContextCombo.setFocusCycleRoot(false);
      deviceContextCombo.setBackground(bkgTextColor);
      deviceContextCombo.addActionListener(new java.awt.event.ActionListener()
      {
        public void actionPerformed(java.awt.event.ActionEvent e)
        {
          fillInSubsystems(deviceContextCombo.getSelectedItem().toString());
          fillInDeviceServers();
        }
      });
    }
    return deviceContextCombo;
  }
  /**
   * This method initializes jTextField
   * 
   * @return javax.swing.JTextField
   */
  private javax.swing.JTextField getDeviceContrextText()
  {
    if (deviceContrextText == null)
    {
      deviceContrextText = new javax.swing.JTextField();
      deviceContrextText.setBounds(12, 24, 93, 15);
      deviceContrextText.setName("DeviceContrextText");
      deviceContrextText.setText("Device Context");
      deviceContrextText.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
      deviceContrextText.setBackground(bkgColor);
      deviceContrextText.setEditable(false);
    }
    return deviceContrextText;
  }
  /**
   * This method initializes jTextField1
   * 
   * @return javax.swing.JTextField
   */
  private javax.swing.JTextField getDeviceServerText()
  {
    if (deviceServerText == null)
    {
      deviceServerText = new javax.swing.JTextField();
      deviceServerText.setBounds(10, 60, 91, 15);
      deviceServerText.setName("DeviceServerText");
      deviceServerText.setText("Device Server");
      deviceServerText.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
      deviceServerText.setBackground(bkgColor);
      deviceServerText.setEditable(false);
    }
    return deviceServerText;
  }
  /**
   * This method initializes jTextField2
   * 
   * @return javax.swing.JTextField
   */
  private javax.swing.JTextField getDeviceSubsystemText()
  {
    if (deviceSubsystemText == null)
    {
      deviceSubsystemText = new javax.swing.JTextField();
      deviceSubsystemText.setBounds(174, 24, 114, 15);
      deviceSubsystemText.setName("DeviceSubsystemText");
      deviceSubsystemText.setText("Device Subsystem");
      deviceSubsystemText.setBackground(bkgColor);
      deviceSubsystemText.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
      deviceSubsystemText.setEditable(false);
    }
    return deviceSubsystemText;
  }
  /**
   * This method initializes jTextField3
   * 
   * @return javax.swing.JTextField
   */
  private javax.swing.JTextField getDeviceNameText()
  {
    if (deviceNameText == null)
    {
      deviceNameText = new javax.swing.JTextField();
      deviceNameText.setBounds(176, 60, 87, 15);
      deviceNameText.setName("DeviceNameText");
      deviceNameText.setText("Device Name");
      deviceNameText.setBackground(bkgColor);
      deviceNameText.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
      deviceNameText.setEditable(false);
    }
    return deviceNameText;
  }
  /**
   * This method initializes jTextField4
   * 
   * @return javax.swing.JTextField
   */
  private javax.swing.JTextField getDevicePropertyText()
  {
    if (devicePropertyText == null)
    {
      devicePropertyText = new javax.swing.JTextField();
      devicePropertyText.setBounds(365, 60, 99, 15);
      devicePropertyText.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
      devicePropertyText.setBackground(bkgColor);
      devicePropertyText.setName("DevicePropertyText");
      devicePropertyText.setText("Device Property");
      devicePropertyText.setEditable(false);
    }
    return devicePropertyText;
  }
  /**
   * This method initializes jCheckBox
   * 
   * @return javax.swing.JCheckBox
   */
  private javax.swing.JCheckBox getStockPropertiesChecked()
  {
    if (stockPropertiesChecked == null)
    {
      stockPropertiesChecked = new javax.swing.JCheckBox();
      stockPropertiesChecked.setBounds(365, 35, 149, 24);
      stockPropertiesChecked.setName("StockPropertiesChecked");
      stockPropertiesChecked.setText("Show Stock Proprties");
      stockPropertiesChecked.setBackground(bkgColor);
      stockPropertiesChecked.addItemListener(new java.awt.event.ItemListener()
      {
        public void itemStateChanged(java.awt.event.ItemEvent e)
        {
          fillInDeviceProperties();
        }
      });
    }
    return stockPropertiesChecked;
  }
  private void fillInDeviceNames()
  {
    String[] devs = null;
    if (deviceNameCombo.getItemCount() > 0) deviceNameCombo.removeAllItems();
    if (!propertyQueryPrecedence.isSelected())
    {
      devs = TQuery.getDeviceNames(deviceContextCombo.getSelectedItem().toString(), deviceServerCombo
          .getSelectedItem().toString());
      if (TQuery.devices_have_query_function) propertyQueryPrecedence.setSelected(true);
    }
    else
    {
      if (devicePropertyCombo.getSelectedIndex() < 0) return;
      devs = TQuery.getDeviceNames(deviceContextCombo.getSelectedItem().toString(), deviceServerCombo
          .getSelectedItem().toString(), devicePropertyCombo.getSelectedItem().toString());
    }
    if (devs == null || devs.length == 0)
    {
      deviceNameCombo.addItem("#0");
    }
    else
    {
      for (int i = 0; i < devs.length; i++)
      {
        deviceNameCombo.addItem(devs[i]);
      }
    }
    devlist = devs;
  }
  /**
   * This method initializes jComboBox1
   * 
   * @return javax.swing.JComboBox
   */
  private javax.swing.JComboBox getDeviceServerCombo()
  {
    if (deviceServerCombo == null)
    {
      deviceServerCombo = new javax.swing.JComboBox();
      deviceServerCombo.setBounds(10, 75, 150, 20);
      deviceServerCombo.setName("DeviceServerCombo");
      deviceServerCombo.setLightWeightPopupEnabled(false);
      deviceServerCombo.setEditable(false);
      deviceServerCombo.setBackground(bkgTextColor);
      deviceServerCombo.addActionListener(new java.awt.event.ActionListener()
      {
        public void actionPerformed(java.awt.event.ActionEvent e)
        {
          if (deviceServerCombo.getSelectedIndex() < 0) return; // removeAll
                                                                // will also
                                                                // generate this
                                                                // event
          propertyQueryPrecedence.setSelected(false);
          deviceQueryPrecedence.setSelected(false);
          fillInDeviceNames();
          fillInDeviceProperties();
        }
      });
    }
    return deviceServerCombo;
  }// @jve:visual-info decl-index=0 visual-constraint="23,15"
  /**
   * This method initializes jComboBox2
   * 
   * @return javax.swing.JComboBox
   */
  private javax.swing.JComboBox getDeviceSubsystemCombo()
  {
    if (deviceSubsystemCombo == null)
    {
      deviceSubsystemCombo = new javax.swing.JComboBox();
      deviceSubsystemCombo.setBounds(177, 40, 160, 20);
      deviceSubsystemCombo.setName("DeviceSubsystemCombo");
      deviceSubsystemCombo.setLightWeightPopupEnabled(false);
      deviceSubsystemCombo.setEditable(false);
      deviceSubsystemCombo.setBackground(bkgTextColor);
      deviceSubsystemCombo.addActionListener(new java.awt.event.ActionListener()
      {
        public void actionPerformed(java.awt.event.ActionEvent e)
        {
          if (deviceSubsystemCombo.getSelectedIndex() < 0) return;
          fillInDeviceServers();
        }
      });
    }
    return deviceSubsystemCombo;
  }
  private void fillInDeviceProperties()
  {
    String con, dev, srv;
    if (deviceServerCombo.getSelectedIndex() < 0) return;
    con = (deviceContextCombo.getSelectedIndex() < 0) ? "" : deviceContextCombo.getSelectedItem().toString();
    dev = (deviceNameCombo.getSelectedIndex() < 0) ? "#0" : deviceNameCombo.getSelectedItem().toString();
    srv = deviceServerCombo.getSelectedItem().toString();
    if (devicePropertyCombo.getItemCount() > 0) devicePropertyCombo.removeAllItems();
    String[] prps = TQuery.getDeviceProperties(con, srv, dev);
    if (prps == null) return;
    if (TQuery.properties_have_query_function)
    {
      deviceQueryPrecedence.setSelected(true);
      propertyQueryPrecedence.setSelected(false);
    }
    if (stockPropertiesChecked.isSelected())
    {
      String[] sprps = TQuery.getStockProperties(con, srv);
      if (sprps != null)
      {
        Arrays.sort(sprps);
        devicePropertyCombo.setForeground(java.awt.Color.red);
        for (int i = 0; i < sprps.length; i++)
          devicePropertyCombo.addItem(sprps[i]);
        devicePropertyCombo.setForeground(java.awt.Color.black);
      }
    }
    Arrays.sort(prps);
    for (int i = 0; i < prps.length; i++)
    {
      if (supressQueryProperties.isSelected())
      {
        if (prps[i].endsWith(".NAM")) continue;
        if (prps[i].endsWith(".HIST")) continue;
        if (prps[i].endsWith(".EGU")) continue;
      }
      devicePropertyCombo.addItem(prps[i]);
    }
  }
  /**
   * This method initializes jComboBox3
   * 
   * @return javax.swing.JComboBox
   */
  private javax.swing.JComboBox getDeviceNameCombo()
  {
    if (deviceNameCombo == null)
    {
      deviceNameCombo = new javax.swing.JComboBox();
      deviceNameCombo.setBounds(176, 75, 162, 20);
      deviceNameCombo.setName("DeviceNameCombo");
      deviceNameCombo.setLightWeightPopupEnabled(false);
      deviceNameCombo.setEditable(true);
      deviceNameCombo.setBackground(bkgTextColor);
      deviceNameCombo.addActionListener(new java.awt.event.ActionListener()
      {
        public void actionPerformed(java.awt.event.ActionEvent e)
        {
          if (deviceNameCombo.getSelectedIndex() < 0) return;
          if (deviceQueryPrecedence.isSelected()) fillInDeviceProperties();
        }
      });
    }
    return deviceNameCombo;
  }
  void fillInPropertyInfoCombos(String con, String srv)
  {
    dataSizeInput.setText("" + xpqs[ptrxpqs].prpSize);
    dataTypeCombo.setSelectedIndex(getDataTypeComboIndex(xpqs[ptrxpqs].prpFormat));
    propertyDescriptionText.setText(" " + xpqs[ptrxpqs].prpDescription);
    if (xpqs[ptrxpqs].prpFormat == TFormat.CF_STRUCT)
    {
      if (xpqs[ptrxpqs].prpTag.length() > 0) // tagged structure
      {
        TQuery.AcquireAndRegisterStructInfo(con, srv, xpqs[ptrxpqs].prpTag);
      }
    }
    logScaleChecked.setSelected(xpqs[ptrxpqs].prpGraphType == 1);
    if (xpqs[ptrxpqs].prpSize > 1024)
    {
      drawModeCombo.setSelectedIndex(1);
    }
    else if ((xpqs[ptrxpqs].prpArrayType & TArrayType.AT_SPECTRUM) == TArrayType.AT_SPECTRUM)
    {
      drawModeCombo.setSelectedIndex(0); // polyline
    }
    else if ((xpqs[ptrxpqs].prpArrayType & TArrayType.AT_CHANNEL) == TArrayType.AT_CHANNEL)
    {
      drawModeCombo.setSelectedIndex(2); // histogram
    }
    else
    {
      drawModeCombo.setSelectedIndex(7); // text
    }
    if (xpqs[ptrxpqs].prpSizeIn > 0)
    {
      inputDataTypeCombo.setSelectedIndex(getDataTypeComboIndex(xpqs[ptrxpqs].prpFormatIn));
    }
    else if (xpqs[ptrxpqs].prpSize > 0)
    {
      inputDataTypeCombo.setSelectedIndex(getDataTypeComboIndex(xpqs[ptrxpqs].prpFormat));
    }
    else
    {
      inputDataTypeCombo.setSelectedIndex(getDataTypeComboIndex(TFormat.CF_TEXT));
    }
  }
  void fillInPropertyInformation(String prp)
  {
    String con = "";
    String dev = "#0";
    if (deviceServerCombo.getSelectedIndex() < 0) return;
    String srv = deviceServerCombo.getSelectedItem().toString();
    if (deviceContextCombo.getSelectedIndex() >= 0) con = deviceContextCombo.getSelectedItem().toString();
    if (deviceNameCombo.getSelectedIndex() >= 0) dev = deviceNameCombo.getSelectedItem().toString();
    nxpqs = 0;
    ptrxpqs = 0;
    xpqs = TQuery.getDevicePropertyInformationX(con, srv, dev, prp);
    if (xpqs == null || xpqs.length == 0 || xpqs[0] == null)
    {
      xpqs = TQuery.getStockPropertyInformationX(con, srv, dev, prp);
      if (xpqs == null || xpqs.length == 0 || xpqs[0] == null) return;
    }
    nxpqs = xpqs.length;
    fillInPropertyInfoCombos(con, srv);
    historyCheckBox.setVisible(xpqs[ptrxpqs].prpHistoryDepthShort > 0);
    historyCheckBox.setSelected(false);
    devicePropertyToggleButton.setVisible(xpqs[ptrxpqs].prpNumOverloads > 1);
  }
  /**
   * This method initializes jComboBox4
   * 
   * @return javax.swing.JComboBox
   */
  private javax.swing.JComboBox getDevicePropertyCombo()
  {
    if (devicePropertyCombo == null)
    {
      devicePropertyCombo = new javax.swing.JComboBox();
      devicePropertyCombo.setBounds(365, 75, 176, 20);
      devicePropertyCombo.setName("DevicePropertyCombo");
      devicePropertyCombo.setLightWeightPopupEnabled(false);
      devicePropertyCombo.setEditable(true);
      devicePropertyCombo.setBackground(bkgTextColor);
      devicePropertyCombo.addActionListener(new java.awt.event.ActionListener()
      {
        public void actionPerformed(java.awt.event.ActionEvent e)
        {
          if (devicePropertyCombo.getSelectedIndex() < 0) return;
          if (propertyQueryPrecedence.isSelected()) fillInDeviceNames();
          fillInPropertyInformation(devicePropertyCombo.getSelectedItem().toString());
        }
      });
    }
    return devicePropertyCombo;
  }
  /**
   * This method initializes jTextField5
   * 
   * @return javax.swing.JTextField
   */
  private javax.swing.JTextField getDataSizeText()
  {
    if (dataSizeText == null)
    {
      dataSizeText = new javax.swing.JTextField();
      dataSizeText.setBounds(14, 99, 61, 15);
      dataSizeText.setBackground(bkgColor);
      dataSizeText.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
      dataSizeText.setName("DataSizeText");
      dataSizeText.setText("Data Size");
    }
    return dataSizeText;
  }
  /**
   * This method initializes jTextField6
   * 
   * @return javax.swing.JTextField
   */
  private javax.swing.JTextField getDataTypeText()
  {
    if (dataTypeText == null)
    {
      dataTypeText = new javax.swing.JTextField();
      dataTypeText.setBounds(79, 99, 67, 15);
      dataTypeText.setBackground(bkgColor);
      dataTypeText.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
      dataTypeText.setName("DataTypeText");
      dataTypeText.setText("Data Type");
    }
    return dataTypeText;
  }
  /**
   * This method initializes jTextField7
   * 
   * @return javax.swing.JTextField
   */
  private javax.swing.JTextField getPropertyDescriptionText()
  {
    if (propertyDescriptionText == null)
    {
      propertyDescriptionText = new javax.swing.JTextField();
      propertyDescriptionText.setBounds(177, 103, 306, 26);
      propertyDescriptionText.setBackground(bkgTextColor);
      propertyDescriptionText.setBorder(javax.swing.BorderFactory.createLineBorder(java.awt.Color.gray, 1));
      propertyDescriptionText.setName("PropertyDescriptionText");
    }
    return propertyDescriptionText;
  }
  /**
   * This method initializes jTextField8
   * 
   * @return javax.swing.JTextField
   */
  private javax.swing.JTextField getTimeoutText()
  {
    if (timeoutText == null)
    {
      timeoutText = new javax.swing.JTextField();
      timeoutText.setBounds(489, 96, 54, 16);
      timeoutText.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
      timeoutText.setBackground(bkgColor);
      timeoutText.setName("TimeoutText");
      timeoutText.setText("Timeout");
    }
    return timeoutText;
  }
  /**
   * This method initializes jTextArea
   * 
   * @return javax.swing.JTextArea
   */
  private javax.swing.JTextArea getDataSizeInput()
  {
    if (dataSizeInput == null)
    {
      dataSizeInput = new javax.swing.JTextArea();
      dataSizeInput.setBounds(13, 115, 43, 18);
      dataSizeInput.setBackground(bkgColor);
      dataSizeInput.setBorder(javax.swing.BorderFactory.createLineBorder(java.awt.Color.gray, 1));
      dataSizeInput.setName("DataSizeInput");
      dataSizeInput.setText("1");
    }
    return dataSizeInput;
  }
  private int[] dataTypeComboXref;
  private void fillInDataTypes(javax.swing.JComboBox cb)
  {
    int i;
    if (dataTypeComboXref == null)
    {
      dataTypeComboXref = new int[TFormat.availableFormats.length];
      for (i = 0; i < TFormat.availableFormats.length; i++)
        dataTypeComboXref[i] = TFormat.getFormatCode(TFormat.availableFormats[i]);
    }
    if (cb.getItemCount() > 0) cb.removeAllItems();
    for (i = 0; i < TFormat.availableFormats.length; i++)
    {
      cb.addItem(TFormat.availableFormats[i]);
    }
  }
  private int getDataTypeComboIndex(int code)
  {
    int i;
    if (code < 0) code += 256;
    for (i = 0; i < dataTypeComboXref.length; i++)
    {
      if (dataTypeComboXref[i] == code) return i;
    }
    return -1;
  }
  /**
   * This method initializes jComboBox5
   * 
   * @return javax.swing.JComboBox
   */
  private javax.swing.JComboBox getDataTypeCombo()
  {
    if (dataTypeCombo == null)
    {
      dataTypeCombo = new javax.swing.JComboBox();
      dataTypeCombo.setBounds(80, 115, 86, 20);
      dataTypeCombo.setName("DataTypeCombo");
      dataTypeCombo.setLightWeightPopupEnabled(false);
      dataTypeCombo.setBackground(bkgColor);
      fillInDataTypes(dataTypeCombo);
      dataTypeCombo.addActionListener(new java.awt.event.ActionListener()
      {
        public void actionPerformed(java.awt.event.ActionEvent e)
        {
          // System.out.println("actionPerformed()"); // TODO Auto-generated
          // Event stub actionPerformed()
        }
      });
    }
    return dataTypeCombo;
  }
  /**
   * This method initializes jTextArea1
   * 
   * @return javax.swing.JTextArea
   */
  private javax.swing.JTextArea getTimeoutInput()
  {
    if (timeoutInput == null)
    {
      timeoutInput = new javax.swing.JTextArea();
      timeoutInput.setBounds(499, 112, 42, 18);
      timeoutInput.setBackground(bkgColor);
      timeoutInput.setBorder(javax.swing.BorderFactory.createLineBorder(java.awt.Color.gray, 1));
      timeoutInput.setName("TimeoutInput");
      timeoutInput.setText("1000");
    }
    return timeoutInput;
  }
  public class BrowserCallback implements TLinkCallback
  {
    public void callback(TLink lnk)
    {
      int cc;
      if ((cc = lnk.getLinkStatus()) != 0)
      {
        String msg = new String("Link Error : " + lnk.getProperty() + " -> " + lnk.getLastError());
        acop.PrintText(msg);
        System.out.println(msg);
        return;
      }
      displayDataForSelectedProperty(cc);
    }
  }
  private void displayDataForSelectedProperty(int cc)
  {
    int id = -1;
    acop.ClearScreen();
    acop.ClearText();
    if (cc == 0)
    {
      if (dataOut == null) return;
      long dts = browserLink.getLastTimeStamp();
      int ms = (int) (dts % 1000);
      String add = ms < 10 ? ".00" : ms < 100 ? ".0" : ".";
      Date td = new Date(dts);
      String ts = td.toString().substring(11, 19) + add + ms;
      acop.setCaption(browserLink.getFullDeviceName() + " " + xpqs[ptrxpqs].prpName + " @ " + ts);
      if (drawModeCombo.getSelectedIndex() != 7) // text
      {
        Object o = dataOut.getDataObject();
        long timestamp = dataOut.getDataTimeStamp();
        int siz = dataOut.dCompletionLength;
        acop.setXMax(siz);
        acop.setXMin(0);
        acop.setYMax(xpqs[ptrxpqs].prpMaxValue);
        acop.setYMin(xpqs[ptrxpqs].prpMinValue);
        acop.setYAxisLabel(xpqs[ptrxpqs].prpUnits);
        acop.setXAxisLabel(xpqs[ptrxpqs].rngUnits);
        if ((xpqs[ptrxpqs].prpArrayType & TArrayType.AT_CHANNEL) == TArrayType.AT_CHANNEL)
        {
          id = acop.Draw(o, null, null, devlist);
        }
        else
        {
          id = acop.Draw(o);
        }
        if (autoscaleChecked.isSelected()) acop.AutoScale(false, false, true, true, id);
      }
      else
      {
        dataOut.setArrayDelimiter("\n");
        id = acop.Draw(dataOut.toString().trim());
      }
    }
    else
    {
      String err = browserLink.getLastError();
      if (err == null || err.length() == 0) err = TErrorList.getErrorString(cc);
      if (drawModeCombo.getSelectedIndex() != 7) // text
      {
        if (browserLink != null) acop.PrintText(err);
      }
      else
      {
        String[] aerr = new String[1];
        aerr[0] = err;
        id = acop.Draw(aerr);
      }
    }
  }
  private int getDataForSelectedProperty(int mode)
  {
    int id = -1, cc = 0;
    int to = (new Integer(getTimeoutInput().getText())).intValue() ;
    String fmt = dataTypeCombo.getSelectedItem().toString();
    short ifmt = TFormat.getFormatCode(fmt);
    int siz = (new Integer(getDataSizeInput().getText())).intValue();
    try
    {
      String con = deviceContextCombo.getSelectedItem().toString();
      String srv = deviceServerCombo.getSelectedItem().toString();
      String dev = deviceNameCombo.getSelectedItem().toString();
      String prp = devicePropertyCombo.getSelectedItem().toString();
      if (historyCheckBox.isSelected()) prp += ".HIST";
      String tgt;
      tgt = srv + "/" + dev;
      if (con.length() > 0 && con.compareTo("DEFAULT") != 0)
      {
        tgt = "/" + con + "/" + tgt;
      }
      if (ifmt == TFormat.CF_STRUCT)
      {
        drawModeCombo.setSelectedIndex(7); // text
        int ssiz = TStructRegistry.getSizeInBytes(xpqs[ptrxpqs].prpTag);
        if (ssiz != -1)   
        {
          ssiz *= xpqs[ptrxpqs].prpSize;
          byte[] sdata = new byte[ssiz];
          dataOut = new TDataType(sdata, xpqs[ptrxpqs].prpTag);
        }
        else
        {
          ssiz = xpqs[ptrxpqs].prpSize;
          byte[] sdata = new byte[ssiz];
          dataOut = new TDataType(sdata);
        }
      }
      else
      {
        dataOut = new TDataType(siz, ifmt);
      }
      if (browserLink != null) browserLink.cancel();
      dataIn = getInputData();
      short access = TAccess.CA_READ;
      if (writeAccessSelected.isSelected()) access |= TAccess.CA_WRITE;
      browserLink = new TLink(tgt, prp, dataOut, dataIn, access);
      if (debugLevel != browserLink.getDebugLevel()) browserLink.setDebugLevel(debugLevel);
      if ((mode & 0xff) == TMode.CM_SINGLE)
      {
        cc = browserLink.execute(to, true);
        displayDataForSelectedProperty(cc);
        browserLink.cancel();
        return cc;
      }
      if ((mode & 0xff) == TMode.CM_POLL)
      {
        id = browserLink.attach((short) mode, browserCallback, to);
        return id < 0 ? id : 0;
      }
    }
    catch (Exception e)
    {
      if (debugLevel > 0) e.printStackTrace();      
    }
    return 0;
  }
  /**
   * This method initializes jButton
   * 
   * @return javax.swing.JButton
   */
  private javax.swing.JButton getReadButton()
  {
    if (readButton == null)
    {
      readButton = new javax.swing.JButton();
      readButton.setBounds(465, 143, 80, 25);
      readButton.setName("ReadButton");
      readButton.setText("Read");
      readButton.addActionListener(new java.awt.event.ActionListener()
      {
        public void actionPerformed(java.awt.event.ActionEvent e)
        {
          int cc = getDataForSelectedProperty(TMode.CM_SINGLE);
        }
      });
    }
    return readButton;
  }
  /**
   * This method initializes jButton1
   * 
   * @return javax.swing.JButton
   */
  private javax.swing.JButton getPollButton()
  {
    if (pollButton == null)
    {
      pollButton = new javax.swing.JButton();
      pollButton.setBounds(465, 172, 80, 25);
      pollButton.setName("PollButton");
      pollButton.setText("Poll");
      pollButton.addActionListener(new java.awt.event.ActionListener()
      {
        public void actionPerformed(java.awt.event.ActionEvent e)
        {
          if (pollButton.getText().compareTo("Stop") == 0)
          {
            if (browserLink != null) browserLink.cancel();
            pollButton.setText("Poll");
            readButton.setEnabled(true);
            return;
          }
          int id = getDataForSelectedProperty(TMode.CM_POLL);
          if (id != 0)
          {
            acop.PrintText(acop.getStatus());
          }
          else
          {
            pollButton.setText("Stop");
            readButton.setEnabled(false);
          }
        }
      });
    }
    return pollButton;
  }
  /**
   * This method initializes jTextField9
   * 
   * @return javax.swing.JTextField
   */
  private javax.swing.JTextField getDrawModeText()
  {
    if (drawModeText == null)
    {
      drawModeText = new javax.swing.JTextField();
      drawModeText.setBounds(480, 202, 67, 15);
      drawModeText.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
      drawModeText.setBackground(bkgColor);
      drawModeText.setName("DrawModeText");
      drawModeText.setText("Draw Mode");
    }
    return drawModeText;
  }
  public String[] drawModes = {"PolyLine", "BarLine", "Histogram", "Dots", "AdjHisto", "Rects", "Circles",
      "Text" // ,"LineDots","BarDots","HistoDots"
  };
  private javax.swing.JCheckBox historyCheckBox = null;
  private javax.swing.JCheckBox inputPanelCheckBox = null;
  private javax.swing.JCheckBox writeAccessSelected = null;
  private javax.swing.JComboBox inputDataTypeCombo = null;
  private javax.swing.JTextArea inputDataTypeText = null;
  private javax.swing.JEditorPane inputPanelText = null;
  private javax.swing.JButton devicePropertyToggleButton = null;
  private javax.swing.JMenu debugOptionsMenu = null;
  private javax.swing.JMenuItem showFecInfoOption = null;
  private javax.swing.JRadioButtonMenuItem debugOnOption = null;
  private void fillInDrawModes()
  {
    if (drawModeCombo.getItemCount() > 0) drawModeCombo.removeAll();
    for (int i = 0; i < drawModes.length; i++)
    {
      drawModeCombo.addItem(drawModes[i]);
    }
  }
  /**
   * This method initializes jComboBox6
   * 
   * @return javax.swing.JComboBox
   */
  private javax.swing.JComboBox getDrawModeCombo()
  {
    if (drawModeCombo == null)
    {
      drawModeCombo = new javax.swing.JComboBox();
      drawModeCombo.setBounds(468, 218, 80, 20);
      drawModeCombo.setName("DrawModeCombo");
      drawModeCombo.setLightWeightPopupEnabled(false);
      drawModeCombo.setBackground(bkgColor);
      drawModeCombo.setMaximumRowCount(5);
      fillInDrawModes();
      drawModeCombo.addActionListener(new java.awt.event.ActionListener()
      {
        public void actionPerformed(java.awt.event.ActionEvent e)
        {
          acop.setDisplayMode(drawModeCombo.getSelectedIndex());
        }
      });
    }
    return drawModeCombo;
  }
  /**
   * This method initializes jCheckBox1
   * 
   * @return javax.swing.JCheckBox
   */
  private javax.swing.JCheckBox getAutoscaleChecked()
  {
    if (autoscaleChecked == null)
    {
      autoscaleChecked = new javax.swing.JCheckBox();
      autoscaleChecked.setBounds(465, 245, 87, 20);
      autoscaleChecked.setName("AutoscaleChecked");
      autoscaleChecked.setText("Autoscale");
      autoscaleChecked.setBackground(bkgColor);
      autoscaleChecked.addItemListener(new java.awt.event.ItemListener()
      {
        public void itemStateChanged(java.awt.event.ItemEvent e)
        {
          displayDataForSelectedProperty(0);
        }
      });
    }
    return autoscaleChecked;
  }
  /**
   * This method initializes jCheckBox2
   * 
   * @return javax.swing.JCheckBox
   */
  private javax.swing.JCheckBox getLogScaleChecked()
  {
    if (logScaleChecked == null)
    {
      logScaleChecked = new javax.swing.JCheckBox();
      logScaleChecked.setBounds(465, 270, 87, 20);
      logScaleChecked.setName("LogScaleChecked");
      logScaleChecked.setText("Log Scale");
      logScaleChecked.setBackground(bkgColor);
      logScaleChecked.addItemListener(new java.awt.event.ItemListener()
      {
        public void itemStateChanged(java.awt.event.ItemEvent e)
        {
          if (logScaleChecked.isSelected())
            acop.setGraphStyle(1);
          else
            acop.setGraphStyle(0);
          displayDataForSelectedProperty(0);
        }
      });
    }
    return logScaleChecked;
  }
  /**
   * This method initializes jCheckBox
   * 
   * @return javax.swing.JCheckBox
   */
  private javax.swing.JCheckBox getHistoryCheckBox()
  {
    if (historyCheckBox == null)
    {
      historyCheckBox = new javax.swing.JCheckBox();
      historyCheckBox.setBounds(465, 295, 87, 20);
      historyCheckBox.setName("historyCheckBox");
      historyCheckBox.setText("History");
      historyCheckBox.setBackground(bkgColor);
      historyCheckBox.addItemListener(new java.awt.event.ItemListener()
      {
        public void itemStateChanged(java.awt.event.ItemEvent e)
        {
          if (historyCheckBox.isSelected())
          {
            drawModeCombo.setSelectedIndex(0); // polyline
            dataSizeInput.setText("" + xpqs[ptrxpqs].prpHistoryDepthShort);
          }
          else
          {
            if (xpqs[ptrxpqs].prpSize > 1024)
            {
              drawModeCombo.setSelectedIndex(0);
            }
            else if ((xpqs[ptrxpqs].prpArrayType & TArrayType.AT_SPECTRUM) == TArrayType.AT_SPECTRUM)
            {
              drawModeCombo.setSelectedIndex(0); // polyline
            }
            else if ((xpqs[ptrxpqs].prpArrayType & TArrayType.AT_CHANNEL) == TArrayType.AT_CHANNEL)
            {
              drawModeCombo.setSelectedIndex(2); // histogram
            }
            else
            {
              drawModeCombo.setSelectedIndex(7); // text
            }
            dataSizeInput.setText("" + xpqs[ptrxpqs].prpSize);
          }
        }
      });
    }
    return historyCheckBox;
  }
  /**
   * This method initializes jCheckBox1
   * 
   * @return javax.swing.JCheckBox
   */
  private javax.swing.JCheckBox getInputPanelCheckBox()
  {
    if (inputPanelCheckBox == null)
    {
      inputPanelCheckBox = new javax.swing.JCheckBox();
      inputPanelCheckBox.setBounds(465, 320, 87, 20);
      inputPanelCheckBox.setName("inputPanelCheckBox");
      inputPanelCheckBox.setText("InputPane");
      inputPanelCheckBox.setBackground(bkgColor);
      inputPanelCheckBox.addItemListener(new java.awt.event.ItemListener()
      {
        public void itemStateChanged(java.awt.event.ItemEvent e)
        {
          inputDataTypeText.setText("");
          if (inputPanelCheckBox.isSelected())
          {
            browserInstance.setSize(PANEL_XEXTENT_LARGE, PANEL_YEXTENT_SMALL);
            inputPanelText.setVisible(true);
            inputDataTypeCombo.setVisible(true);
            writeAccessSelected.setVisible(true);
            inputDataTypeText.setVisible(true);
          }
          else
          {
            browserInstance.setSize(PANEL_XEXTENT_SMALL, PANEL_YEXTENT_SMALL);
            writeAccessSelected.setSelected(false);
            inputPanelText.setVisible(false);
            inputDataTypeCombo.setVisible(false);
            writeAccessSelected.setVisible(false);
            inputDataTypeText.setVisible(false);
            readButton.setText("Read");
          }
        }
      });
    }
    return inputPanelCheckBox;
  }
  /**
   * This method initializes jCheckBox
   * 
   * @return javax.swing.JCheckBox
   */
  private javax.swing.JCheckBox getWriteAccessSelected()
  {
    if (writeAccessSelected == null)
    {
      writeAccessSelected = new javax.swing.JCheckBox();
      writeAccessSelected.setBounds(621, 39, 108, 16);
      writeAccessSelected.setName("writeAccessSelected");
      writeAccessSelected.setText("Write Access");
      writeAccessSelected.setVisible(false);
      writeAccessSelected.setBackground(bkgColor);
      writeAccessSelected.addActionListener(new java.awt.event.ActionListener()
      {
        public void actionPerformed(java.awt.event.ActionEvent e)
        {
          if (writeAccessSelected.isSelected())
            readButton.setText("Write");
          else
            readButton.setText("Read");
        }
      });
    }
    return writeAccessSelected;
  }
  /**
   * This method initializes jComboBox
   * 
   * @return javax.swing.JComboBox
   */
  private javax.swing.JComboBox getInputDataTypeCombo()
  {
    if (inputDataTypeCombo == null)
    {
      inputDataTypeCombo = new javax.swing.JComboBox();
      inputDataTypeCombo.setBounds(638, 76, 89, 17);
      inputDataTypeCombo.setName("inputDataTypeCombo");
      fillInDataTypes(inputDataTypeCombo);
      inputDataTypeCombo.setVisible(false);
      inputDataTypeCombo.setBackground(bkgColor);
    }
    return inputDataTypeCombo;
  }
  private TDataType getInputData()
  {
    if (!inputPanelCheckBox.isSelected()) return null;
    String fmt = inputDataTypeCombo.getSelectedItem().toString();
    String txt = inputPanelText.getText().trim();
    if (txt.length() == 0) return null;
    String del = " ";
    if (txt.indexOf(',') != -1) del = ",";
    String[] vars = new String[txt.length()]; // = txt.split(del);
    String[] v = txt.split("\n");
    int siz = 0, len = 0;
    for (int n = 0; n < v.length; n++)
    {
      String[] sv = v[n].trim().split(del);
      for (int p = 0; p < sv.length; p++)
        vars[siz++] = sv[p].trim();
    }
    // int siz = vars.length;
    int i = 0, retrycnt = 2;
    while (retrycnt-- > 0)
    {
      try
      {
        switch (TFormat.getFormatCode(fmt))
        {
          case TFormat.CF_DOUBLE:
          {
            double[] vals = new double[siz];
            for (i = 0; i < siz; i++)
              vals[i] = new Double(vars[i]).doubleValue();
            return new TDataType(vals);
          }
          case TFormat.CF_SHORT:
          {
            short[] vals = new short[siz];
            for (i = 0; i < siz; i++)
              vals[i] = new Short(vars[i]).shortValue();
            return new TDataType(vals);
          }
          case TFormat.CF_LONG:
          {
            int[] vals = new int[siz];
            for (i = 0; i < siz; i++)
              vals[i] = new Integer(vars[i]).intValue();
            return new TDataType(vals);
          }
          case TFormat.CF_BOOLEAN:
          {
            int[] vals = new int[siz];
            for (i = 0; i < siz; i++)
            {
              if (vars[i].compareToIgnoreCase("true") == 0) vals[i] = 1;
              else if (vars[i].compareToIgnoreCase("false") == 0) vals[i] = 0;
              else vals[i] = new Integer(vars[i]).intValue();
            }
            return new TDataType(vals);
          }
          case TFormat.CF_FLOAT:
          {
            float[] vals = new float[siz];
            for (i = 0; i < siz; i++)
              vals[i] = new Float(vars[i]).floatValue();
            return new TDataType(vals);
          }
          case TFormat.CF_BYTE:
          {
            byte[] vals = new byte[siz];
            for (i = 0; i < siz; i++)
              vals[i] = new Byte(vars[i]).byteValue();
            return new TDataType(vals);
          }
          case TFormat.CF_TEXT:
          {
            return new TDataType(txt);
          }
          case TFormat.CF_XML:
          {
            TDataType tdt = new TDataType(txt);
            tdt.dFormat = TFormat.CF_XML;
            return tdt;
          }
          case TFormat.CF_NAME8:
          {
            NAME8[] vals = new NAME8[siz];
            for (i = 0; i < siz; i++)
              vals[i] = new NAME8(vars[i]);
            return new TDataType(vals);
          }
          case TFormat.CF_NAME16:
          {
            NAME16[] vals = new NAME16[siz];
            for (i = 0; i < siz; i++)
              vals[i] = new NAME16(vars[i]);
            return new TDataType(vals);
          }
          case TFormat.CF_NAME32:
          {
            NAME32[] vals = new NAME32[siz];
            for (i = 0; i < siz; i++)
              vals[i] = new NAME32(vars[i]);
            return new TDataType(vals);
          }
          case TFormat.CF_NAME48:
          {
            NAME48[] vals = new NAME48[siz];
            for (i = 0; i < siz; i++)
              vals[i] = new NAME48(vars[i]);
            return new TDataType(vals);
          }
          case TFormat.CF_NAME64:
          {
            NAME64[] vals = new NAME64[siz];
            for (i = 0; i < siz; i++)
              vals[i] = new NAME64(vars[i]);
            return new TDataType(vals);
          }
          case TFormat.CF_NAME16I:
          {
            len = siz / 2;
            NAME16I[] vals = new NAME16I[len];
            for (i = 0; i < len; i++)
              vals[i] = new NAME16I(vars[i * 2], new Integer(vars[i * 2 + 1]).intValue());
            return new TDataType(vals);
          }
          case TFormat.CF_NAME32I:
          {
            len = siz / 2;
            NAME32I[] vals = new NAME32I[len];
            for (i = 0; i < len; i++)
              vals[i] = new NAME32I(vars[i * 2], new Integer(vars[i * 2 + 1]).intValue());
            return new TDataType(vals);
          }
          case TFormat.CF_NAME48I:
          {
            len = siz / 2;
            NAME48I[] vals = new NAME48I[len];
            for (i = 0; i < len; i++)
              vals[i] = new NAME48I(vars[i * 2], new Integer(vars[i * 2 + 1]).intValue());
            return new TDataType(vals);
          }
          case TFormat.CF_NAME64I:
          {
            len = siz / 2;
            NAME64I[] vals = new NAME64I[len];
            for (i = 0; i < len; i++)
              vals[i] = new NAME64I(vars[i * 2], new Integer(vars[i * 2 + 1]).intValue());
            return new TDataType(vals);
          }
          case TFormat.CF_UNAME:
          {
            len = siz / 5;
            UNAME[] vals = new UNAME[len];
            for (i = 0; i < len; i++)
              vals[i] = new UNAME(new Integer(vars[i * 5]).intValue(), new Float(vars[i * 5 + 1]).floatValue(),new Float(vars[i * 5 + 2]).floatValue(),new Float(vars[i * 5 + 3]).floatValue(),vars[i*5+4]);
            return new TDataType(vals);
          }
          case TFormat.CF_USTRING:
          {
            len = siz / 5;
            USTRING[] vals = new USTRING[len];
            for (i = 0; i < len; i++)
              vals[i] = new USTRING(new Integer(vars[i * 5]).intValue(), new Float(vars[i * 5 + 1]).floatValue(),new Float(vars[i * 5 + 2]).floatValue(),new Integer(vars[i * 5 + 3]).intValue(),vars[i*5+4]);
            return new TDataType(vals);
          }
          case TFormat.CF_LNGINT:
          {
            len = siz / 2;
            INTINT[] vals = new INTINT[len];
            for (i = 0; i < len; i++)
              vals[i] = new INTINT(new Integer(vars[i * 2]).intValue(), new Integer(vars[i * 2 + 1]).intValue());
            return new TDataType(vals);
          }
          case TFormat.CF_FLTINT:
          {
            len = siz / 2;
            FLTINT[] vals = new FLTINT[len];
            for (i = 0; i < len; i++)
              vals[i] = new FLTINT(new Float(vars[i * 2]).floatValue(), new Integer(vars[i * 2 + 1]).intValue());
            return new TDataType(vals);
          }
          case TFormat.CF_FLTFLT:
          {
            len = siz / 2;
            FLTFLT[] vals = new FLTFLT[len];
            for (i = 0; i < len; i++)
              vals[i] = new FLTFLT(new Float(vars[i * 2]).floatValue(), new Float(vars[i * 2 + 1])
                  .floatValue());
            return new TDataType(vals);
          }
          case TFormat.CF_DBLDBL:
          {
            len = siz / 2;
            DBLDBL[] vals = new DBLDBL[len];
            for (i = 0; i < len; i++)
              vals[i] = new DBLDBL(new Double(vars[i * 2]).doubleValue(), new Double(vars[i * 2 + 1])
                  .doubleValue());
            return new TDataType(vals);
          }
          case TFormat.CF_NAME16FI:
          {
            len = siz / 3;
            NAME16FI[] vals = new NAME16FI[len];
            for (i = 0; i < len; i++)
              vals[i] = new NAME16FI(vars[i * 3], new Integer(vars[i * 3 + 2]).intValue(), new Float(
                  vars[i * 3 + 1]).floatValue());
            return new TDataType(vals);
          }
          case TFormat.CF_NAME16DBLDBL:
          {
            len = siz / 3;
            NAME16DBLDBL[] vals = new NAME16DBLDBL[len];
            for (i = 0; i < len; i++)
              vals[i] = new NAME16DBLDBL(vars[i * 3], new Double(vars[i * 3 + 2]).doubleValue(), new Double(
                  vars[i * 3 + 1]).doubleValue());
            return new TDataType(vals);
          }
          case TFormat.CF_NAME32DBLDBL:
          {
            len = siz / 3;
            NAME32DBLDBL[] vals = new NAME32DBLDBL[len];
            for (i = 0; i < len; i++)
              vals[i] = new NAME32DBLDBL(vars[i * 3], new Double(vars[i * 3 + 2]).doubleValue(), new Double(
                  vars[i * 3 + 1]).doubleValue());
            return new TDataType(vals);
          }
          case TFormat.CF_NAME64DBLDBL:
          {
            len = siz / 3;
            NAME64DBLDBL[] vals = new NAME64DBLDBL[len];
            for (i = 0; i < len; i++)
              vals[i] = new NAME64DBLDBL(vars[i * 3], new Double(vars[i * 3 + 2]).doubleValue(), new Double(
                  vars[i * 3 + 1]).doubleValue());
            return new TDataType(vals);
          }
          case TFormat.CF_FLTFLTINT:
          {
            len = siz / 3;
            FLTFLTINT[] vals = new FLTFLTINT[len];
            for (i = 0; i < len; i++)
              vals[i] = new FLTFLTINT(new Float(vars[i * 3]).floatValue(), new Float(vars[i * 3 + 1])
                  .floatValue(), new Integer(vars[i * 3 + 2]).intValue());
            return new TDataType(vals);
          }
          case TFormat.CF_FLTINTINT:
          {
            len = siz / 3;
            FLTINTINT[] vals = new FLTINTINT[len];
            for (i = 0; i < len; i++)
              vals[i] = new FLTINTINT(new Float(vars[i * 3]).floatValue(), new Integer(vars[i * 3 + 1])
                  .intValue(), new Integer(vars[i * 3 + 2]).intValue());
            return new TDataType(vals);
          }
          case TFormat.CF_INTFLTFLTFLT:
          {
            len = siz / 4;
            INTFLTFLTFLT[] vals = new INTFLTFLTFLT[len];
            for (i = 0; i < len; i++)
              vals[i] = new INTFLTFLTFLT(new Integer(vars[i * 4]).intValue(), new Float(vars[i * 4 + 1])
                  .floatValue(), new Float(vars[i * 4 + 2]).floatValue(), new Float(vars[i * 4 + 3])
                  .floatValue());
            return new TDataType(vals);
          }
          case TFormat.CF_INTFLTINT:
          {
            len = siz / 3;
            INTFLTINT[] vals = new INTFLTINT[len];
            for (i = 0; i < len; i++)
              vals[i] = new INTFLTINT(new Integer(vars[i * 3]).intValue(), new Float(vars[i * 3 + 1])
                  .floatValue(), new Integer(vars[i * 3 + 2]).intValue());
            return new TDataType(vals);
          }
          case TFormat.CF_INTINTFLTFLT:
          {
            len = siz / 4;
            INTINTFLTFLT[] vals = new INTINTFLTFLT[len];
            for (i = 0; i < len; i++)
              vals[i] = new INTINTFLTFLT(new Float(vars[i * 4 + 2]).floatValue(), new Float(vars[i * 4 + 3])
                  .floatValue(), new Integer(vars[i * 4]).intValue(), new Integer(vars[i * 4 + 1]).intValue());
            return new TDataType(vals);
          }
          case TFormat.CF_INTINTINTINT:
          {
            len = siz / 4;
            INTINTINTINT[] vals = new INTINTINTINT[len];
            for (i = 0; i < len; i++)
              vals[i] = new INTINTINTINT(new Integer(vars[i * 4]).intValue(), new Integer(vars[i * 4 + 1]).intValue(), 
                  new Integer(vars[i * 4 + 2]).intValue(), new Integer(vars[i * 4 + 3]).intValue());
            return new TDataType(vals);
          }
          case TFormat.CF_INTINTINT:
          {
            len = siz / 4;
            INTINTINT[] vals = new INTINTINT[len];
            for (i = 0; i < len; i++)
              vals[i] = new INTINTINT(new Integer(vars[i * 4]).intValue(), new Integer(vars[i * 4 + 1]).intValue(), 
                  new Integer(vars[i * 4 + 2]).intValue());
            return new TDataType(vals);
          }
        }
        return null;
      }
      catch (NumberFormatException e)
      {
        siz = i;
      }
    }
    return null;
  }
  /**
   * This method initializes jTextArea
   * 
   * @return javax.swing.JTextArea
   */
  private javax.swing.JTextArea getInputDataTypeText()
  {
    if (inputDataTypeText == null)
    {
      inputDataTypeText = new javax.swing.JTextArea();
      inputDataTypeText.setBounds(613, 58, 116, 14);
      inputDataTypeText.setBackground(bkgColor);
      inputDataTypeText.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
      inputDataTypeText.setName("inputDataTypeText");
      inputDataTypeText.setText("Input Data Type");
      inputDataTypeText.setVisible(false);
      inputDataTypeText.setEditable(false);
    }
    return inputDataTypeText;
  }
  /**
   * This method initializes jEditorPane
   * 
   * @return javax.swing.JEditorPane
   */
  private javax.swing.JEditorPane getInputPanelText()
  {
    if (inputPanelText == null)
    {
      inputPanelText = new javax.swing.JEditorPane();
      inputPanelText.setBounds(568, 101, 161, 240);
      inputPanelText.setVisible(false);
      inputPanelText.setName("InputPanelText");
      inputPanelText.setBorder(javax.swing.BorderFactory.createLineBorder(java.awt.Color.gray, 1));
    }
    return inputPanelText;
  }
  /**
   * This method initializes jButton
   * 
   * @return javax.swing.JButton
   */
  private javax.swing.JButton getDevicePropertyToggleButton()
  {
    if (devicePropertyToggleButton == null)
    {
      devicePropertyToggleButton = new javax.swing.JButton();
      devicePropertyToggleButton.setBounds(464, 60, 78, 13);
      devicePropertyToggleButton.setText("toggle");
      devicePropertyToggleButton.setName("devicePropertyToggleButton");
      devicePropertyToggleButton.setVisible(false);
      devicePropertyToggleButton.setBackground(bkgColor);
      devicePropertyToggleButton.addActionListener(new java.awt.event.ActionListener()
      {
        public void actionPerformed(java.awt.event.ActionEvent e)
        {
          if (nxpqs > 1) ptrxpqs = (ptrxpqs + 1) % nxpqs;
          String srv = deviceServerCombo.getSelectedItem().toString();
          String con = deviceContextCombo.getSelectedItem().toString();
          fillInPropertyInfoCombos(con, srv);
        }
      });
    }
    return devicePropertyToggleButton;
  }
  /**
   * This method initializes jMenu
   * 
   * @return javax.swing.JMenu
   */
  private javax.swing.JMenu getDebugOptionsMenu()
  {
    if (debugOptionsMenu == null)
    {
      debugOptionsMenu = new javax.swing.JMenu();
      debugOptionsMenu.add(getShowFecInfoOption());
      debugOptionsMenu.add(getDebugOnOption());
      debugOptionsMenu.setText("Debug Options");
      debugOptionsMenu.setName("debugOptions");
      debugOptionsMenu.setBackground(bkgColor);
    }
    return debugOptionsMenu;
  }
  /**
   * This method initializes jMenuItem
   * 
   * @return javax.swing.JMenuItem
   */
  private javax.swing.JMenuItem getShowFecInfoOption()
  {
    if (showFecInfoOption == null)
    {
      showFecInfoOption = new javax.swing.JMenuItem();
      showFecInfoOption.setName("showFecInfoOption");
      showFecInfoOption.setText("Show Fec Information");
      showFecInfoOption.addActionListener(new java.awt.event.ActionListener()
      {
        public void actionPerformed(java.awt.event.ActionEvent e)
        {
          drawModeCombo.setSelectedIndex(7);
          String srv = deviceServerCombo.getSelectedItem().toString();
          String con = deviceContextCombo.getSelectedItem().toString();
          String s = TQuery.getModuleAddressInfo(srv, con);
          String sa[] = s.split("\n");
          String sb[] = new String[sa.length + 3];
          int i;
          for (i = 0; i < sa.length; i++)
            sb[i] = sa[i];
          sb[i++] = TQuery.getTineVersion(con, srv);
          sb[i++] = TQuery.getAppVersion(con, srv);
          sb[i++] = TQuery.getAppDate(con, srv);
          acop.ClearScreen();
          acop.ClearText();
          acop.Draw(sb);
        }
      });
    }
    return showFecInfoOption;
  }
  /**
   * This method initializes jRadioButtonMenuItem
   * 
   * @return javax.swing.JRadioButtonMenuItem
   */
  private javax.swing.JRadioButtonMenuItem getDebugOnOption()
  {
    if (debugOnOption == null)
    {
      debugOnOption = new javax.swing.JRadioButtonMenuItem();
      debugOnOption.setText("Debug On");
      debugOnOption.setName("debugOnOption");
      debugOnOption.addItemListener(new java.awt.event.ItemListener()
      {
        public void itemStateChanged(java.awt.event.ItemEvent e)
        {
          debugLevel = debugOnOption.isSelected() ? 2 : 0;
        }
      });
    }
    return debugOnOption;
  }
} // @jve:visual-info decl-index=0 visual-constraint="23,15"
